'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var LexicalComposer = require('@lexical/react/LexicalComposer');
var LexicalRichTextPlugin = require('@lexical/react/LexicalRichTextPlugin');
var LexicalContentEditable = require('@lexical/react/LexicalContentEditable');
var LexicalHistoryPlugin = require('@lexical/react/LexicalHistoryPlugin');
var LexicalAutoFocusPlugin = require('@lexical/react/LexicalAutoFocusPlugin');
var LexicalErrorBoundary = require('@lexical/react/LexicalErrorBoundary');
var LexicalComposerContext = require('@lexical/react/LexicalComposerContext');
var React = require('react');
var require$$0 = require('lexical');
var reactDom = require('react-dom');
var ui = require('@cpchain-foundation/ui');
var Skeleton = require('react-loading-skeleton');
var LexicalLinkPlugin = require('@lexical/react/LexicalLinkPlugin');
var LexicalListPlugin = require('@lexical/react/LexicalListPlugin');
var LexicalMarkdownShortcutPlugin = require('@lexical/react/LexicalMarkdownShortcutPlugin');
var LexicalOnChangePlugin = require('@lexical/react/LexicalOnChangePlugin');
var LexicalAutoLinkPlugin = require('@lexical/react/LexicalAutoLinkPlugin');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var LexicalErrorBoundary__default = /*#__PURE__*/_interopDefaultLegacy(LexicalErrorBoundary);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0);
var Skeleton__default = /*#__PURE__*/_interopDefaultLegacy(Skeleton);

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "body {\n  margin: 0;\n  background: #eee;\n  font-family: system-ui, -apple-system, BlinkMacSystemFont, \".SFNSText-Regular\",\n    sans-serif;\n  font-weight: 500;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.other h2 {\n  font-size: 18px;\n  color: #444;\n  margin-bottom: 7px;\n}\n\n.other a {\n  color: #777;\n  text-decoration: underline;\n  font-size: 14px;\n}\n\n.other ul {\n  padding: 0;\n  margin: 0;\n  list-style-type: none;\n}\n\n.App {\n  font-family: sans-serif;\n  text-align: center;\n}\n\nh1 {\n  font-size: 24px;\n  color: #333;\n}\n\n.ltr {\n  text-align: left;\n}\n\n.rtl {\n  text-align: right;\n}\n\n.editor-container {\n  position: static !important;\n  margin: 20px auto 20px auto;\n  border-radius: 2px;\n  width: 80%;\n  color: #000;\n  position: relative;\n  line-height: 20px;\n  font-weight: 400;\n  text-align: left;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n}\n\n.editor-viewer {\n  margin: 20px auto 20px auto;\n  border-radius: 2px;\n  width: 80%;\n  color: #000;\n  position: relative;\n  line-height: 20px;\n  font-weight: 400;\n  text-align: left;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n  /* background: #fff; */\n}\n\n.editor-inner {\n  background: #fff;\n  position: relative;\n  min-height: 60vh;\n}\n\n.editor-inner h1 {\n  /* h1 不在编辑器内部显示 */\n  display: none;\n}\n\n\n.editor-input {\n  min-height: 150px;\n  resize: none;\n  font-size: 15px;\n  caret-color: rgb(5, 5, 5);\n  position: relative;\n  -moz-tab-size: 1;\n    -o-tab-size: 1;\n       tab-size: 1;\n  outline: 0;\n  padding: 15px 10px;\n  caret-color: #444;\n}\n\n.editor-placeholder {\n  color: #999;\n  overflow: hidden;\n  position: absolute;\n  text-overflow: ellipsis;\n  top: 15px;\n  left: 10px;\n  font-size: 15px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  display: inline-block;\n  pointer-events: none;\n}\n\n.editor-text-bold {\n  font-weight: bold;\n}\n\n.editor-text-italic {\n  font-style: italic;\n}\n\n.editor-text-underline {\n  text-decoration: underline;\n}\n\n.editor-text-strikethrough {\n  text-decoration: line-through;\n}\n\n.editor-text-underlineStrikethrough {\n  text-decoration: underline line-through;\n}\n\n.editor-text-code {\n  background-color: rgb(240, 242, 245);\n  padding: 1px 0.25rem;\n  font-family: Menlo, Consolas, Monaco, monospace;\n  font-size: 94%;\n}\n\n.editor-link {\n  color: rgb(33, 111, 219);\n  text-decoration: none;\n}\n\n.tree-view-output {\n  display: block;\n  background: #222;\n  color: #fff;\n  padding: 5px;\n  font-size: 12px;\n  white-space: pre-wrap;\n  margin: 1px auto 10px auto;\n  max-height: 250px;\n  position: relative;\n  border-bottom-left-radius: 10px;\n  border-bottom-right-radius: 10px;\n  overflow: auto;\n  line-height: 14px;\n}\n\n.editor-code {\n  background-color: rgb(240, 242, 245);\n  font-family: Menlo, Consolas, Monaco, monospace;\n  display: block;\n  padding: 8px 8px 8px 52px;\n  line-height: 1.53;\n  font-size: 13px;\n  margin: 0;\n  margin-top: 8px;\n  margin-bottom: 8px;\n  -moz-tab-size: 2;\n    -o-tab-size: 2;\n       tab-size: 2;\n  /* white-space: pre; */\n  overflow-x: auto;\n  position: relative;\n}\n\n.editor-code:before {\n  content: attr(data-gutter);\n  position: absolute;\n  background-color: #eee;\n  left: 0;\n  top: 0;\n  border-right: 1px solid #ccc;\n  padding: 8px;\n  color: #777;\n  white-space: pre-wrap;\n  text-align: right;\n  min-width: 25px;\n}\n\n.editor-code:after {\n  content: attr(data-highlight-language);\n  top: 0;\n  right: 3px;\n  padding: 3px;\n  font-size: 10px;\n  text-transform: uppercase;\n  position: absolute;\n  color: rgba(0, 0, 0, 0.5);\n}\n\n.editor-tokenComment {\n  color: slategray;\n}\n\n.editor-tokenPunctuation {\n  color: #999;\n}\n\n.editor-tokenProperty {\n  color: #905;\n}\n\n.editor-tokenSelector {\n  color: #690;\n}\n\n.editor-tokenOperator {\n  color: #9a6e3a;\n}\n\n.editor-tokenAttr {\n  color: #07a;\n}\n\n.editor-tokenVariable {\n  color: #e90;\n}\n\n.editor-tokenFunction {\n  color: #dd4a68;\n}\n\n.editor-paragraph {\n  margin: 0;\n  margin-bottom: 8px;\n  position: relative;\n}\n\n.editor-paragraph:last-child {\n  margin-bottom: 0;\n}\n\n.editor-heading-h1 {\n  font-size: 24px;\n  color: rgb(5, 5, 5);\n  font-weight: 400;\n  margin: 0;\n  margin-bottom: 12px;\n  padding: 0;\n}\n\n.editor-heading-h2 {\n  font-size: 15px;\n  color: rgb(101, 103, 107);\n  font-weight: 700;\n  margin: 0;\n  margin-top: 10px;\n  padding: 0;\n  text-transform: uppercase;\n}\n\n.editor-quote {\n  margin: 0;\n  margin-left: 20px;\n  font-size: 15px;\n  color: rgb(101, 103, 107);\n  border-left-color: rgb(206, 208, 212);\n  border-left-width: 4px;\n  border-left-style: solid;\n  padding-left: 16px;\n}\n\n.editor-list-ol {\n  padding: 0;\n  margin: 0;\n  margin-left: 16px;\n}\n\n.editor-list-ul {\n  padding: 0;\n  margin: 0;\n  margin-left: 16px;\n}\n\n.editor-listitem {\n  margin: 8px 32px 8px 32px;\n}\n\n.editor-nested-listitem {\n  list-style-type: none;\n}\n\npre::-webkit-scrollbar {\n  background: transparent;\n  width: 10px;\n}\n\npre::-webkit-scrollbar-thumb {\n  background: #999;\n}\n\n.debug-timetravel-panel {\n  overflow: hidden;\n  padding: 0 0 10px 0;\n  margin: auto;\n  display: flex;\n}\n\n.debug-timetravel-panel-slider {\n  padding: 0;\n  flex: 8;\n}\n\n.debug-timetravel-panel-button {\n  padding: 0;\n  border: 0;\n  background: none;\n  flex: 1;\n  color: #fff;\n  font-size: 12px;\n}\n\n.debug-timetravel-panel-button:hover {\n  text-decoration: underline;\n}\n\n.debug-timetravel-button {\n  border: 0;\n  padding: 0;\n  font-size: 12px;\n  top: 10px;\n  right: 15px;\n  position: absolute;\n  background: none;\n  color: #fff;\n}\n\n.debug-timetravel-button:hover {\n  text-decoration: underline;\n}\n\n.emoji {\n  color: transparent;\n  background-size: 16px 16px;\n  background-position: center;\n  background-repeat: no-repeat;\n  vertical-align: middle;\n  margin: 0 -1px;\n}\n\n.emoji-inner {\n  padding: 0 0.15em;\n}\n\n.emoji-inner::-moz-selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.emoji-inner::selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.emoji-inner::moz-selection {\n  color: transparent;\n  background-color: rgba(150, 150, 150, 0.4);\n}\n\n.toolbar {\n  display: flex;\n  margin-bottom: 1px;\n  background: #fff;\n  padding: 4px;\n  border-top-left-radius: 10px;\n  border-top-right-radius: 10px;\n  vertical-align: middle;\n}\n\n.toolbar button.toolbar-item {\n  border: 0;\n  display: flex;\n  background: none;\n  border-radius: 10px;\n  padding: 8px;\n  cursor: pointer;\n  vertical-align: middle;\n}\n\n.toolbar button.toolbar-item:disabled {\n  cursor: not-allowed;\n}\n\n.toolbar button.toolbar-item.spaced {\n  margin-right: 2px;\n}\n\n.toolbar button.toolbar-item i.format {\n  background-size: contain;\n  display: inline-block;\n  height: 18px;\n  width: 18px;\n  margin-top: 2px;\n  vertical-align: -0.25em;\n  display: flex;\n  opacity: 0.6;\n}\n\n.toolbar button.toolbar-item:disabled i.format {\n  opacity: 0.2;\n}\n\n.toolbar button.toolbar-item.active {\n  background-color: rgba(223, 232, 250, 0.3);\n}\n\n.toolbar button.toolbar-item.active i {\n  opacity: 1;\n}\n\n.toolbar .toolbar-item:hover:not([disabled]) {\n  background-color: #eee;\n}\n\n.toolbar .divider {\n  width: 1px;\n  background-color: #eee;\n  margin: 0 4px;\n}\n\n.toolbar select.toolbar-item {\n  border: 0;\n  display: flex;\n  background: none;\n  border-radius: 10px;\n  padding: 8px;\n  vertical-align: middle;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  width: 70px;\n  font-size: 14px;\n  color: #777;\n  text-overflow: ellipsis;\n}\n\n.toolbar select.code-language {\n  text-transform: capitalize;\n  width: 130px;\n}\n\n.toolbar .toolbar-item .text {\n  display: flex;\n  line-height: 20px;\n  width: 200px;\n  vertical-align: middle;\n  font-size: 14px;\n  color: #777;\n  text-overflow: ellipsis;\n  width: 70px;\n  overflow: hidden;\n  height: 20px;\n  text-align: left;\n}\n\n.toolbar .toolbar-item .icon {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  margin-right: 8px;\n  line-height: 16px;\n  background-size: contain;\n}\n\n.toolbar i.chevron-down {\n  margin-top: 3px;\n  width: 16px;\n  height: 16px;\n  display: flex;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\n.toolbar i.chevron-down.inside {\n  width: 16px;\n  height: 16px;\n  display: flex;\n  margin-left: -25px;\n  margin-top: 11px;\n  margin-right: 10px;\n  pointer-events: none;\n}\n\ni.chevron-down {\n  background-color: transparent;\n  background-size: contain;\n  display: inline-block;\n  height: 8px;\n  width: 8px;\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chevron-down\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z\"/></svg>');\n\n}\n\n#block-controls button:hover {\n  background-color: #efefef;\n}\n\n#block-controls button:focus-visible {\n  border-color: blue;\n}\n\n#block-controls span.block-type {\n  background-size: contain;\n  display: block;\n  width: 18px;\n  height: 18px;\n  margin: 2px;\n}\n\n#block-controls span.block-type.paragraph {\n  background-image: url(images/icons/text-paragraph.svg);\n}\n\n#block-controls span.block-type.h1 {\n  background-image: url(images/icons/type-h1.svg);\n}\n\n#block-controls span.block-type.h2 {\n  background-image: url(images/icons/type-h2.svg);\n}\n\n#block-controls span.block-type.quote {\n  background-image: url(images/icons/chat-square-quote.svg);\n}\n\n#block-controls span.block-type.ul {\n  background-image: url(images/icons/list-ul.svg);\n}\n\n#block-controls span.block-type.ol {\n  background-image: url(images/icons/list-ol.svg);\n}\n\n#block-controls span.block-type.code {\n  background-image: url(images/icons/code.svg);\n}\n\n.dropdown {\n  z-index: 5;\n  display: block;\n  position: absolute;\n  box-shadow: 0 12px 28px 0 rgba(0, 0, 0, 0.2), 0 2px 4px 0 rgba(0, 0, 0, 0.1),\n    inset 0 0 0 1px rgba(255, 255, 255, 0.5);\n  border-radius: 8px;\n  min-width: 100px;\n  min-height: 40px;\n  background-color: #fff;\n}\n\n.dropdown .item {\n  margin: 0 8px 0 8px;\n  padding: 8px;\n  color: #050505;\n  cursor: pointer;\n  line-height: 16px;\n  font-size: 15px;\n  display: flex;\n  align-content: center;\n  flex-direction: row;\n  flex-shrink: 0;\n  justify-content: space-between;\n  background-color: #fff;\n  border-radius: 8px;\n  border: 0;\n  min-width: 268px;\n}\n\n.dropdown .item .active {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  background-size: contain;\n}\n\n.dropdown .item:first-child {\n  margin-top: 8px;\n}\n\n.dropdown .item:last-child {\n  margin-bottom: 8px;\n}\n\n.dropdown .item:hover {\n  background-color: #eee;\n}\n\n.dropdown .item .text {\n  display: flex;\n  line-height: 20px;\n  flex-grow: 1;\n  width: 200px;\n}\n\n.dropdown .item .icon {\n  display: flex;\n  width: 20px;\n  height: 20px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  margin-right: 12px;\n  line-height: 16px;\n  background-size: contain;\n}\n\n.link-editor {\n  position: absolute;\n  z-index: 100;\n  top: -10000px;\n  left: -10000px;\n  margin-top: -6px;\n  max-width: 300px;\n  width: 100%;\n  opacity: 0;\n  background-color: #fff;\n  box-shadow: 0px 5px 10px rgba(0, 0, 0, 0.3);\n  border-radius: 8px;\n  transition: opacity 0.5s;\n}\n\n.link-editor .link-input {\n  display: block;\n  width: calc(100% - 24px);\n  box-sizing: border-box;\n  margin: 8px 12px;\n  padding: 8px 12px;\n  border-radius: 15px;\n  background-color: #eee;\n  font-size: 15px;\n  color: rgb(5, 5, 5);\n  border: 0;\n  outline: 0;\n  position: relative;\n  font-family: inherit;\n}\n\n.link-editor div.link-edit {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chevron-down\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z\"/></svg>');\n\n  background-size: 16px;\n  background-position: center;\n  background-repeat: no-repeat;\n  width: 35px;\n  vertical-align: -0.25em;\n  position: absolute;\n  right: 0;\n  top: 0;\n  bottom: 0;\n  cursor: pointer;\n}\n\n.link-editor .link-input a {\n  color: rgb(33, 111, 219);\n  text-decoration: none;\n  display: block;\n  white-space: nowrap;\n  overflow: hidden;\n  margin-right: 30px;\n  text-overflow: ellipsis;\n}\n\n.link-editor .link-input a:hover {\n  text-decoration: underline;\n}\n\n.link-editor .button {\n  width: 20px;\n  height: 20px;\n  display: inline-block;\n  padding: 6px;\n  border-radius: 8px;\n  cursor: pointer;\n  margin: 0 2px;\n}\n\n.link-editor .button.hovered {\n  width: 20px;\n  height: 20px;\n  display: inline-block;\n  background-color: #eee;\n}\n\n.link-editor .button i,\n.actions i {\n  background-size: contain;\n  display: inline-block;\n  height: 20px;\n  width: 20px;\n  vertical-align: -0.25em;\n}\n\ni.undo {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-arrow-counterclockwise\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M8 3a5 5 0 1 1-4.546 2.914.5.5 0 0 0-.908-.417A6 6 0 1 0 8 2v1z\"/><path d=\"M8 4.466V.534a.25.25 0 0 0-.41-.192L5.23 2.308a.25.25 0 0 0 0 .384l2.36 1.966A.25.25 0 0 0 8 4.466z\"/></svg>');\n  /* background-image: url(images/icons/arrow-counterclockwise.svg); */\n}\n\ni.redo {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-arrow-clockwise\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M8 3a5 5 0 1 0 4.546 2.914.5.5 0 0 1 .908-.417A6 6 0 1 1 8 2v1z\"/><path d=\"M8 4.466V.534a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384L8.41 4.658A.25.25 0 0 1 8 4.466z\"/></svg>');\n  /* background-image: url(images/icons/arrow-clockwise.svg); */\n}\n\n.icon.paragraph {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-paragraph\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm4-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-paragraph.svg); */\n}\n\n.icon.large-heading,\n.icon.h1 {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-h1\" viewBox=\"0 0 16 16\"><path d=\"M8.637 13V3.669H7.379V7.62H2.758V3.67H1.5V13h1.258V8.728h4.62V13h1.259zm5.329 0V3.669h-1.244L10.5 5.316v1.265l2.16-1.565h.062V13h1.244z\"/></svg>');\n  /* background-image: url(images/icons/type-h1.svg); */\n}\n\n.icon.small-heading,\n.icon.h2 {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-h2\" viewBox=\"0 0 16 16\"><path d=\"M7.638 13V3.669H6.38V7.62H1.759V3.67H.5V13h1.258V8.728h4.62V13h1.259zm3.022-6.733v-.048c0-.889.63-1.668 1.716-1.668.957 0 1.675.608 1.675 1.572 0 .855-.554 1.504-1.067 2.085l-3.513 3.999V13H15.5v-1.094h-4.245v-.075l2.481-2.844c.875-.998 1.586-1.784 1.586-2.953 0-1.463-1.155-2.556-2.919-2.556-1.941 0-2.966 1.326-2.966 2.74v.049h1.223z\"/></svg>');\n  /* background-image: url(images/icons/type-h2.svg); */\n}\n\n.icon.bullet-list,\n.icon.ul {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-list-ul\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm-3 1a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2zm0 4a1 1 0 1 0 0-2 1 1 0 0 0 0 2z\"/></svg>');\n  /* background-image: url(images/icons/list-ul.svg); */\n}\n\n.icon.numbered-list,\n.icon.ol {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-list-ol\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M5 11.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zm0-4a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5z\"/><path d=\"M1.713 11.865v-.474H2c.217 0 .363-.137.363-.317 0-.185-.158-.31-.361-.31-.223 0-.367.152-.373.31h-.59c.016-.467.373-.787.986-.787.588-.002.954.291.957.703a.595.595 0 0 1-.492.594v.033a.615.615 0 0 1 .569.631c.003.533-.502.8-1.051.8-.656 0-1-.37-1.008-.794h.582c.008.178.186.306.422.309.254 0 .424-.145.422-.35-.002-.195-.155-.348-.414-.348h-.3zm-.004-4.699h-.604v-.035c0-.408.295-.844.958-.844.583 0 .96.326.96.756 0 .389-.257.617-.476.848l-.537.572v.03h1.054V9H1.143v-.395l.957-.99c.138-.142.293-.304.293-.508 0-.18-.147-.32-.342-.32a.33.33 0 0 0-.342.338v.041zM2.564 5h-.635V2.924h-.031l-.598.42v-.567l.629-.443h.635V5z\"/></svg>');\n  /* background-image: url(images/icons/list-ol.svg); */\n}\n\n.icon.quote {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-chat-square-quote\" viewBox=\"0 0 16 16\"><path d=\"M14 1a1 1 0 0 1 1 1v8a1 1 0 0 1-1 1h-2.5a2 2 0 0 0-1.6.8L8 14.333 6.1 11.8a2 2 0 0 0-1.6-.8H2a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1h12zM2 0a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2h2.5a1 1 0 0 1 .8.4l1.9 2.533a1 1 0 0 0 1.6 0l1.9-2.533a1 1 0 0 1 .8-.4H14a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z\"/><path d=\"M7.066 4.76A1.665 1.665 0 0 0 4 5.668a1.667 1.667 0 0 0 2.561 1.406c-.131.389-.375.804-.777 1.22a.417.417 0 1 0 .6.58c1.486-1.54 1.293-3.214.682-4.112zm4 0A1.665 1.665 0 0 0 8 5.668a1.667 1.667 0 0 0 2.561 1.406c-.131.389-.375.804-.777 1.22a.417.417 0 1 0 .6.58c1.486-1.54 1.293-3.214.682-4.112z\"/></svg>');\n  /* background-image: url(images/icons/chat-square-quote.svg); */\n}\n\n.icon.code {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-code\" viewBox=\"0 0 16 16\"><path d=\"M5.854 4.854a.5.5 0 1 0-.708-.708l-3.5 3.5a.5.5 0 0 0 0 .708l3.5 3.5a.5.5 0 0 0 .708-.708L2.707 8l3.147-3.146zm4.292 0a.5.5 0 0 1 .708-.708l3.5 3.5a.5.5 0 0 1 0 .708l-3.5 3.5a.5.5 0 0 1-.708-.708L13.293 8l-3.147-3.146z\"/></svg>');\n  /* background-image: url(images/icons/code.svg); */\n}\n\ni.bold {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-bold\" viewBox=\"0 0 16 16\"><path d=\"M8.21 13c2.106 0 3.412-1.087 3.412-2.823 0-1.306-.984-2.283-2.324-2.386v-.055a2.176 2.176 0 0 0 1.852-2.14c0-1.51-1.162-2.46-3.014-2.46H3.843V13H8.21zM5.908 4.674h1.696c.963 0 1.517.451 1.517 1.244 0 .834-.629 1.32-1.73 1.32H5.908V4.673zm0 6.788V8.598h1.73c1.217 0 1.88.492 1.88 1.415 0 .943-.643 1.449-1.832 1.449H5.907z\"/></svg>');\n  /* background-image: url(images/icons/type-bold.svg); */\n}\n\ni.italic {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-italic\" viewBox=\"0 0 16 16\"><path d=\"M7.991 11.674 9.53 4.455c.123-.595.246-.71 1.347-.807l.11-.52H7.211l-.11.52c1.06.096 1.128.212 1.005.807L6.57 11.674c-.123.595-.246.71-1.346.806l-.11.52h3.774l.11-.52c-1.06-.095-1.129-.211-1.006-.806z\"/></svg>');\n  /* background-image: url(images/icons/type-italic.svg); */\n}\n\ni.underline {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-underline\" viewBox=\"0 0 16 16\"><path d=\"M5.313 3.136h-1.23V9.54c0 2.105 1.47 3.623 3.917 3.623s3.917-1.518 3.917-3.623V3.136h-1.23v6.323c0 1.49-.978 2.57-2.687 2.57-1.709 0-2.687-1.08-2.687-2.57V3.136zM12.5 15h-9v-1h9v1z\"/></svg>');\n  /* background-image: url(images/icons/type-underline.svg); */\n}\n\ni.strikethrough {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-type-strikethrough\" viewBox=\"0 0 16 16\"><path d=\"M6.333 5.686c0 .31.083.581.27.814H5.166a2.776 2.776 0 0 1-.099-.76c0-1.627 1.436-2.768 3.48-2.768 1.969 0 3.39 1.175 3.445 2.85h-1.23c-.11-1.08-.964-1.743-2.25-1.743-1.23 0-2.18.602-2.18 1.607zm2.194 7.478c-2.153 0-3.589-1.107-3.705-2.81h1.23c.144 1.06 1.129 1.703 2.544 1.703 1.34 0 2.31-.705 2.31-1.675 0-.827-.547-1.374-1.914-1.675L8.046 8.5H1v-1h14v1h-3.504c.468.437.675.994.675 1.697 0 1.826-1.436 2.967-3.644 2.967z\"/></svg>');\n  /* background-image: url(images/icons/type-strikethrough.svg); */\n}\n\ni.code {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-code\" viewBox=\"0 0 16 16\"><path d=\"M5.854 4.854a.5.5 0 1 0-.708-.708l-3.5 3.5a.5.5 0 0 0 0 .708l3.5 3.5a.5.5 0 0 0 .708-.708L2.707 8l3.147-3.146zm4.292 0a.5.5 0 0 1 .708-.708l3.5 3.5a.5.5 0 0 1 0 .708l-3.5 3.5a.5.5 0 0 1-.708-.708L13.293 8l-3.147-3.146z\"/></svg>');\n  /* background-image: url(images/icons/code.svg); */\n}\n\ni.link {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-link\" viewBox=\"0 0 16 16\"><path d=\"M6.354 5.5H4a3 3 0 0 0 0 6h3a3 3 0 0 0 2.83-4H9c-.086 0-.17.01-.25.031A2 2 0 0 1 7 10.5H4a2 2 0 1 1 0-4h1.535c.218-.376.495-.714.82-1z\"/><path d=\"M9 5.5a3 3 0 0 0-2.83 4h1.098A2 2 0 0 1 9 6.5h3a2 2 0 1 1 0 4h-1.535a4.02 4.02 0 0 1-.82 1H12a3 3 0 1 0 0-6H9z\"/></svg>');\n  /* background-image: url(images/icons/link.svg); */\n}\n\ni.left-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-left\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-left.svg); */\n}\n\ni.center-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-center\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M4 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-2-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm2-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-2-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-center.svg); */\n}\n\ni.right-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-text-right\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M6 12.5a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-4-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm4-3a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zm-4-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/text-right.svg); */\n}\n\ni.justify-align {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-justify\" viewBox=\"0 0 16 16\"><path fill-rule=\"evenodd\" d=\"M2 12.5a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5zm0-3a.5.5 0 0 1 .5-.5h11a.5.5 0 0 1 0 1h-11a.5.5 0 0 1-.5-.5z\"/></svg>');\n  /* background-image: url(images/icons/justify.svg); */\n}\n\n.editor-list-ol {\n  list-style-type: decimal !important;\n}\n\n.editor-list-ul {\n  list-style-type: disc !important;\n}\n\ni.video {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-file-play\" viewBox=\"0 0 16 16\"><path d=\"M6 10.117V5.883a.5.5 0 0 1 .757-.429l3.528 2.117a.5.5 0 0 1 0 .858l-3.528 2.117a.5.5 0 0 1-.757-.43z\"/><path d=\"M4 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H4zm0 1h8a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1H4a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1z\"/></svg>');\n  /* background-image: url(images/icons/video.svg); */\n}\n\ni.image {\n  background-image: url('data:image/svg+xml,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-file-earmark-image\" viewBox=\"0 0 16 16\"><path d=\"M6.502 7a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3z\"/><path d=\"M14 14a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h5.5L14 4.5V14zM4 1a1 1 0 0 0-1 1v10l2.224-2.224a.5.5 0 0 1 .61-.075L8 11l2.157-3.02a.5.5 0 0 1 .76-.063L13 10V4.5h-2A1.5 1.5 0 0 1 9.5 3V1H4z\"/></svg>');\n  /* background-image: url(images/icons/image.svg); */\n}\n\n.editor-img {\n  /* background:url(images/icons/img-holder.svg) no-repeat scroll 0 0;  */\n}\n\n.changes_add span{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n.changes_add div{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n.changes_add p{\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  text-decoration: underline;\n}\n\n\n.changes_remove div{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n\n.changes_remove span{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n.changes_remove p{\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  text-decoration: line-through;\n}\n\n.changes_add::before {\n  content: '+';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_remove::before {\n  content: '-';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_add::after {\n  content: '...';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n.changes_remove::after {\n  content: '...';\n  display: block;\n  margin-bottom: 8px; \n  margin-top: 8px;\n  font-size: 20px;\n}\n\n.changes_section{\n  margin-top:  12px;\n  margin-bottom: 12px;\n}\n\n.changes_remove img {\n  background-color: rgba(255, 0, 0, 0.2) !important;\n  padding: 20px; \n}\n.changes_add img {\n  background-color: rgba(0, 255, 0, 0.2) !important;\n  padding: 20px; \n}";
styleInject(css_248z);

const exampleTheme = {
    ltr: "ltr",
    rtl: "rtl",
    placeholder: "editor-placeholder",
    paragraph: "editor-paragraph",
    quote: "editor-quote",
    heading: {
        h1: "editor-heading-h1",
        h2: "editor-heading-h2",
        h3: "editor-heading-h3",
        h4: "editor-heading-h4",
        h5: "editor-heading-h5"
    },
    list: {
        nested: {
            listitem: "editor-nested-listitem"
        },
        ol: "editor-list-ol",
        ul: "editor-list-ul",
        listitem: "editor-listitem"
    },
    image: "editor-image",
    link: "editor-link",
    text: {
        bold: "editor-text-bold",
        italic: "editor-text-italic",
        overflowed: "editor-text-overflowed",
        hashtag: "editor-text-hashtag",
        underline: "editor-text-underline",
        strikethrough: "editor-text-strikethrough",
        underlineStrikethrough: "editor-text-underlineStrikethrough",
        code: "editor-text-code"
    },
    code: "editor-code",
    codeHighlight: {
        atrule: "editor-tokenAttr",
        attr: "editor-tokenAttr",
        boolean: "editor-tokenProperty",
        builtin: "editor-tokenSelector",
        cdata: "editor-tokenComment",
        char: "editor-tokenSelector",
        class: "editor-tokenFunction",
        "class-name": "editor-tokenFunction",
        comment: "editor-tokenComment",
        constant: "editor-tokenProperty",
        deleted: "editor-tokenProperty",
        doctype: "editor-tokenComment",
        entity: "editor-tokenOperator",
        function: "editor-tokenFunction",
        important: "editor-tokenVariable",
        inserted: "editor-tokenSelector",
        keyword: "editor-tokenAttr",
        namespace: "editor-tokenVariable",
        number: "editor-tokenProperty",
        operator: "editor-tokenOperator",
        prolog: "editor-tokenComment",
        property: "editor-tokenProperty",
        punctuation: "editor-tokenPunctuation",
        regex: "editor-tokenVariable",
        selector: "editor-tokenSelector",
        string: "editor-tokenSelector",
        symbol: "editor-tokenProperty",
        tag: "editor-tokenProperty",
        url: "editor-tokenOperator",
        variable: "editor-tokenVariable"
    }
};

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

var LexicalLink_dev = {};

var LexicalUtils_dev = {};

var LexicalSelection_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalSelection_dev;

function requireLexicalSelection_dev () {
	if (hasRequiredLexicalSelection_dev) return LexicalSelection_dev;
	hasRequiredLexicalSelection_dev = 1;

	var lexical = require$$0__default["default"];

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const CSS_TO_STYLES = new Map();

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	function getDOMTextNode(element) {
	  let node = element;

	  while (node != null) {
	    if (node.nodeType === Node.TEXT_NODE) {
	      return node;
	    }

	    node = node.firstChild;
	  }

	  return null;
	}

	function getDOMIndexWithinParent(node) {
	  const parent = node.parentNode;

	  if (parent == null) {
	    throw new Error('Should never happen');
	  }

	  return [parent, Array.from(parent.childNodes).indexOf(node)];
	}
	/**
	 * Creates a selection range for the DOM.
	 * @param editor - The lexical editor.
	 * @param anchorNode - The anchor node of a selection.
	 * @param _anchorOffset - The amount of space offset from the anchor to the focus.
	 * @param focusNode - The current focus.
	 * @param _focusOffset - The amount of space offset from the focus to the anchor.
	 * @returns The range of selection for the DOM that was created.
	 */


	function createDOMRange(editor, anchorNode, _anchorOffset, focusNode, _focusOffset) {
	  const anchorKey = anchorNode.getKey();
	  const focusKey = focusNode.getKey();
	  const range = document.createRange();
	  let anchorDOM = editor.getElementByKey(anchorKey);
	  let focusDOM = editor.getElementByKey(focusKey);
	  let anchorOffset = _anchorOffset;
	  let focusOffset = _focusOffset;

	  if (lexical.$isTextNode(anchorNode)) {
	    anchorDOM = getDOMTextNode(anchorDOM);
	  }

	  if (lexical.$isTextNode(focusNode)) {
	    focusDOM = getDOMTextNode(focusDOM);
	  }

	  if (anchorNode === undefined || focusNode === undefined || anchorDOM === null || focusDOM === null) {
	    return null;
	  }

	  if (anchorDOM.nodeName === 'BR') {
	    [anchorDOM, anchorOffset] = getDOMIndexWithinParent(anchorDOM);
	  }

	  if (focusDOM.nodeName === 'BR') {
	    [focusDOM, focusOffset] = getDOMIndexWithinParent(focusDOM);
	  }

	  const firstChild = anchorDOM.firstChild;

	  if (anchorDOM === focusDOM && firstChild != null && firstChild.nodeName === 'BR' && anchorOffset === 0 && focusOffset === 0) {
	    focusOffset = 1;
	  }

	  try {
	    range.setStart(anchorDOM, anchorOffset);
	    range.setEnd(focusDOM, focusOffset);
	  } catch (e) {
	    return null;
	  }

	  if (range.collapsed && (anchorOffset !== focusOffset || anchorKey !== focusKey)) {
	    // Range is backwards, we need to reverse it
	    range.setStart(focusDOM, focusOffset);
	    range.setEnd(anchorDOM, anchorOffset);
	  }

	  return range;
	}
	/**
	 * Creates DOMRects, generally used to help the editor find a specific location on the screen.
	 * @param editor - The lexical editor
	 * @param range - A fragment of a document that can contain nodes and parts of text nodes.
	 * @returns The selectionRects as an array.
	 */

	function createRectsFromDOMRange(editor, range) {
	  const rootElement = editor.getRootElement();

	  if (rootElement === null) {
	    return [];
	  }

	  const rootRect = rootElement.getBoundingClientRect();
	  const computedStyle = getComputedStyle(rootElement);
	  const rootPadding = parseFloat(computedStyle.paddingLeft) + parseFloat(computedStyle.paddingRight);
	  const selectionRects = Array.from(range.getClientRects());
	  let selectionRectsLength = selectionRects.length; //sort rects from top left to bottom right.

	  selectionRects.sort((a, b) => {
	    const top = a.top - b.top; // Some rects match position closely, but not perfectly,
	    // so we give a 3px tolerance.

	    if (Math.abs(top) <= 3) {
	      return a.left - b.left;
	    }

	    return top;
	  });
	  let prevRect;

	  for (let i = 0; i < selectionRectsLength; i++) {
	    const selectionRect = selectionRects[i]; // Exclude rects that overlap preceding Rects in the sorted list.

	    const isOverlappingRect = prevRect && prevRect.top <= selectionRect.top && prevRect.top + prevRect.height > selectionRect.top && prevRect.left + prevRect.width > selectionRect.left; // Exclude selections that span the entire element

	    const selectionSpansElement = selectionRect.width + rootPadding === rootRect.width;

	    if (isOverlappingRect || selectionSpansElement) {
	      selectionRects.splice(i--, 1);
	      selectionRectsLength--;
	      continue;
	    }

	    prevRect = selectionRect;
	  }

	  return selectionRects;
	}
	/**
	 * Creates an object containing all the styles and their values provided in the CSS string.
	 * @param css - The CSS string of styles and their values.
	 * @returns The styleObject containing all the styles and their values.
	 */

	function getStyleObjectFromRawCSS(css) {
	  const styleObject = {};
	  const styles = css.split(';');

	  for (const style of styles) {
	    if (style !== '') {
	      const [key, value] = style.split(/:([^]+)/); // split on first colon

	      styleObject[key.trim()] = value.trim();
	    }
	  }

	  return styleObject;
	}
	/**
	 * Given a CSS string, returns an object from the style cache.
	 * @param css - The CSS property as a string.
	 * @returns The value of the given CSS property.
	 */

	function getStyleObjectFromCSS(css) {
	  let value = CSS_TO_STYLES.get(css);

	  if (value === undefined) {
	    value = getStyleObjectFromRawCSS(css);
	    CSS_TO_STYLES.set(css, value);
	  }

	  {
	    // Freeze the value in DEV to prevent accidental mutations
	    Object.freeze(value);
	  }

	  return value;
	}
	/**
	 * Gets the CSS styles from the style object.
	 * @param styles - The style object containing the styles to get.
	 * @returns A string containing the CSS styles and their values.
	 */

	function getCSSFromStyleObject(styles) {
	  let css = '';

	  for (const style in styles) {
	    if (style) {
	      css += `${style}: ${styles[style]};`;
	    }
	  }

	  return css;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	function $updateElementNodeProperties(target, source) {
	  target.__first = source.__first;
	  target.__last = source.__last;
	  target.__size = source.__size;
	  target.__format = source.__format;
	  target.__indent = source.__indent;
	  target.__dir = source.__dir;
	  return target;
	}

	function $updateTextNodeProperties(target, source) {
	  target.__format = source.__format;
	  target.__style = source.__style;
	  target.__mode = source.__mode;
	  target.__detail = source.__detail;
	  return target;
	}
	/**
	 * Returns a copy of a node, but generates a new key for the copy.
	 * @param node - The node to be cloned.
	 * @returns The clone of the node.
	 */


	function $cloneWithProperties(node) {
	  const latest = node.getLatest();
	  const constructor = latest.constructor; // @ts-expect-error

	  const clone = constructor.clone(latest);
	  clone.__parent = latest.__parent;
	  clone.__next = latest.__next;
	  clone.__prev = latest.__prev;

	  if (lexical.$isElementNode(latest) && lexical.$isElementNode(clone)) {
	    return $updateElementNodeProperties(clone, latest);
	  }

	  if (lexical.$isTextNode(latest) && lexical.$isTextNode(clone)) {
	    return $updateTextNodeProperties(clone, latest);
	  }

	  return clone;
	}
	/**
	 * Generally used to append text content to HTML and JSON. Grabs the text content and "slices"
	 * it to be generated into the new TextNode.
	 * @param selection - The selection containing the node whose TextNode is to be edited.
	 * @param textNode - The TextNode to be edited.
	 * @returns The updated TextNode.
	 */

	function $sliceSelectedTextNodeContent(selection, textNode) {
	  if (textNode.isSelected() && !textNode.isSegmented() && !textNode.isToken() && (lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    const anchorNode = selection.anchor.getNode();
	    const focusNode = selection.focus.getNode();
	    const isAnchor = textNode.is(anchorNode);
	    const isFocus = textNode.is(focusNode);

	    if (isAnchor || isFocus) {
	      const isBackward = selection.isBackward();
	      const [anchorOffset, focusOffset] = selection.getCharacterOffsets();
	      const isSame = anchorNode.is(focusNode);
	      const isFirst = textNode.is(isBackward ? focusNode : anchorNode);
	      const isLast = textNode.is(isBackward ? anchorNode : focusNode);
	      let startOffset = 0;
	      let endOffset = undefined;

	      if (isSame) {
	        startOffset = anchorOffset > focusOffset ? focusOffset : anchorOffset;
	        endOffset = anchorOffset > focusOffset ? anchorOffset : focusOffset;
	      } else if (isFirst) {
	        const offset = isBackward ? focusOffset : anchorOffset;
	        startOffset = offset;
	        endOffset = undefined;
	      } else if (isLast) {
	        const offset = isBackward ? anchorOffset : focusOffset;
	        startOffset = 0;
	        endOffset = offset;
	      }

	      textNode.__text = textNode.__text.slice(startOffset, endOffset);
	      return textNode;
	    }
	  }

	  return textNode;
	}
	/**
	 * Determines if the current selection is at the end of the node.
	 * @param point - The point of the selection to test.
	 * @returns true if the provided point offset is in the last possible position, false otherwise.
	 */

	function $isAtNodeEnd(point) {
	  if (point.type === 'text') {
	    return point.offset === point.getNode().getTextContentSize();
	  }

	  return point.offset === point.getNode().getChildrenSize();
	}
	/**
	 * Trims text from a node in order to shorten it, eg. to enforce a text's max length. If it deletes text
	 * that is an ancestor of the anchor then it will leave 2 indents, otherwise, if no text content exists, it deletes
	 * the TextNode. It will move the focus to either the end of any left over text or beginning of a new TextNode.
	 * @param editor - The lexical editor.
	 * @param anchor - The anchor of the current selection, where the selection should be pointing.
	 * @param delCount - The amount of characters to delete. Useful as a dynamic variable eg. textContentSize - maxLength;
	 */

	function trimTextContentFromAnchor(editor, anchor, delCount) {
	  // Work from the current selection anchor point
	  let currentNode = anchor.getNode();
	  let remaining = delCount;

	  if (lexical.$isElementNode(currentNode)) {
	    const descendantNode = currentNode.getDescendantByIndex(anchor.offset);

	    if (descendantNode !== null) {
	      currentNode = descendantNode;
	    }
	  }

	  while (remaining > 0 && currentNode !== null) {
	    let nextNode = currentNode.getPreviousSibling();
	    let additionalElementWhitespace = 0;

	    if (nextNode === null) {
	      let parent = currentNode.getParentOrThrow();
	      let parentSibling = parent.getPreviousSibling();

	      while (parentSibling === null) {
	        parent = parent.getParent();

	        if (parent === null) {
	          nextNode = null;
	          break;
	        }

	        parentSibling = parent.getPreviousSibling();
	      }

	      if (parent !== null) {
	        additionalElementWhitespace = parent.isInline() ? 0 : 2;

	        if (lexical.$isElementNode(parentSibling)) {
	          nextNode = parentSibling.getLastDescendant();
	        } else {
	          nextNode = parentSibling;
	        }
	      }
	    }

	    let text = currentNode.getTextContent(); // If the text is empty, we need to consider adding in two line breaks to match
	    // the content if we were to get it from its parent.

	    if (text === '' && lexical.$isElementNode(currentNode) && !currentNode.isInline()) {
	      // TODO: should this be handled in core?
	      text = '\n\n';
	    }

	    const currentNodeSize = currentNode.getTextContentSize();

	    if (!lexical.$isTextNode(currentNode) || remaining >= currentNodeSize) {
	      const parent = currentNode.getParent();
	      currentNode.remove();

	      if (parent != null && parent.getChildrenSize() === 0 && !lexical.$isRootNode(parent)) {
	        parent.remove();
	      }

	      remaining -= currentNodeSize + additionalElementWhitespace;
	      currentNode = nextNode;
	    } else {
	      const key = currentNode.getKey(); // See if we can just revert it to what was in the last editor state

	      const prevTextContent = editor.getEditorState().read(() => {
	        const prevNode = lexical.$getNodeByKey(key);

	        if (lexical.$isTextNode(prevNode) && prevNode.isSimpleText()) {
	          return prevNode.getTextContent();
	        }

	        return null;
	      });
	      const offset = currentNodeSize - remaining;
	      const slicedText = text.slice(0, offset);

	      if (prevTextContent !== null && prevTextContent !== text) {
	        const prevSelection = lexical.$getPreviousSelection();
	        let target = currentNode;

	        if (!currentNode.isSimpleText()) {
	          const textNode = lexical.$createTextNode(prevTextContent);
	          currentNode.replace(textNode);
	          target = textNode;
	        } else {
	          currentNode.setTextContent(prevTextContent);
	        }

	        if (lexical.$isRangeSelection(prevSelection) && prevSelection.isCollapsed()) {
	          const prevOffset = prevSelection.anchor.offset;
	          target.select(prevOffset, prevOffset);
	        }
	      } else if (currentNode.isSimpleText()) {
	        // Split text
	        const isSelected = anchor.key === key;
	        let anchorOffset = anchor.offset; // Move offset to end if it's less than the remaining number, otherwise
	        // we'll have a negative splitStart.

	        if (anchorOffset < remaining) {
	          anchorOffset = currentNodeSize;
	        }

	        const splitStart = isSelected ? anchorOffset - remaining : 0;
	        const splitEnd = isSelected ? anchorOffset : offset;

	        if (isSelected && splitStart === 0) {
	          const [excessNode] = currentNode.splitText(splitStart, splitEnd);
	          excessNode.remove();
	        } else {
	          const [, excessNode] = currentNode.splitText(splitStart, splitEnd);
	          excessNode.remove();
	        }
	      } else {
	        const textNode = lexical.$createTextNode(slicedText);
	        currentNode.replace(textNode);
	      }

	      remaining = 0;
	    }
	  }
	}
	/**
	 * Gets the TextNode's style object and adds the styles to the CSS.
	 * @param node - The TextNode to add styles to.
	 */

	function $addNodeStyle(node) {
	  const CSSText = node.getStyle();
	  const styles = getStyleObjectFromRawCSS(CSSText);
	  CSS_TO_STYLES.set(CSSText, styles);
	}

	function $patchStyle(target, patch) {
	  const prevStyles = getStyleObjectFromCSS('getStyle' in target ? target.getStyle() : target.style);
	  const newStyles = Object.entries(patch).reduce((styles, [key, value]) => {
	    if (value === null) {
	      delete styles[key];
	    } else {
	      styles[key] = value;
	    }

	    return styles;
	  }, { ...prevStyles
	  } || {});
	  const newCSSText = getCSSFromStyleObject(newStyles);
	  target.setStyle(newCSSText);
	  CSS_TO_STYLES.set(newCSSText, newStyles);
	}
	/**
	 * Applies the provided styles to the TextNodes in the provided Selection.
	 * Will update partially selected TextNodes by splitting the TextNode and applying
	 * the styles to the appropriate one.
	 * @param selection - The selected node(s) to update.
	 * @param patch - The patch to apply, which can include multiple styles. { CSSProperty: value }
	 */


	function $patchStyleText(selection, patch) {
	  const selectedNodes = selection.getNodes();
	  const selectedNodesLength = selectedNodes.length;
	  const lastIndex = selectedNodesLength - 1;
	  let firstNode = selectedNodes[0];
	  let lastNode = selectedNodes[lastIndex];

	  if (selection.isCollapsed()) {
	    $patchStyle(selection, patch);
	    return;
	  }

	  const anchor = selection.anchor;
	  const focus = selection.focus;
	  const firstNodeText = firstNode.getTextContent();
	  const firstNodeTextLength = firstNodeText.length;
	  const focusOffset = focus.offset;
	  let anchorOffset = anchor.offset;
	  const isBefore = anchor.isBefore(focus);
	  let startOffset = isBefore ? anchorOffset : focusOffset;
	  let endOffset = isBefore ? focusOffset : anchorOffset;
	  const startType = isBefore ? anchor.type : focus.type;
	  const endType = isBefore ? focus.type : anchor.type;
	  const endKey = isBefore ? focus.key : anchor.key; // This is the case where the user only selected the very end of the
	  // first node so we don't want to include it in the formatting change.

	  if (lexical.$isTextNode(firstNode) && startOffset === firstNodeTextLength) {
	    const nextSibling = firstNode.getNextSibling();

	    if (lexical.$isTextNode(nextSibling)) {
	      // we basically make the second node the firstNode, changing offsets accordingly
	      anchorOffset = 0;
	      startOffset = 0;
	      firstNode = nextSibling;
	    }
	  } // This is the case where we only selected a single node


	  if (selectedNodes.length === 1) {
	    if (lexical.$isTextNode(firstNode)) {
	      startOffset = startType === 'element' ? 0 : anchorOffset > focusOffset ? focusOffset : anchorOffset;
	      endOffset = endType === 'element' ? firstNodeTextLength : anchorOffset > focusOffset ? anchorOffset : focusOffset; // No actual text is selected, so do nothing.

	      if (startOffset === endOffset) {
	        return;
	      } // The entire node is selected, so just format it


	      if (startOffset === 0 && endOffset === firstNodeTextLength) {
	        $patchStyle(firstNode, patch);
	        firstNode.select(startOffset, endOffset);
	      } else {
	        // The node is partially selected, so split it into two nodes
	        // and style the selected one.
	        const splitNodes = firstNode.splitText(startOffset, endOffset);
	        const replacement = startOffset === 0 ? splitNodes[0] : splitNodes[1];
	        $patchStyle(replacement, patch);
	        replacement.select(0, endOffset - startOffset);
	      }
	    } // multiple nodes selected.

	  } else {
	    if (lexical.$isTextNode(firstNode) && startOffset < firstNode.getTextContentSize()) {
	      if (startOffset !== 0) {
	        // the entire first node isn't selected, so split it
	        firstNode = firstNode.splitText(startOffset)[1];
	        startOffset = 0;
	      }

	      $patchStyle(firstNode, patch);
	    }

	    if (lexical.$isTextNode(lastNode)) {
	      const lastNodeText = lastNode.getTextContent();
	      const lastNodeTextLength = lastNodeText.length; // The last node might not actually be the end node
	      //
	      // If not, assume the last node is fully-selected unless the end offset is
	      // zero.

	      if (lastNode.__key !== endKey && endOffset !== 0) {
	        endOffset = lastNodeTextLength;
	      } // if the entire last node isn't selected, split it


	      if (endOffset !== lastNodeTextLength) {
	        [lastNode] = lastNode.splitText(endOffset);
	      }

	      if (endOffset !== 0) {
	        $patchStyle(lastNode, patch);
	      }
	    } // style all the text nodes in between


	    for (let i = 1; i < lastIndex; i++) {
	      const selectedNode = selectedNodes[i];
	      const selectedNodeKey = selectedNode.getKey();

	      if (lexical.$isTextNode(selectedNode) && selectedNodeKey !== firstNode.getKey() && selectedNodeKey !== lastNode.getKey() && !selectedNode.isToken()) {
	        $patchStyle(selectedNode, patch);
	      }
	    }
	  }
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	/**
	 * Converts all nodes in the selection that are of one block type to another.
	 * @param selection - The selected blocks to be converted.
	 * @param createElement - The function that creates the node. eg. $createParagraphNode.
	 */

	function $setBlocksType(selection, createElement) {
	  if (selection.anchor.key === 'root') {
	    const element = createElement();
	    const root = lexical.$getRoot();
	    const firstChild = root.getFirstChild();

	    if (firstChild) {
	      firstChild.replace(element, true);
	    } else {
	      root.append(element);
	    }

	    return;
	  }

	  const nodes = selection.getNodes();
	  let maybeBlock = selection.anchor.getNode().getParentOrThrow();

	  if (nodes.indexOf(maybeBlock) === -1) {
	    nodes.push(maybeBlock);
	  }

	  if (maybeBlock.isInline()) {
	    maybeBlock = maybeBlock.getParentOrThrow();

	    if (nodes.indexOf(maybeBlock) === -1) {
	      nodes.push(maybeBlock);
	    }
	  }

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];

	    if (!isBlock(node)) {
	      continue;
	    }

	    const targetElement = createElement();
	    targetElement.setFormat(node.getFormatType());
	    targetElement.setIndent(node.getIndent());
	    node.replace(targetElement, true);
	  }
	}

	function isBlock(node) {
	  if (!lexical.$isElementNode(node) || lexical.$isRootOrShadowRoot(node)) {
	    return false;
	  }

	  const firstChild = node.getFirstChild();
	  const isLeafElement = firstChild === null || lexical.$isLineBreakNode(firstChild) || lexical.$isTextNode(firstChild) || firstChild.isInline();
	  return !node.isInline() && node.canBeEmpty() !== false && isLeafElement;
	}

	function isPointAttached(point) {
	  return point.getNode().isAttached();
	}

	function $removeParentEmptyElements(startingNode) {
	  let node = startingNode;

	  while (node !== null && !lexical.$isRootOrShadowRoot(node)) {
	    const latest = node.getLatest();
	    const parentNode = node.getParent();

	    if (latest.getChildrenSize() === 0) {
	      node.remove(true);
	    }

	    node = parentNode;
	  }
	}
	/**
	 * @deprecated
	 * Wraps all nodes in the selection into another node of the type returned by createElement.
	 * @param selection - The selection of nodes to be wrapped.
	 * @param createElement - A function that creates the wrapping ElementNode. eg. $createParagraphNode.
	 * @param wrappingElement - An element to append the wrapped selection and its children to.
	 */


	function $wrapNodes(selection, createElement, wrappingElement = null) {
	  const nodes = selection.getNodes();
	  const nodesLength = nodes.length;
	  const anchor = selection.anchor;

	  if (nodesLength === 0 || nodesLength === 1 && anchor.type === 'element' && anchor.getNode().getChildrenSize() === 0) {
	    const target = anchor.type === 'text' ? anchor.getNode().getParentOrThrow() : anchor.getNode();
	    const children = target.getChildren();
	    let element = createElement();
	    element.setFormat(target.getFormatType());
	    element.setIndent(target.getIndent());
	    children.forEach(child => element.append(child));

	    if (wrappingElement) {
	      element = wrappingElement.append(element);
	    }

	    target.replace(element);
	    return;
	  }

	  let topLevelNode = null;
	  let descendants = [];

	  for (let i = 0; i < nodesLength; i++) {
	    const node = nodes[i]; // Determine whether wrapping has to be broken down into multiple chunks. This can happen if the
	    // user selected multiple Root-like nodes that have to be treated separately as if they are
	    // their own branch. I.e. you don't want to wrap a whole table, but rather the contents of each
	    // of each of the cell nodes.

	    if (lexical.$isRootOrShadowRoot(node)) {
	      $wrapNodesImpl(selection, descendants, descendants.length, createElement, wrappingElement);
	      descendants = [];
	      topLevelNode = node;
	    } else if (topLevelNode === null || topLevelNode !== null && lexical.$hasAncestor(node, topLevelNode)) {
	      descendants.push(node);
	    } else {
	      $wrapNodesImpl(selection, descendants, descendants.length, createElement, wrappingElement);
	      descendants = [node];
	    }
	  }

	  $wrapNodesImpl(selection, descendants, descendants.length, createElement, wrappingElement);
	}
	/**
	 * Wraps each node into a new ElementNode.
	 * @param selection - The selection of nodes to wrap.
	 * @param nodes - An array of nodes, generally the descendants of the selection.
	 * @param nodesLength - The length of nodes.
	 * @param createElement - A function that creates the wrapping ElementNode. eg. $createParagraphNode.
	 * @param wrappingElement - An element to wrap all the nodes into.
	 * @returns
	 */

	function $wrapNodesImpl(selection, nodes, nodesLength, createElement, wrappingElement = null) {
	  if (nodes.length === 0) {
	    return;
	  }

	  const firstNode = nodes[0];
	  const elementMapping = new Map();
	  const elements = []; // The below logic is to find the right target for us to
	  // either insertAfter/insertBefore/append the corresponding
	  // elements to. This is made more complicated due to nested
	  // structures.

	  let target = lexical.$isElementNode(firstNode) ? firstNode : firstNode.getParentOrThrow();

	  if (target.isInline()) {
	    target = target.getParentOrThrow();
	  }

	  let targetIsPrevSibling = false;

	  while (target !== null) {
	    const prevSibling = target.getPreviousSibling();

	    if (prevSibling !== null) {
	      target = prevSibling;
	      targetIsPrevSibling = true;
	      break;
	    }

	    target = target.getParentOrThrow();

	    if (lexical.$isRootOrShadowRoot(target)) {
	      break;
	    }
	  }

	  const emptyElements = new Set(); // Find any top level empty elements

	  for (let i = 0; i < nodesLength; i++) {
	    const node = nodes[i];

	    if (lexical.$isElementNode(node) && node.getChildrenSize() === 0) {
	      emptyElements.add(node.getKey());
	    }
	  }

	  const movedNodes = new Set(); // Move out all leaf nodes into our elements array.
	  // If we find a top level empty element, also move make
	  // an element for that.

	  for (let i = 0; i < nodesLength; i++) {
	    const node = nodes[i];
	    let parent = node.getParent();

	    if (parent !== null && parent.isInline()) {
	      parent = parent.getParent();
	    }

	    if (parent !== null && lexical.$isLeafNode(node) && !movedNodes.has(node.getKey())) {
	      const parentKey = parent.getKey();

	      if (elementMapping.get(parentKey) === undefined) {
	        const targetElement = createElement();
	        targetElement.setFormat(parent.getFormatType());
	        targetElement.setIndent(parent.getIndent());
	        elements.push(targetElement);
	        elementMapping.set(parentKey, targetElement); // Move node and its siblings to the new
	        // element.

	        parent.getChildren().forEach(child => {
	          targetElement.append(child);
	          movedNodes.add(child.getKey());

	          if (lexical.$isElementNode(child)) {
	            // Skip nested leaf nodes if the parent has already been moved
	            child.getChildrenKeys().forEach(key => movedNodes.add(key));
	          }
	        });
	        $removeParentEmptyElements(parent);
	      }
	    } else if (emptyElements.has(node.getKey())) {
	      const targetElement = createElement();
	      targetElement.setFormat(node.getFormatType());
	      targetElement.setIndent(node.getIndent());
	      elements.push(targetElement);
	      node.remove(true);
	    }
	  }

	  if (wrappingElement !== null) {
	    for (let i = 0; i < elements.length; i++) {
	      const element = elements[i];
	      wrappingElement.append(element);
	    }
	  }

	  let lastElement = null; // If our target is Root-like, let's see if we can re-adjust
	  // so that the target is the first child instead.

	  if (lexical.$isRootOrShadowRoot(target)) {
	    if (targetIsPrevSibling) {
	      if (wrappingElement !== null) {
	        target.insertAfter(wrappingElement);
	      } else {
	        for (let i = elements.length - 1; i >= 0; i--) {
	          const element = elements[i];
	          target.insertAfter(element);
	        }
	      }
	    } else {
	      const firstChild = target.getFirstChild();

	      if (lexical.$isElementNode(firstChild)) {
	        target = firstChild;
	      }

	      if (firstChild === null) {
	        if (wrappingElement) {
	          target.append(wrappingElement);
	        } else {
	          for (let i = 0; i < elements.length; i++) {
	            const element = elements[i];
	            target.append(element);
	            lastElement = element;
	          }
	        }
	      } else {
	        if (wrappingElement !== null) {
	          firstChild.insertBefore(wrappingElement);
	        } else {
	          for (let i = 0; i < elements.length; i++) {
	            const element = elements[i];
	            firstChild.insertBefore(element);
	            lastElement = element;
	          }
	        }
	      }
	    }
	  } else {
	    if (wrappingElement) {
	      target.insertAfter(wrappingElement);
	    } else {
	      for (let i = elements.length - 1; i >= 0; i--) {
	        const element = elements[i];
	        target.insertAfter(element);
	        lastElement = element;
	      }
	    }
	  }

	  const prevSelection = lexical.$getPreviousSelection();

	  if (lexical.$isRangeSelection(prevSelection) && isPointAttached(prevSelection.anchor) && isPointAttached(prevSelection.focus)) {
	    lexical.$setSelection(prevSelection.clone());
	  } else if (lastElement !== null) {
	    lastElement.selectEnd();
	  } else {
	    selection.dirty = true;
	  }
	}
	/**
	 * Determines if the default character selection should be overridden. Used with DecoratorNodes
	 * @param selection - The selection whose default character selection may need to be overridden.
	 * @param isBackward - Is the selection backwards (the focus comes before the anchor)?
	 * @returns true if it should be overridden, false if not.
	 */

	function $shouldOverrideDefaultCharacterSelection(selection, isBackward) {
	  const possibleNode = lexical.$getAdjacentNode(selection.focus, isBackward);
	  return lexical.$isDecoratorNode(possibleNode) && !possibleNode.isIsolated() || lexical.$isElementNode(possibleNode) && !possibleNode.isInline() && !possibleNode.canBeEmpty();
	}
	/**
	 * Moves the selection according to the arguments.
	 * @param selection - The selected text or nodes.
	 * @param isHoldingShift - Is the shift key being held down during the operation.
	 * @param isBackward - Is the selection selected backwards (the focus comes before the anchor)?
	 * @param granularity - The distance to adjust the current selection.
	 */

	function $moveCaretSelection(selection, isHoldingShift, isBackward, granularity) {
	  selection.modify(isHoldingShift ? 'extend' : 'move', isBackward, granularity);
	}
	/**
	 * Tests a parent element for right to left direction.
	 * @param selection - The selection whose parent is to be tested.
	 * @returns true if the selections' parent element has a direction of 'rtl' (right to left), false otherwise.
	 */

	function $isParentElementRTL(selection) {
	  const anchorNode = selection.anchor.getNode();
	  const parent = lexical.$isRootNode(anchorNode) ? anchorNode : anchorNode.getParentOrThrow();
	  return parent.getDirection() === 'rtl';
	}
	/**
	 * Moves selection by character according to arguments.
	 * @param selection - The selection of the characters to move.
	 * @param isHoldingShift - Is the shift key being held down during the operation.
	 * @param isBackward - Is the selection backward (the focus comes before the anchor)?
	 */

	function $moveCharacter(selection, isHoldingShift, isBackward) {
	  const isRTL = $isParentElementRTL(selection);
	  $moveCaretSelection(selection, isHoldingShift, isBackward ? !isRTL : isRTL, 'character');
	}
	/**
	 * Expands the current Selection to cover all of the content in the editor.
	 * @param selection - The current selection.
	 */

	function $selectAll(selection) {
	  const anchor = selection.anchor;
	  const focus = selection.focus;
	  const anchorNode = anchor.getNode();
	  const topParent = anchorNode.getTopLevelElementOrThrow();
	  const root = topParent.getParentOrThrow();
	  let firstNode = root.getFirstDescendant();
	  let lastNode = root.getLastDescendant();
	  let firstType = 'element';
	  let lastType = 'element';
	  let lastOffset = 0;

	  if (lexical.$isTextNode(firstNode)) {
	    firstType = 'text';
	  } else if (!lexical.$isElementNode(firstNode) && firstNode !== null) {
	    firstNode = firstNode.getParentOrThrow();
	  }

	  if (lexical.$isTextNode(lastNode)) {
	    lastType = 'text';
	    lastOffset = lastNode.getTextContentSize();
	  } else if (!lexical.$isElementNode(lastNode) && lastNode !== null) {
	    lastNode = lastNode.getParentOrThrow();
	  }

	  if (firstNode && lastNode) {
	    anchor.set(firstNode.getKey(), 0, firstType);
	    focus.set(lastNode.getKey(), lastOffset, lastType);
	  }
	}
	/**
	 * Returns the current value of a CSS property for Nodes, if set. If not set, it returns the defaultValue.
	 * @param node - The node whose style value to get.
	 * @param styleProperty - The CSS style property.
	 * @param defaultValue - The default value for the property.
	 * @returns The value of the property for node.
	 */

	function $getNodeStyleValueForProperty(node, styleProperty, defaultValue) {
	  const css = node.getStyle();
	  const styleObject = getStyleObjectFromCSS(css);

	  if (styleObject !== null) {
	    return styleObject[styleProperty] || defaultValue;
	  }

	  return defaultValue;
	}
	/**
	 * Returns the current value of a CSS property for TextNodes in the Selection, if set. If not set, it returns the defaultValue.
	 * If all TextNodes do not have the same value, it returns an empty string.
	 * @param selection - The selection of TextNodes whose value to find.
	 * @param styleProperty - The CSS style property.
	 * @param defaultValue - The default value for the property, defaults to an empty string.
	 * @returns The value of the property for the selected TextNodes.
	 */


	function $getSelectionStyleValueForProperty(selection, styleProperty, defaultValue = '') {
	  let styleValue = null;
	  const nodes = selection.getNodes();
	  const anchor = selection.anchor;
	  const focus = selection.focus;
	  const isBackward = selection.isBackward();
	  const endOffset = isBackward ? focus.offset : anchor.offset;
	  const endNode = isBackward ? focus.getNode() : anchor.getNode();

	  if (selection.style !== '') {
	    const css = selection.style;
	    const styleObject = getStyleObjectFromCSS(css);

	    if (styleObject !== null && styleProperty in styleObject) {
	      return styleObject[styleProperty];
	    }
	  }

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i]; // if no actual characters in the end node are selected, we don't
	    // include it in the selection for purposes of determining style
	    // value

	    if (i !== 0 && endOffset === 0 && node.is(endNode)) {
	      continue;
	    }

	    if (lexical.$isTextNode(node)) {
	      const nodeStyleValue = $getNodeStyleValueForProperty(node, styleProperty, defaultValue);

	      if (styleValue === null) {
	        styleValue = nodeStyleValue;
	      } else if (styleValue !== nodeStyleValue) {
	        // multiple text nodes are in the selection and they don't all
	        // have the same style.
	        styleValue = '';
	        break;
	      }
	    }
	  }

	  return styleValue === null ? defaultValue : styleValue;
	}

	LexicalSelection_dev.$addNodeStyle = $addNodeStyle;
	LexicalSelection_dev.$cloneWithProperties = $cloneWithProperties;
	LexicalSelection_dev.$getSelectionStyleValueForProperty = $getSelectionStyleValueForProperty;
	LexicalSelection_dev.$isAtNodeEnd = $isAtNodeEnd;
	LexicalSelection_dev.$isParentElementRTL = $isParentElementRTL;
	LexicalSelection_dev.$moveCaretSelection = $moveCaretSelection;
	LexicalSelection_dev.$moveCharacter = $moveCharacter;
	LexicalSelection_dev.$patchStyleText = $patchStyleText;
	LexicalSelection_dev.$selectAll = $selectAll;
	LexicalSelection_dev.$setBlocksType = $setBlocksType;
	LexicalSelection_dev.$shouldOverrideDefaultCharacterSelection = $shouldOverrideDefaultCharacterSelection;
	LexicalSelection_dev.$sliceSelectedTextNodeContent = $sliceSelectedTextNodeContent;
	LexicalSelection_dev.$wrapNodes = $wrapNodes;
	LexicalSelection_dev.createDOMRange = createDOMRange;
	LexicalSelection_dev.createRectsFromDOMRange = createRectsFromDOMRange;
	LexicalSelection_dev.getStyleObjectFromCSS = getStyleObjectFromCSS;
	LexicalSelection_dev.trimTextContentFromAnchor = trimTextContentFromAnchor;
	return LexicalSelection_dev;
}

var LexicalSelection_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalSelection_prod;

function requireLexicalSelection_prod () {
	if (hasRequiredLexicalSelection_prod) return LexicalSelection_prod;
	hasRequiredLexicalSelection_prod = 1;
var k=require$$0__default["default"];let u=new Map;function v(a){for(;null!=a;){if(a.nodeType===Node.TEXT_NODE)return a;a=a.firstChild;}return null}function w(a){let b=a.parentNode;if(null==b)throw Error("Should never happen");return [b,Array.from(b.childNodes).indexOf(a)]}function y(a){let b={};a=a.split(";");for(let c of a)if(""!==c){let [e,d]=c.split(/:([^]+)/);b[e.trim()]=d.trim();}return b}function z(a){let b=u.get(a);void 0===b&&(b=y(a),u.set(a,b));return b}
	function A(a){let b="";for(let c in a)c&&(b+=`${c}: ${a[c]};`);return b}function B(a,b){var c=z("getStyle"in a?a.getStyle():a.style);b=Object.entries(b).reduce((e,[d,f])=>{null===f?delete e[d]:e[d]=f;return e},{...c});c=A(b);a.setStyle(c);u.set(c,b);}function C(a){for(;null!==a&&!k.$isRootOrShadowRoot(a);){let b=a.getLatest(),c=a.getParent();0===b.getChildrenSize()&&a.remove(!0);a=c;}}
	function D(a,b,c,e,d=null){if(0!==b.length){var f=b[0],h=new Map,g=[];f=k.$isElementNode(f)?f:f.getParentOrThrow();f.isInline()&&(f=f.getParentOrThrow());for(var l=!1;null!==f;){var m=f.getPreviousSibling();if(null!==m){f=m;l=!0;break}f=f.getParentOrThrow();if(k.$isRootOrShadowRoot(f))break}m=new Set;for(var q=0;q<c;q++){var p=b[q];k.$isElementNode(p)&&0===p.getChildrenSize()&&m.add(p.getKey());}var n=new Set;for(q=0;q<c;q++){p=b[q];var r=p.getParent();null!==r&&r.isInline()&&(r=r.getParent());if(null!==
	r&&k.$isLeafNode(p)&&!n.has(p.getKey())){if(p=r.getKey(),void 0===h.get(p)){let t=e();t.setFormat(r.getFormatType());t.setIndent(r.getIndent());g.push(t);h.set(p,t);r.getChildren().forEach(x=>{t.append(x);n.add(x.getKey());k.$isElementNode(x)&&x.getChildrenKeys().forEach(G=>n.add(G));});C(r);}}else m.has(p.getKey())&&(r=e(),r.setFormat(p.getFormatType()),r.setIndent(p.getIndent()),g.push(r),p.remove(!0));}if(null!==d)for(b=0;b<g.length;b++)d.append(g[b]);b=null;if(k.$isRootOrShadowRoot(f))if(l)if(null!==
	d)f.insertAfter(d);else for(d=g.length-1;0<=d;d--)f.insertAfter(g[d]);else if(l=f.getFirstChild(),k.$isElementNode(l)&&(f=l),null===l)if(d)f.append(d);else for(d=0;d<g.length;d++)l=g[d],f.append(l),b=l;else if(null!==d)l.insertBefore(d);else for(f=0;f<g.length;f++)d=g[f],l.insertBefore(d),b=d;else if(d)f.insertAfter(d);else for(d=g.length-1;0<=d;d--)l=g[d],f.insertAfter(l),b=l;g=k.$getPreviousSelection();k.$isRangeSelection(g)&&g.anchor.getNode().isAttached()&&g.focus.getNode().isAttached()?k.$setSelection(g.clone()):
	null!==b?b.selectEnd():a.dirty=!0;}}function E(a,b,c,e){a.modify(b?"extend":"move",c,e);}function F(a){a=a.anchor.getNode();return "rtl"===(k.$isRootNode(a)?a:a.getParentOrThrow()).getDirection()}LexicalSelection_prod.$addNodeStyle=function(a){a=a.getStyle();let b=y(a);u.set(a,b);};
	LexicalSelection_prod.$cloneWithProperties=function(a){a=a.getLatest();let b=a.constructor.clone(a);b.__parent=a.__parent;b.__next=a.__next;b.__prev=a.__prev;if(k.$isElementNode(a)&&k.$isElementNode(b))return b.__first=a.__first,b.__last=a.__last,b.__size=a.__size,b.__format=a.__format,b.__indent=a.__indent,b.__dir=a.__dir,b;k.$isTextNode(a)&&k.$isTextNode(b)&&(b.__format=a.__format,b.__style=a.__style,b.__mode=a.__mode,b.__detail=a.__detail);return b};
	LexicalSelection_prod.$getSelectionStyleValueForProperty=function(a,b,c=""){let e=null,d=a.getNodes();var f=a.anchor,h=a.focus,g=a.isBackward();let l=g?h.offset:f.offset;f=g?h.getNode():f.getNode();if(""!==a.style&&(a=z(a.style),null!==a&&b in a))return a[b];for(a=0;a<d.length;a++){var m=d[a];if((0===a||0!==l||!m.is(f))&&k.$isTextNode(m))if(h=b,g=c,m=m.getStyle(),m=z(m),h=null!==m?m[h]||g:g,null===e)e=h;else if(e!==h){e="";break}}return null===e?c:e};
	LexicalSelection_prod.$isAtNodeEnd=function(a){return "text"===a.type?a.offset===a.getNode().getTextContentSize():a.offset===a.getNode().getChildrenSize()};LexicalSelection_prod.$isParentElementRTL=F;LexicalSelection_prod.$moveCaretSelection=E;LexicalSelection_prod.$moveCharacter=function(a,b,c){let e=F(a);E(a,b,c?!e:e,"character");};
	LexicalSelection_prod.$patchStyleText=function(a,b){var c=a.getNodes();let e=c.length-1,d=c[0],f=c[e];if(a.isCollapsed())B(a,b);else {var h=a.anchor,g=a.focus,l=d.getTextContent().length,m=g.offset,q=h.offset,p=h.isBefore(g),n=p?q:m;a=p?m:q;var r=p?h.type:g.type,t=p?g.type:h.type;h=p?g.key:h.key;k.$isTextNode(d)&&n===l&&(g=d.getNextSibling(),k.$isTextNode(g)&&(n=q=0,d=g));if(1===c.length)k.$isTextNode(d)&&(n="element"===r?0:q>m?m:q,a="element"===t?l:q>m?q:m,n!==a&&(0===n&&a===l?(B(d,b),d.select(n,a)):(c=d.splitText(n,
	a),c=0===n?c[0]:c[1],B(c,b),c.select(0,a-n))));else for(k.$isTextNode(d)&&n<d.getTextContentSize()&&(0!==n&&(d=d.splitText(n)[1]),B(d,b)),k.$isTextNode(f)&&(n=f.getTextContent().length,f.__key!==h&&0!==a&&(a=n),a!==n&&([f]=f.splitText(a)),0!==a&&B(f,b)),a=1;a<e;a++)n=c[a],l=n.getKey(),k.$isTextNode(n)&&l!==d.getKey()&&l!==f.getKey()&&!n.isToken()&&B(n,b);}};
	LexicalSelection_prod.$selectAll=function(a){let b=a.anchor;a=a.focus;var c=b.getNode().getTopLevelElementOrThrow().getParentOrThrow();let e=c.getFirstDescendant();c=c.getLastDescendant();let d="element",f="element",h=0;k.$isTextNode(e)?d="text":k.$isElementNode(e)||null===e||(e=e.getParentOrThrow());k.$isTextNode(c)?(f="text",h=c.getTextContentSize()):k.$isElementNode(c)||null===c||(c=c.getParentOrThrow());e&&c&&(b.set(e.getKey(),0,d),a.set(c.getKey(),h,f));};
	LexicalSelection_prod.$setBlocksType=function(a,b){if("root"===a.anchor.key){b=b();var c=k.$getRoot();(a=c.getFirstChild())?a.replace(b,!0):c.append(b);}else for(c=a.getNodes(),a=a.anchor.getNode().getParentOrThrow(),-1===c.indexOf(a)&&c.push(a),a.isInline()&&(a=a.getParentOrThrow(),-1===c.indexOf(a)&&c.push(a)),a=0;a<c.length;a++){let f=c[a];var e=f;if(!k.$isElementNode(e)||k.$isRootOrShadowRoot(e))e=!1;else {var d=e.getFirstChild();d=null===d||k.$isLineBreakNode(d)||k.$isTextNode(d)||d.isInline();e=!e.isInline()&&
	!1!==e.canBeEmpty()&&d;}e&&(e=b(),e.setFormat(f.getFormatType()),e.setIndent(f.getIndent()),f.replace(e,!0));}};LexicalSelection_prod.$shouldOverrideDefaultCharacterSelection=function(a,b){a=k.$getAdjacentNode(a.focus,b);return k.$isDecoratorNode(a)&&!a.isIsolated()||k.$isElementNode(a)&&!a.isInline()&&!a.canBeEmpty()};
	LexicalSelection_prod.$sliceSelectedTextNodeContent=function(a,b){if(b.isSelected()&&!b.isSegmented()&&!b.isToken()&&(k.$isRangeSelection(a)||k.DEPRECATED_$isGridSelection(a))){var c=a.anchor.getNode(),e=a.focus.getNode(),d=b.is(c),f=b.is(e);if(d||f){d=a.isBackward();let [h,g]=a.getCharacterOffsets();a=c.is(e);f=b.is(d?e:c);e=b.is(d?c:e);c=0;let l=void 0;a?(c=h>g?g:h,l=h>g?h:g):f?(c=d?g:h,l=void 0):e&&(d=d?h:g,c=0,l=d);b.__text=b.__text.slice(c,l);}}return b};
	LexicalSelection_prod.$wrapNodes=function(a,b,c=null){var e=a.getNodes();let d=e.length;var f=a.anchor;if(0===d||1===d&&"element"===f.type&&0===f.getNode().getChildrenSize()){a="text"===f.type?f.getNode().getParentOrThrow():f.getNode();e=a.getChildren();let g=b();g.setFormat(a.getFormatType());g.setIndent(a.getIndent());e.forEach(l=>g.append(l));c&&(g=c.append(g));a.replace(g);}else {f=null;var h=[];for(let g=0;g<d;g++){let l=e[g];k.$isRootOrShadowRoot(l)?(D(a,h,h.length,b,c),h=[],f=l):null===f||null!==f&&k.$hasAncestor(l,
	f)?h.push(l):(D(a,h,h.length,b,c),h=[l]);}D(a,h,h.length,b,c);}};
	LexicalSelection_prod.createDOMRange=function(a,b,c,e,d){let f=b.getKey(),h=e.getKey(),g=document.createRange(),l=a.getElementByKey(f);a=a.getElementByKey(h);k.$isTextNode(b)&&(l=v(l));k.$isTextNode(e)&&(a=v(a));if(void 0===b||void 0===e||null===l||null===a)return null;"BR"===l.nodeName&&([l,c]=w(l));"BR"===a.nodeName&&([a,d]=w(a));b=l.firstChild;l===a&&null!=b&&"BR"===b.nodeName&&0===c&&0===d&&(d=1);try{g.setStart(l,c),g.setEnd(a,d);}catch(m){return null}!g.collapsed||c===d&&f===h||(g.setStart(a,d),g.setEnd(l,
	c));return g};LexicalSelection_prod.createRectsFromDOMRange=function(a,b){var c=a.getRootElement();if(null===c)return [];a=c.getBoundingClientRect();c=getComputedStyle(c);c=parseFloat(c.paddingLeft)+parseFloat(c.paddingRight);b=Array.from(b.getClientRects());let e=b.length;b.sort((f,h)=>{let g=f.top-h.top;return 3>=Math.abs(g)?f.left-h.left:g});let d;for(let f=0;f<e;f++){let h=b[f],g=h.width+c===a.width;d&&d.top<=h.top&&d.top+d.height>h.top&&d.left+d.width>h.left||g?(b.splice(f--,1),e--):d=h;}return b};
	LexicalSelection_prod.getStyleObjectFromCSS=z;
	LexicalSelection_prod.trimTextContentFromAnchor=function(a,b,c){let e=b.getNode();if(k.$isElementNode(e)){var d=e.getDescendantByIndex(b.offset);null!==d&&(e=d);}for(;0<c&&null!==e;){var f=e.getPreviousSibling(),h=0;if(null===f){d=e.getParentOrThrow();for(var g=d.getPreviousSibling();null===g;){d=d.getParent();if(null===d){f=null;break}g=d.getPreviousSibling();}null!==d&&(h=d.isInline()?0:2,f=k.$isElementNode(g)?g.getLastDescendant():g);}g=e.getTextContent();""===g&&k.$isElementNode(e)&&!e.isInline()&&(g="\n\n");
	d=e.getTextContentSize();if(!k.$isTextNode(e)||c>=d)g=e.getParent(),e.remove(),null==g||0!==g.getChildrenSize()||k.$isRootNode(g)||g.remove(),c-=d+h,e=f;else {let l=e.getKey();h=a.getEditorState().read(()=>{const q=k.$getNodeByKey(l);return k.$isTextNode(q)&&q.isSimpleText()?q.getTextContent():null});f=d-c;let m=g.slice(0,f);null!==h&&h!==g?(c=k.$getPreviousSelection(),d=e,e.isSimpleText()?e.setTextContent(h):(d=k.$createTextNode(h),e.replace(d)),k.$isRangeSelection(c)&&c.isCollapsed()&&(c=c.anchor.offset,
	d.select(c,c))):e.isSimpleText()?(h=b.key===l,g=b.offset,g<c&&(g=d),c=h?g-c:0,d=h?g:f,h&&0===c?([c]=e.splitText(c,d),c.remove()):([,c]=e.splitText(c,d),c.remove())):(c=k.$createTextNode(m),e.replace(c));c=0;}}};
	return LexicalSelection_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalSelection = process.env.NODE_ENV === 'development' ? requireLexicalSelection_dev() : requireLexicalSelection_prod();
var LexicalSelection_1 = LexicalSelection;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalUtils_dev;

function requireLexicalUtils_dev () {
	if (hasRequiredLexicalUtils_dev) return LexicalUtils_dev;
	hasRequiredLexicalUtils_dev = 1;

	var selection = LexicalSelection_1;
	var lexical = require$$0__default["default"];

	/** @module @lexical/utils */

	/**
	 * Takes an HTML element and adds the classNames passed within an array,
	 * ignoring any non-string types. A space can be used to add multiple classes
	 * eg. addClassNamesToElement(element, ['element-inner active', true, null])
	 * will add both 'element-inner' and 'active' as classes to that element.
	 * @param element - The element in which the classes are added
	 * @param classNames - An array defining the class names to add to the element
	 */
	function addClassNamesToElement(element, ...classNames) {
	  classNames.forEach(className => {
	    if (typeof className === 'string') {
	      const classesToAdd = className.split(' ').filter(n => n !== '');
	      element.classList.add(...classesToAdd);
	    }
	  });
	}
	/**
	 * Takes an HTML element and removes the classNames passed within an array,
	 * ignoring any non-string types. A space can be used to remove multiple classes
	 * eg. removeClassNamesFromElement(element, ['active small', true, null])
	 * will remove both the 'active' and 'small' classes from that element.
	 * @param element - The element in which the classes are removed
	 * @param classNames - An array defining the class names to remove from the element
	 */

	function removeClassNamesFromElement(element, ...classNames) {
	  classNames.forEach(className => {
	    if (typeof className === 'string') {
	      element.classList.remove(...className.split(' '));
	    }
	  });
	}
	/**
	 * Returns true if the file type matches the types passed within the acceptableMimeTypes array, false otherwise.
	 * The types passed must be strings and are CASE-SENSITIVE.
	 * eg. if file is of type 'text' and acceptableMimeTypes = ['TEXT', 'IMAGE'] the function will return false.
	 * @param file - The file you want to type check.
	 * @param acceptableMimeTypes - An array of strings of types which the file is checked against.
	 * @returns true if the file is an acceptable mime type, false otherwise.
	 */

	function isMimeType(file, acceptableMimeTypes) {
	  for (const acceptableType of acceptableMimeTypes) {
	    if (file.type.startsWith(acceptableType)) {
	      return true;
	    }
	  }

	  return false;
	}
	/**
	 * Lexical File Reader with:
	 *  1. MIME type support
	 *  2. batched results (HistoryPlugin compatibility)
	 *  3. Order aware (respects the order when multiple Files are passed)
	 *
	 * const filesResult = await mediaFileReader(files, ['image/']);
	 * filesResult.forEach(file => editor.dispatchCommand('INSERT_IMAGE', {
	 *   src: file.result,
	 * }));
	 */

	function mediaFileReader(files, acceptableMimeTypes) {
	  const filesIterator = files[Symbol.iterator]();
	  return new Promise((resolve, reject) => {
	    const processed = [];

	    const handleNextFile = () => {
	      const {
	        done,
	        value: file
	      } = filesIterator.next();

	      if (done) {
	        return resolve(processed);
	      }

	      const fileReader = new FileReader();
	      fileReader.addEventListener('error', reject);
	      fileReader.addEventListener('load', () => {
	        const result = fileReader.result;

	        if (typeof result === 'string') {
	          processed.push({
	            file,
	            result
	          });
	        }

	        handleNextFile();
	      });

	      if (isMimeType(file, acceptableMimeTypes)) {
	        fileReader.readAsDataURL(file);
	      } else {
	        handleNextFile();
	      }
	    };

	    handleNextFile();
	  });
	}
	/**
	 * "Depth-First Search" starts at the root/top node of a tree and goes as far as it can down a branch end
	 * before backtracking and finding a new path. Consider solving a maze by hugging either wall, moving down a
	 * branch until you hit a dead-end (leaf) and backtracking to find the nearest branching path and repeat.
	 * It will then return all the nodes found in the search in an array of objects.
	 * @param startingNode - The node to start the search, if ommitted, it will start at the root node.
	 * @param endingNode - The node to end the search, if ommitted, it will find all descendants of the startingNode.
	 * @returns An array of objects of all the nodes found by the search, including their depth into the tree.
	 * {depth: number, node: LexicalNode} It will always return at least 1 node (the ending node) so long as it exists
	 */

	function $dfs(startingNode, endingNode) {
	  const nodes = [];
	  const start = (startingNode || lexical.$getRoot()).getLatest();
	  const end = endingNode || (lexical.$isElementNode(start) ? start.getLastDescendant() : start);
	  let node = start;
	  let depth = $getDepth(node);

	  while (node !== null && !node.is(end)) {
	    nodes.push({
	      depth,
	      node
	    });

	    if (lexical.$isElementNode(node) && node.getChildrenSize() > 0) {
	      node = node.getFirstChild();
	      depth++;
	    } else {
	      // Find immediate sibling or nearest parent sibling
	      let sibling = null;

	      while (sibling === null && node !== null) {
	        sibling = node.getNextSibling();

	        if (sibling === null) {
	          node = node.getParent();
	          depth--;
	        } else {
	          node = sibling;
	        }
	      }
	    }
	  }

	  if (node !== null && node.is(end)) {
	    nodes.push({
	      depth,
	      node
	    });
	  }

	  return nodes;
	}

	function $getDepth(node) {
	  let innerNode = node;
	  let depth = 0;

	  while ((innerNode = innerNode.getParent()) !== null) {
	    depth++;
	  }

	  return depth;
	}
	/**
	 * Takes a node and traverses up its ancestors (toward the root node)
	 * in order to find a specific type of node.
	 * @param node - the node to begin searching.
	 * @param klass - an instance of the type of node to look for.
	 * @returns the node of type klass that was passed, or null if none exist.
	 */


	function $getNearestNodeOfType(node, klass) {
	  let parent = node;

	  while (parent != null) {
	    if (parent instanceof klass) {
	      return parent;
	    }

	    parent = parent.getParent();
	  }

	  return null;
	}
	/**
	 * Returns the element node of the nearest ancestor, otherwise throws an error.
	 * @param startNode - The starting node of the search
	 * @returns The ancestor node found
	 */

	function $getNearestBlockElementAncestorOrThrow(startNode) {
	  const blockNode = $findMatchingParent(startNode, node => lexical.$isElementNode(node) && !node.isInline());

	  if (!lexical.$isElementNode(blockNode)) {
	    {
	      throw Error(`Expected node ${startNode.__key} to have closest block element node.`);
	    }
	  }

	  return blockNode;
	}

	/**
	 * Starts with a node and moves up the tree (toward the root node) to find a matching node based on
	 * the search parameters of the findFn. (Consider JavaScripts' .find() function where a testing function must be
	 * passed as an argument. eg. if( (node) => node.__type === 'div') ) return true; otherwise return false
	 * @param startingNode - The node where the search starts.
	 * @param findFn - A testing function that returns true if the current node satisfies the testing parameters.
	 * @returns A parent node that matches the findFn parameters, or null if one wasn't found.
	 */
	function $findMatchingParent(startingNode, findFn) {
	  let curr = startingNode;

	  while (curr !== lexical.$getRoot() && curr != null) {
	    if (findFn(curr)) {
	      return curr;
	    }

	    curr = curr.getParent();
	  }

	  return null;
	}

	/**
	 * Returns a function that will execute all functions passed when called. It is generally used
	 * to register multiple lexical listeners and then tear them down with a single function call, such
	 * as React's useEffect hook.
	 * @example
	 * ```ts
	 * useEffect(() => {
	 *   return mergeRegister(
	 *     editor.registerCommand(...registerCommand1 logic),
	 *     editor.registerCommand(...registerCommand2 logic),
	 *     editor.registerCommand(...registerCommand3 logic)
	 *   )
	 * }, [editor])
	 * ```
	 * In this case, useEffect is returning the function returned by mergeRegister as a cleanup
	 * function to be executed after either the useEffect runs again (due to one of its dependencies
	 * updating) or the compenent it resides in unmounts.
	 * Note the functions don't neccesarily need to be in an array as all arguements
	 * are considered to be the func argument and spread from there.
	 * @param func - An array of functions meant to be executed by the returned function.
	 * @returns the function which executes all the passed register command functions.
	 */
	function mergeRegister(...func) {
	  return () => {
	    func.forEach(f => f());
	  };
	}
	/**
	 * Attempts to resolve nested element nodes of the same type into a single node of that type.
	 * It is generally used for marks/commenting
	 * @param editor - The lexical editor
	 * @param targetNode - The target for the nested element to be extracted from.
	 * @param cloneNode - See {@link $createMarkNode}
	 * @param handleOverlap - Handles any overlap between the node to extract and the targetNode
	 * @returns The lexical editor
	 */

	function registerNestedElementResolver(editor, targetNode, cloneNode, handleOverlap) {
	  const $isTargetNode = node => {
	    return node instanceof targetNode;
	  };

	  const $findMatch = node => {
	    // First validate we don't have any children that are of the target,
	    // as we need to handle them first.
	    const children = node.getChildren();

	    for (let i = 0; i < children.length; i++) {
	      const child = children[i];

	      if ($isTargetNode(child)) {
	        return null;
	      }
	    }

	    let parentNode = node;
	    let childNode = node;

	    while (parentNode !== null) {
	      childNode = parentNode;
	      parentNode = parentNode.getParent();

	      if ($isTargetNode(parentNode)) {
	        return {
	          child: childNode,
	          parent: parentNode
	        };
	      }
	    }

	    return null;
	  };

	  const elementNodeTransform = node => {
	    const match = $findMatch(node);

	    if (match !== null) {
	      const {
	        child,
	        parent
	      } = match; // Simple path, we can move child out and siblings into a new parent.

	      if (child.is(node)) {
	        handleOverlap(parent, node);
	        const nextSiblings = child.getNextSiblings();
	        const nextSiblingsLength = nextSiblings.length;
	        parent.insertAfter(child);

	        if (nextSiblingsLength !== 0) {
	          const newParent = cloneNode(parent);
	          child.insertAfter(newParent);

	          for (let i = 0; i < nextSiblingsLength; i++) {
	            newParent.append(nextSiblings[i]);
	          }
	        }

	        if (!parent.canBeEmpty() && parent.getChildrenSize() === 0) {
	          parent.remove();
	        }
	      }
	    }
	  };

	  return editor.registerNodeTransform(targetNode, elementNodeTransform);
	}
	/**
	 * Clones the editor and marks it as dirty to be reconciled. If there was a selection,
	 * it would be set back to its previous state, or null otherwise.
	 * @param editor - The lexical editor
	 * @param editorState - The editor's state
	 */

	function $restoreEditorState(editor, editorState) {
	  const FULL_RECONCILE = 2;
	  const nodeMap = new Map();
	  const activeEditorState = editor._pendingEditorState;

	  for (const [key, node] of editorState._nodeMap) {
	    const clone = selection.$cloneWithProperties(node);

	    if (lexical.$isTextNode(clone)) {
	      clone.__text = node.__text;
	    }

	    nodeMap.set(key, clone);
	  }

	  if (activeEditorState) {
	    activeEditorState._nodeMap = nodeMap;
	  }

	  editor._dirtyType = FULL_RECONCILE;
	  const selection$1 = editorState._selection;
	  lexical.$setSelection(selection$1 === null ? null : selection$1.clone());
	}
	/**
	 * If the selected insertion area is the root/shadow root node (see {@link lexical!$isRootOrShadowRoot}),
	 * the node will be appended there, otherwise, it will be inserted before the insertion area.
	 * If there is no selection where the node is to be inserted, it will be appended after any current nodes
	 * within the tree, as a child of the root node. A paragraph node will then be added after the inserted node and selected.
	 * @param node - The node to be inserted
	 * @returns The node after its insertion
	 */

	function $insertNodeToNearestRoot(node) {
	  const selection = lexical.$getSelection() || lexical.$getPreviousSelection();

	  if (lexical.$isRangeSelection(selection)) {
	    const {
	      focus
	    } = selection;
	    const focusNode = focus.getNode();
	    const focusOffset = focus.offset;

	    if (lexical.$isRootOrShadowRoot(focusNode)) {
	      const focusChild = focusNode.getChildAtIndex(focusOffset);

	      if (focusChild == null) {
	        focusNode.append(node);
	      } else {
	        focusChild.insertBefore(node);
	      }

	      node.selectNext();
	    } else {
	      let splitNode;
	      let splitOffset;

	      if (lexical.$isTextNode(focusNode)) {
	        splitNode = focusNode.getParentOrThrow();
	        splitOffset = focusNode.getIndexWithinParent();

	        if (focusOffset > 0) {
	          splitOffset += 1;
	          focusNode.splitText(focusOffset);
	        }
	      } else {
	        splitNode = focusNode;
	        splitOffset = focusOffset;
	      }

	      const [, rightTree] = lexical.$splitNode(splitNode, splitOffset);
	      rightTree.insertBefore(node);
	      rightTree.selectStart();
	    }
	  } else {
	    if (lexical.$isNodeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection)) {
	      const nodes = selection.getNodes();
	      nodes[nodes.length - 1].getTopLevelElementOrThrow().insertAfter(node);
	    } else {
	      const root = lexical.$getRoot();
	      root.append(node);
	    }

	    const paragraphNode = lexical.$createParagraphNode();
	    node.insertAfter(paragraphNode);
	    paragraphNode.select();
	  }

	  return node.getLatest();
	}
	/**
	 * Wraps the node into another node created from a createElementNode function, eg. $createParagraphNode
	 * @param node - Node to be wrapped.
	 * @param createElementNode - Creates a new lexcial element to wrap the to-be-wrapped node and returns it.
	 * @returns A new lexcial element with the previous node appended within (as a child, including its children).
	 */

	function $wrapNodeInElement(node, createElementNode) {
	  const elementNode = createElementNode();
	  node.replace(elementNode);
	  elementNode.append(node);
	  return elementNode;
	}
	/**
	 * @param x - The element being tested
	 * @returns Returns true if x is an HTML anchor tag, false otherwise
	 */

	function isHTMLAnchorElement(x) {
	  return isHTMLElement(x) && x.tagName === 'A';
	}
	/**
	 * @param x - The element being testing
	 * @returns Returns true if x is an HTML element, false otherwise.
	 */

	function isHTMLElement(x) {
	  // @ts-ignore-next-line - strict check on nodeType here should filter out non-Element EventTarget implementors
	  return x.nodeType === 1;
	} // eslint-disable-next-line @typescript-eslint/no-explicit-any

	/**
	 * @param object = The instance of the type
	 * @param objectClass = The class of the type
	 * @returns Whether the object is has the same Klass of the objectClass, ignoring the difference across window (e.g. different iframs)
	 */
	function objectKlassEquals(object, objectClass) {
	  return object !== null ? Object.getPrototypeOf(object).constructor.name === objectClass.name : false;
	}

	LexicalUtils_dev.$splitNode = lexical.$splitNode;
	LexicalUtils_dev.$dfs = $dfs;
	LexicalUtils_dev.$findMatchingParent = $findMatchingParent;
	LexicalUtils_dev.$getNearestBlockElementAncestorOrThrow = $getNearestBlockElementAncestorOrThrow;
	LexicalUtils_dev.$getNearestNodeOfType = $getNearestNodeOfType;
	LexicalUtils_dev.$insertNodeToNearestRoot = $insertNodeToNearestRoot;
	LexicalUtils_dev.$restoreEditorState = $restoreEditorState;
	LexicalUtils_dev.$wrapNodeInElement = $wrapNodeInElement;
	LexicalUtils_dev.addClassNamesToElement = addClassNamesToElement;
	LexicalUtils_dev.isHTMLAnchorElement = isHTMLAnchorElement;
	LexicalUtils_dev.isHTMLElement = isHTMLElement;
	LexicalUtils_dev.isMimeType = isMimeType;
	LexicalUtils_dev.mediaFileReader = mediaFileReader;
	LexicalUtils_dev.mergeRegister = mergeRegister;
	LexicalUtils_dev.objectKlassEquals = objectKlassEquals;
	LexicalUtils_dev.registerNestedElementResolver = registerNestedElementResolver;
	LexicalUtils_dev.removeClassNamesFromElement = removeClassNamesFromElement;
	return LexicalUtils_dev;
}

var LexicalUtils_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalUtils_prod;

function requireLexicalUtils_prod () {
	if (hasRequiredLexicalUtils_prod) return LexicalUtils_prod;
	hasRequiredLexicalUtils_prod = 1;
var g=LexicalSelection_1,n=require$$0__default["default"];function p(a){let b=new URLSearchParams;b.append("code",a);for(let c=1;c<arguments.length;c++)b.append("v",arguments[c]);throw Error(`Minified Lexical error #${a}; visit https://lexical.dev/docs/error?${b} for the full message or `+"use the non-minified dev environment for full errors and additional helpful warnings.");}function q(a,b){for(let c of b)if(a.type.startsWith(c))return !0;return !1}
	function t(a,b){for(;a!==n.$getRoot()&&null!=a;){if(b(a))return a;a=a.getParent();}return null}function u(a){return 1===a.nodeType}LexicalUtils_prod.$splitNode=n.$splitNode;
	LexicalUtils_prod.$dfs=function(a,b){let c=[];a=(a||n.$getRoot()).getLatest();b=b||(n.$isElementNode(a)?a.getLastDescendant():a);for(var f=a,d=0;null!==(f=f.getParent());)d++;for(f=d;null!==a&&!a.is(b);)if(c.push({depth:f,node:a}),n.$isElementNode(a)&&0<a.getChildrenSize())a=a.getFirstChild(),f++;else for(d=null;null===d&&null!==a;)d=a.getNextSibling(),null===d?(a=a.getParent(),f--):a=d;null!==a&&a.is(b)&&c.push({depth:f,node:a});return c};LexicalUtils_prod.$findMatchingParent=t;
	LexicalUtils_prod.$getNearestBlockElementAncestorOrThrow=function(a){let b=t(a,c=>n.$isElementNode(c)&&!c.isInline());n.$isElementNode(b)||p(4,a.__key);return b};LexicalUtils_prod.$getNearestNodeOfType=function(a,b){for(;null!=a;){if(a instanceof b)return a;a=a.getParent();}return null};
	LexicalUtils_prod.$insertNodeToNearestRoot=function(a){var b=n.$getSelection()||n.$getPreviousSelection();if(n.$isRangeSelection(b)){var {focus:c}=b;b=c.getNode();c=c.offset;if(n.$isRootOrShadowRoot(b))c=b.getChildAtIndex(c),null==c?b.append(a):c.insertBefore(a),a.selectNext();else {let f,d;n.$isTextNode(b)?(f=b.getParentOrThrow(),d=b.getIndexWithinParent(),0<c&&(d+=1,b.splitText(c))):(f=b,d=c);[,b]=n.$splitNode(f,d);b.insertBefore(a);b.selectStart();}}else n.$isNodeSelection(b)||n.DEPRECATED_$isGridSelection(b)?
	(b=b.getNodes(),b[b.length-1].getTopLevelElementOrThrow().insertAfter(a)):n.$getRoot().append(a),b=n.$createParagraphNode(),a.insertAfter(b),b.select();return a.getLatest()};LexicalUtils_prod.$restoreEditorState=function(a,b){let c=new Map,f=a._pendingEditorState;for(let [d,e]of b._nodeMap){let h=g.$cloneWithProperties(e);n.$isTextNode(h)&&(h.__text=e.__text);c.set(d,h);}f&&(f._nodeMap=c);a._dirtyType=2;a=b._selection;n.$setSelection(null===a?null:a.clone());};
	LexicalUtils_prod.$wrapNodeInElement=function(a,b){b=b();a.replace(b);b.append(a);return b};LexicalUtils_prod.addClassNamesToElement=function(a,...b){b.forEach(c=>{"string"===typeof c&&(c=c.split(" ").filter(f=>""!==f),a.classList.add(...c));});};LexicalUtils_prod.isHTMLAnchorElement=function(a){return u(a)&&"A"===a.tagName};LexicalUtils_prod.isHTMLElement=u;LexicalUtils_prod.isMimeType=q;
	LexicalUtils_prod.mediaFileReader=function(a,b){let c=a[Symbol.iterator]();return new Promise((f,d)=>{let e=[],h=()=>{const {done:m,value:k}=c.next();if(m)return f(e);const l=new FileReader;l.addEventListener("error",d);l.addEventListener("load",()=>{const r=l.result;"string"===typeof r&&e.push({file:k,result:r});h();});q(k,b)?l.readAsDataURL(k):h();};h();})};LexicalUtils_prod.mergeRegister=function(...a){return ()=>{a.forEach(b=>b());}};
	LexicalUtils_prod.objectKlassEquals=function(a,b){return null!==a?Object.getPrototypeOf(a).constructor.name===b.name:!1};
	LexicalUtils_prod.registerNestedElementResolver=function(a,b,c,f){return a.registerNodeTransform(b,d=>{a:{var e=d.getChildren();for(var h=0;h<e.length;h++)if(e[h]instanceof b){e=null;break a}for(e=d;null!==e;)if(h=e,e=e.getParent(),e instanceof b){e={child:h,parent:e};break a}e=null;}if(null!==e){const {child:m,parent:k}=e;if(m.is(d)){f(k,d);d=m.getNextSiblings();e=d.length;k.insertAfter(m);if(0!==e){h=c(k);m.insertAfter(h);for(let l=0;l<e;l++)h.append(d[l]);}k.canBeEmpty()||0!==k.getChildrenSize()||k.remove();}}})};
	LexicalUtils_prod.removeClassNamesFromElement=function(a,...b){b.forEach(c=>{"string"===typeof c&&a.classList.remove(...c.split(" "));});};
	return LexicalUtils_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalUtils = process.env.NODE_ENV === 'development' ? requireLexicalUtils_dev() : requireLexicalUtils_prod();
var LexicalUtils_1 = LexicalUtils;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalLink_dev;

function requireLexicalLink_dev () {
	if (hasRequiredLexicalLink_dev) return LexicalLink_dev;
	hasRequiredLexicalLink_dev = 1;

	var utils = LexicalUtils_1;
	var lexical = require$$0__default["default"];

	/** @module @lexical/link */
	const SUPPORTED_URL_PROTOCOLS = new Set(['http:', 'https:', 'mailto:', 'sms:', 'tel:']);
	/** @noInheritDoc */

	class LinkNode extends lexical.ElementNode {
	  /** @internal */

	  /** @internal */

	  /** @internal */

	  /** @internal */
	  static getType() {
	    return 'link';
	  }

	  static clone(node) {
	    return new LinkNode(node.__url, {
	      rel: node.__rel,
	      target: node.__target,
	      title: node.__title
	    }, node.__key);
	  }

	  constructor(url, attributes = {}, key) {
	    super(key);
	    const {
	      target = null,
	      rel = null,
	      title = null
	    } = attributes;
	    this.__url = url;
	    this.__target = target;
	    this.__rel = rel;
	    this.__title = title;
	  }

	  createDOM(config) {
	    const element = document.createElement('a');
	    element.href = this.sanitizeUrl(this.__url);

	    if (this.__target !== null) {
	      element.target = this.__target;
	    }

	    if (this.__rel !== null) {
	      element.rel = this.__rel;
	    }

	    if (this.__title !== null) {
	      element.title = this.__title;
	    }

	    utils.addClassNamesToElement(element, config.theme.link);
	    return element;
	  }

	  updateDOM(prevNode, anchor, config) {
	    const url = this.__url;
	    const target = this.__target;
	    const rel = this.__rel;
	    const title = this.__title;

	    if (url !== prevNode.__url) {
	      anchor.href = url;
	    }

	    if (target !== prevNode.__target) {
	      if (target) {
	        anchor.target = target;
	      } else {
	        anchor.removeAttribute('target');
	      }
	    }

	    if (rel !== prevNode.__rel) {
	      if (rel) {
	        anchor.rel = rel;
	      } else {
	        anchor.removeAttribute('rel');
	      }
	    }

	    if (title !== prevNode.__title) {
	      if (title) {
	        anchor.title = title;
	      } else {
	        anchor.removeAttribute('title');
	      }
	    }

	    return false;
	  }

	  static importDOM() {
	    return {
	      a: node => ({
	        conversion: convertAnchorElement,
	        priority: 1
	      })
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createLinkNode(serializedNode.url, {
	      rel: serializedNode.rel,
	      target: serializedNode.target,
	      title: serializedNode.title
	    });
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  sanitizeUrl(url) {
	    try {
	      const parsedUrl = new URL(url); // eslint-disable-next-line no-script-url

	      if (!SUPPORTED_URL_PROTOCOLS.has(parsedUrl.protocol)) {
	        return 'about:blank';
	      }
	    } catch {
	      return url;
	    }

	    return url;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      rel: this.getRel(),
	      target: this.getTarget(),
	      title: this.getTitle(),
	      type: 'link',
	      url: this.getURL(),
	      version: 1
	    };
	  }

	  getURL() {
	    return this.getLatest().__url;
	  }

	  setURL(url) {
	    const writable = this.getWritable();
	    writable.__url = url;
	  }

	  getTarget() {
	    return this.getLatest().__target;
	  }

	  setTarget(target) {
	    const writable = this.getWritable();
	    writable.__target = target;
	  }

	  getRel() {
	    return this.getLatest().__rel;
	  }

	  setRel(rel) {
	    const writable = this.getWritable();
	    writable.__rel = rel;
	  }

	  getTitle() {
	    return this.getLatest().__title;
	  }

	  setTitle(title) {
	    const writable = this.getWritable();
	    writable.__title = title;
	  }

	  insertNewAfter(selection, restoreSelection = true) {
	    const element = this.getParentOrThrow().insertNewAfter(selection, restoreSelection);

	    if (lexical.$isElementNode(element)) {
	      const linkNode = $createLinkNode(this.__url, {
	        rel: this.__rel,
	        target: this.__target,
	        title: this.__title
	      });
	      element.append(linkNode);
	      return linkNode;
	    }

	    return null;
	  }

	  canInsertTextBefore() {
	    return false;
	  }

	  canInsertTextAfter() {
	    return false;
	  }

	  canBeEmpty() {
	    return false;
	  }

	  isInline() {
	    return true;
	  }

	  extractWithChild(child, selection, destination) {
	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    const anchorNode = selection.anchor.getNode();
	    const focusNode = selection.focus.getNode();
	    return this.isParentOf(anchorNode) && this.isParentOf(focusNode) && selection.getTextContent().length > 0;
	  }

	}

	function convertAnchorElement(domNode) {
	  let node = null;

	  if (utils.isHTMLAnchorElement(domNode)) {
	    const content = domNode.textContent;

	    if (content !== null && content !== '') {
	      node = $createLinkNode(domNode.getAttribute('href') || '', {
	        rel: domNode.getAttribute('rel'),
	        target: domNode.getAttribute('target'),
	        title: domNode.getAttribute('title')
	      });
	    }
	  }

	  return {
	    node
	  };
	}
	/**
	 * Takes a URL and creates a LinkNode.
	 * @param url - The URL the LinkNode should direct to.
	 * @param attributes - Optional HTML a tag attributes { target, rel, title }
	 * @returns The LinkNode.
	 */


	function $createLinkNode(url, attributes) {
	  return lexical.$applyNodeReplacement(new LinkNode(url, attributes));
	}
	/**
	 * Determines if node is a LinkNode.
	 * @param node - The node to be checked.
	 * @returns true if node is a LinkNode, false otherwise.
	 */

	function $isLinkNode(node) {
	  return node instanceof LinkNode;
	}
	// Custom node type to override `canInsertTextAfter` that will
	// allow typing within the link
	class AutoLinkNode extends LinkNode {
	  static getType() {
	    return 'autolink';
	  }

	  static clone(node) {
	    return new AutoLinkNode(node.__url, {
	      rel: node.__rel,
	      target: node.__target,
	      title: node.__title
	    }, node.__key);
	  }

	  static importJSON(serializedNode) {
	    const node = $createAutoLinkNode(serializedNode.url, {
	      rel: serializedNode.rel,
	      target: serializedNode.target,
	      title: serializedNode.title
	    });
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  static importDOM() {
	    // TODO: Should link node should handle the import over autolink?
	    return null;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      type: 'autolink',
	      version: 1
	    };
	  }

	  insertNewAfter(selection, restoreSelection = true) {
	    const element = this.getParentOrThrow().insertNewAfter(selection, restoreSelection);

	    if (lexical.$isElementNode(element)) {
	      const linkNode = $createAutoLinkNode(this.__url, {
	        rel: this._rel,
	        target: this.__target,
	        title: this.__title
	      });
	      element.append(linkNode);
	      return linkNode;
	    }

	    return null;
	  }

	}
	/**
	 * Takes a URL and creates an AutoLinkNode. AutoLinkNodes are generally automatically generated
	 * during typing, which is especially useful when a button to generate a LinkNode is not practical.
	 * @param url - The URL the LinkNode should direct to.
	 * @param attributes - Optional HTML a tag attributes. { target, rel, title }
	 * @returns The LinkNode.
	 */

	function $createAutoLinkNode(url, attributes) {
	  return lexical.$applyNodeReplacement(new AutoLinkNode(url, attributes));
	}
	/**
	 * Determines if node is an AutoLinkNode.
	 * @param node - The node to be checked.
	 * @returns true if node is an AutoLinkNode, false otherwise.
	 */

	function $isAutoLinkNode(node) {
	  return node instanceof AutoLinkNode;
	}
	const TOGGLE_LINK_COMMAND = lexical.createCommand('TOGGLE_LINK_COMMAND');
	/**
	 * Generates or updates a LinkNode. It can also delete a LinkNode if the URL is null,
	 * but saves any children and brings them up to the parent node.
	 * @param url - The URL the link directs to.
	 * @param attributes - Optional HTML a tag attributes. { target, rel, title }
	 */

	function toggleLink(url, attributes = {}) {
	  const {
	    target,
	    title
	  } = attributes;
	  const rel = attributes.rel === undefined ? 'noreferrer' : attributes.rel;
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection)) {
	    return;
	  }

	  const nodes = selection.extract();

	  if (url === null) {
	    // Remove LinkNodes
	    nodes.forEach(node => {
	      const parent = node.getParent();

	      if ($isLinkNode(parent)) {
	        const children = parent.getChildren();

	        for (let i = 0; i < children.length; i++) {
	          parent.insertBefore(children[i]);
	        }

	        parent.remove();
	      }
	    });
	  } else {
	    // Add or merge LinkNodes
	    if (nodes.length === 1) {
	      const firstNode = nodes[0]; // if the first node is a LinkNode or if its
	      // parent is a LinkNode, we update the URL, target and rel.

	      const linkNode = $isLinkNode(firstNode) ? firstNode : $getLinkAncestor(firstNode);

	      if (linkNode !== null) {
	        linkNode.setURL(url);

	        if (target !== undefined) {
	          linkNode.setTarget(target);
	        }

	        if (rel !== null) {
	          linkNode.setRel(rel);
	        }

	        if (title !== undefined) {
	          linkNode.setTitle(title);
	        }

	        return;
	      }
	    }

	    let prevParent = null;
	    let linkNode = null;
	    nodes.forEach(node => {
	      const parent = node.getParent();

	      if (parent === linkNode || parent === null || lexical.$isElementNode(node) && !node.isInline()) {
	        return;
	      }

	      if ($isLinkNode(parent)) {
	        linkNode = parent;
	        parent.setURL(url);

	        if (target !== undefined) {
	          parent.setTarget(target);
	        }

	        if (rel !== null) {
	          linkNode.setRel(rel);
	        }

	        if (title !== undefined) {
	          linkNode.setTitle(title);
	        }

	        return;
	      }

	      if (!parent.is(prevParent)) {
	        prevParent = parent;
	        linkNode = $createLinkNode(url, {
	          rel,
	          target
	        });

	        if ($isLinkNode(parent)) {
	          if (node.getPreviousSibling() === null) {
	            parent.insertBefore(linkNode);
	          } else {
	            parent.insertAfter(linkNode);
	          }
	        } else {
	          node.insertBefore(linkNode);
	        }
	      }

	      if ($isLinkNode(node)) {
	        if (node.is(linkNode)) {
	          return;
	        }

	        if (linkNode !== null) {
	          const children = node.getChildren();

	          for (let i = 0; i < children.length; i++) {
	            linkNode.append(children[i]);
	          }
	        }

	        node.remove();
	        return;
	      }

	      if (linkNode !== null) {
	        linkNode.append(node);
	      }
	    });
	  }
	}

	function $getLinkAncestor(node) {
	  return $getAncestor(node, $isLinkNode);
	}

	function $getAncestor(node, predicate) {
	  let parent = node;

	  while (parent !== null && (parent = parent.getParent()) !== null && !predicate(parent));

	  return parent;
	}

	LexicalLink_dev.$createAutoLinkNode = $createAutoLinkNode;
	LexicalLink_dev.$createLinkNode = $createLinkNode;
	LexicalLink_dev.$isAutoLinkNode = $isAutoLinkNode;
	LexicalLink_dev.$isLinkNode = $isLinkNode;
	LexicalLink_dev.AutoLinkNode = AutoLinkNode;
	LexicalLink_dev.LinkNode = LinkNode;
	LexicalLink_dev.TOGGLE_LINK_COMMAND = TOGGLE_LINK_COMMAND;
	LexicalLink_dev.toggleLink = toggleLink;
	return LexicalLink_dev;
}

var LexicalLink_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalLink_prod;

function requireLexicalLink_prod () {
	if (hasRequiredLexicalLink_prod) return LexicalLink_prod;
	hasRequiredLexicalLink_prod = 1;
var k=LexicalUtils_1,n=require$$0__default["default"];let p=new Set(["http:","https:","mailto:","sms:","tel:"]);
	class q extends n.ElementNode{static getType(){return "link"}static clone(a){return new q(a.__url,{rel:a.__rel,target:a.__target,title:a.__title},a.__key)}constructor(a,b={},d){super(d);let {target:l=null,rel:h=null,title:e=null}=b;this.__url=a;this.__target=l;this.__rel=h;this.__title=e;}createDOM(a){let b=document.createElement("a");b.href=this.sanitizeUrl(this.__url);null!==this.__target&&(b.target=this.__target);null!==this.__rel&&(b.rel=this.__rel);null!==this.__title&&(b.title=this.__title);k.addClassNamesToElement(b,
	a.theme.link);return b}updateDOM(a,b){let d=this.__url,l=this.__target,h=this.__rel,e=this.__title;d!==a.__url&&(b.href=d);l!==a.__target&&(l?b.target=l:b.removeAttribute("target"));h!==a.__rel&&(h?b.rel=h:b.removeAttribute("rel"));e!==a.__title&&(e?b.title=e:b.removeAttribute("title"));return !1}static importDOM(){return {a:()=>({conversion:r,priority:1})}}static importJSON(a){let b=t(a.url,{rel:a.rel,target:a.target,title:a.title});b.setFormat(a.format);b.setIndent(a.indent);b.setDirection(a.direction);
	return b}sanitizeUrl(a){try{let b=new URL(a);if(!p.has(b.protocol))return "about:blank"}catch{}return a}exportJSON(){return {...super.exportJSON(),rel:this.getRel(),target:this.getTarget(),title:this.getTitle(),type:"link",url:this.getURL(),version:1}}getURL(){return this.getLatest().__url}setURL(a){this.getWritable().__url=a;}getTarget(){return this.getLatest().__target}setTarget(a){this.getWritable().__target=a;}getRel(){return this.getLatest().__rel}setRel(a){this.getWritable().__rel=a;}getTitle(){return this.getLatest().__title}setTitle(a){this.getWritable().__title=
	a;}insertNewAfter(a,b=!0){a=this.getParentOrThrow().insertNewAfter(a,b);return n.$isElementNode(a)?(b=t(this.__url,{rel:this.__rel,target:this.__target,title:this.__title}),a.append(b),b):null}canInsertTextBefore(){return !1}canInsertTextAfter(){return !1}canBeEmpty(){return !1}isInline(){return !0}extractWithChild(a,b){if(!n.$isRangeSelection(b))return !1;a=b.anchor.getNode();let d=b.focus.getNode();return this.isParentOf(a)&&this.isParentOf(d)&&0<b.getTextContent().length}}
	function r(a){let b=null;if(k.isHTMLAnchorElement(a)){let d=a.textContent;null!==d&&""!==d&&(b=t(a.getAttribute("href")||"",{rel:a.getAttribute("rel"),target:a.getAttribute("target"),title:a.getAttribute("title")}));}return {node:b}}function t(a,b){return n.$applyNodeReplacement(new q(a,b))}function v(a){return a instanceof q}
	class w extends q{static getType(){return "autolink"}static clone(a){return new w(a.__url,{rel:a.__rel,target:a.__target,title:a.__title},a.__key)}static importJSON(a){let b=x(a.url,{rel:a.rel,target:a.target,title:a.title});b.setFormat(a.format);b.setIndent(a.indent);b.setDirection(a.direction);return b}static importDOM(){return null}exportJSON(){return {...super.exportJSON(),type:"autolink",version:1}}insertNewAfter(a,b=!0){a=this.getParentOrThrow().insertNewAfter(a,b);return n.$isElementNode(a)?
	(b=x(this.__url,{rel:this._rel,target:this.__target,title:this.__title}),a.append(b),b):null}}function x(a,b){return n.$applyNodeReplacement(new w(a,b))}let y=n.createCommand("TOGGLE_LINK_COMMAND");function z(a,b){for(;null!==a&&null!==(a=a.getParent())&&!b(a););return a}LexicalLink_prod.$createAutoLinkNode=x;LexicalLink_prod.$createLinkNode=t;LexicalLink_prod.$isAutoLinkNode=function(a){return a instanceof w};LexicalLink_prod.$isLinkNode=v;LexicalLink_prod.AutoLinkNode=w;LexicalLink_prod.LinkNode=q;LexicalLink_prod.TOGGLE_LINK_COMMAND=y;
	LexicalLink_prod.toggleLink=function(a,b={}){let {target:d,title:l}=b,h=void 0===b.rel?"noreferrer":b.rel;b=n.$getSelection();if(n.$isRangeSelection(b))if(b=b.extract(),null===a)b.forEach(m=>{m=m.getParent();if(v(m)){let c=m.getChildren();for(let f=0;f<c.length;f++)m.insertBefore(c[f]);m.remove();}});else {if(1===b.length){var e=b[0];e=v(e)?e:z(e,v);if(null!==e){e.setURL(a);void 0!==d&&e.setTarget(d);null!==h&&e.setRel(h);void 0!==l&&e.setTitle(l);return}}let m=null,c=null;b.forEach(f=>{var g=f.getParent();
	if(g!==c&&null!==g&&(!n.$isElementNode(f)||f.isInline()))if(v(g))c=g,g.setURL(a),void 0!==d&&g.setTarget(d),null!==h&&c.setRel(h),void 0!==l&&c.setTitle(l);else if(g.is(m)||(m=g,c=t(a,{rel:h,target:d}),v(g)?null===f.getPreviousSibling()?g.insertBefore(c):g.insertAfter(c):f.insertBefore(c)),v(f)){if(!f.is(c)){if(null!==c){g=f.getChildren();for(let u=0;u<g.length;u++)c.append(g[u]);}f.remove();}}else null!==c&&c.append(f);});}};
	return LexicalLink_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalLink = process.env.NODE_ENV === 'development' ? requireLexicalLink_dev() : requireLexicalLink_prod();
var LexicalLink_1 = LexicalLink;

var LexicalList_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalList_dev;

function requireLexicalList_dev () {
	if (hasRequiredLexicalList_dev) return LexicalList_dev;
	hasRequiredLexicalList_dev = 1;

	var lexical = require$$0__default["default"];
	var utils = LexicalUtils_1;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	/**
	 * Checks the depth of listNode from the root node.
	 * @param listNode - The ListNode to be checked.
	 * @returns The depth of the ListNode.
	 */

	function $getListDepth(listNode) {
	  let depth = 1;
	  let parent = listNode.getParent();

	  while (parent != null) {
	    if ($isListItemNode(parent)) {
	      const parentList = parent.getParent();

	      if ($isListNode(parentList)) {
	        depth++;
	        parent = parentList.getParent();
	        continue;
	      }

	      {
	        throw Error(`A ListItemNode must have a ListNode for a parent.`);
	      }
	    }

	    return depth;
	  }

	  return depth;
	}
	/**
	 * Finds the nearest ancestral ListNode and returns it, throws an invariant if listItem is not a ListItemNode.
	 * @param listItem - The node to be checked.
	 * @returns The ListNode found.
	 */

	function $getTopListNode(listItem) {
	  let list = listItem.getParent();

	  if (!$isListNode(list)) {
	    {
	      throw Error(`A ListItemNode must have a ListNode for a parent.`);
	    }
	  }

	  let parent = list;

	  while (parent !== null) {
	    parent = parent.getParent();

	    if ($isListNode(parent)) {
	      list = parent;
	    }
	  }

	  return list;
	}
	/**
	 * A recursive Depth-First Search (Postorder Traversal) that finds all of a node's children
	 * that are of type ListItemNode and returns them in an array.
	 * @param node - The ListNode to start the search.
	 * @returns An array containing all nodes of type ListItemNode found.
	 */
	// This should probably be $getAllChildrenOfType

	function $getAllListItems(node) {
	  let listItemNodes = [];
	  const listChildren = node.getChildren().filter($isListItemNode);

	  for (let i = 0; i < listChildren.length; i++) {
	    const listItemNode = listChildren[i];
	    const firstChild = listItemNode.getFirstChild();

	    if ($isListNode(firstChild)) {
	      listItemNodes = listItemNodes.concat($getAllListItems(firstChild));
	    } else {
	      listItemNodes.push(listItemNode);
	    }
	  }

	  return listItemNodes;
	}
	/**
	 * Checks to see if the passed node is a ListItemNode and has a ListNode as a child.
	 * @param node - The node to be checked.
	 * @returns true if the node is a ListItemNode and has a ListNode child, false otherwise.
	 */

	function isNestedListNode(node) {
	  return $isListItemNode(node) && $isListNode(node.getFirstChild());
	}
	/**
	 * Takes a deeply nested ListNode or ListItemNode and traverses up the branch to delete the first
	 * ancestral ListNode (which could be the root ListNode) or ListItemNode with siblings, essentially
	 * bringing the deeply nested node up the branch once. Would remove sublist if it has siblings.
	 * Should not break ListItem -> List -> ListItem chain as empty List/ItemNodes should be removed on .remove().
	 * @param sublist - The nested ListNode or ListItemNode to be brought up the branch.
	 */

	function $removeHighestEmptyListParent(sublist) {
	  // Nodes may be repeatedly indented, to create deeply nested lists that each
	  // contain just one bullet.
	  // Our goal is to remove these (empty) deeply nested lists. The easiest
	  // way to do that is crawl back up the tree until we find a node that has siblings
	  // (e.g. is actually part of the list contents) and delete that, or delete
	  // the root of the list (if no list nodes have siblings.)
	  let emptyListPtr = sublist;

	  while (emptyListPtr.getNextSibling() == null && emptyListPtr.getPreviousSibling() == null) {
	    const parent = emptyListPtr.getParent();

	    if (parent == null || !($isListItemNode(emptyListPtr) || $isListNode(emptyListPtr))) {
	      break;
	    }

	    emptyListPtr = parent;
	  }

	  emptyListPtr.remove();
	}
	/**
	 * Wraps a node into a ListItemNode.
	 * @param node - The node to be wrapped into a ListItemNode
	 * @returns The ListItemNode which the passed node is wrapped in.
	 */

	function wrapInListItem(node) {
	  const listItemWrapper = $createListItemNode();
	  return listItemWrapper.append(node);
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	function $isSelectingEmptyListItem(anchorNode, nodes) {
	  return $isListItemNode(anchorNode) && (nodes.length === 0 || nodes.length === 1 && anchorNode.is(nodes[0]) && anchorNode.getChildrenSize() === 0);
	}

	function $getListItemValue(listItem) {
	  const list = listItem.getParent();
	  let value = 1;

	  if (list != null) {
	    if (!$isListNode(list)) {
	      {
	        throw Error(`$getListItemValue: list node is not parent of list item node`);
	      }
	    } else {
	      value = list.getStart();
	    }
	  }

	  const siblings = listItem.getPreviousSiblings();

	  for (let i = 0; i < siblings.length; i++) {
	    const sibling = siblings[i];

	    if ($isListItemNode(sibling) && !$isListNode(sibling.getFirstChild())) {
	      value++;
	    }
	  }

	  return value;
	}
	/**
	 * Inserts a new ListNode. If the selection's anchor node is an empty ListItemNode and is a child of
	 * the root/shadow root, it will replace the ListItemNode with a ListNode and the old ListItemNode.
	 * Otherwise it will replace its parent with a new ListNode and re-insert the ListItemNode and any previous children.
	 * If the selection's anchor node is not an empty ListItemNode, it will add a new ListNode or merge an existing ListNode,
	 * unless the the node is a leaf node, in which case it will attempt to find a ListNode up the branch and replace it with
	 * a new ListNode, or create a new ListNode at the nearest root/shadow root.
	 * @param editor - The lexical editor.
	 * @param listType - The type of list, "number" | "bullet" | "check".
	 */


	function insertList(editor, listType) {
	  editor.update(() => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection)) {
	      const nodes = selection.getNodes();
	      const anchor = selection.anchor;
	      const anchorNode = anchor.getNode();
	      const anchorNodeParent = anchorNode.getParent();

	      if ($isSelectingEmptyListItem(anchorNode, nodes)) {
	        const list = $createListNode(listType);

	        if (lexical.$isRootOrShadowRoot(anchorNodeParent)) {
	          anchorNode.replace(list);
	          const listItem = $createListItemNode();

	          if (lexical.$isElementNode(anchorNode)) {
	            listItem.setFormat(anchorNode.getFormatType());
	            listItem.setIndent(anchorNode.getIndent());
	          }

	          list.append(listItem);
	        } else if ($isListItemNode(anchorNode)) {
	          const parent = anchorNode.getParentOrThrow();
	          append(list, parent.getChildren());
	          parent.replace(list);
	        }

	        return;
	      } else {
	        const handled = new Set();

	        for (let i = 0; i < nodes.length; i++) {
	          const node = nodes[i];

	          if (lexical.$isElementNode(node) && node.isEmpty() && !handled.has(node.getKey())) {
	            createListOrMerge(node, listType);
	            continue;
	          }

	          if (lexical.$isLeafNode(node)) {
	            let parent = node.getParent();

	            while (parent != null) {
	              const parentKey = parent.getKey();

	              if ($isListNode(parent)) {
	                if (!handled.has(parentKey)) {
	                  const newListNode = $createListNode(listType);
	                  append(newListNode, parent.getChildren());
	                  parent.replace(newListNode);
	                  updateChildrenListItemValue(newListNode);
	                  handled.add(parentKey);
	                }

	                break;
	              } else {
	                const nextParent = parent.getParent();

	                if (lexical.$isRootOrShadowRoot(nextParent) && !handled.has(parentKey)) {
	                  handled.add(parentKey);
	                  createListOrMerge(parent, listType);
	                  break;
	                }

	                parent = nextParent;
	              }
	            }
	          }
	        }
	      }
	    }
	  });
	}

	function append(node, nodesToAppend) {
	  node.splice(node.getChildrenSize(), 0, nodesToAppend);
	}

	function createListOrMerge(node, listType) {
	  if ($isListNode(node)) {
	    return node;
	  }

	  const previousSibling = node.getPreviousSibling();
	  const nextSibling = node.getNextSibling();
	  const listItem = $createListItemNode();
	  listItem.setFormat(node.getFormatType());
	  listItem.setIndent(node.getIndent());
	  append(listItem, node.getChildren());

	  if ($isListNode(previousSibling) && listType === previousSibling.getListType()) {
	    previousSibling.append(listItem);
	    node.remove(); // if the same type of list is on both sides, merge them.

	    if ($isListNode(nextSibling) && listType === nextSibling.getListType()) {
	      append(previousSibling, nextSibling.getChildren());
	      nextSibling.remove();
	    }

	    return previousSibling;
	  } else if ($isListNode(nextSibling) && listType === nextSibling.getListType()) {
	    nextSibling.getFirstChildOrThrow().insertBefore(listItem);
	    node.remove();
	    return nextSibling;
	  } else {
	    const list = $createListNode(listType);
	    list.append(listItem);
	    node.replace(list);
	    updateChildrenListItemValue(list);
	    return list;
	  }
	}
	/**
	 * A recursive function that goes through each list and their children, including nested lists,
	 * appending list2 children after list1 children and updating ListItemNode values.
	 * @param list1 - The first list to be merged.
	 * @param list2 - The second list to be merged.
	 */


	function mergeLists(list1, list2) {
	  const listItem1 = list1.getLastChild();
	  const listItem2 = list2.getFirstChild();

	  if (listItem1 && listItem2 && isNestedListNode(listItem1) && isNestedListNode(listItem2)) {
	    mergeLists(listItem1.getFirstChild(), listItem2.getFirstChild());
	    listItem2.remove();
	  }

	  const toMerge = list2.getChildren();

	  if (toMerge.length > 0) {
	    list1.append(...toMerge);
	    updateChildrenListItemValue(list1);
	  }

	  list2.remove();
	}
	/**
	 * Searches for the nearest ancestral ListNode and removes it. If selection is an empty ListItemNode
	 * it will remove the whole list, including the ListItemNode. For each ListItemNode in the ListNode,
	 * removeList will also generate new ParagraphNodes in the removed ListNode's place. Any child node
	 * inside a ListItemNode will be appended to the new ParagraphNodes.
	 * @param editor - The lexical editor.
	 */

	function removeList(editor) {
	  editor.update(() => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isRangeSelection(selection)) {
	      const listNodes = new Set();
	      const nodes = selection.getNodes();
	      const anchorNode = selection.anchor.getNode();

	      if ($isSelectingEmptyListItem(anchorNode, nodes)) {
	        listNodes.add($getTopListNode(anchorNode));
	      } else {
	        for (let i = 0; i < nodes.length; i++) {
	          const node = nodes[i];

	          if (lexical.$isLeafNode(node)) {
	            const listItemNode = utils.$getNearestNodeOfType(node, ListItemNode);

	            if (listItemNode != null) {
	              listNodes.add($getTopListNode(listItemNode));
	            }
	          }
	        }
	      }

	      for (const listNode of listNodes) {
	        let insertionPoint = listNode;
	        const listItems = $getAllListItems(listNode);

	        for (const listItemNode of listItems) {
	          const paragraph = lexical.$createParagraphNode();
	          append(paragraph, listItemNode.getChildren());
	          insertionPoint.insertAfter(paragraph);
	          insertionPoint = paragraph; // When the anchor and focus fall on the textNode
	          // we don't have to change the selection because the textNode will be appended to
	          // the newly generated paragraph.
	          // When selection is in empty nested list item, selection is actually on the listItemNode.
	          // When the corresponding listItemNode is deleted and replaced by the newly generated paragraph
	          // we should manually set the selection's focus and anchor to the newly generated paragraph.

	          if (listItemNode.__key === selection.anchor.key) {
	            selection.anchor.set(paragraph.getKey(), 0, 'element');
	          }

	          if (listItemNode.__key === selection.focus.key) {
	            selection.focus.set(paragraph.getKey(), 0, 'element');
	          }

	          listItemNode.remove();
	        }

	        listNode.remove();
	      }
	    }
	  });
	}
	/**
	 * Takes the value of a child ListItemNode and makes it the value the ListItemNode
	 * should be if it isn't already. If only certain children should be updated, they
	 * can be passed optionally in an array.
	 * @param list - The list whose children are updated.
	 * @param children - An array of the children to be updated.
	 */

	function updateChildrenListItemValue(list, children) {
	  const childrenOrExisting = children || list.getChildren();

	  if (childrenOrExisting !== undefined) {
	    for (let i = 0; i < childrenOrExisting.length; i++) {
	      const child = childrenOrExisting[i];

	      if ($isListItemNode(child)) {
	        const prevValue = child.getValue();
	        const nextValue = $getListItemValue(child);

	        if (prevValue !== nextValue) {
	          child.setValue(nextValue);
	        }
	      }
	    }
	  }
	}
	/**
	 * Adds an empty ListNode/ListItemNode chain at listItemNode, so as to
	 * create an indent effect. Won't indent ListItemNodes that have a ListNode as
	 * a child, but does merge sibling ListItemNodes if one has a nested ListNode.
	 * @param listItemNode - The ListItemNode to be indented.
	 */

	function $handleIndent(listItemNode) {
	  // go through each node and decide where to move it.
	  const removed = new Set();

	  if (isNestedListNode(listItemNode) || removed.has(listItemNode.getKey())) {
	    return;
	  }

	  const parent = listItemNode.getParent(); // We can cast both of the below `isNestedListNode` only returns a boolean type instead of a user-defined type guards

	  const nextSibling = listItemNode.getNextSibling();
	  const previousSibling = listItemNode.getPreviousSibling(); // if there are nested lists on either side, merge them all together.

	  if (isNestedListNode(nextSibling) && isNestedListNode(previousSibling)) {
	    const innerList = previousSibling.getFirstChild();

	    if ($isListNode(innerList)) {
	      innerList.append(listItemNode);
	      const nextInnerList = nextSibling.getFirstChild();

	      if ($isListNode(nextInnerList)) {
	        const children = nextInnerList.getChildren();
	        append(innerList, children);
	        nextSibling.remove();
	        removed.add(nextSibling.getKey());
	      }

	      updateChildrenListItemValue(innerList);
	    }
	  } else if (isNestedListNode(nextSibling)) {
	    // if the ListItemNode is next to a nested ListNode, merge them
	    const innerList = nextSibling.getFirstChild();

	    if ($isListNode(innerList)) {
	      const firstChild = innerList.getFirstChild();

	      if (firstChild !== null) {
	        firstChild.insertBefore(listItemNode);
	      }

	      updateChildrenListItemValue(innerList);
	    }
	  } else if (isNestedListNode(previousSibling)) {
	    const innerList = previousSibling.getFirstChild();

	    if ($isListNode(innerList)) {
	      innerList.append(listItemNode);
	      updateChildrenListItemValue(innerList);
	    }
	  } else {
	    // otherwise, we need to create a new nested ListNode
	    if ($isListNode(parent)) {
	      const newListItem = $createListItemNode();
	      const newList = $createListNode(parent.getListType());
	      newListItem.append(newList);
	      newList.append(listItemNode);

	      if (previousSibling) {
	        previousSibling.insertAfter(newListItem);
	      } else if (nextSibling) {
	        nextSibling.insertBefore(newListItem);
	      } else {
	        parent.append(newListItem);
	      }

	      updateChildrenListItemValue(newList);
	    }
	  }

	  if ($isListNode(parent)) {
	    updateChildrenListItemValue(parent);
	  }
	}
	/**
	 * Removes an indent by removing an empty ListNode/ListItemNode chain. An indented ListItemNode
	 * has a great grandparent node of type ListNode, which is where the ListItemNode will reside
	 * within as a child.
	 * @param listItemNode - The ListItemNode to remove the indent (outdent).
	 */

	function $handleOutdent(listItemNode) {
	  // go through each node and decide where to move it.
	  if (isNestedListNode(listItemNode)) {
	    return;
	  }

	  const parentList = listItemNode.getParent();
	  const grandparentListItem = parentList ? parentList.getParent() : undefined;
	  const greatGrandparentList = grandparentListItem ? grandparentListItem.getParent() : undefined; // If it doesn't have these ancestors, it's not indented.

	  if ($isListNode(greatGrandparentList) && $isListItemNode(grandparentListItem) && $isListNode(parentList)) {
	    // if it's the first child in it's parent list, insert it into the
	    // great grandparent list before the grandparent
	    const firstChild = parentList ? parentList.getFirstChild() : undefined;
	    const lastChild = parentList ? parentList.getLastChild() : undefined;

	    if (listItemNode.is(firstChild)) {
	      grandparentListItem.insertBefore(listItemNode);

	      if (parentList.isEmpty()) {
	        grandparentListItem.remove();
	      } // if it's the last child in it's parent list, insert it into the
	      // great grandparent list after the grandparent.

	    } else if (listItemNode.is(lastChild)) {
	      grandparentListItem.insertAfter(listItemNode);

	      if (parentList.isEmpty()) {
	        grandparentListItem.remove();
	      }
	    } else {
	      // otherwise, we need to split the siblings into two new nested lists
	      const listType = parentList.getListType();
	      const previousSiblingsListItem = $createListItemNode();
	      const previousSiblingsList = $createListNode(listType);
	      previousSiblingsListItem.append(previousSiblingsList);
	      listItemNode.getPreviousSiblings().forEach(sibling => previousSiblingsList.append(sibling));
	      const nextSiblingsListItem = $createListItemNode();
	      const nextSiblingsList = $createListNode(listType);
	      nextSiblingsListItem.append(nextSiblingsList);
	      append(nextSiblingsList, listItemNode.getNextSiblings()); // put the sibling nested lists on either side of the grandparent list item in the great grandparent.

	      grandparentListItem.insertBefore(previousSiblingsListItem);
	      grandparentListItem.insertAfter(nextSiblingsListItem); // replace the grandparent list item (now between the siblings) with the outdented list item.

	      grandparentListItem.replace(listItemNode);
	    }

	    updateChildrenListItemValue(parentList);
	    updateChildrenListItemValue(greatGrandparentList);
	  }
	}
	/**
	 * Attempts to insert a ParagraphNode at selection and selects the new node. The selection must contain a ListItemNode
	 * or a node that does not already contain text. If its grandparent is the root/shadow root, it will get the ListNode
	 * (which should be the parent node) and insert the ParagraphNode as a sibling to the ListNode. If the ListNode is
	 * nested in a ListItemNode instead, it will add the ParagraphNode after the grandparent ListItemNode.
	 * Throws an invariant if the selection is not a child of a ListNode.
	 * @returns true if a ParagraphNode was inserted succesfully, false if there is no selection
	 * or the selection does not contain a ListItemNode or the node already holds text.
	 */

	function $handleListInsertParagraph() {
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection) || !selection.isCollapsed()) {
	    return false;
	  } // Only run this code on empty list items


	  const anchor = selection.anchor.getNode();

	  if (!$isListItemNode(anchor) || anchor.getTextContent() !== '') {
	    return false;
	  }

	  const topListNode = $getTopListNode(anchor);
	  const parent = anchor.getParent();

	  if (!$isListNode(parent)) {
	    throw Error(`A ListItemNode must have a ListNode for a parent.`);
	  }

	  const grandparent = parent.getParent();
	  let replacementNode;

	  if (lexical.$isRootOrShadowRoot(grandparent)) {
	    replacementNode = lexical.$createParagraphNode();
	    topListNode.insertAfter(replacementNode);
	  } else if ($isListItemNode(grandparent)) {
	    replacementNode = $createListItemNode();
	    grandparent.insertAfter(replacementNode);
	  } else {
	    return false;
	  }

	  replacementNode.select();
	  const nextSiblings = anchor.getNextSiblings();

	  if (nextSiblings.length > 0) {
	    const newList = $createListNode(parent.getListType());

	    if (lexical.$isParagraphNode(replacementNode)) {
	      replacementNode.insertAfter(newList);
	    } else {
	      const newListItem = $createListItemNode();
	      newListItem.append(newList);
	      replacementNode.insertAfter(newListItem);
	    }

	    nextSiblings.forEach(sibling => {
	      sibling.remove();
	      newList.append(sibling);
	    });
	  } // Don't leave hanging nested empty lists


	  $removeHighestEmptyListParent(anchor);
	  return true;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	/** @noInheritDoc */
	class ListItemNode extends lexical.ElementNode {
	  /** @internal */

	  /** @internal */
	  static getType() {
	    return 'listitem';
	  }

	  static clone(node) {
	    return new ListItemNode(node.__value, node.__checked, node.__key);
	  }

	  constructor(value, checked, key) {
	    super(key);
	    this.__value = value === undefined ? 1 : value;
	    this.__checked = checked;
	  }

	  createDOM(config) {
	    const element = document.createElement('li');
	    const parent = this.getParent();

	    if ($isListNode(parent) && parent.getListType() === 'check') {
	      updateListItemChecked(element, this, null);
	    }

	    element.value = this.__value;
	    $setListItemThemeClassNames(element, config.theme, this);
	    return element;
	  }

	  updateDOM(prevNode, dom, config) {
	    const parent = this.getParent();

	    if ($isListNode(parent) && parent.getListType() === 'check') {
	      updateListItemChecked(dom, this, prevNode);
	    } // @ts-expect-error - this is always HTMLListItemElement


	    dom.value = this.__value;
	    $setListItemThemeClassNames(dom, config.theme, this);
	    return false;
	  }

	  static transform() {
	    return node => {
	      const parent = node.getParent();

	      if ($isListNode(parent)) {
	        updateChildrenListItemValue(parent);

	        if (parent.getListType() !== 'check' && node.getChecked() != null) {
	          node.setChecked(undefined);
	        }
	      }
	    };
	  }

	  static importDOM() {
	    return {
	      li: node => ({
	        conversion: convertListItemElement,
	        priority: 0
	      })
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createListItemNode();
	    node.setChecked(serializedNode.checked);
	    node.setValue(serializedNode.value);
	    node.setFormat(serializedNode.format);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      checked: this.getChecked(),
	      type: 'listitem',
	      value: this.getValue(),
	      version: 1
	    };
	  }

	  append(...nodes) {
	    for (let i = 0; i < nodes.length; i++) {
	      const node = nodes[i];

	      if (lexical.$isElementNode(node) && this.canMergeWith(node)) {
	        const children = node.getChildren();
	        this.append(...children);
	        node.remove();
	      } else {
	        super.append(node);
	      }
	    }

	    return this;
	  }

	  replace(replaceWithNode, includeChildren) {
	    if ($isListItemNode(replaceWithNode)) {
	      return super.replace(replaceWithNode);
	    }

	    this.setIndent(0);
	    const list = this.getParentOrThrow();
	    if (!$isListNode(list)) return replaceWithNode;

	    if (list.__first === this.getKey()) {
	      list.insertBefore(replaceWithNode);
	    } else if (list.__last === this.getKey()) {
	      list.insertAfter(replaceWithNode);
	    } else {
	      // Split the list
	      const newList = $createListNode(list.getListType());
	      let nextSibling = this.getNextSibling();

	      while (nextSibling) {
	        const nodeToAppend = nextSibling;
	        nextSibling = nextSibling.getNextSibling();
	        newList.append(nodeToAppend);
	      }

	      list.insertAfter(replaceWithNode);
	      replaceWithNode.insertAfter(newList);
	    }

	    if (includeChildren) {
	      this.getChildren().forEach(child => {
	        replaceWithNode.append(child);
	      });
	    }

	    this.remove();

	    if (list.getChildrenSize() === 0) {
	      list.remove();
	    }

	    return replaceWithNode;
	  }

	  insertAfter(node, restoreSelection = true) {
	    const listNode = this.getParentOrThrow();

	    if (!$isListNode(listNode)) {
	      {
	        throw Error(`insertAfter: list node is not parent of list item node`);
	      }
	    }

	    const siblings = this.getNextSiblings();

	    if ($isListItemNode(node)) {
	      const after = super.insertAfter(node, restoreSelection);
	      const afterListNode = node.getParentOrThrow();

	      if ($isListNode(afterListNode)) {
	        updateChildrenListItemValue(afterListNode);
	      }

	      return after;
	    } // Attempt to merge if the list is of the same type.


	    if ($isListNode(node)) {
	      let child = node;
	      const children = node.getChildren();

	      for (let i = children.length - 1; i >= 0; i--) {
	        child = children[i];
	        this.insertAfter(child, restoreSelection);
	      }

	      return child;
	    } // Otherwise, split the list
	    // Split the lists and insert the node in between them


	    listNode.insertAfter(node, restoreSelection);

	    if (siblings.length !== 0) {
	      const newListNode = $createListNode(listNode.getListType());
	      siblings.forEach(sibling => newListNode.append(sibling));
	      node.insertAfter(newListNode, restoreSelection);
	    }

	    return node;
	  }

	  remove(preserveEmptyParent) {
	    const prevSibling = this.getPreviousSibling();
	    const nextSibling = this.getNextSibling();
	    super.remove(preserveEmptyParent);

	    if (prevSibling && nextSibling && isNestedListNode(prevSibling) && isNestedListNode(nextSibling)) {
	      mergeLists(prevSibling.getFirstChild(), nextSibling.getFirstChild());
	      nextSibling.remove();
	    } else if (nextSibling) {
	      const parent = nextSibling.getParent();

	      if ($isListNode(parent)) {
	        updateChildrenListItemValue(parent);
	      }
	    }
	  }

	  insertNewAfter(_, restoreSelection = true) {
	    const newElement = $createListItemNode(this.__checked == null ? undefined : false);
	    this.insertAfter(newElement, restoreSelection);
	    return newElement;
	  }

	  collapseAtStart(selection) {
	    const paragraph = lexical.$createParagraphNode();
	    const children = this.getChildren();
	    children.forEach(child => paragraph.append(child));
	    const listNode = this.getParentOrThrow();
	    const listNodeParent = listNode.getParentOrThrow();
	    const isIndented = $isListItemNode(listNodeParent);

	    if (listNode.getChildrenSize() === 1) {
	      if (isIndented) {
	        // if the list node is nested, we just want to remove it,
	        // effectively unindenting it.
	        listNode.remove();
	        listNodeParent.select();
	      } else {
	        listNode.insertBefore(paragraph);
	        listNode.remove(); // If we have selection on the list item, we'll need to move it
	        // to the paragraph

	        const anchor = selection.anchor;
	        const focus = selection.focus;
	        const key = paragraph.getKey();

	        if (anchor.type === 'element' && anchor.getNode().is(this)) {
	          anchor.set(key, anchor.offset, 'element');
	        }

	        if (focus.type === 'element' && focus.getNode().is(this)) {
	          focus.set(key, focus.offset, 'element');
	        }
	      }
	    } else {
	      listNode.insertBefore(paragraph);
	      this.remove();
	    }

	    return true;
	  }

	  getValue() {
	    const self = this.getLatest();
	    return self.__value;
	  }

	  setValue(value) {
	    const self = this.getWritable();
	    self.__value = value;
	  }

	  getChecked() {
	    const self = this.getLatest();
	    return self.__checked;
	  }

	  setChecked(checked) {
	    const self = this.getWritable();
	    self.__checked = checked;
	  }

	  toggleChecked() {
	    this.setChecked(!this.__checked);
	  }

	  getIndent() {
	    // If we don't have a parent, we are likely serializing
	    const parent = this.getParent();

	    if (parent === null) {
	      return this.getLatest().__indent;
	    } // ListItemNode should always have a ListNode for a parent.


	    let listNodeParent = parent.getParentOrThrow();
	    let indentLevel = 0;

	    while ($isListItemNode(listNodeParent)) {
	      listNodeParent = listNodeParent.getParentOrThrow().getParentOrThrow();
	      indentLevel++;
	    }

	    return indentLevel;
	  }

	  setIndent(indent) {
	    if (!(typeof indent === 'number' && indent > -1)) {
	      throw Error(`Invalid indent value.`);
	    }

	    let currentIndent = this.getIndent();

	    while (currentIndent !== indent) {
	      if (currentIndent < indent) {
	        $handleIndent(this);
	        currentIndent++;
	      } else {
	        $handleOutdent(this);
	        currentIndent--;
	      }
	    }

	    return this;
	  }

	  insertBefore(nodeToInsert) {
	    if ($isListItemNode(nodeToInsert)) {
	      const parent = this.getParentOrThrow();

	      if ($isListNode(parent)) {
	        const siblings = this.getNextSiblings();
	        updateChildrenListItemValue(parent, siblings);
	      }
	    }

	    return super.insertBefore(nodeToInsert);
	  }

	  canInsertAfter(node) {
	    return $isListItemNode(node);
	  }

	  canReplaceWith(replacement) {
	    return $isListItemNode(replacement);
	  }

	  canMergeWith(node) {
	    return lexical.$isParagraphNode(node) || $isListItemNode(node);
	  }

	  extractWithChild(child, selection) {
	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    const anchorNode = selection.anchor.getNode();
	    const focusNode = selection.focus.getNode();
	    return this.isParentOf(anchorNode) && this.isParentOf(focusNode) && this.getTextContent().length === selection.getTextContent().length;
	  }

	  isParentRequired() {
	    return true;
	  }

	  createParentElementNode() {
	    return $createListNode('bullet');
	  }

	}

	function $setListItemThemeClassNames(dom, editorThemeClasses, node) {
	  const classesToAdd = [];
	  const classesToRemove = [];
	  const listTheme = editorThemeClasses.list;
	  const listItemClassName = listTheme ? listTheme.listitem : undefined;
	  let nestedListItemClassName;

	  if (listTheme && listTheme.nested) {
	    nestedListItemClassName = listTheme.nested.listitem;
	  }

	  if (listItemClassName !== undefined) {
	    const listItemClasses = listItemClassName.split(' ');
	    classesToAdd.push(...listItemClasses);
	  }

	  if (listTheme) {
	    const parentNode = node.getParent();
	    const isCheckList = $isListNode(parentNode) && parentNode.getListType() === 'check';
	    const checked = node.getChecked();

	    if (!isCheckList || checked) {
	      classesToRemove.push(listTheme.listitemUnchecked);
	    }

	    if (!isCheckList || !checked) {
	      classesToRemove.push(listTheme.listitemChecked);
	    }

	    if (isCheckList) {
	      classesToAdd.push(checked ? listTheme.listitemChecked : listTheme.listitemUnchecked);
	    }
	  }

	  if (nestedListItemClassName !== undefined) {
	    const nestedListItemClasses = nestedListItemClassName.split(' ');

	    if (node.getChildren().some(child => $isListNode(child))) {
	      classesToAdd.push(...nestedListItemClasses);
	    } else {
	      classesToRemove.push(...nestedListItemClasses);
	    }
	  }

	  if (classesToRemove.length > 0) {
	    utils.removeClassNamesFromElement(dom, ...classesToRemove);
	  }

	  if (classesToAdd.length > 0) {
	    utils.addClassNamesToElement(dom, ...classesToAdd);
	  }
	}

	function updateListItemChecked(dom, listItemNode, prevListItemNode, listNode) {
	  // Only add attributes for leaf list items
	  if ($isListNode(listItemNode.getFirstChild())) {
	    dom.removeAttribute('role');
	    dom.removeAttribute('tabIndex');
	    dom.removeAttribute('aria-checked');
	  } else {
	    dom.setAttribute('role', 'checkbox');
	    dom.setAttribute('tabIndex', '-1');

	    if (!prevListItemNode || listItemNode.__checked !== prevListItemNode.__checked) {
	      dom.setAttribute('aria-checked', listItemNode.getChecked() ? 'true' : 'false');
	    }
	  }
	}

	function convertListItemElement(domNode) {
	  const checked = utils.isHTMLElement(domNode) && domNode.getAttribute('aria-checked') === 'true';
	  return {
	    node: $createListItemNode(checked)
	  };
	}
	/**
	 * Creates a new List Item node, passing true/false will convert it to a checkbox input.
	 * @param checked - Is the List Item a checkbox and, if so, is it checked? undefined/null: not a checkbox, true/false is a checkbox and checked/unchecked, respectively.
	 * @returns The new List Item.
	 */


	function $createListItemNode(checked) {
	  return lexical.$applyNodeReplacement(new ListItemNode(undefined, checked));
	}
	/**
	 * Checks to see if the node is a ListItemNode.
	 * @param node - The node to be checked.
	 * @returns true if the node is a ListItemNode, false otherwise.
	 */

	function $isListItemNode(node) {
	  return node instanceof ListItemNode;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	/** @noInheritDoc */
	class ListNode extends lexical.ElementNode {
	  /** @internal */

	  /** @internal */

	  /** @internal */
	  static getType() {
	    return 'list';
	  }

	  static clone(node) {
	    const listType = node.__listType || TAG_TO_LIST_TYPE[node.__tag];
	    return new ListNode(listType, node.__start, node.__key);
	  }

	  constructor(listType, start, key) {
	    super(key);

	    const _listType = TAG_TO_LIST_TYPE[listType] || listType;

	    this.__listType = _listType;
	    this.__tag = _listType === 'number' ? 'ol' : 'ul';
	    this.__start = start;
	  }

	  getTag() {
	    return this.__tag;
	  }

	  setListType(type) {
	    const writable = this.getWritable();
	    writable.__listType = type;
	    writable.__tag = type === 'number' ? 'ol' : 'ul';
	  }

	  getListType() {
	    return this.__listType;
	  }

	  getStart() {
	    return this.__start;
	  } // View


	  createDOM(config, _editor) {
	    const tag = this.__tag;
	    const dom = document.createElement(tag);

	    if (this.__start !== 1) {
	      dom.setAttribute('start', String(this.__start));
	    } // @ts-expect-error Internal field.


	    dom.__lexicalListType = this.__listType;
	    setListThemeClassNames(dom, config.theme, this);
	    return dom;
	  }

	  updateDOM(prevNode, dom, config) {
	    if (prevNode.__tag !== this.__tag) {
	      return true;
	    }

	    setListThemeClassNames(dom, config.theme, this);
	    return false;
	  }

	  static importDOM() {
	    return {
	      ol: node => ({
	        conversion: convertListNode,
	        priority: 0
	      }),
	      ul: node => ({
	        conversion: convertListNode,
	        priority: 0
	      })
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createListNode(serializedNode.listType, serializedNode.start);
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  exportDOM(editor) {
	    const {
	      element
	    } = super.exportDOM(editor);

	    if (element) {
	      if (this.__start !== 1) {
	        element.setAttribute('start', String(this.__start));
	      }

	      if (this.__listType === 'check') {
	        element.setAttribute('__lexicalListType', 'check');
	      }
	    }

	    return {
	      element
	    };
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      listType: this.getListType(),
	      start: this.getStart(),
	      tag: this.getTag(),
	      type: 'list',
	      version: 1
	    };
	  }

	  canBeEmpty() {
	    return false;
	  }

	  canIndent() {
	    return false;
	  }

	  append(...nodesToAppend) {
	    for (let i = 0; i < nodesToAppend.length; i++) {
	      const currentNode = nodesToAppend[i];

	      if ($isListItemNode(currentNode)) {
	        super.append(currentNode);
	      } else {
	        const listItemNode = $createListItemNode();

	        if ($isListNode(currentNode)) {
	          listItemNode.append(currentNode);
	        } else if (lexical.$isElementNode(currentNode)) {
	          const textNode = lexical.$createTextNode(currentNode.getTextContent());
	          listItemNode.append(textNode);
	        } else {
	          listItemNode.append(currentNode);
	        }

	        super.append(listItemNode);
	      }
	    }

	    updateChildrenListItemValue(this);
	    return this;
	  }

	  extractWithChild(child) {
	    return $isListItemNode(child);
	  }

	}

	function setListThemeClassNames(dom, editorThemeClasses, node) {
	  const classesToAdd = [];
	  const classesToRemove = [];
	  const listTheme = editorThemeClasses.list;

	  if (listTheme !== undefined) {
	    const listLevelsClassNames = listTheme[`${node.__tag}Depth`] || [];
	    const listDepth = $getListDepth(node) - 1;
	    const normalizedListDepth = listDepth % listLevelsClassNames.length;
	    const listLevelClassName = listLevelsClassNames[normalizedListDepth];
	    const listClassName = listTheme[node.__tag];
	    let nestedListClassName;
	    const nestedListTheme = listTheme.nested;

	    if (nestedListTheme !== undefined && nestedListTheme.list) {
	      nestedListClassName = nestedListTheme.list;
	    }

	    if (listClassName !== undefined) {
	      classesToAdd.push(listClassName);
	    }

	    if (listLevelClassName !== undefined) {
	      const listItemClasses = listLevelClassName.split(' ');
	      classesToAdd.push(...listItemClasses);

	      for (let i = 0; i < listLevelsClassNames.length; i++) {
	        if (i !== normalizedListDepth) {
	          classesToRemove.push(node.__tag + i);
	        }
	      }
	    }

	    if (nestedListClassName !== undefined) {
	      const nestedListItemClasses = nestedListClassName.split(' ');

	      if (listDepth > 1) {
	        classesToAdd.push(...nestedListItemClasses);
	      } else {
	        classesToRemove.push(...nestedListItemClasses);
	      }
	    }
	  }

	  if (classesToRemove.length > 0) {
	    utils.removeClassNamesFromElement(dom, ...classesToRemove);
	  }

	  if (classesToAdd.length > 0) {
	    utils.addClassNamesToElement(dom, ...classesToAdd);
	  }
	}
	/*
	 * This function normalizes the children of a ListNode after the conversion from HTML,
	 * ensuring that they are all ListItemNodes and contain either a single nested ListNode
	 * or some other inline content.
	 */


	function normalizeChildren(nodes) {
	  const normalizedListItems = [];

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];

	    if ($isListItemNode(node)) {
	      normalizedListItems.push(node);
	      const children = node.getChildren();

	      if (children.length > 1) {
	        children.forEach(child => {
	          if ($isListNode(child)) {
	            normalizedListItems.push(wrapInListItem(child));
	          }
	        });
	      }
	    } else {
	      normalizedListItems.push(wrapInListItem(node));
	    }
	  }

	  return normalizedListItems;
	}

	function convertListNode(domNode) {
	  const nodeName = domNode.nodeName.toLowerCase();
	  let node = null;

	  if (nodeName === 'ol') {
	    // @ts-ignore
	    const start = domNode.start;
	    node = $createListNode('number', start);
	  } else if (nodeName === 'ul') {
	    if (utils.isHTMLElement(domNode) && domNode.getAttribute('__lexicallisttype') === 'check') {
	      node = $createListNode('check');
	    } else {
	      node = $createListNode('bullet');
	    }
	  }

	  return {
	    after: normalizeChildren,
	    node
	  };
	}

	const TAG_TO_LIST_TYPE = {
	  ol: 'number',
	  ul: 'bullet'
	};
	/**
	 * Creates a ListNode of listType.
	 * @param listType - The type of list to be created. Can be 'number', 'bullet', or 'check'.
	 * @param start - Where an ordered list starts its count, start = 1 if left undefined.
	 * @returns The new ListNode
	 */

	function $createListNode(listType, start = 1) {
	  return lexical.$applyNodeReplacement(new ListNode(listType, start));
	}
	/**
	 * Checks to see if the node is a ListNode.
	 * @param node - The node to be checked.
	 * @returns true if the node is a ListNode, false otherwise.
	 */

	function $isListNode(node) {
	  return node instanceof ListNode;
	}

	/** @module @lexical/list */
	const INSERT_UNORDERED_LIST_COMMAND = lexical.createCommand('INSERT_UNORDERED_LIST_COMMAND');
	const INSERT_ORDERED_LIST_COMMAND = lexical.createCommand('INSERT_ORDERED_LIST_COMMAND');
	const INSERT_CHECK_LIST_COMMAND = lexical.createCommand('INSERT_CHECK_LIST_COMMAND');
	const REMOVE_LIST_COMMAND = lexical.createCommand('REMOVE_LIST_COMMAND');

	LexicalList_dev.$createListItemNode = $createListItemNode;
	LexicalList_dev.$createListNode = $createListNode;
	LexicalList_dev.$getListDepth = $getListDepth;
	LexicalList_dev.$handleListInsertParagraph = $handleListInsertParagraph;
	LexicalList_dev.$isListItemNode = $isListItemNode;
	LexicalList_dev.$isListNode = $isListNode;
	LexicalList_dev.INSERT_CHECK_LIST_COMMAND = INSERT_CHECK_LIST_COMMAND;
	LexicalList_dev.INSERT_ORDERED_LIST_COMMAND = INSERT_ORDERED_LIST_COMMAND;
	LexicalList_dev.INSERT_UNORDERED_LIST_COMMAND = INSERT_UNORDERED_LIST_COMMAND;
	LexicalList_dev.ListItemNode = ListItemNode;
	LexicalList_dev.ListNode = ListNode;
	LexicalList_dev.REMOVE_LIST_COMMAND = REMOVE_LIST_COMMAND;
	LexicalList_dev.insertList = insertList;
	LexicalList_dev.removeList = removeList;
	return LexicalList_dev;
}

var LexicalList_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalList_prod;

function requireLexicalList_prod () {
	if (hasRequiredLexicalList_prod) return LexicalList_prod;
	hasRequiredLexicalList_prod = 1;
var h=require$$0__default["default"],k=LexicalUtils_1;function m(a){let b=new URLSearchParams;b.append("code",a);for(let c=1;c<arguments.length;c++)b.append("v",arguments[c]);throw Error(`Minified Lexical error #${a}; visit https://lexical.dev/docs/error?${b} for the full message or `+"use the non-minified dev environment for full errors and additional helpful warnings.");}
	function n(a){let b=1;for(a=a.getParent();null!=a;){if(p(a)){a=a.getParent();if(q(a)){b++;a=a.getParent();continue}m(40);}break}return b}function r(a){a=a.getParent();q(a)||m(40);let b=a;for(;null!==b;)b=b.getParent(),q(b)&&(a=b);return a}function t(a){let b=[];a=a.getChildren().filter(p);for(let c=0;c<a.length;c++){let d=a[c],e=d.getFirstChild();q(e)?b=b.concat(t(e)):b.push(d);}return b}function u(a){return p(a)&&q(a.getFirstChild())}
	function v(a){for(;null==a.getNextSibling()&&null==a.getPreviousSibling();){let b=a.getParent();if(null==b||!p(a)&&!q(a))break;a=b;}a.remove();}function w(a){return y().append(a)}function z(a,b){return p(a)&&(0===b.length||1===b.length&&a.is(b[0])&&0===a.getChildrenSize())}function B(a,b){a.splice(a.getChildrenSize(),0,b);}
	function C(a,b){if(q(a))return a;let c=a.getPreviousSibling(),d=a.getNextSibling(),e=y();e.setFormat(a.getFormatType());e.setIndent(a.getIndent());B(e,a.getChildren());if(q(c)&&b===c.getListType())return c.append(e),a.remove(),q(d)&&b===d.getListType()&&(B(c,d.getChildren()),d.remove()),c;if(q(d)&&b===d.getListType())return d.getFirstChildOrThrow().insertBefore(e),a.remove(),d;b=D(b);b.append(e);a.replace(b);E(b);return b}
	function F(a,b){var c=a.getLastChild();let d=b.getFirstChild();c&&d&&u(c)&&u(d)&&(F(c.getFirstChild(),d.getFirstChild()),d.remove());c=b.getChildren();0<c.length&&(a.append(...c),E(a));b.remove();}function E(a,b){a=b||a.getChildren();if(void 0!==a)for(b=0;b<a.length;b++){let f=a[b];if(p(f)){let g=f.getValue();var c=f,d=c.getParent(),e=1;null!=d&&(q(d)?e=d.getStart():m(44));c=c.getPreviousSiblings();for(d=0;d<c.length;d++){let l=c[d];p(l)&&!q(l.getFirstChild())&&e++;}g!==e&&f.setValue(e);}}}
	function G(a){if(!u(a)){var b=a.getParent(),c=b?b.getParent():void 0,d=c?c.getParent():void 0;if(q(d)&&p(c)&&q(b)){var e=b?b.getFirstChild():void 0,f=b?b.getLastChild():void 0;if(a.is(e))c.insertBefore(a),b.isEmpty()&&c.remove();else if(a.is(f))c.insertAfter(a),b.isEmpty()&&c.remove();else {var g=b.getListType();e=y();let l=D(g);e.append(l);a.getPreviousSiblings().forEach(x=>l.append(x));f=y();g=D(g);f.append(g);B(g,a.getNextSiblings());c.insertBefore(e);c.insertAfter(f);c.replace(a);}E(b);E(d);}}}
	class H extends h.ElementNode{static getType(){return "listitem"}static clone(a){return new H(a.__value,a.__checked,a.__key)}constructor(a,b,c){super(c);this.__value=void 0===a?1:a;this.__checked=b;}createDOM(a){let b=document.createElement("li"),c=this.getParent();q(c)&&"check"===c.getListType()&&I(b,this,null);b.value=this.__value;J(b,a.theme,this);return b}updateDOM(a,b,c){let d=this.getParent();q(d)&&"check"===d.getListType()&&I(b,this,a);b.value=this.__value;J(b,c.theme,this);return !1}static transform(){return a=>
	{let b=a.getParent();q(b)&&(E(b),"check"!==b.getListType()&&null!=a.getChecked()&&a.setChecked(void 0));}}static importDOM(){return {li:()=>({conversion:K,priority:0})}}static importJSON(a){let b=y();b.setChecked(a.checked);b.setValue(a.value);b.setFormat(a.format);b.setDirection(a.direction);return b}exportJSON(){return {...super.exportJSON(),checked:this.getChecked(),type:"listitem",value:this.getValue(),version:1}}append(...a){for(let b=0;b<a.length;b++){let c=a[b];if(h.$isElementNode(c)&&this.canMergeWith(c)){let d=
	c.getChildren();this.append(...d);c.remove();}else super.append(c);}return this}replace(a,b){if(p(a))return super.replace(a);this.setIndent(0);let c=this.getParentOrThrow();if(!q(c))return a;if(c.__first===this.getKey())c.insertBefore(a);else if(c.__last===this.getKey())c.insertAfter(a);else {let d=D(c.getListType()),e=this.getNextSibling();for(;e;){let f=e;e=e.getNextSibling();d.append(f);}c.insertAfter(a);a.insertAfter(d);}b&&this.getChildren().forEach(d=>{a.append(d);});this.remove();0===c.getChildrenSize()&&
	c.remove();return a}insertAfter(a,b=!0){var c=this.getParentOrThrow();q(c)||m(39);var d=this.getNextSiblings();if(p(a))return b=super.insertAfter(a,b),a=a.getParentOrThrow(),q(a)&&E(a),b;if(q(a)){c=a;a=a.getChildren();for(d=a.length-1;0<=d;d--)c=a[d],this.insertAfter(c,b);return c}c.insertAfter(a,b);if(0!==d.length){let e=D(c.getListType());d.forEach(f=>e.append(f));a.insertAfter(e,b);}return a}remove(a){let b=this.getPreviousSibling(),c=this.getNextSibling();super.remove(a);b&&c&&u(b)&&u(c)?(F(b.getFirstChild(),
	c.getFirstChild()),c.remove()):c&&(a=c.getParent(),q(a)&&E(a));}insertNewAfter(a,b=!0){a=y(null==this.__checked?void 0:!1);this.insertAfter(a,b);return a}collapseAtStart(a){let b=h.$createParagraphNode();this.getChildren().forEach(f=>b.append(f));var c=this.getParentOrThrow(),d=c.getParentOrThrow();let e=p(d);1===c.getChildrenSize()?e?(c.remove(),d.select()):(c.insertBefore(b),c.remove(),c=a.anchor,a=a.focus,d=b.getKey(),"element"===c.type&&c.getNode().is(this)&&c.set(d,c.offset,"element"),"element"===
	a.type&&a.getNode().is(this)&&a.set(d,a.offset,"element")):(c.insertBefore(b),this.remove());return !0}getValue(){return this.getLatest().__value}setValue(a){this.getWritable().__value=a;}getChecked(){return this.getLatest().__checked}setChecked(a){this.getWritable().__checked=a;}toggleChecked(){this.setChecked(!this.__checked);}getIndent(){var a=this.getParent();if(null===a)return this.getLatest().__indent;a=a.getParentOrThrow();let b=0;for(;p(a);)a=a.getParentOrThrow().getParentOrThrow(),b++;return b}setIndent(a){"number"===
	typeof a&&-1<a||m(117);let b=this.getIndent();for(;b!==a;)if(b<a){a:{var c=new Set;if(u(this)||c.has(this.getKey()))break a;let g=this.getParent();var d=this.getNextSibling(),e=this.getPreviousSibling();if(u(d)&&u(e)){if(e=e.getFirstChild(),q(e)){e.append(this);var f=d.getFirstChild();q(f)&&(f=f.getChildren(),B(e,f),d.remove(),c.add(d.getKey()));E(e);}}else u(d)?(d=d.getFirstChild(),q(d)&&(c=d.getFirstChild(),null!==c&&c.insertBefore(this),E(d))):u(e)?(d=e.getFirstChild(),q(d)&&(d.append(this),E(d))):
	q(g)&&(c=y(),f=D(g.getListType()),c.append(f),f.append(this),e?e.insertAfter(c):d?d.insertBefore(c):g.append(c),E(f));q(g)&&E(g);}b++;}else G(this),b--;return this}insertBefore(a){if(p(a)){let b=this.getParentOrThrow();if(q(b)){let c=this.getNextSiblings();E(b,c);}}return super.insertBefore(a)}canInsertAfter(a){return p(a)}canReplaceWith(a){return p(a)}canMergeWith(a){return h.$isParagraphNode(a)||p(a)}extractWithChild(a,b){if(!h.$isRangeSelection(b))return !1;a=b.anchor.getNode();let c=b.focus.getNode();
	return this.isParentOf(a)&&this.isParentOf(c)&&this.getTextContent().length===b.getTextContent().length}isParentRequired(){return !0}createParentElementNode(){return D("bullet")}}
	function J(a,b,c){let d=[],e=[];var f=(b=b.list)?b.listitem:void 0;if(b&&b.nested)var g=b.nested.listitem;void 0!==f&&(f=f.split(" "),d.push(...f));if(b){f=c.getParent();f=q(f)&&"check"===f.getListType();let l=c.getChecked();f&&!l||e.push(b.listitemUnchecked);f&&l||e.push(b.listitemChecked);f&&d.push(l?b.listitemChecked:b.listitemUnchecked);}void 0!==g&&(g=g.split(" "),c.getChildren().some(l=>q(l))?d.push(...g):e.push(...g));0<e.length&&k.removeClassNamesFromElement(a,...e);0<d.length&&k.addClassNamesToElement(a,
	...d);}function I(a,b,c){q(b.getFirstChild())?(a.removeAttribute("role"),a.removeAttribute("tabIndex"),a.removeAttribute("aria-checked")):(a.setAttribute("role","checkbox"),a.setAttribute("tabIndex","-1"),c&&b.__checked===c.__checked||a.setAttribute("aria-checked",b.getChecked()?"true":"false"));}function K(a){a=k.isHTMLElement(a)&&"true"===a.getAttribute("aria-checked");return {node:y(a)}}function y(a){return h.$applyNodeReplacement(new H(void 0,a))}function p(a){return a instanceof H}
	class L extends h.ElementNode{static getType(){return "list"}static clone(a){return new L(a.__listType||N[a.__tag],a.__start,a.__key)}constructor(a,b,c){super(c);this.__listType=a=N[a]||a;this.__tag="number"===a?"ol":"ul";this.__start=b;}getTag(){return this.__tag}setListType(a){let b=this.getWritable();b.__listType=a;b.__tag="number"===a?"ol":"ul";}getListType(){return this.__listType}getStart(){return this.__start}createDOM(a){let b=document.createElement(this.__tag);1!==this.__start&&b.setAttribute("start",
	String(this.__start));b.__lexicalListType=this.__listType;O(b,a.theme,this);return b}updateDOM(a,b,c){if(a.__tag!==this.__tag)return !0;O(b,c.theme,this);return !1}static importDOM(){return {ol:()=>({conversion:P,priority:0}),ul:()=>({conversion:P,priority:0})}}static importJSON(a){let b=D(a.listType,a.start);b.setFormat(a.format);b.setIndent(a.indent);b.setDirection(a.direction);return b}exportDOM(a){({element:a}=super.exportDOM(a));a&&(1!==this.__start&&a.setAttribute("start",String(this.__start)),
	"check"===this.__listType&&a.setAttribute("__lexicalListType","check"));return {element:a}}exportJSON(){return {...super.exportJSON(),listType:this.getListType(),start:this.getStart(),tag:this.getTag(),type:"list",version:1}}canBeEmpty(){return !1}canIndent(){return !1}append(...a){for(let c=0;c<a.length;c++){var b=a[c];if(p(b))super.append(b);else {let d=y();q(b)?d.append(b):h.$isElementNode(b)?(b=h.$createTextNode(b.getTextContent()),d.append(b)):d.append(b);super.append(d);}}E(this);return this}extractWithChild(a){return p(a)}}
	function O(a,b,c){let d=[],e=[];var f=b.list;if(void 0!==f){let l=f[`${c.__tag}Depth`]||[];b=n(c)-1;let x=b%l.length;var g=l[x];let M=f[c.__tag],A;f=f.nested;void 0!==f&&f.list&&(A=f.list);void 0!==M&&d.push(M);if(void 0!==g)for(g=g.split(" "),d.push(...g),g=0;g<l.length;g++)g!==x&&e.push(c.__tag+g);void 0!==A&&(c=A.split(" "),1<b?d.push(...c):e.push(...c));}0<e.length&&k.removeClassNamesFromElement(a,...e);0<d.length&&k.addClassNamesToElement(a,...d);}
	function Q(a){let b=[];for(let d=0;d<a.length;d++){var c=a[d];p(c)?(b.push(c),c=c.getChildren(),1<c.length&&c.forEach(e=>{q(e)&&b.push(w(e));})):b.push(w(c));}return b}function P(a){let b=a.nodeName.toLowerCase(),c=null;"ol"===b?c=D("number",a.start):"ul"===b&&(c=k.isHTMLElement(a)&&"check"===a.getAttribute("__lexicallisttype")?D("check"):D("bullet"));return {after:Q,node:c}}let N={ol:"number",ul:"bullet"};function D(a,b=1){return h.$applyNodeReplacement(new L(a,b))}
	function q(a){return a instanceof L}let R=h.createCommand("INSERT_UNORDERED_LIST_COMMAND"),S=h.createCommand("INSERT_ORDERED_LIST_COMMAND"),T=h.createCommand("INSERT_CHECK_LIST_COMMAND"),U=h.createCommand("REMOVE_LIST_COMMAND");LexicalList_prod.$createListItemNode=y;LexicalList_prod.$createListNode=D;LexicalList_prod.$getListDepth=n;
	LexicalList_prod.$handleListInsertParagraph=function(){var a=h.$getSelection();if(!h.$isRangeSelection(a)||!a.isCollapsed())return !1;a=a.anchor.getNode();if(!p(a)||""!==a.getTextContent())return !1;var b=r(a),c=a.getParent();q(c)||m(40);let d=c.getParent(),e;if(h.$isRootOrShadowRoot(d))e=h.$createParagraphNode(),b.insertAfter(e);else if(p(d))e=y(),d.insertAfter(e);else return !1;e.select();b=a.getNextSiblings();if(0<b.length){let f=D(c.getListType());h.$isParagraphNode(e)?e.insertAfter(f):(c=y(),c.append(f),
	e.insertAfter(c));b.forEach(g=>{g.remove();f.append(g);});}v(a);return !0};LexicalList_prod.$isListItemNode=p;LexicalList_prod.$isListNode=q;LexicalList_prod.INSERT_CHECK_LIST_COMMAND=T;LexicalList_prod.INSERT_ORDERED_LIST_COMMAND=S;LexicalList_prod.INSERT_UNORDERED_LIST_COMMAND=R;LexicalList_prod.ListItemNode=H;LexicalList_prod.ListNode=L;LexicalList_prod.REMOVE_LIST_COMMAND=U;
	LexicalList_prod.insertList=function(a,b){a.update(()=>{var c=h.$getSelection();if(h.$isRangeSelection(c)||h.DEPRECATED_$isGridSelection(c)){var d=c.getNodes();c=c.anchor.getNode();var e=c.getParent();if(z(c,d))d=D(b),h.$isRootOrShadowRoot(e)?(c.replace(d),e=y(),h.$isElementNode(c)&&(e.setFormat(c.getFormatType()),e.setIndent(c.getIndent())),d.append(e)):p(c)&&(c=c.getParentOrThrow(),B(d,c.getChildren()),c.replace(d));else for(c=new Set,e=0;e<d.length;e++){var f=d[e];if(h.$isElementNode(f)&&f.isEmpty()&&!c.has(f.getKey()))C(f,
	b);else if(h.$isLeafNode(f))for(f=f.getParent();null!=f;){let l=f.getKey();if(q(f)){if(!c.has(l)){var g=D(b);B(g,f.getChildren());f.replace(g);E(g);c.add(l);}break}else {g=f.getParent();if(h.$isRootOrShadowRoot(g)&&!c.has(l)){c.add(l);C(f,b);break}f=g;}}}}});};
	LexicalList_prod.removeList=function(a){a.update(()=>{let b=h.$getSelection();if(h.$isRangeSelection(b)){var c=new Set,d=b.getNodes(),e=b.anchor.getNode();if(z(e,d))c.add(r(e));else for(e=0;e<d.length;e++){var f=d[e];h.$isLeafNode(f)&&(f=k.$getNearestNodeOfType(f,H),null!=f&&c.add(r(f)));}for(let g of c){c=g;d=t(g);for(let l of d)d=h.$createParagraphNode(),B(d,l.getChildren()),c.insertAfter(d),c=d,l.__key===b.anchor.key&&b.anchor.set(d.getKey(),0,"element"),l.__key===b.focus.key&&b.focus.set(d.getKey(),0,"element"),
	l.remove();g.remove();}}});};
	return LexicalList_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalList = process.env.NODE_ENV === 'development' ? requireLexicalList_dev() : requireLexicalList_prod();
var LexicalList_1 = LexicalList;

var LexicalRichText_dev = {};

var LexicalClipboard_dev = {};

var LexicalHtml_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalHtml_dev;

function requireLexicalHtml_dev () {
	if (hasRequiredLexicalHtml_dev) return LexicalHtml_dev;
	hasRequiredLexicalHtml_dev = 1;

	var selection = LexicalSelection_1;
	var lexical = require$$0__default["default"];

	/** @module @lexical/html */
	/**
	 * How you parse your html string to get a document is left up to you. In the browser you can use the native
	 * DOMParser API to generate a document (see clipboard.ts), but to use in a headless environment you can use JSDom
	 * or an equivilant library and pass in the document here.
	 */

	function $generateNodesFromDOM(editor, dom) {
	  const elements = dom.body ? dom.body.childNodes : [];
	  let lexicalNodes = [];

	  for (let i = 0; i < elements.length; i++) {
	    const element = elements[i];

	    if (!IGNORE_TAGS.has(element.nodeName)) {
	      const lexicalNode = $createNodesFromDOM(element, editor);

	      if (lexicalNode !== null) {
	        lexicalNodes = lexicalNodes.concat(lexicalNode);
	      }
	    }
	  }

	  return lexicalNodes;
	}
	function $generateHtmlFromNodes(editor, selection) {
	  if (typeof document === 'undefined' || typeof window === 'undefined') {
	    throw new Error('To use $generateHtmlFromNodes in headless mode please initialize a headless browser implementation such as JSDom before calling this function.');
	  }

	  const container = document.createElement('div');
	  const root = lexical.$getRoot();
	  const topLevelChildren = root.getChildren();

	  for (let i = 0; i < topLevelChildren.length; i++) {
	    const topLevelNode = topLevelChildren[i];
	    $appendNodesToHTML(editor, topLevelNode, container, selection);
	  }

	  return container.innerHTML;
	}

	function $appendNodesToHTML(editor, currentNode, parentElement, selection$1 = null) {
	  let shouldInclude = selection$1 != null ? currentNode.isSelected(selection$1) : true;
	  const shouldExclude = lexical.$isElementNode(currentNode) && currentNode.excludeFromCopy('html');
	  let target = currentNode;

	  if (selection$1 !== null) {
	    let clone = selection.$cloneWithProperties(currentNode);
	    clone = lexical.$isTextNode(clone) && selection$1 != null ? selection.$sliceSelectedTextNodeContent(selection$1, clone) : clone;
	    target = clone;
	  }

	  const children = lexical.$isElementNode(target) ? target.getChildren() : [];
	  const {
	    element,
	    after
	  } = target.exportDOM(editor);

	  if (!element) {
	    return false;
	  }

	  const fragment = document.createDocumentFragment();

	  for (let i = 0; i < children.length; i++) {
	    const childNode = children[i];
	    const shouldIncludeChild = $appendNodesToHTML(editor, childNode, fragment, selection$1);

	    if (!shouldInclude && lexical.$isElementNode(currentNode) && shouldIncludeChild && currentNode.extractWithChild(childNode, selection$1, 'html')) {
	      shouldInclude = true;
	    }
	  }

	  if (shouldInclude && !shouldExclude) {
	    element.append(fragment);
	    parentElement.append(element);

	    if (after) {
	      const newElement = after.call(target, element);
	      if (newElement) element.replaceWith(newElement);
	    }
	  } else {
	    parentElement.append(fragment);
	  }

	  return shouldInclude;
	}

	function getConversionFunction(domNode, editor) {
	  const {
	    nodeName
	  } = domNode;

	  const cachedConversions = editor._htmlConversions.get(nodeName.toLowerCase());

	  let currentConversion = null;

	  if (cachedConversions !== undefined) {
	    for (const cachedConversion of cachedConversions) {
	      const domConversion = cachedConversion(domNode);

	      if (domConversion !== null && (currentConversion === null || currentConversion.priority < domConversion.priority)) {
	        currentConversion = domConversion;
	      }
	    }
	  }

	  return currentConversion !== null ? currentConversion.conversion : null;
	}

	const IGNORE_TAGS = new Set(['STYLE', 'SCRIPT']);

	function $createNodesFromDOM(node, editor, forChildMap = new Map(), parentLexicalNode) {
	  let lexicalNodes = [];

	  if (IGNORE_TAGS.has(node.nodeName)) {
	    return lexicalNodes;
	  }

	  let currentLexicalNode = null;
	  const transformFunction = getConversionFunction(node, editor);
	  const transformOutput = transformFunction ? transformFunction(node) : null;
	  let postTransform = null;

	  if (transformOutput !== null) {
	    postTransform = transformOutput.after;
	    const transformNodes = transformOutput.node;
	    currentLexicalNode = Array.isArray(transformNodes) ? transformNodes[transformNodes.length - 1] : transformNodes;

	    if (currentLexicalNode !== null) {
	      for (const [, forChildFunction] of forChildMap) {
	        currentLexicalNode = forChildFunction(currentLexicalNode, parentLexicalNode);

	        if (!currentLexicalNode) {
	          break;
	        }
	      }

	      if (currentLexicalNode) {
	        lexicalNodes.push(...(Array.isArray(transformNodes) ? transformNodes : [currentLexicalNode]));
	      }
	    }

	    if (transformOutput.forChild != null) {
	      forChildMap.set(node.nodeName, transformOutput.forChild);
	    }
	  } // If the DOM node doesn't have a transformer, we don't know what
	  // to do with it but we still need to process any childNodes.


	  const children = node.childNodes;
	  let childLexicalNodes = [];

	  for (let i = 0; i < children.length; i++) {
	    childLexicalNodes.push(...$createNodesFromDOM(children[i], editor, new Map(forChildMap), currentLexicalNode));
	  }

	  if (postTransform != null) {
	    childLexicalNodes = postTransform(childLexicalNodes);
	  }

	  if (currentLexicalNode == null) {
	    // If it hasn't been converted to a LexicalNode, we hoist its children
	    // up to the same level as it.
	    lexicalNodes = lexicalNodes.concat(childLexicalNodes);
	  } else {
	    if (lexical.$isElementNode(currentLexicalNode)) {
	      // If the current node is a ElementNode after conversion,
	      // we can append all the children to it.
	      currentLexicalNode.append(...childLexicalNodes);
	    }
	  }

	  return lexicalNodes;
	}

	LexicalHtml_dev.$generateHtmlFromNodes = $generateHtmlFromNodes;
	LexicalHtml_dev.$generateNodesFromDOM = $generateNodesFromDOM;
	return LexicalHtml_dev;
}

var LexicalHtml_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalHtml_prod;

function requireLexicalHtml_prod () {
	if (hasRequiredLexicalHtml_prod) return LexicalHtml_prod;
	hasRequiredLexicalHtml_prod = 1;
var m=LexicalSelection_1,q=require$$0__default["default"];
	function r(c,d,h,a=null){let e=null!=a?d.isSelected(a):!0,k=q.$isElementNode(d)&&d.excludeFromCopy("html");var f=d;null!==a&&(f=m.$cloneWithProperties(d),f=q.$isTextNode(f)&&null!=a?m.$sliceSelectedTextNodeContent(a,f):f);let g=q.$isElementNode(f)?f.getChildren():[],{element:b,after:l}=f.exportDOM(c);if(!b)return !1;let n=document.createDocumentFragment();for(let p=0;p<g.length;p++){let t=g[p],w=r(c,t,n,a);!e&&q.$isElementNode(d)&&w&&d.extractWithChild(t,a,"html")&&(e=!0);}e&&!k?(b.append(n),h.append(b),
	l&&(c=l.call(f,b))&&b.replaceWith(c)):h.append(n);return e}let u=new Set(["STYLE","SCRIPT"]);
	function v(c,d,h=new Map,a){let e=[];if(u.has(c.nodeName))return e;let k=null;var f,{nodeName:g}=c,b=d._htmlConversions.get(g.toLowerCase());g=null;if(void 0!==b)for(f of b)b=f(c),null!==b&&(null===g||g.priority<b.priority)&&(g=b);g=(f=null!==g?g.conversion:null)?f(c):null;f=null;if(null!==g){f=g.after;b=g.node;k=Array.isArray(b)?b[b.length-1]:b;if(null!==k){for(var [,l]of h)if(k=l(k,a),!k)break;k&&e.push(...(Array.isArray(b)?b:[k]));}null!=g.forChild&&h.set(c.nodeName,g.forChild);}c=c.childNodes;a=
	[];for(l=0;l<c.length;l++)a.push(...v(c[l],d,new Map(h),k));null!=f&&(a=f(a));null==k?e=e.concat(a):q.$isElementNode(k)&&k.append(...a);return e}
	LexicalHtml_prod.$generateHtmlFromNodes=function(c,d){if("undefined"===typeof document||"undefined"===typeof window)throw Error("To use $generateHtmlFromNodes in headless mode please initialize a headless browser implementation such as JSDom before calling this function.");let h=document.createElement("div"),a=q.$getRoot().getChildren();for(let e=0;e<a.length;e++)r(c,a[e],h,d);return h.innerHTML};
	LexicalHtml_prod.$generateNodesFromDOM=function(c,d){d=d.body?d.body.childNodes:[];let h=[];for(let e=0;e<d.length;e++){var a=d[e];u.has(a.nodeName)||(a=v(a,c),null!==a&&(h=h.concat(a)));}return h};
	return LexicalHtml_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalHtml = process.env.NODE_ENV === 'development' ? requireLexicalHtml_dev() : requireLexicalHtml_prod();
var LexicalHtml_1 = LexicalHtml;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalClipboard_dev;

function requireLexicalClipboard_dev () {
	if (hasRequiredLexicalClipboard_dev) return LexicalClipboard_dev;
	hasRequiredLexicalClipboard_dev = 1;

	var html = LexicalHtml_1;
	var selection = LexicalSelection_1;
	var utils = LexicalUtils_1;
	var lexical = require$$0__default["default"];

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const CAN_USE_DOM = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined';

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	const getDOMSelection = targetWindow => CAN_USE_DOM ? (targetWindow || window).getSelection() : null;
	/**
	 * Returns the *currently selected* Lexical content as an HTML string, relying on the
	 * logic defined in the exportDOM methods on the LexicalNode classes. Note that
	 * this will not return the HTML content of the entire editor (unless all the content is included
	 * in the current selection).
	 *
	 * @param editor - LexicalEditor instance to get HTML content from
	 * @returns a string of HTML content
	 */


	function $getHtmlContent(editor) {
	  const selection = lexical.$getSelection();

	  if (selection == null) {
	    {
	      throw Error(`Expected valid LexicalSelection`);
	    }
	  } // If we haven't selected anything


	  if (lexical.$isRangeSelection(selection) && selection.isCollapsed() || selection.getNodes().length === 0) {
	    return '';
	  }

	  return html.$generateHtmlFromNodes(editor, selection);
	}
	/**
	 * Returns the *currently selected* Lexical content as a JSON string, relying on the
	 * logic defined in the exportJSON methods on the LexicalNode classes. Note that
	 * this will not return the JSON content of the entire editor (unless all the content is included
	 * in the current selection).
	 *
	 * @param editor  - LexicalEditor instance to get the JSON content from
	 * @returns
	 */

	function $getLexicalContent(editor) {
	  const selection = lexical.$getSelection();

	  if (selection == null) {
	    {
	      throw Error(`Expected valid LexicalSelection`);
	    }
	  } // If we haven't selected anything


	  if (lexical.$isRangeSelection(selection) && selection.isCollapsed() || selection.getNodes().length === 0) {
	    return null;
	  }

	  return JSON.stringify($generateJSONFromSelectedNodes(editor, selection));
	}
	/**
	 * Attempts to insert content of the mime-types text/plain or text/uri-list from
	 * the provided DataTransfer object into the editor at the provided selection.
	 * text/uri-list is only used if text/plain is not also provided.
	 *
	 * @param dataTransfer an object conforming to the [DataTransfer interface] (https://html.spec.whatwg.org/multipage/dnd.html#the-datatransfer-interface)
	 * @param selection the selection to use as the insertion point for the content in the DataTransfer object
	 */

	function $insertDataTransferForPlainText(dataTransfer, selection) {
	  const text = dataTransfer.getData('text/plain') || dataTransfer.getData('text/uri-list');

	  if (text != null) {
	    selection.insertRawText(text);
	  }
	}
	/**
	 * Attempts to insert content of the mime-types application/x-lexical-editor, text/html,
	 * text/plain, or text/uri-list (in descending order of priority) from the provided DataTransfer
	 * object into the editor at the provided selection.
	 *
	 * @param dataTransfer an object conforming to the [DataTransfer interface] (https://html.spec.whatwg.org/multipage/dnd.html#the-datatransfer-interface)
	 * @param selection the selection to use as the insertion point for the content in the DataTransfer object
	 * @param editor the LexicalEditor the content is being inserted into.
	 */

	function $insertDataTransferForRichText(dataTransfer, selection, editor) {
	  const lexicalString = dataTransfer.getData('application/x-lexical-editor');

	  if (lexicalString) {
	    try {
	      const payload = JSON.parse(lexicalString);

	      if (payload.namespace === editor._config.namespace && Array.isArray(payload.nodes)) {
	        const nodes = $generateNodesFromSerializedNodes(payload.nodes);
	        return $insertGeneratedNodes(editor, nodes, selection);
	      }
	    } catch {// Fail silently.
	    }
	  }

	  const htmlString = dataTransfer.getData('text/html');

	  if (htmlString) {
	    try {
	      const parser = new DOMParser();
	      const dom = parser.parseFromString(htmlString, 'text/html');
	      const nodes = html.$generateNodesFromDOM(editor, dom);
	      return $insertGeneratedNodes(editor, nodes, selection);
	    } catch {// Fail silently.
	    }
	  } // Multi-line plain text in rich text mode pasted as separate paragraphs
	  // instead of single paragraph with linebreaks.
	  // Webkit-specific: Supports read 'text/uri-list' in clipboard.


	  const text = dataTransfer.getData('text/plain') || dataTransfer.getData('text/uri-list');

	  if (text != null) {
	    if (lexical.$isRangeSelection(selection)) {
	      const parts = text.split(/(\r?\n|\t)/);
	      const partsLength = parts.length;

	      for (let i = 0; i < partsLength; i++) {
	        const part = parts[i];

	        if (part === '\n' || part === '\r\n') {
	          selection.insertParagraph();
	        } else if (part === '\t') {
	          selection.insertNodes([lexical.$createTabNode()]);
	        } else {
	          selection.insertText(part);
	        }
	      }
	    } else {
	      selection.insertRawText(text);
	    }
	  }
	}
	/**
	 * Inserts Lexical nodes into the editor using different strategies depending on
	 * some simple selection-based heuristics. If you're looking for a generic way to
	 * to insert nodes into the editor at a specific selection point, you probably want
	 * {@link lexical.$insertNodes}
	 *
	 * @param editor LexicalEditor instance to insert the nodes into.
	 * @param nodes The nodes to insert.
	 * @param selection The selection to insert the nodes into.
	 */

	function $insertGeneratedNodes(editor, nodes, selection) {
	  const isSelectionInsideOfGrid = lexical.DEPRECATED_$isGridSelection(selection) || utils.$findMatchingParent(selection.anchor.getNode(), n => lexical.DEPRECATED_$isGridCellNode(n)) !== null && utils.$findMatchingParent(selection.focus.getNode(), n => lexical.DEPRECATED_$isGridCellNode(n)) !== null;

	  if (isSelectionInsideOfGrid && nodes.length === 1 && lexical.DEPRECATED_$isGridNode(nodes[0])) {
	    $mergeGridNodesStrategy(nodes, selection, false, editor);
	    return;
	  }

	  $basicInsertStrategy(nodes, selection);
	  return;
	}

	function $basicInsertStrategy(nodes, selection) {
	  // Wrap text and inline nodes in paragraph nodes so we have all blocks at the top-level
	  const topLevelBlocks = [];
	  let currentBlock = null;

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    const isLineBreakNode = lexical.$isLineBreakNode(node);

	    if (isLineBreakNode || lexical.$isDecoratorNode(node) && node.isInline() || lexical.$isElementNode(node) && node.isInline() || lexical.$isTextNode(node) || node.isParentRequired()) {
	      if (currentBlock === null) {
	        currentBlock = node.createParentElementNode();
	        topLevelBlocks.push(currentBlock); // In the case of LineBreakNode, we just need to
	        // add an empty ParagraphNode to the topLevelBlocks.

	        if (isLineBreakNode) {
	          continue;
	        }
	      }

	      if (currentBlock !== null) {
	        currentBlock.append(node);
	      }
	    } else {
	      topLevelBlocks.push(node);
	      currentBlock = null;
	    }
	  }

	  if (lexical.$isRangeSelection(selection)) {
	    selection.insertNodes(topLevelBlocks);
	  } else if (lexical.DEPRECATED_$isGridSelection(selection)) {
	    // If there's an active grid selection and a non grid is pasted, add to the anchor.
	    const anchorCell = selection.anchor.getNode();

	    if (!lexical.DEPRECATED_$isGridCellNode(anchorCell)) {
	      {
	        throw Error(`Expected Grid Cell in Grid Selection`);
	      }
	    }

	    anchorCell.append(...topLevelBlocks);
	  }
	}

	function $mergeGridNodesStrategy(nodes, selection, isFromLexical, editor) {
	  if (nodes.length !== 1 || !lexical.DEPRECATED_$isGridNode(nodes[0])) {
	    {
	      throw Error(`$mergeGridNodesStrategy: Expected Grid insertion.`);
	    }
	  }

	  const newGrid = nodes[0];
	  const newGridRows = newGrid.getChildren();
	  const newColumnCount = newGrid.getFirstChildOrThrow().getChildrenSize();
	  const newRowCount = newGrid.getChildrenSize();
	  const gridCellNode = utils.$findMatchingParent(selection.anchor.getNode(), n => lexical.DEPRECATED_$isGridCellNode(n));
	  const gridRowNode = gridCellNode && utils.$findMatchingParent(gridCellNode, n => lexical.DEPRECATED_$isGridRowNode(n));
	  const gridNode = gridRowNode && utils.$findMatchingParent(gridRowNode, n => lexical.DEPRECATED_$isGridNode(n));

	  if (!lexical.DEPRECATED_$isGridCellNode(gridCellNode) || !lexical.DEPRECATED_$isGridRowNode(gridRowNode) || !lexical.DEPRECATED_$isGridNode(gridNode)) {
	    {
	      throw Error(`$mergeGridNodesStrategy: Expected selection to be inside of a Grid.`);
	    }
	  }

	  const startY = gridRowNode.getIndexWithinParent();
	  const stopY = Math.min(gridNode.getChildrenSize() - 1, startY + newRowCount - 1);
	  const startX = gridCellNode.getIndexWithinParent();
	  const stopX = Math.min(gridRowNode.getChildrenSize() - 1, startX + newColumnCount - 1);
	  const fromX = Math.min(startX, stopX);
	  const fromY = Math.min(startY, stopY);
	  const toX = Math.max(startX, stopX);
	  const toY = Math.max(startY, stopY);
	  const gridRowNodes = gridNode.getChildren();
	  let newRowIdx = 0;
	  let newAnchorCellKey;
	  let newFocusCellKey;

	  for (let r = fromY; r <= toY; r++) {
	    const currentGridRowNode = gridRowNodes[r];

	    if (!lexical.DEPRECATED_$isGridRowNode(currentGridRowNode)) {
	      {
	        throw Error(`getNodes: expected to find GridRowNode`);
	      }
	    }

	    const newGridRowNode = newGridRows[newRowIdx];

	    if (!lexical.DEPRECATED_$isGridRowNode(newGridRowNode)) {
	      {
	        throw Error(`getNodes: expected to find GridRowNode`);
	      }
	    }

	    const gridCellNodes = currentGridRowNode.getChildren();
	    const newGridCellNodes = newGridRowNode.getChildren();
	    let newColumnIdx = 0;

	    for (let c = fromX; c <= toX; c++) {
	      const currentGridCellNode = gridCellNodes[c];

	      if (!lexical.DEPRECATED_$isGridCellNode(currentGridCellNode)) {
	        {
	          throw Error(`getNodes: expected to find GridCellNode`);
	        }
	      }

	      const newGridCellNode = newGridCellNodes[newColumnIdx];

	      if (!lexical.DEPRECATED_$isGridCellNode(newGridCellNode)) {
	        {
	          throw Error(`getNodes: expected to find GridCellNode`);
	        }
	      }

	      if (r === fromY && c === fromX) {
	        newAnchorCellKey = currentGridCellNode.getKey();
	      } else if (r === toY && c === toX) {
	        newFocusCellKey = currentGridCellNode.getKey();
	      }

	      const originalChildren = currentGridCellNode.getChildren();
	      newGridCellNode.getChildren().forEach(child => {
	        if (lexical.$isTextNode(child)) {
	          const paragraphNode = lexical.$createParagraphNode();
	          paragraphNode.append(child);
	          currentGridCellNode.append(child);
	        } else {
	          currentGridCellNode.append(child);
	        }
	      });
	      originalChildren.forEach(n => n.remove());
	      newColumnIdx++;
	    }

	    newRowIdx++;
	  }

	  if (newAnchorCellKey && newFocusCellKey) {
	    const newGridSelection = lexical.DEPRECATED_$createGridSelection();
	    newGridSelection.set(gridNode.getKey(), newAnchorCellKey, newFocusCellKey);
	    lexical.$setSelection(newGridSelection);
	    editor.dispatchCommand(lexical.SELECTION_CHANGE_COMMAND, undefined);
	  }
	}

	function exportNodeToJSON(node) {
	  const serializedNode = node.exportJSON();
	  const nodeClass = node.constructor; // @ts-expect-error TODO Replace Class utility type with InstanceType

	  if (serializedNode.type !== nodeClass.getType()) {
	    {
	      throw Error(`LexicalNode: Node ${nodeClass.name} does not implement .exportJSON().`);
	    }
	  } // @ts-expect-error TODO Replace Class utility type with InstanceType


	  const serializedChildren = serializedNode.children;

	  if (lexical.$isElementNode(node)) {
	    if (!Array.isArray(serializedChildren)) {
	      {
	        throw Error(`LexicalNode: Node ${nodeClass.name} is an element but .exportJSON() does not have a children array.`);
	      }
	    }
	  }

	  return serializedNode;
	}

	function $appendNodesToJSON(editor, selection$1, currentNode, targetArray = []) {
	  let shouldInclude = selection$1 != null ? currentNode.isSelected(selection$1) : true;
	  const shouldExclude = lexical.$isElementNode(currentNode) && currentNode.excludeFromCopy('html');
	  let target = currentNode;

	  if (selection$1 !== null) {
	    let clone = selection.$cloneWithProperties(currentNode);
	    clone = lexical.$isTextNode(clone) && selection$1 != null ? selection.$sliceSelectedTextNodeContent(selection$1, clone) : clone;
	    target = clone;
	  }

	  const children = lexical.$isElementNode(target) ? target.getChildren() : [];
	  const serializedNode = exportNodeToJSON(target); // TODO: TextNode calls getTextContent() (NOT node.__text) within it's exportJSON method
	  // which uses getLatest() to get the text from the original node with the same key.
	  // This is a deeper issue with the word "clone" here, it's still a reference to the
	  // same node as far as the LexicalEditor is concerned since it shares a key.
	  // We need a way to create a clone of a Node in memory with it's own key, but
	  // until then this hack will work for the selected text extract use case.

	  if (lexical.$isTextNode(target)) {
	    const text = target.__text; // If an uncollapsed selection ends or starts at the end of a line of specialized,
	    // TextNodes, such as code tokens, we will get a 'blank' TextNode here, i.e., one
	    // with text of length 0. We don't want this, it makes a confusing mess. Reset!

	    if (text.length > 0) {
	      serializedNode.text = text;
	    } else {
	      shouldInclude = false;
	    }
	  }

	  for (let i = 0; i < children.length; i++) {
	    const childNode = children[i];
	    const shouldIncludeChild = $appendNodesToJSON(editor, selection$1, childNode, serializedNode.children);

	    if (!shouldInclude && lexical.$isElementNode(currentNode) && shouldIncludeChild && currentNode.extractWithChild(childNode, selection$1, 'clone')) {
	      shouldInclude = true;
	    }
	  }

	  if (shouldInclude && !shouldExclude) {
	    targetArray.push(serializedNode);
	  } else if (Array.isArray(serializedNode.children)) {
	    for (let i = 0; i < serializedNode.children.length; i++) {
	      const serializedChildNode = serializedNode.children[i];
	      targetArray.push(serializedChildNode);
	    }
	  }

	  return shouldInclude;
	} // TODO why $ function with Editor instance?

	/**
	 * Gets the Lexical JSON of the nodes inside the provided Selection.
	 *
	 * @param editor LexicalEditor to get the JSON content from.
	 * @param selection Selection to get the JSON content from.
	 * @returns an object with the editor namespace and a list of serializable nodes as JavaScript objects.
	 */


	function $generateJSONFromSelectedNodes(editor, selection) {
	  const nodes = [];
	  const root = lexical.$getRoot();
	  const topLevelChildren = root.getChildren();

	  for (let i = 0; i < topLevelChildren.length; i++) {
	    const topLevelNode = topLevelChildren[i];
	    $appendNodesToJSON(editor, selection, topLevelNode, nodes);
	  }

	  return {
	    namespace: editor._config.namespace,
	    nodes
	  };
	}
	/**
	 * This method takes an array of objects conforming to the BaseSeralizedNode interface and returns
	 * an Array containing instances of the corresponding LexicalNode classes registered on the editor.
	 * Normally, you'd get an Array of BaseSerialized nodes from {@link $generateJSONFromSelectedNodes}
	 *
	 * @param serializedNodes an Array of objects conforming to the BaseSerializedNode interface.
	 * @returns an Array of Lexical Node objects.
	 */

	function $generateNodesFromSerializedNodes(serializedNodes) {
	  const nodes = [];

	  for (let i = 0; i < serializedNodes.length; i++) {
	    const serializedNode = serializedNodes[i];
	    const node = lexical.$parseSerializedNode(serializedNode);

	    if (lexical.$isTextNode(node)) {
	      selection.$addNodeStyle(node);
	    }

	    nodes.push(node);
	  }

	  return nodes;
	}
	const EVENT_LATENCY = 50;
	let clipboardEventTimeout = null; // TODO custom selection
	// TODO potentially have a node customizable version for plain text

	/**
	 * Copies the content of the current selection to the clipboard in
	 * text/plain, text/html, and application/x-lexical-editor (Lexical JSON)
	 * formats.
	 *
	 * @param editor the LexicalEditor instance to copy content from
	 * @param event the native browser ClipboardEvent to add the content to.
	 * @returns
	 */

	async function copyToClipboard(editor, event) {
	  if (clipboardEventTimeout !== null) {
	    // Prevent weird race conditions that can happen when this function is run multiple times
	    // synchronously. In the future, we can do better, we can cancel/override the previously running job.
	    return false;
	  }

	  if (event !== null) {
	    return new Promise((resolve, reject) => {
	      editor.update(() => {
	        resolve($copyToClipboardEvent(editor, event));
	      });
	    });
	  }

	  const rootElement = editor.getRootElement();
	  const windowDocument = editor._window == null ? window.document : editor._window.document;
	  const domSelection = getDOMSelection(editor._window);

	  if (rootElement === null || domSelection === null) {
	    return false;
	  }

	  const element = windowDocument.createElement('span');
	  element.style.cssText = 'position: fixed; top: -1000px;';
	  element.append(windowDocument.createTextNode('#'));
	  rootElement.append(element);
	  const range = new Range();
	  range.setStart(element, 0);
	  range.setEnd(element, 1);
	  domSelection.removeAllRanges();
	  domSelection.addRange(range);
	  return new Promise((resolve, reject) => {
	    const removeListener = editor.registerCommand(lexical.COPY_COMMAND, secondEvent => {
	      if (utils.objectKlassEquals(secondEvent, ClipboardEvent)) {
	        removeListener();

	        if (clipboardEventTimeout !== null) {
	          window.clearTimeout(clipboardEventTimeout);
	          clipboardEventTimeout = null;
	        }

	        resolve($copyToClipboardEvent(editor, secondEvent));
	      } // Block the entire copy flow while we wait for the next ClipboardEvent


	      return true;
	    }, lexical.COMMAND_PRIORITY_CRITICAL); // If the above hack execCommand hack works, this timeout code should never fire. Otherwise,
	    // the listener will be quickly freed so that the user can reuse it again

	    clipboardEventTimeout = window.setTimeout(() => {
	      removeListener();
	      clipboardEventTimeout = null;
	      resolve(false);
	    }, EVENT_LATENCY);
	    windowDocument.execCommand('copy');
	    element.remove();
	  });
	} // TODO shouldn't pass editor (pass namespace directly)

	function $copyToClipboardEvent(editor, event) {
	  const domSelection = getDOMSelection(editor._window);

	  if (!domSelection) {
	    return false;
	  }

	  const anchorDOM = domSelection.anchorNode;
	  const focusDOM = domSelection.focusNode;

	  if (anchorDOM !== null && focusDOM !== null && !lexical.isSelectionWithinEditor(editor, anchorDOM, focusDOM)) {
	    return false;
	  }

	  event.preventDefault();
	  const clipboardData = event.clipboardData;
	  const selection = lexical.$getSelection();

	  if (clipboardData === null || selection === null) {
	    return false;
	  }

	  const htmlString = $getHtmlContent(editor);
	  const lexicalString = $getLexicalContent(editor);
	  let plainString = '';

	  if (selection !== null) {
	    plainString = selection.getTextContent();
	  }

	  if (htmlString !== null) {
	    clipboardData.setData('text/html', htmlString);
	  }

	  if (lexicalString !== null) {
	    clipboardData.setData('application/x-lexical-editor', lexicalString);
	  }

	  clipboardData.setData('text/plain', plainString);
	  return true;
	}

	LexicalClipboard_dev.$generateJSONFromSelectedNodes = $generateJSONFromSelectedNodes;
	LexicalClipboard_dev.$generateNodesFromSerializedNodes = $generateNodesFromSerializedNodes;
	LexicalClipboard_dev.$getHtmlContent = $getHtmlContent;
	LexicalClipboard_dev.$getLexicalContent = $getLexicalContent;
	LexicalClipboard_dev.$insertDataTransferForPlainText = $insertDataTransferForPlainText;
	LexicalClipboard_dev.$insertDataTransferForRichText = $insertDataTransferForRichText;
	LexicalClipboard_dev.$insertGeneratedNodes = $insertGeneratedNodes;
	LexicalClipboard_dev.copyToClipboard = copyToClipboard;
	return LexicalClipboard_dev;
}

var LexicalClipboard_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalClipboard_prod;

function requireLexicalClipboard_prod () {
	if (hasRequiredLexicalClipboard_prod) return LexicalClipboard_prod;
	hasRequiredLexicalClipboard_prod = 1;
var d=LexicalHtml_1,p=LexicalSelection_1,r=LexicalUtils_1,u=require$$0__default["default"];function z(a){let b=new URLSearchParams;b.append("code",a);for(let c=1;c<arguments.length;c++)b.append("v",arguments[c]);throw Error(`Minified Lexical error #${a}; visit https://lexical.dev/docs/error?${b} for the full message or `+"use the non-minified dev environment for full errors and additional helpful warnings.");}
	let A="undefined"!==typeof window&&"undefined"!==typeof window.document&&"undefined"!==typeof window.document.createElement;function B(a){let b=u.$getSelection();if(null==b)throw Error("Expected valid LexicalSelection");return u.$isRangeSelection(b)&&b.isCollapsed()||0===b.getNodes().length?"":d.$generateHtmlFromNodes(a,b)}
	function C(a){let b=u.$getSelection();if(null==b)throw Error("Expected valid LexicalSelection");return u.$isRangeSelection(b)&&b.isCollapsed()||0===b.getNodes().length?null:JSON.stringify(D(a,b))}function E(a,b,c){(u.DEPRECATED_$isGridSelection(c)||null!==r.$findMatchingParent(c.anchor.getNode(),e=>u.DEPRECATED_$isGridCellNode(e))&&null!==r.$findMatchingParent(c.focus.getNode(),e=>u.DEPRECATED_$isGridCellNode(e)))&&1===b.length&&u.DEPRECATED_$isGridNode(b[0])?F(b,c,!1,a):I(b,c);}
	function I(a,b){let c=[],e=null;for(let f=0;f<a.length;f++){let h=a[f],g=u.$isLineBreakNode(h);if(g||u.$isDecoratorNode(h)&&h.isInline()||u.$isElementNode(h)&&h.isInline()||u.$isTextNode(h)||h.isParentRequired()){if(null===e&&(e=h.createParentElementNode(),c.push(e),g))continue;null!==e&&e.append(h);}else c.push(h),e=null;}u.$isRangeSelection(b)?b.insertNodes(c):u.DEPRECATED_$isGridSelection(b)&&(a=b.anchor.getNode(),u.DEPRECATED_$isGridCellNode(a)||z(41),a.append(...c));}
	function F(a,b,c,e){1===a.length&&u.DEPRECATED_$isGridNode(a[0])||z(42);var f=a[0];a=f.getChildren();c=f.getFirstChildOrThrow().getChildrenSize();var h=f.getChildrenSize(),g=r.$findMatchingParent(b.anchor.getNode(),l=>u.DEPRECATED_$isGridCellNode(l));b=(f=g&&r.$findMatchingParent(g,l=>u.DEPRECATED_$isGridRowNode(l)))&&r.$findMatchingParent(f,l=>u.DEPRECATED_$isGridNode(l));u.DEPRECATED_$isGridCellNode(g)&&u.DEPRECATED_$isGridRowNode(f)&&u.DEPRECATED_$isGridNode(b)||z(43);var k=f.getIndexWithinParent(),
	m=Math.min(b.getChildrenSize()-1,k+h-1);h=g.getIndexWithinParent();g=Math.min(f.getChildrenSize()-1,h+c-1);c=Math.min(h,g);f=Math.min(k,m);h=Math.max(h,g);k=Math.max(k,m);m=b.getChildren();g=0;let n,q;for(let l=f;l<=k;l++){var t=m[l];u.DEPRECATED_$isGridRowNode(t)||z(24);var y=a[g];u.DEPRECATED_$isGridRowNode(y)||z(24);t=t.getChildren();y=y.getChildren();let G=0;for(let v=c;v<=h;v++){let w=t[v];u.DEPRECATED_$isGridCellNode(w)||z(25);let H=y[G];u.DEPRECATED_$isGridCellNode(H)||z(25);l===f&&v===c?n=
	w.getKey():l===k&&v===h&&(q=w.getKey());let N=w.getChildren();H.getChildren().forEach(x=>{u.$isTextNode(x)&&u.$createParagraphNode().append(x);w.append(x);});N.forEach(x=>x.remove());G++;}g++;}n&&q&&(a=u.DEPRECATED_$createGridSelection(),a.set(b.getKey(),n,q),u.$setSelection(a),e.dispatchCommand(u.SELECTION_CHANGE_COMMAND,void 0));}
	function J(a,b,c,e=[]){let f=null!=b?c.isSelected(b):!0,h=u.$isElementNode(c)&&c.excludeFromCopy("html");var g=c;if(null!==b){var k=p.$cloneWithProperties(c);g=k=u.$isTextNode(k)&&null!=b?p.$sliceSelectedTextNodeContent(b,k):k;}let m=u.$isElementNode(g)?g.getChildren():[];var n=g;k=n.exportJSON();var q=n.constructor;k.type!==q.getType()&&z(58,q.name);let t=k.children;u.$isElementNode(n)&&(Array.isArray(t)||z(59,q.name));u.$isTextNode(g)&&(g=g.__text,0<g.length?k.text=g:f=!1);for(g=0;g<m.length;g++)n=
	m[g],q=J(a,b,n,k.children),!f&&u.$isElementNode(c)&&q&&c.extractWithChild(n,b,"clone")&&(f=!0);if(f&&!h)e.push(k);else if(Array.isArray(k.children))for(a=0;a<k.children.length;a++)e.push(k.children[a]);return f}function D(a,b){let c=[],e=u.$getRoot().getChildren();for(let f=0;f<e.length;f++)J(a,b,e[f],c);return {namespace:a._config.namespace,nodes:c}}function K(a){let b=[];for(let c=0;c<a.length;c++){let e=u.$parseSerializedNode(a[c]);u.$isTextNode(e)&&p.$addNodeStyle(e);b.push(e);}return b}let L=null;
	function M(a,b){var c=A?(a._window||window).getSelection():null;if(!c)return !1;var e=c.anchorNode;c=c.focusNode;if(null!==e&&null!==c&&!u.isSelectionWithinEditor(a,e,c))return !1;b.preventDefault();b=b.clipboardData;e=u.$getSelection();if(null===b||null===e)return !1;c=B(a);a=C(a);let f="";null!==e&&(f=e.getTextContent());null!==c&&b.setData("text/html",c);null!==a&&b.setData("application/x-lexical-editor",a);b.setData("text/plain",f);return !0}LexicalClipboard_prod.$generateJSONFromSelectedNodes=D;
	LexicalClipboard_prod.$generateNodesFromSerializedNodes=K;LexicalClipboard_prod.$getHtmlContent=B;LexicalClipboard_prod.$getLexicalContent=C;LexicalClipboard_prod.$insertDataTransferForPlainText=function(a,b){a=a.getData("text/plain")||a.getData("text/uri-list");null!=a&&b.insertRawText(a);};
	LexicalClipboard_prod.$insertDataTransferForRichText=function(a,b,c){var e=a.getData("application/x-lexical-editor");if(e)try{let g=JSON.parse(e);if(g.namespace===c._config.namespace&&Array.isArray(g.nodes)){let k=K(g.nodes);return E(c,k,b)}}catch{}if(e=a.getData("text/html"))try{var f=(new DOMParser).parseFromString(e,"text/html"),h=d.$generateNodesFromDOM(c,f);return E(c,h,b)}catch{}a=a.getData("text/plain")||a.getData("text/uri-list");if(null!=a)if(u.$isRangeSelection(b))for(a=a.split(/(\r?\n|\t)/),c=a.length,
	f=0;f<c;f++)h=a[f],"\n"===h||"\r\n"===h?b.insertParagraph():"\t"===h?b.insertNodes([u.$createTabNode()]):b.insertText(h);else b.insertRawText(a);};LexicalClipboard_prod.$insertGeneratedNodes=E;
	LexicalClipboard_prod.copyToClipboard=async function(a,b){if(null!==L)return !1;if(null!==b)return new Promise(g=>{a.update(()=>{g(M(a,b));});});var c=a.getRootElement();let e=null==a._window?window.document:a._window.document,f=A?(a._window||window).getSelection():null;if(null===c||null===f)return !1;let h=e.createElement("span");h.style.cssText="position: fixed; top: -1000px;";h.append(e.createTextNode("#"));c.append(h);c=new Range;c.setStart(h,0);c.setEnd(h,1);f.removeAllRanges();f.addRange(c);return new Promise(g=>
	{let k=a.registerCommand(u.COPY_COMMAND,m=>{r.objectKlassEquals(m,ClipboardEvent)&&(k(),null!==L&&(window.clearTimeout(L),L=null),g(M(a,m)));return !0},u.COMMAND_PRIORITY_CRITICAL);L=window.setTimeout(()=>{k();L=null;g(!1);},50);e.execCommand("copy");h.remove();})};
	return LexicalClipboard_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var LexicalClipboard_1;
var hasRequiredLexicalClipboard;

function requireLexicalClipboard () {
	if (hasRequiredLexicalClipboard) return LexicalClipboard_1;
	hasRequiredLexicalClipboard = 1;
	const LexicalClipboard = process.env.NODE_ENV === 'development' ? requireLexicalClipboard_dev() : requireLexicalClipboard_prod();
	LexicalClipboard_1 = LexicalClipboard;
	return LexicalClipboard_1;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalRichText_dev;

function requireLexicalRichText_dev () {
	if (hasRequiredLexicalRichText_dev) return LexicalRichText_dev;
	hasRequiredLexicalRichText_dev = 1;

	var clipboard = requireLexicalClipboard();
	var selection = LexicalSelection_1;
	var utils = LexicalUtils_1;
	var lexical = require$$0__default["default"];

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	function caretFromPoint(x, y) {
	  if (typeof document.caretRangeFromPoint !== 'undefined') {
	    const range = document.caretRangeFromPoint(x, y);

	    if (range === null) {
	      return null;
	    }

	    return {
	      node: range.startContainer,
	      offset: range.startOffset
	    }; // @ts-ignore
	  } else if (document.caretPositionFromPoint !== 'undefined') {
	    // @ts-ignore FF - no types
	    const range = document.caretPositionFromPoint(x, y);

	    if (range === null) {
	      return null;
	    }

	    return {
	      node: range.offsetNode,
	      offset: range.offset
	    };
	  } else {
	    // Gracefully handle IE
	    return null;
	  }
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const CAN_USE_DOM = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined';

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const documentMode = CAN_USE_DOM && 'documentMode' in document ? document.documentMode : null;
	CAN_USE_DOM && /Mac|iPod|iPhone|iPad/.test(navigator.platform);
	CAN_USE_DOM && /^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent);
	const CAN_USE_BEFORE_INPUT = CAN_USE_DOM && 'InputEvent' in window && !documentMode ? 'getTargetRanges' in new window.InputEvent('input') : false;
	const IS_SAFARI = CAN_USE_DOM && /Version\/[\d.]+.*Safari/.test(navigator.userAgent);
	const IS_IOS = CAN_USE_DOM && /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream; // Keep these in case we need to use them in the future.
	// export const IS_WINDOWS: boolean = CAN_USE_DOM && /Win/.test(navigator.platform);

	const IS_CHROME = CAN_USE_DOM && /^(?=.*Chrome).*/i.test(navigator.userAgent); // export const canUseTextInputEvent: boolean = CAN_USE_DOM && 'TextEvent' in window && !documentMode;

	const IS_APPLE_WEBKIT = CAN_USE_DOM && /AppleWebKit\/[\d.]+/.test(navigator.userAgent) && !IS_CHROME;

	/** @module @lexical/rich-text */
	const DRAG_DROP_PASTE = lexical.createCommand('DRAG_DROP_PASTE_FILE');

	/** @noInheritDoc */
	class QuoteNode extends lexical.ElementNode {
	  static getType() {
	    return 'quote';
	  }

	  static clone(node) {
	    return new QuoteNode(node.__key);
	  }

	  constructor(key) {
	    super(key);
	  } // View


	  createDOM(config) {
	    const element = document.createElement('blockquote');
	    utils.addClassNamesToElement(element, config.theme.quote);
	    return element;
	  }

	  updateDOM(prevNode, dom) {
	    return false;
	  }

	  static importDOM() {
	    return {
	      blockquote: node => ({
	        conversion: convertBlockquoteElement,
	        priority: 0
	      })
	    };
	  }

	  exportDOM(editor) {
	    const {
	      element
	    } = super.exportDOM(editor);

	    if (element && this.isEmpty()) {
	      element.append(document.createElement('br'));
	    }

	    if (element) {
	      const formatType = this.getFormatType();
	      element.style.textAlign = formatType;
	      const direction = this.getDirection();

	      if (direction) {
	        element.dir = direction;
	      }
	    }

	    return {
	      element
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createQuoteNode();
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      type: 'quote'
	    };
	  } // Mutation


	  insertNewAfter(_, restoreSelection) {
	    const newBlock = lexical.$createParagraphNode();
	    const direction = this.getDirection();
	    newBlock.setDirection(direction);
	    this.insertAfter(newBlock, restoreSelection);
	    return newBlock;
	  }

	  collapseAtStart() {
	    const paragraph = lexical.$createParagraphNode();
	    const children = this.getChildren();
	    children.forEach(child => paragraph.append(child));
	    this.replace(paragraph);
	    return true;
	  }

	}
	function $createQuoteNode() {
	  return lexical.$applyNodeReplacement(new QuoteNode());
	}
	function $isQuoteNode(node) {
	  return node instanceof QuoteNode;
	}

	/** @noInheritDoc */
	class HeadingNode extends lexical.ElementNode {
	  /** @internal */
	  static getType() {
	    return 'heading';
	  }

	  static clone(node) {
	    return new HeadingNode(node.__tag, node.__key);
	  }

	  constructor(tag, key) {
	    super(key);
	    this.__tag = tag;
	  }

	  getTag() {
	    return this.__tag;
	  } // View


	  createDOM(config) {
	    const tag = this.__tag;
	    const element = document.createElement(tag);
	    const theme = config.theme;
	    const classNames = theme.heading;

	    if (classNames !== undefined) {
	      const className = classNames[tag];
	      utils.addClassNamesToElement(element, className);
	    }

	    return element;
	  }

	  updateDOM(prevNode, dom) {
	    return false;
	  }

	  static importDOM() {
	    return {
	      h1: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      h2: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      h3: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      h4: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      h5: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      h6: node => ({
	        conversion: convertHeadingElement,
	        priority: 0
	      }),
	      p: node => {
	        // domNode is a <p> since we matched it by nodeName
	        const paragraph = node;
	        const firstChild = paragraph.firstChild;

	        if (firstChild !== null && isGoogleDocsTitle(firstChild)) {
	          return {
	            conversion: () => ({
	              node: null
	            }),
	            priority: 3
	          };
	        }

	        return null;
	      },
	      span: node => {
	        if (isGoogleDocsTitle(node)) {
	          return {
	            conversion: domNode => {
	              return {
	                node: $createHeadingNode('h1')
	              };
	            },
	            priority: 3
	          };
	        }

	        return null;
	      }
	    };
	  }

	  exportDOM(editor) {
	    const {
	      element
	    } = super.exportDOM(editor);

	    if (element && this.isEmpty()) {
	      element.append(document.createElement('br'));
	    }

	    if (element) {
	      const formatType = this.getFormatType();
	      element.style.textAlign = formatType;
	      const direction = this.getDirection();

	      if (direction) {
	        element.dir = direction;
	      }
	    }

	    return {
	      element
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createHeadingNode(serializedNode.tag);
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      tag: this.getTag(),
	      type: 'heading',
	      version: 1
	    };
	  } // Mutation


	  insertNewAfter(selection, restoreSelection = true) {
	    const anchorOffet = selection ? selection.anchor.offset : 0;
	    const newElement = anchorOffet > 0 && anchorOffet < this.getTextContentSize() ? $createHeadingNode(this.getTag()) : lexical.$createParagraphNode();
	    const direction = this.getDirection();
	    newElement.setDirection(direction);
	    this.insertAfter(newElement, restoreSelection);
	    return newElement;
	  }

	  collapseAtStart() {
	    const newElement = !this.isEmpty() ? $createHeadingNode(this.getTag()) : lexical.$createParagraphNode();
	    const children = this.getChildren();
	    children.forEach(child => newElement.append(child));
	    this.replace(newElement);
	    return true;
	  }

	  extractWithChild() {
	    return true;
	  }

	}

	function isGoogleDocsTitle(domNode) {
	  if (domNode.nodeName.toLowerCase() === 'span') {
	    return domNode.style.fontSize === '26pt';
	  }

	  return false;
	}

	function convertHeadingElement(element) {
	  const nodeName = element.nodeName.toLowerCase();
	  let node = null;

	  if (nodeName === 'h1' || nodeName === 'h2' || nodeName === 'h3' || nodeName === 'h4' || nodeName === 'h5' || nodeName === 'h6') {
	    node = $createHeadingNode(nodeName);

	    if (element.style !== null) {
	      node.setFormat(element.style.textAlign);
	    }
	  }

	  return {
	    node
	  };
	}

	function convertBlockquoteElement(element) {
	  const node = $createQuoteNode();

	  if (element.style !== null) {
	    node.setFormat(element.style.textAlign);
	  }

	  return {
	    node
	  };
	}

	function $createHeadingNode(headingTag) {
	  return lexical.$applyNodeReplacement(new HeadingNode(headingTag));
	}
	function $isHeadingNode(node) {
	  return node instanceof HeadingNode;
	}

	function onPasteForRichText(event, editor) {
	  event.preventDefault();
	  editor.update(() => {
	    const selection = lexical.$getSelection();
	    const clipboardData = event instanceof InputEvent || event instanceof KeyboardEvent ? null : event.clipboardData;

	    if (clipboardData != null && (lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	      clipboard.$insertDataTransferForRichText(clipboardData, selection, editor);
	    }
	  }, {
	    tag: 'paste'
	  });
	}

	async function onCutForRichText(event, editor) {
	  await clipboard.copyToClipboard(editor, utils.objectKlassEquals(event, ClipboardEvent) ? event : null);
	  editor.update(() => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isRangeSelection(selection)) {
	      selection.removeText();
	    } else if (lexical.$isNodeSelection(selection)) {
	      selection.getNodes().forEach(node => node.remove());
	    }
	  });
	} // Clipboard may contain files that we aren't allowed to read. While the event is arguably useless,
	// in certain ocassions, we want to know whether it was a file transfer, as opposed to text. We
	// control this with the first boolean flag.


	function eventFiles(event) {
	  let dataTransfer = null;

	  if (event instanceof DragEvent) {
	    dataTransfer = event.dataTransfer;
	  } else if (event instanceof ClipboardEvent) {
	    dataTransfer = event.clipboardData;
	  }

	  if (dataTransfer === null) {
	    return [false, [], false];
	  }

	  const types = dataTransfer.types;
	  const hasFiles = types.includes('Files');
	  const hasContent = types.includes('text/html') || types.includes('text/plain');
	  return [hasFiles, Array.from(dataTransfer.files), hasContent];
	}

	function handleIndentAndOutdent(indentOrOutdent) {
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection)) {
	    return false;
	  }

	  const alreadyHandled = new Set();
	  const nodes = selection.getNodes();

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    const key = node.getKey();

	    if (alreadyHandled.has(key)) {
	      continue;
	    }

	    const parentBlock = utils.$getNearestBlockElementAncestorOrThrow(node);
	    const parentKey = parentBlock.getKey();

	    if (parentBlock.canIndent() && !alreadyHandled.has(parentKey)) {
	      alreadyHandled.add(parentKey);
	      indentOrOutdent(parentBlock);
	    }
	  }

	  return alreadyHandled.size > 0;
	}

	function $isTargetWithinDecorator(target) {
	  const node = lexical.$getNearestNodeFromDOMNode(target);
	  return lexical.$isDecoratorNode(node);
	}

	function $isSelectionAtEndOfRoot(selection) {
	  const focus = selection.focus;
	  return focus.key === 'root' && focus.offset === lexical.$getRoot().getChildrenSize();
	}

	function registerRichText(editor) {
	  const removeListener = utils.mergeRegister(editor.registerCommand(lexical.CLICK_COMMAND, payload => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isNodeSelection(selection)) {
	      selection.clear();
	      return true;
	    }

	    return false;
	  }, 0), editor.registerCommand(lexical.DELETE_CHARACTER_COMMAND, isBackward => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.deleteCharacter(isBackward);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.DELETE_WORD_COMMAND, isBackward => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.deleteWord(isBackward);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.DELETE_LINE_COMMAND, isBackward => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.deleteLine(isBackward);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.CONTROLLED_TEXT_INSERTION_COMMAND, eventOrText => {
	    const selection = lexical.$getSelection();

	    if (typeof eventOrText === 'string') {
	      if (lexical.$isRangeSelection(selection)) {
	        selection.insertText(eventOrText);
	      } else if (lexical.DEPRECATED_$isGridSelection(selection)) ;
	    } else {
	      if (!lexical.$isRangeSelection(selection) && !lexical.DEPRECATED_$isGridSelection(selection)) {
	        return false;
	      }

	      const dataTransfer = eventOrText.dataTransfer;

	      if (dataTransfer != null) {
	        clipboard.$insertDataTransferForRichText(dataTransfer, selection, editor);
	      } else if (lexical.$isRangeSelection(selection)) {
	        const data = eventOrText.data;

	        if (data) {
	          selection.insertText(data);
	        }

	        return true;
	      }
	    }

	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.REMOVE_TEXT_COMMAND, () => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.removeText();
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.FORMAT_TEXT_COMMAND, format => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.formatText(format);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.FORMAT_ELEMENT_COMMAND, format => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection) && !lexical.$isNodeSelection(selection)) {
	      return false;
	    }

	    const nodes = selection.getNodes();

	    for (const node of nodes) {
	      const element = utils.$findMatchingParent(node, parentNode => lexical.$isElementNode(parentNode) && !parentNode.isInline());

	      if (element !== null) {
	        element.setFormat(format);
	      }
	    }

	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.INSERT_LINE_BREAK_COMMAND, selectStart => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.insertLineBreak(selectStart);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.INSERT_PARAGRAPH_COMMAND, () => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    selection.insertParagraph();
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.INSERT_TAB_COMMAND, () => {
	    lexical.$insertNodes([lexical.$createTabNode()]);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.INDENT_CONTENT_COMMAND, () => {
	    return handleIndentAndOutdent(block => {
	      const indent = block.getIndent();
	      block.setIndent(indent + 1);
	    });
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.OUTDENT_CONTENT_COMMAND, () => {
	    return handleIndentAndOutdent(block => {
	      const indent = block.getIndent();

	      if (indent > 0) {
	        block.setIndent(indent - 1);
	      }
	    });
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ARROW_UP_COMMAND, event => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isNodeSelection(selection) && !$isTargetWithinDecorator(event.target)) {
	      // If selection is on a node, let's try and move selection
	      // back to being a range selection.
	      const nodes = selection.getNodes();

	      if (nodes.length > 0) {
	        nodes[0].selectPrevious();
	        return true;
	      }
	    } else if (lexical.$isRangeSelection(selection)) {
	      const possibleNode = lexical.$getAdjacentNode(selection.focus, true);

	      if (!event.shiftKey && lexical.$isDecoratorNode(possibleNode) && !possibleNode.isIsolated() && !possibleNode.isInline()) {
	        possibleNode.selectPrevious();
	        event.preventDefault();
	        return true;
	      }
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ARROW_DOWN_COMMAND, event => {
	    const selection = lexical.$getSelection();

	    if (lexical.$isNodeSelection(selection)) {
	      // If selection is on a node, let's try and move selection
	      // back to being a range selection.
	      const nodes = selection.getNodes();

	      if (nodes.length > 0) {
	        nodes[0].selectNext(0, 0);
	        return true;
	      }
	    } else if (lexical.$isRangeSelection(selection)) {
	      if ($isSelectionAtEndOfRoot(selection)) {
	        event.preventDefault();
	        return true;
	      }

	      const possibleNode = lexical.$getAdjacentNode(selection.focus, false);

	      if (!event.shiftKey && lexical.$isDecoratorNode(possibleNode) && !possibleNode.isIsolated() && !possibleNode.isInline()) {
	        possibleNode.selectNext();
	        event.preventDefault();
	        return true;
	      }
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ARROW_LEFT_COMMAND, event => {
	    const selection$1 = lexical.$getSelection();

	    if (lexical.$isNodeSelection(selection$1)) {
	      // If selection is on a node, let's try and move selection
	      // back to being a range selection.
	      const nodes = selection$1.getNodes();

	      if (nodes.length > 0) {
	        event.preventDefault();
	        nodes[0].selectPrevious();
	        return true;
	      }
	    }

	    if (!lexical.$isRangeSelection(selection$1)) {
	      return false;
	    }

	    if (selection.$shouldOverrideDefaultCharacterSelection(selection$1, true)) {
	      const isHoldingShift = event.shiftKey;
	      event.preventDefault();
	      selection.$moveCharacter(selection$1, isHoldingShift, true);
	      return true;
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ARROW_RIGHT_COMMAND, event => {
	    const selection$1 = lexical.$getSelection();

	    if (lexical.$isNodeSelection(selection$1) && !$isTargetWithinDecorator(event.target)) {
	      // If selection is on a node, let's try and move selection
	      // back to being a range selection.
	      const nodes = selection$1.getNodes();

	      if (nodes.length > 0) {
	        event.preventDefault();
	        nodes[0].selectNext(0, 0);
	        return true;
	      }
	    }

	    if (!lexical.$isRangeSelection(selection$1)) {
	      return false;
	    }

	    const isHoldingShift = event.shiftKey;

	    if (selection.$shouldOverrideDefaultCharacterSelection(selection$1, false)) {
	      event.preventDefault();
	      selection.$moveCharacter(selection$1, isHoldingShift, false);
	      return true;
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_BACKSPACE_COMMAND, event => {
	    if ($isTargetWithinDecorator(event.target)) {
	      return false;
	    }

	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    event.preventDefault();
	    const {
	      anchor
	    } = selection;
	    const anchorNode = anchor.getNode();

	    if (selection.isCollapsed() && anchor.offset === 0 && !lexical.$isRootNode(anchorNode)) {
	      const element = utils.$getNearestBlockElementAncestorOrThrow(anchorNode);

	      if (element.getIndent() > 0) {
	        return editor.dispatchCommand(lexical.OUTDENT_CONTENT_COMMAND, undefined);
	      }
	    }

	    return editor.dispatchCommand(lexical.DELETE_CHARACTER_COMMAND, true);
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_DELETE_COMMAND, event => {
	    if ($isTargetWithinDecorator(event.target)) {
	      return false;
	    }

	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    event.preventDefault();
	    return editor.dispatchCommand(lexical.DELETE_CHARACTER_COMMAND, false);
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ENTER_COMMAND, event => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    if (event !== null) {
	      // If we have beforeinput, then we can avoid blocking
	      // the default behavior. This ensures that the iOS can
	      // intercept that we're actually inserting a paragraph,
	      // and autocomplete, autocapitalize etc work as intended.
	      // This can also cause a strange performance issue in
	      // Safari, where there is a noticeable pause due to
	      // preventing the key down of enter.
	      if ((IS_IOS || IS_SAFARI || IS_APPLE_WEBKIT) && CAN_USE_BEFORE_INPUT) {
	        return false;
	      }

	      event.preventDefault();

	      if (event.shiftKey) {
	        return editor.dispatchCommand(lexical.INSERT_LINE_BREAK_COMMAND, false);
	      }
	    }

	    return editor.dispatchCommand(lexical.INSERT_PARAGRAPH_COMMAND, undefined);
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.KEY_ESCAPE_COMMAND, () => {
	    const selection = lexical.$getSelection();

	    if (!lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    editor.blur();
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.DROP_COMMAND, event => {
	    const [, files] = eventFiles(event);

	    if (files.length > 0) {
	      const x = event.clientX;
	      const y = event.clientY;
	      const eventRange = caretFromPoint(x, y);

	      if (eventRange !== null) {
	        const {
	          offset: domOffset,
	          node: domNode
	        } = eventRange;
	        const node = lexical.$getNearestNodeFromDOMNode(domNode);

	        if (node !== null) {
	          const selection = lexical.$createRangeSelection();

	          if (lexical.$isTextNode(node)) {
	            selection.anchor.set(node.getKey(), domOffset, 'text');
	            selection.focus.set(node.getKey(), domOffset, 'text');
	          } else {
	            const parentKey = node.getParentOrThrow().getKey();
	            const offset = node.getIndexWithinParent() + 1;
	            selection.anchor.set(parentKey, offset, 'element');
	            selection.focus.set(parentKey, offset, 'element');
	          }

	          const normalizedSelection = lexical.$normalizeSelection__EXPERIMENTAL(selection);
	          lexical.$setSelection(normalizedSelection);
	        }

	        editor.dispatchCommand(DRAG_DROP_PASTE, files);
	      }

	      event.preventDefault();
	      return true;
	    }

	    const selection = lexical.$getSelection();

	    if (lexical.$isRangeSelection(selection)) {
	      return true;
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.DRAGSTART_COMMAND, event => {
	    const [isFileTransfer] = eventFiles(event);
	    const selection = lexical.$getSelection();

	    if (isFileTransfer && !lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.DRAGOVER_COMMAND, event => {
	    const [isFileTransfer] = eventFiles(event);
	    const selection = lexical.$getSelection();

	    if (isFileTransfer && !lexical.$isRangeSelection(selection)) {
	      return false;
	    }

	    const x = event.clientX;
	    const y = event.clientY;
	    const eventRange = caretFromPoint(x, y);

	    if (eventRange !== null) {
	      const node = lexical.$getNearestNodeFromDOMNode(eventRange.node);

	      if (lexical.$isDecoratorNode(node)) {
	        // Show browser caret as the user is dragging the media across the screen. Won't work
	        // for DecoratorNode nor it's relevant.
	        event.preventDefault();
	      }
	    }

	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.COPY_COMMAND, event => {
	    clipboard.copyToClipboard(editor, utils.objectKlassEquals(event, ClipboardEvent) ? event : null);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.CUT_COMMAND, event => {
	    onCutForRichText(event, editor);
	    return true;
	  }, lexical.COMMAND_PRIORITY_EDITOR), editor.registerCommand(lexical.PASTE_COMMAND, event => {
	    const [, files, hasTextContent] = eventFiles(event);

	    if (files.length > 0 && !hasTextContent) {
	      editor.dispatchCommand(DRAG_DROP_PASTE, files);
	      return true;
	    } // if inputs then paste within the input ignore creating a new node on paste event


	    if (lexical.isSelectionCapturedInDecoratorInput(event.target)) {
	      return false;
	    }

	    const selection = lexical.$getSelection();

	    if (lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection)) {
	      onPasteForRichText(event, editor);
	      return true;
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_EDITOR));
	  return removeListener;
	}

	LexicalRichText_dev.$createHeadingNode = $createHeadingNode;
	LexicalRichText_dev.$createQuoteNode = $createQuoteNode;
	LexicalRichText_dev.$isHeadingNode = $isHeadingNode;
	LexicalRichText_dev.$isQuoteNode = $isQuoteNode;
	LexicalRichText_dev.DRAG_DROP_PASTE = DRAG_DROP_PASTE;
	LexicalRichText_dev.HeadingNode = HeadingNode;
	LexicalRichText_dev.QuoteNode = QuoteNode;
	LexicalRichText_dev.eventFiles = eventFiles;
	LexicalRichText_dev.registerRichText = registerRichText;
	return LexicalRichText_dev;
}

var LexicalRichText_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalRichText_prod;

function requireLexicalRichText_prod () {
	if (hasRequiredLexicalRichText_prod) return LexicalRichText_prod;
	hasRequiredLexicalRichText_prod = 1;
var c=requireLexicalClipboard(),g=LexicalSelection_1,h=LexicalUtils_1,k=require$$0__default["default"];function l(b,a){return "undefined"!==typeof document.caretRangeFromPoint?(b=document.caretRangeFromPoint(b,a),null===b?null:{node:b.startContainer,offset:b.startOffset}):"undefined"!==document.caretPositionFromPoint?(b=document.caretPositionFromPoint(b,a),null===b?null:{node:b.offsetNode,offset:b.offset}):null}
	let n="undefined"!==typeof window&&"undefined"!==typeof window.document&&"undefined"!==typeof window.document.createElement,p=n&&"documentMode"in document?document.documentMode:null;n&&/Mac|iPod|iPhone|iPad/.test(navigator.platform);n&&/^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent);
	let q=n&&"InputEvent"in window&&!p?"getTargetRanges"in new window.InputEvent("input"):!1,r=n&&/Version\/[\d.]+.*Safari/.test(navigator.userAgent),t=n&&/iPad|iPhone|iPod/.test(navigator.userAgent)&&!window.MSStream,u=n&&/^(?=.*Chrome).*/i.test(navigator.userAgent),v=n&&/AppleWebKit\/[\d.]+/.test(navigator.userAgent)&&!u,w=k.createCommand("DRAG_DROP_PASTE_FILE");
	class x extends k.ElementNode{static getType(){return "quote"}static clone(b){return new x(b.__key)}constructor(b){super(b);}createDOM(b){let a=document.createElement("blockquote");h.addClassNamesToElement(a,b.theme.quote);return a}updateDOM(){return !1}static importDOM(){return {blockquote:()=>({conversion:y,priority:0})}}exportDOM(b){({element:b}=super.exportDOM(b));b&&this.isEmpty()&&b.append(document.createElement("br"));if(b){var a=this.getFormatType();b.style.textAlign=a;if(a=this.getDirection())b.dir=
	a;}return {element:b}}static importJSON(b){let a=z();a.setFormat(b.format);a.setIndent(b.indent);a.setDirection(b.direction);return a}exportJSON(){return {...super.exportJSON(),type:"quote"}}insertNewAfter(b,a){b=k.$createParagraphNode();let d=this.getDirection();b.setDirection(d);this.insertAfter(b,a);return b}collapseAtStart(){let b=k.$createParagraphNode();this.getChildren().forEach(a=>b.append(a));this.replace(b);return !0}}function z(){return k.$applyNodeReplacement(new x)}
	class B extends k.ElementNode{static getType(){return "heading"}static clone(b){return new B(b.__tag,b.__key)}constructor(b,a){super(a);this.__tag=b;}getTag(){return this.__tag}createDOM(b){let a=this.__tag,d=document.createElement(a);b=b.theme.heading;void 0!==b&&h.addClassNamesToElement(d,b[a]);return d}updateDOM(){return !1}static importDOM(){return {h1:()=>({conversion:C,priority:0}),h2:()=>({conversion:C,priority:0}),h3:()=>({conversion:C,priority:0}),h4:()=>({conversion:C,priority:0}),h5:()=>({conversion:C,
	priority:0}),h6:()=>({conversion:C,priority:0}),p:b=>{b=b.firstChild;return null!==b&&D(b)?{conversion:()=>({node:null}),priority:3}:null},span:b=>D(b)?{conversion:()=>({node:E("h1")}),priority:3}:null}}exportDOM(b){({element:b}=super.exportDOM(b));b&&this.isEmpty()&&b.append(document.createElement("br"));if(b){var a=this.getFormatType();b.style.textAlign=a;if(a=this.getDirection())b.dir=a;}return {element:b}}static importJSON(b){let a=E(b.tag);a.setFormat(b.format);a.setIndent(b.indent);a.setDirection(b.direction);
	return a}exportJSON(){return {...super.exportJSON(),tag:this.getTag(),type:"heading",version:1}}insertNewAfter(b,a=!0){b=b?b.anchor.offset:0;b=0<b&&b<this.getTextContentSize()?E(this.getTag()):k.$createParagraphNode();let d=this.getDirection();b.setDirection(d);this.insertAfter(b,a);return b}collapseAtStart(){let b=this.isEmpty()?k.$createParagraphNode():E(this.getTag());this.getChildren().forEach(a=>b.append(a));this.replace(b);return !0}extractWithChild(){return !0}}
	function D(b){return "span"===b.nodeName.toLowerCase()?"26pt"===b.style.fontSize:!1}function C(b){let a=b.nodeName.toLowerCase(),d=null;if("h1"===a||"h2"===a||"h3"===a||"h4"===a||"h5"===a||"h6"===a)d=E(a),null!==b.style&&d.setFormat(b.style.textAlign);return {node:d}}function y(b){let a=z();null!==b.style&&a.setFormat(b.style.textAlign);return {node:a}}function E(b){return k.$applyNodeReplacement(new B(b))}
	function F(b,a){b.preventDefault();a.update(()=>{let d=k.$getSelection(),e=b instanceof InputEvent||b instanceof KeyboardEvent?null:b.clipboardData;null!=e&&(k.$isRangeSelection(d)||k.DEPRECATED_$isGridSelection(d))&&c.$insertDataTransferForRichText(e,d,a);},{tag:"paste"});}
	async function G(b,a){await c.copyToClipboard(a,h.objectKlassEquals(b,ClipboardEvent)?b:null);a.update(()=>{let d=k.$getSelection();k.$isRangeSelection(d)?d.removeText():k.$isNodeSelection(d)&&d.getNodes().forEach(e=>e.remove());});}function H(b){let a=null;b instanceof DragEvent?a=b.dataTransfer:b instanceof ClipboardEvent&&(a=b.clipboardData);if(null===a)return [!1,[],!1];var d=a.types;b=d.includes("Files");d=d.includes("text/html")||d.includes("text/plain");return [b,Array.from(a.files),d]}
	function I(b){var a=k.$getSelection();if(!k.$isRangeSelection(a))return !1;let d=new Set;a=a.getNodes();for(let m=0;m<a.length;m++){var e=a[m],f=e.getKey();d.has(f)||(e=h.$getNearestBlockElementAncestorOrThrow(e),f=e.getKey(),e.canIndent()&&!d.has(f)&&(d.add(f),b(e)));}return 0<d.size}function J(b){b=k.$getNearestNodeFromDOMNode(b);return k.$isDecoratorNode(b)}LexicalRichText_prod.$createHeadingNode=E;LexicalRichText_prod.$createQuoteNode=z;LexicalRichText_prod.$isHeadingNode=function(b){return b instanceof B};
	LexicalRichText_prod.$isQuoteNode=function(b){return b instanceof x};LexicalRichText_prod.DRAG_DROP_PASTE=w;LexicalRichText_prod.HeadingNode=B;LexicalRichText_prod.QuoteNode=x;LexicalRichText_prod.eventFiles=H;
	LexicalRichText_prod.registerRichText=function(b){return h.mergeRegister(b.registerCommand(k.CLICK_COMMAND,()=>{const a=k.$getSelection();return k.$isNodeSelection(a)?(a.clear(),!0):!1},0),b.registerCommand(k.DELETE_CHARACTER_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;d.deleteCharacter(a);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.DELETE_WORD_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;d.deleteWord(a);return !0},k.COMMAND_PRIORITY_EDITOR),
	b.registerCommand(k.DELETE_LINE_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;d.deleteLine(a);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.CONTROLLED_TEXT_INSERTION_COMMAND,a=>{const d=k.$getSelection();if("string"===typeof a)k.$isRangeSelection(d)?d.insertText(a):k.DEPRECATED_$isGridSelection(d);else {if(!k.$isRangeSelection(d)&&!k.DEPRECATED_$isGridSelection(d))return !1;const e=a.dataTransfer;null!=e?c.$insertDataTransferForRichText(e,d,b):k.$isRangeSelection(d)&&
	(a=a.data)&&d.insertText(a);}return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.REMOVE_TEXT_COMMAND,()=>{const a=k.$getSelection();if(!k.$isRangeSelection(a))return !1;a.removeText();return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.FORMAT_TEXT_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;d.formatText(a);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.FORMAT_ELEMENT_COMMAND,a=>{var d=k.$getSelection();if(!k.$isRangeSelection(d)&&!k.$isNodeSelection(d))return !1;
	d=d.getNodes();for(const e of d)d=h.$findMatchingParent(e,f=>k.$isElementNode(f)&&!f.isInline()),null!==d&&d.setFormat(a);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.INSERT_LINE_BREAK_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;d.insertLineBreak(a);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.INSERT_PARAGRAPH_COMMAND,()=>{const a=k.$getSelection();if(!k.$isRangeSelection(a))return !1;a.insertParagraph();return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.INSERT_TAB_COMMAND,
	()=>{k.$insertNodes([k.$createTabNode()]);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.INDENT_CONTENT_COMMAND,()=>I(a=>{const d=a.getIndent();a.setIndent(d+1);}),k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.OUTDENT_CONTENT_COMMAND,()=>I(a=>{const d=a.getIndent();0<d&&a.setIndent(d-1);}),k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_ARROW_UP_COMMAND,a=>{var d=k.$getSelection();if(k.$isNodeSelection(d)&&!J(a.target)){if(a=d.getNodes(),0<a.length)return a[0].selectPrevious(),!0}else if(k.$isRangeSelection(d)&&
	(d=k.$getAdjacentNode(d.focus,!0),!a.shiftKey&&k.$isDecoratorNode(d)&&!d.isIsolated()&&!d.isInline()))return d.selectPrevious(),a.preventDefault(),!0;return !1},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_ARROW_DOWN_COMMAND,a=>{var d=k.$getSelection();if(k.$isNodeSelection(d)){if(a=d.getNodes(),0<a.length)return a[0].selectNext(0,0),!0}else if(k.$isRangeSelection(d)){let e=d.focus;if("root"===e.key&&e.offset===k.$getRoot().getChildrenSize())return a.preventDefault(),!0;d=k.$getAdjacentNode(d.focus,
	!1);if(!a.shiftKey&&k.$isDecoratorNode(d)&&!d.isIsolated()&&!d.isInline())return d.selectNext(),a.preventDefault(),!0}return !1},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_ARROW_LEFT_COMMAND,a=>{const d=k.$getSelection();if(k.$isNodeSelection(d)){var e=d.getNodes();if(0<e.length)return a.preventDefault(),e[0].selectPrevious(),!0}return k.$isRangeSelection(d)?g.$shouldOverrideDefaultCharacterSelection(d,!0)?(e=a.shiftKey,a.preventDefault(),g.$moveCharacter(d,e,!0),!0):!1:!1},k.COMMAND_PRIORITY_EDITOR),
	b.registerCommand(k.KEY_ARROW_RIGHT_COMMAND,a=>{const d=k.$getSelection();if(k.$isNodeSelection(d)&&!J(a.target)){var e=d.getNodes();if(0<e.length)return a.preventDefault(),e[0].selectNext(0,0),!0}if(!k.$isRangeSelection(d))return !1;e=a.shiftKey;return g.$shouldOverrideDefaultCharacterSelection(d,!1)?(a.preventDefault(),g.$moveCharacter(d,e,!1),!0):!1},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_BACKSPACE_COMMAND,a=>{if(J(a.target))return !1;const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;
	a.preventDefault();({anchor:a}=d);const e=a.getNode();return d.isCollapsed()&&0===a.offset&&!k.$isRootNode(e)&&0<h.$getNearestBlockElementAncestorOrThrow(e).getIndent()?b.dispatchCommand(k.OUTDENT_CONTENT_COMMAND,void 0):b.dispatchCommand(k.DELETE_CHARACTER_COMMAND,!0)},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_DELETE_COMMAND,a=>{if(J(a.target))return !1;const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;a.preventDefault();return b.dispatchCommand(k.DELETE_CHARACTER_COMMAND,!1)},
	k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_ENTER_COMMAND,a=>{const d=k.$getSelection();if(!k.$isRangeSelection(d))return !1;if(null!==a){if((t||r||v)&&q)return !1;a.preventDefault();if(a.shiftKey)return b.dispatchCommand(k.INSERT_LINE_BREAK_COMMAND,!1)}return b.dispatchCommand(k.INSERT_PARAGRAPH_COMMAND,void 0)},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.KEY_ESCAPE_COMMAND,()=>{const a=k.$getSelection();if(!k.$isRangeSelection(a))return !1;b.blur();return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.DROP_COMMAND,
	a=>{const [,d]=H(a);if(0<d.length){var e=l(a.clientX,a.clientY);if(null!==e){const {offset:m,node:K}=e;var f=k.$getNearestNodeFromDOMNode(K);if(null!==f){e=k.$createRangeSelection();if(k.$isTextNode(f))e.anchor.set(f.getKey(),m,"text"),e.focus.set(f.getKey(),m,"text");else {const A=f.getParentOrThrow().getKey();f=f.getIndexWithinParent()+1;e.anchor.set(A,f,"element");e.focus.set(A,f,"element");}e=k.$normalizeSelection__EXPERIMENTAL(e);k.$setSelection(e);}b.dispatchCommand(w,d);}a.preventDefault();return !0}a=
	k.$getSelection();return k.$isRangeSelection(a)?!0:!1},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.DRAGSTART_COMMAND,a=>{[a]=H(a);const d=k.$getSelection();return a&&!k.$isRangeSelection(d)?!1:!0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.DRAGOVER_COMMAND,a=>{var [d]=H(a);const e=k.$getSelection();if(d&&!k.$isRangeSelection(e))return !1;d=l(a.clientX,a.clientY);null!==d&&(d=k.$getNearestNodeFromDOMNode(d.node),k.$isDecoratorNode(d)&&a.preventDefault());return !0},k.COMMAND_PRIORITY_EDITOR),
	b.registerCommand(k.COPY_COMMAND,a=>{c.copyToClipboard(b,h.objectKlassEquals(a,ClipboardEvent)?a:null);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.CUT_COMMAND,a=>{G(a,b);return !0},k.COMMAND_PRIORITY_EDITOR),b.registerCommand(k.PASTE_COMMAND,a=>{const [,d,e]=H(a);if(0<d.length&&!e)return b.dispatchCommand(w,d),!0;if(k.isSelectionCapturedInDecoratorInput(a.target))return !1;const f=k.$getSelection();return k.$isRangeSelection(f)||k.DEPRECATED_$isGridSelection(f)?(F(a,b),!0):!1},k.COMMAND_PRIORITY_EDITOR))};
	return LexicalRichText_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalRichText = process.env.NODE_ENV === 'development' ? requireLexicalRichText_dev() : requireLexicalRichText_prod();
var LexicalRichText_1 = LexicalRichText;

var LexicalCode_dev = {};

var prism = {exports: {}};

prism.exports;

var hasRequiredPrism;

function requirePrism () {
	if (hasRequiredPrism) return prism.exports;
	hasRequiredPrism = 1;
	(function (module) {
		/* **********************************************
		     Begin prism-core.js
		********************************************** */

		/// <reference lib="WebWorker"/>

		var _self = (typeof window !== 'undefined')
			? window   // if in browser
			: (
				(typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope)
					? self // if in worker
					: {}   // if in node js
			);

		/**
		 * Prism: Lightweight, robust, elegant syntax highlighting
		 *
		 * @license MIT <https://opensource.org/licenses/MIT>
		 * @author Lea Verou <https://lea.verou.me>
		 * @namespace
		 * @public
		 */
		var Prism = (function (_self) {

			// Private helper vars
			var lang = /(?:^|\s)lang(?:uage)?-([\w-]+)(?=\s|$)/i;
			var uniqueId = 0;

			// The grammar object for plaintext
			var plainTextGrammar = {};


			var _ = {
				/**
				 * By default, Prism will attempt to highlight all code elements (by calling {@link Prism.highlightAll}) on the
				 * current page after the page finished loading. This might be a problem if e.g. you wanted to asynchronously load
				 * additional languages or plugins yourself.
				 *
				 * By setting this value to `true`, Prism will not automatically highlight all code elements on the page.
				 *
				 * You obviously have to change this value before the automatic highlighting started. To do this, you can add an
				 * empty Prism object into the global scope before loading the Prism script like this:
				 *
				 * ```js
				 * window.Prism = window.Prism || {};
				 * Prism.manual = true;
				 * // add a new <script> to load Prism's script
				 * ```
				 *
				 * @default false
				 * @type {boolean}
				 * @memberof Prism
				 * @public
				 */
				manual: _self.Prism && _self.Prism.manual,
				/**
				 * By default, if Prism is in a web worker, it assumes that it is in a worker it created itself, so it uses
				 * `addEventListener` to communicate with its parent instance. However, if you're using Prism manually in your
				 * own worker, you don't want it to do this.
				 *
				 * By setting this value to `true`, Prism will not add its own listeners to the worker.
				 *
				 * You obviously have to change this value before Prism executes. To do this, you can add an
				 * empty Prism object into the global scope before loading the Prism script like this:
				 *
				 * ```js
				 * window.Prism = window.Prism || {};
				 * Prism.disableWorkerMessageHandler = true;
				 * // Load Prism's script
				 * ```
				 *
				 * @default false
				 * @type {boolean}
				 * @memberof Prism
				 * @public
				 */
				disableWorkerMessageHandler: _self.Prism && _self.Prism.disableWorkerMessageHandler,

				/**
				 * A namespace for utility methods.
				 *
				 * All function in this namespace that are not explicitly marked as _public_ are for __internal use only__ and may
				 * change or disappear at any time.
				 *
				 * @namespace
				 * @memberof Prism
				 */
				util: {
					encode: function encode(tokens) {
						if (tokens instanceof Token) {
							return new Token(tokens.type, encode(tokens.content), tokens.alias);
						} else if (Array.isArray(tokens)) {
							return tokens.map(encode);
						} else {
							return tokens.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/\u00a0/g, ' ');
						}
					},

					/**
					 * Returns the name of the type of the given value.
					 *
					 * @param {any} o
					 * @returns {string}
					 * @example
					 * type(null)      === 'Null'
					 * type(undefined) === 'Undefined'
					 * type(123)       === 'Number'
					 * type('foo')     === 'String'
					 * type(true)      === 'Boolean'
					 * type([1, 2])    === 'Array'
					 * type({})        === 'Object'
					 * type(String)    === 'Function'
					 * type(/abc+/)    === 'RegExp'
					 */
					type: function (o) {
						return Object.prototype.toString.call(o).slice(8, -1);
					},

					/**
					 * Returns a unique number for the given object. Later calls will still return the same number.
					 *
					 * @param {Object} obj
					 * @returns {number}
					 */
					objId: function (obj) {
						if (!obj['__id']) {
							Object.defineProperty(obj, '__id', { value: ++uniqueId });
						}
						return obj['__id'];
					},

					/**
					 * Creates a deep clone of the given object.
					 *
					 * The main intended use of this function is to clone language definitions.
					 *
					 * @param {T} o
					 * @param {Record<number, any>} [visited]
					 * @returns {T}
					 * @template T
					 */
					clone: function deepClone(o, visited) {
						visited = visited || {};

						var clone; var id;
						switch (_.util.type(o)) {
							case 'Object':
								id = _.util.objId(o);
								if (visited[id]) {
									return visited[id];
								}
								clone = /** @type {Record<string, any>} */ ({});
								visited[id] = clone;

								for (var key in o) {
									if (o.hasOwnProperty(key)) {
										clone[key] = deepClone(o[key], visited);
									}
								}

								return /** @type {any} */ (clone);

							case 'Array':
								id = _.util.objId(o);
								if (visited[id]) {
									return visited[id];
								}
								clone = [];
								visited[id] = clone;

								(/** @type {Array} */(/** @type {any} */(o))).forEach(function (v, i) {
									clone[i] = deepClone(v, visited);
								});

								return /** @type {any} */ (clone);

							default:
								return o;
						}
					},

					/**
					 * Returns the Prism language of the given element set by a `language-xxxx` or `lang-xxxx` class.
					 *
					 * If no language is set for the element or the element is `null` or `undefined`, `none` will be returned.
					 *
					 * @param {Element} element
					 * @returns {string}
					 */
					getLanguage: function (element) {
						while (element) {
							var m = lang.exec(element.className);
							if (m) {
								return m[1].toLowerCase();
							}
							element = element.parentElement;
						}
						return 'none';
					},

					/**
					 * Sets the Prism `language-xxxx` class of the given element.
					 *
					 * @param {Element} element
					 * @param {string} language
					 * @returns {void}
					 */
					setLanguage: function (element, language) {
						// remove all `language-xxxx` classes
						// (this might leave behind a leading space)
						element.className = element.className.replace(RegExp(lang, 'gi'), '');

						// add the new `language-xxxx` class
						// (using `classList` will automatically clean up spaces for us)
						element.classList.add('language-' + language);
					},

					/**
					 * Returns the script element that is currently executing.
					 *
					 * This does __not__ work for line script element.
					 *
					 * @returns {HTMLScriptElement | null}
					 */
					currentScript: function () {
						if (typeof document === 'undefined') {
							return null;
						}
						if ('currentScript' in document && 1 < 2 /* hack to trip TS' flow analysis */) {
							return /** @type {any} */ (document.currentScript);
						}

						// IE11 workaround
						// we'll get the src of the current script by parsing IE11's error stack trace
						// this will not work for inline scripts

						try {
							throw new Error();
						} catch (err) {
							// Get file src url from stack. Specifically works with the format of stack traces in IE.
							// A stack will look like this:
							//
							// Error
							//    at _.util.currentScript (http://localhost/components/prism-core.js:119:5)
							//    at Global code (http://localhost/components/prism-core.js:606:1)

							var src = (/at [^(\r\n]*\((.*):[^:]+:[^:]+\)$/i.exec(err.stack) || [])[1];
							if (src) {
								var scripts = document.getElementsByTagName('script');
								for (var i in scripts) {
									if (scripts[i].src == src) {
										return scripts[i];
									}
								}
							}
							return null;
						}
					},

					/**
					 * Returns whether a given class is active for `element`.
					 *
					 * The class can be activated if `element` or one of its ancestors has the given class and it can be deactivated
					 * if `element` or one of its ancestors has the negated version of the given class. The _negated version_ of the
					 * given class is just the given class with a `no-` prefix.
					 *
					 * Whether the class is active is determined by the closest ancestor of `element` (where `element` itself is
					 * closest ancestor) that has the given class or the negated version of it. If neither `element` nor any of its
					 * ancestors have the given class or the negated version of it, then the default activation will be returned.
					 *
					 * In the paradoxical situation where the closest ancestor contains __both__ the given class and the negated
					 * version of it, the class is considered active.
					 *
					 * @param {Element} element
					 * @param {string} className
					 * @param {boolean} [defaultActivation=false]
					 * @returns {boolean}
					 */
					isActive: function (element, className, defaultActivation) {
						var no = 'no-' + className;

						while (element) {
							var classList = element.classList;
							if (classList.contains(className)) {
								return true;
							}
							if (classList.contains(no)) {
								return false;
							}
							element = element.parentElement;
						}
						return !!defaultActivation;
					}
				},

				/**
				 * This namespace contains all currently loaded languages and the some helper functions to create and modify languages.
				 *
				 * @namespace
				 * @memberof Prism
				 * @public
				 */
				languages: {
					/**
					 * The grammar for plain, unformatted text.
					 */
					plain: plainTextGrammar,
					plaintext: plainTextGrammar,
					text: plainTextGrammar,
					txt: plainTextGrammar,

					/**
					 * Creates a deep copy of the language with the given id and appends the given tokens.
					 *
					 * If a token in `redef` also appears in the copied language, then the existing token in the copied language
					 * will be overwritten at its original position.
					 *
					 * ## Best practices
					 *
					 * Since the position of overwriting tokens (token in `redef` that overwrite tokens in the copied language)
					 * doesn't matter, they can technically be in any order. However, this can be confusing to others that trying to
					 * understand the language definition because, normally, the order of tokens matters in Prism grammars.
					 *
					 * Therefore, it is encouraged to order overwriting tokens according to the positions of the overwritten tokens.
					 * Furthermore, all non-overwriting tokens should be placed after the overwriting ones.
					 *
					 * @param {string} id The id of the language to extend. This has to be a key in `Prism.languages`.
					 * @param {Grammar} redef The new tokens to append.
					 * @returns {Grammar} The new language created.
					 * @public
					 * @example
					 * Prism.languages['css-with-colors'] = Prism.languages.extend('css', {
					 *     // Prism.languages.css already has a 'comment' token, so this token will overwrite CSS' 'comment' token
					 *     // at its original position
					 *     'comment': { ... },
					 *     // CSS doesn't have a 'color' token, so this token will be appended
					 *     'color': /\b(?:red|green|blue)\b/
					 * });
					 */
					extend: function (id, redef) {
						var lang = _.util.clone(_.languages[id]);

						for (var key in redef) {
							lang[key] = redef[key];
						}

						return lang;
					},

					/**
					 * Inserts tokens _before_ another token in a language definition or any other grammar.
					 *
					 * ## Usage
					 *
					 * This helper method makes it easy to modify existing languages. For example, the CSS language definition
					 * not only defines CSS highlighting for CSS documents, but also needs to define highlighting for CSS embedded
					 * in HTML through `<style>` elements. To do this, it needs to modify `Prism.languages.markup` and add the
					 * appropriate tokens. However, `Prism.languages.markup` is a regular JavaScript object literal, so if you do
					 * this:
					 *
					 * ```js
					 * Prism.languages.markup.style = {
					 *     // token
					 * };
					 * ```
					 *
					 * then the `style` token will be added (and processed) at the end. `insertBefore` allows you to insert tokens
					 * before existing tokens. For the CSS example above, you would use it like this:
					 *
					 * ```js
					 * Prism.languages.insertBefore('markup', 'cdata', {
					 *     'style': {
					 *         // token
					 *     }
					 * });
					 * ```
					 *
					 * ## Special cases
					 *
					 * If the grammars of `inside` and `insert` have tokens with the same name, the tokens in `inside`'s grammar
					 * will be ignored.
					 *
					 * This behavior can be used to insert tokens after `before`:
					 *
					 * ```js
					 * Prism.languages.insertBefore('markup', 'comment', {
					 *     'comment': Prism.languages.markup.comment,
					 *     // tokens after 'comment'
					 * });
					 * ```
					 *
					 * ## Limitations
					 *
					 * The main problem `insertBefore` has to solve is iteration order. Since ES2015, the iteration order for object
					 * properties is guaranteed to be the insertion order (except for integer keys) but some browsers behave
					 * differently when keys are deleted and re-inserted. So `insertBefore` can't be implemented by temporarily
					 * deleting properties which is necessary to insert at arbitrary positions.
					 *
					 * To solve this problem, `insertBefore` doesn't actually insert the given tokens into the target object.
					 * Instead, it will create a new object and replace all references to the target object with the new one. This
					 * can be done without temporarily deleting properties, so the iteration order is well-defined.
					 *
					 * However, only references that can be reached from `Prism.languages` or `insert` will be replaced. I.e. if
					 * you hold the target object in a variable, then the value of the variable will not change.
					 *
					 * ```js
					 * var oldMarkup = Prism.languages.markup;
					 * var newMarkup = Prism.languages.insertBefore('markup', 'comment', { ... });
					 *
					 * assert(oldMarkup !== Prism.languages.markup);
					 * assert(newMarkup === Prism.languages.markup);
					 * ```
					 *
					 * @param {string} inside The property of `root` (e.g. a language id in `Prism.languages`) that contains the
					 * object to be modified.
					 * @param {string} before The key to insert before.
					 * @param {Grammar} insert An object containing the key-value pairs to be inserted.
					 * @param {Object<string, any>} [root] The object containing `inside`, i.e. the object that contains the
					 * object to be modified.
					 *
					 * Defaults to `Prism.languages`.
					 * @returns {Grammar} The new grammar object.
					 * @public
					 */
					insertBefore: function (inside, before, insert, root) {
						root = root || /** @type {any} */ (_.languages);
						var grammar = root[inside];
						/** @type {Grammar} */
						var ret = {};

						for (var token in grammar) {
							if (grammar.hasOwnProperty(token)) {

								if (token == before) {
									for (var newToken in insert) {
										if (insert.hasOwnProperty(newToken)) {
											ret[newToken] = insert[newToken];
										}
									}
								}

								// Do not insert token which also occur in insert. See #1525
								if (!insert.hasOwnProperty(token)) {
									ret[token] = grammar[token];
								}
							}
						}

						var old = root[inside];
						root[inside] = ret;

						// Update references in other language definitions
						_.languages.DFS(_.languages, function (key, value) {
							if (value === old && key != inside) {
								this[key] = ret;
							}
						});

						return ret;
					},

					// Traverse a language definition with Depth First Search
					DFS: function DFS(o, callback, type, visited) {
						visited = visited || {};

						var objId = _.util.objId;

						for (var i in o) {
							if (o.hasOwnProperty(i)) {
								callback.call(o, i, o[i], type || i);

								var property = o[i];
								var propertyType = _.util.type(property);

								if (propertyType === 'Object' && !visited[objId(property)]) {
									visited[objId(property)] = true;
									DFS(property, callback, null, visited);
								} else if (propertyType === 'Array' && !visited[objId(property)]) {
									visited[objId(property)] = true;
									DFS(property, callback, i, visited);
								}
							}
						}
					}
				},

				plugins: {},

				/**
				 * This is the most high-level function in Prism’s API.
				 * It fetches all the elements that have a `.language-xxxx` class and then calls {@link Prism.highlightElement} on
				 * each one of them.
				 *
				 * This is equivalent to `Prism.highlightAllUnder(document, async, callback)`.
				 *
				 * @param {boolean} [async=false] Same as in {@link Prism.highlightAllUnder}.
				 * @param {HighlightCallback} [callback] Same as in {@link Prism.highlightAllUnder}.
				 * @memberof Prism
				 * @public
				 */
				highlightAll: function (async, callback) {
					_.highlightAllUnder(document, async, callback);
				},

				/**
				 * Fetches all the descendants of `container` that have a `.language-xxxx` class and then calls
				 * {@link Prism.highlightElement} on each one of them.
				 *
				 * The following hooks will be run:
				 * 1. `before-highlightall`
				 * 2. `before-all-elements-highlight`
				 * 3. All hooks of {@link Prism.highlightElement} for each element.
				 *
				 * @param {ParentNode} container The root element, whose descendants that have a `.language-xxxx` class will be highlighted.
				 * @param {boolean} [async=false] Whether each element is to be highlighted asynchronously using Web Workers.
				 * @param {HighlightCallback} [callback] An optional callback to be invoked on each element after its highlighting is done.
				 * @memberof Prism
				 * @public
				 */
				highlightAllUnder: function (container, async, callback) {
					var env = {
						callback: callback,
						container: container,
						selector: 'code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code'
					};

					_.hooks.run('before-highlightall', env);

					env.elements = Array.prototype.slice.apply(env.container.querySelectorAll(env.selector));

					_.hooks.run('before-all-elements-highlight', env);

					for (var i = 0, element; (element = env.elements[i++]);) {
						_.highlightElement(element, async === true, env.callback);
					}
				},

				/**
				 * Highlights the code inside a single element.
				 *
				 * The following hooks will be run:
				 * 1. `before-sanity-check`
				 * 2. `before-highlight`
				 * 3. All hooks of {@link Prism.highlight}. These hooks will be run by an asynchronous worker if `async` is `true`.
				 * 4. `before-insert`
				 * 5. `after-highlight`
				 * 6. `complete`
				 *
				 * Some the above hooks will be skipped if the element doesn't contain any text or there is no grammar loaded for
				 * the element's language.
				 *
				 * @param {Element} element The element containing the code.
				 * It must have a class of `language-xxxx` to be processed, where `xxxx` is a valid language identifier.
				 * @param {boolean} [async=false] Whether the element is to be highlighted asynchronously using Web Workers
				 * to improve performance and avoid blocking the UI when highlighting very large chunks of code. This option is
				 * [disabled by default](https://prismjs.com/faq.html#why-is-asynchronous-highlighting-disabled-by-default).
				 *
				 * Note: All language definitions required to highlight the code must be included in the main `prism.js` file for
				 * asynchronous highlighting to work. You can build your own bundle on the
				 * [Download page](https://prismjs.com/download.html).
				 * @param {HighlightCallback} [callback] An optional callback to be invoked after the highlighting is done.
				 * Mostly useful when `async` is `true`, since in that case, the highlighting is done asynchronously.
				 * @memberof Prism
				 * @public
				 */
				highlightElement: function (element, async, callback) {
					// Find language
					var language = _.util.getLanguage(element);
					var grammar = _.languages[language];

					// Set language on the element, if not present
					_.util.setLanguage(element, language);

					// Set language on the parent, for styling
					var parent = element.parentElement;
					if (parent && parent.nodeName.toLowerCase() === 'pre') {
						_.util.setLanguage(parent, language);
					}

					var code = element.textContent;

					var env = {
						element: element,
						language: language,
						grammar: grammar,
						code: code
					};

					function insertHighlightedCode(highlightedCode) {
						env.highlightedCode = highlightedCode;

						_.hooks.run('before-insert', env);

						env.element.innerHTML = env.highlightedCode;

						_.hooks.run('after-highlight', env);
						_.hooks.run('complete', env);
						callback && callback.call(env.element);
					}

					_.hooks.run('before-sanity-check', env);

					// plugins may change/add the parent/element
					parent = env.element.parentElement;
					if (parent && parent.nodeName.toLowerCase() === 'pre' && !parent.hasAttribute('tabindex')) {
						parent.setAttribute('tabindex', '0');
					}

					if (!env.code) {
						_.hooks.run('complete', env);
						callback && callback.call(env.element);
						return;
					}

					_.hooks.run('before-highlight', env);

					if (!env.grammar) {
						insertHighlightedCode(_.util.encode(env.code));
						return;
					}

					if (async && _self.Worker) {
						var worker = new Worker(_.filename);

						worker.onmessage = function (evt) {
							insertHighlightedCode(evt.data);
						};

						worker.postMessage(JSON.stringify({
							language: env.language,
							code: env.code,
							immediateClose: true
						}));
					} else {
						insertHighlightedCode(_.highlight(env.code, env.grammar, env.language));
					}
				},

				/**
				 * Low-level function, only use if you know what you’re doing. It accepts a string of text as input
				 * and the language definitions to use, and returns a string with the HTML produced.
				 *
				 * The following hooks will be run:
				 * 1. `before-tokenize`
				 * 2. `after-tokenize`
				 * 3. `wrap`: On each {@link Token}.
				 *
				 * @param {string} text A string with the code to be highlighted.
				 * @param {Grammar} grammar An object containing the tokens to use.
				 *
				 * Usually a language definition like `Prism.languages.markup`.
				 * @param {string} language The name of the language definition passed to `grammar`.
				 * @returns {string} The highlighted HTML.
				 * @memberof Prism
				 * @public
				 * @example
				 * Prism.highlight('var foo = true;', Prism.languages.javascript, 'javascript');
				 */
				highlight: function (text, grammar, language) {
					var env = {
						code: text,
						grammar: grammar,
						language: language
					};
					_.hooks.run('before-tokenize', env);
					if (!env.grammar) {
						throw new Error('The language "' + env.language + '" has no grammar.');
					}
					env.tokens = _.tokenize(env.code, env.grammar);
					_.hooks.run('after-tokenize', env);
					return Token.stringify(_.util.encode(env.tokens), env.language);
				},

				/**
				 * This is the heart of Prism, and the most low-level function you can use. It accepts a string of text as input
				 * and the language definitions to use, and returns an array with the tokenized code.
				 *
				 * When the language definition includes nested tokens, the function is called recursively on each of these tokens.
				 *
				 * This method could be useful in other contexts as well, as a very crude parser.
				 *
				 * @param {string} text A string with the code to be highlighted.
				 * @param {Grammar} grammar An object containing the tokens to use.
				 *
				 * Usually a language definition like `Prism.languages.markup`.
				 * @returns {TokenStream} An array of strings and tokens, a token stream.
				 * @memberof Prism
				 * @public
				 * @example
				 * let code = `var foo = 0;`;
				 * let tokens = Prism.tokenize(code, Prism.languages.javascript);
				 * tokens.forEach(token => {
				 *     if (token instanceof Prism.Token && token.type === 'number') {
				 *         console.log(`Found numeric literal: ${token.content}`);
				 *     }
				 * });
				 */
				tokenize: function (text, grammar) {
					var rest = grammar.rest;
					if (rest) {
						for (var token in rest) {
							grammar[token] = rest[token];
						}

						delete grammar.rest;
					}

					var tokenList = new LinkedList();
					addAfter(tokenList, tokenList.head, text);

					matchGrammar(text, tokenList, grammar, tokenList.head, 0);

					return toArray(tokenList);
				},

				/**
				 * @namespace
				 * @memberof Prism
				 * @public
				 */
				hooks: {
					all: {},

					/**
					 * Adds the given callback to the list of callbacks for the given hook.
					 *
					 * The callback will be invoked when the hook it is registered for is run.
					 * Hooks are usually directly run by a highlight function but you can also run hooks yourself.
					 *
					 * One callback function can be registered to multiple hooks and the same hook multiple times.
					 *
					 * @param {string} name The name of the hook.
					 * @param {HookCallback} callback The callback function which is given environment variables.
					 * @public
					 */
					add: function (name, callback) {
						var hooks = _.hooks.all;

						hooks[name] = hooks[name] || [];

						hooks[name].push(callback);
					},

					/**
					 * Runs a hook invoking all registered callbacks with the given environment variables.
					 *
					 * Callbacks will be invoked synchronously and in the order in which they were registered.
					 *
					 * @param {string} name The name of the hook.
					 * @param {Object<string, any>} env The environment variables of the hook passed to all callbacks registered.
					 * @public
					 */
					run: function (name, env) {
						var callbacks = _.hooks.all[name];

						if (!callbacks || !callbacks.length) {
							return;
						}

						for (var i = 0, callback; (callback = callbacks[i++]);) {
							callback(env);
						}
					}
				},

				Token: Token
			};
			_self.Prism = _;


			// Typescript note:
			// The following can be used to import the Token type in JSDoc:
			//
			//   @typedef {InstanceType<import("./prism-core")["Token"]>} Token

			/**
			 * Creates a new token.
			 *
			 * @param {string} type See {@link Token#type type}
			 * @param {string | TokenStream} content See {@link Token#content content}
			 * @param {string|string[]} [alias] The alias(es) of the token.
			 * @param {string} [matchedStr=""] A copy of the full string this token was created from.
			 * @class
			 * @global
			 * @public
			 */
			function Token(type, content, alias, matchedStr) {
				/**
				 * The type of the token.
				 *
				 * This is usually the key of a pattern in a {@link Grammar}.
				 *
				 * @type {string}
				 * @see GrammarToken
				 * @public
				 */
				this.type = type;
				/**
				 * The strings or tokens contained by this token.
				 *
				 * This will be a token stream if the pattern matched also defined an `inside` grammar.
				 *
				 * @type {string | TokenStream}
				 * @public
				 */
				this.content = content;
				/**
				 * The alias(es) of the token.
				 *
				 * @type {string|string[]}
				 * @see GrammarToken
				 * @public
				 */
				this.alias = alias;
				// Copy of the full string this token was created from
				this.length = (matchedStr || '').length | 0;
			}

			/**
			 * A token stream is an array of strings and {@link Token Token} objects.
			 *
			 * Token streams have to fulfill a few properties that are assumed by most functions (mostly internal ones) that process
			 * them.
			 *
			 * 1. No adjacent strings.
			 * 2. No empty strings.
			 *
			 *    The only exception here is the token stream that only contains the empty string and nothing else.
			 *
			 * @typedef {Array<string | Token>} TokenStream
			 * @global
			 * @public
			 */

			/**
			 * Converts the given token or token stream to an HTML representation.
			 *
			 * The following hooks will be run:
			 * 1. `wrap`: On each {@link Token}.
			 *
			 * @param {string | Token | TokenStream} o The token or token stream to be converted.
			 * @param {string} language The name of current language.
			 * @returns {string} The HTML representation of the token or token stream.
			 * @memberof Token
			 * @static
			 */
			Token.stringify = function stringify(o, language) {
				if (typeof o == 'string') {
					return o;
				}
				if (Array.isArray(o)) {
					var s = '';
					o.forEach(function (e) {
						s += stringify(e, language);
					});
					return s;
				}

				var env = {
					type: o.type,
					content: stringify(o.content, language),
					tag: 'span',
					classes: ['token', o.type],
					attributes: {},
					language: language
				};

				var aliases = o.alias;
				if (aliases) {
					if (Array.isArray(aliases)) {
						Array.prototype.push.apply(env.classes, aliases);
					} else {
						env.classes.push(aliases);
					}
				}

				_.hooks.run('wrap', env);

				var attributes = '';
				for (var name in env.attributes) {
					attributes += ' ' + name + '="' + (env.attributes[name] || '').replace(/"/g, '&quot;') + '"';
				}

				return '<' + env.tag + ' class="' + env.classes.join(' ') + '"' + attributes + '>' + env.content + '</' + env.tag + '>';
			};

			/**
			 * @param {RegExp} pattern
			 * @param {number} pos
			 * @param {string} text
			 * @param {boolean} lookbehind
			 * @returns {RegExpExecArray | null}
			 */
			function matchPattern(pattern, pos, text, lookbehind) {
				pattern.lastIndex = pos;
				var match = pattern.exec(text);
				if (match && lookbehind && match[1]) {
					// change the match to remove the text matched by the Prism lookbehind group
					var lookbehindLength = match[1].length;
					match.index += lookbehindLength;
					match[0] = match[0].slice(lookbehindLength);
				}
				return match;
			}

			/**
			 * @param {string} text
			 * @param {LinkedList<string | Token>} tokenList
			 * @param {any} grammar
			 * @param {LinkedListNode<string | Token>} startNode
			 * @param {number} startPos
			 * @param {RematchOptions} [rematch]
			 * @returns {void}
			 * @private
			 *
			 * @typedef RematchOptions
			 * @property {string} cause
			 * @property {number} reach
			 */
			function matchGrammar(text, tokenList, grammar, startNode, startPos, rematch) {
				for (var token in grammar) {
					if (!grammar.hasOwnProperty(token) || !grammar[token]) {
						continue;
					}

					var patterns = grammar[token];
					patterns = Array.isArray(patterns) ? patterns : [patterns];

					for (var j = 0; j < patterns.length; ++j) {
						if (rematch && rematch.cause == token + ',' + j) {
							return;
						}

						var patternObj = patterns[j];
						var inside = patternObj.inside;
						var lookbehind = !!patternObj.lookbehind;
						var greedy = !!patternObj.greedy;
						var alias = patternObj.alias;

						if (greedy && !patternObj.pattern.global) {
							// Without the global flag, lastIndex won't work
							var flags = patternObj.pattern.toString().match(/[imsuy]*$/)[0];
							patternObj.pattern = RegExp(patternObj.pattern.source, flags + 'g');
						}

						/** @type {RegExp} */
						var pattern = patternObj.pattern || patternObj;

						for ( // iterate the token list and keep track of the current token/string position
							var currentNode = startNode.next, pos = startPos;
							currentNode !== tokenList.tail;
							pos += currentNode.value.length, currentNode = currentNode.next
						) {

							if (rematch && pos >= rematch.reach) {
								break;
							}

							var str = currentNode.value;

							if (tokenList.length > text.length) {
								// Something went terribly wrong, ABORT, ABORT!
								return;
							}

							if (str instanceof Token) {
								continue;
							}

							var removeCount = 1; // this is the to parameter of removeBetween
							var match;

							if (greedy) {
								match = matchPattern(pattern, pos, text, lookbehind);
								if (!match || match.index >= text.length) {
									break;
								}

								var from = match.index;
								var to = match.index + match[0].length;
								var p = pos;

								// find the node that contains the match
								p += currentNode.value.length;
								while (from >= p) {
									currentNode = currentNode.next;
									p += currentNode.value.length;
								}
								// adjust pos (and p)
								p -= currentNode.value.length;
								pos = p;

								// the current node is a Token, then the match starts inside another Token, which is invalid
								if (currentNode.value instanceof Token) {
									continue;
								}

								// find the last node which is affected by this match
								for (
									var k = currentNode;
									k !== tokenList.tail && (p < to || typeof k.value === 'string');
									k = k.next
								) {
									removeCount++;
									p += k.value.length;
								}
								removeCount--;

								// replace with the new match
								str = text.slice(pos, p);
								match.index -= pos;
							} else {
								match = matchPattern(pattern, 0, str, lookbehind);
								if (!match) {
									continue;
								}
							}

							// eslint-disable-next-line no-redeclare
							var from = match.index;
							var matchStr = match[0];
							var before = str.slice(0, from);
							var after = str.slice(from + matchStr.length);

							var reach = pos + str.length;
							if (rematch && reach > rematch.reach) {
								rematch.reach = reach;
							}

							var removeFrom = currentNode.prev;

							if (before) {
								removeFrom = addAfter(tokenList, removeFrom, before);
								pos += before.length;
							}

							removeRange(tokenList, removeFrom, removeCount);

							var wrapped = new Token(token, inside ? _.tokenize(matchStr, inside) : matchStr, alias, matchStr);
							currentNode = addAfter(tokenList, removeFrom, wrapped);

							if (after) {
								addAfter(tokenList, currentNode, after);
							}

							if (removeCount > 1) {
								// at least one Token object was removed, so we have to do some rematching
								// this can only happen if the current pattern is greedy

								/** @type {RematchOptions} */
								var nestedRematch = {
									cause: token + ',' + j,
									reach: reach
								};
								matchGrammar(text, tokenList, grammar, currentNode.prev, pos, nestedRematch);

								// the reach might have been extended because of the rematching
								if (rematch && nestedRematch.reach > rematch.reach) {
									rematch.reach = nestedRematch.reach;
								}
							}
						}
					}
				}
			}

			/**
			 * @typedef LinkedListNode
			 * @property {T} value
			 * @property {LinkedListNode<T> | null} prev The previous node.
			 * @property {LinkedListNode<T> | null} next The next node.
			 * @template T
			 * @private
			 */

			/**
			 * @template T
			 * @private
			 */
			function LinkedList() {
				/** @type {LinkedListNode<T>} */
				var head = { value: null, prev: null, next: null };
				/** @type {LinkedListNode<T>} */
				var tail = { value: null, prev: head, next: null };
				head.next = tail;

				/** @type {LinkedListNode<T>} */
				this.head = head;
				/** @type {LinkedListNode<T>} */
				this.tail = tail;
				this.length = 0;
			}

			/**
			 * Adds a new node with the given value to the list.
			 *
			 * @param {LinkedList<T>} list
			 * @param {LinkedListNode<T>} node
			 * @param {T} value
			 * @returns {LinkedListNode<T>} The added node.
			 * @template T
			 */
			function addAfter(list, node, value) {
				// assumes that node != list.tail && values.length >= 0
				var next = node.next;

				var newNode = { value: value, prev: node, next: next };
				node.next = newNode;
				next.prev = newNode;
				list.length++;

				return newNode;
			}
			/**
			 * Removes `count` nodes after the given node. The given node will not be removed.
			 *
			 * @param {LinkedList<T>} list
			 * @param {LinkedListNode<T>} node
			 * @param {number} count
			 * @template T
			 */
			function removeRange(list, node, count) {
				var next = node.next;
				for (var i = 0; i < count && next !== list.tail; i++) {
					next = next.next;
				}
				node.next = next;
				next.prev = node;
				list.length -= i;
			}
			/**
			 * @param {LinkedList<T>} list
			 * @returns {T[]}
			 * @template T
			 */
			function toArray(list) {
				var array = [];
				var node = list.head.next;
				while (node !== list.tail) {
					array.push(node.value);
					node = node.next;
				}
				return array;
			}


			if (!_self.document) {
				if (!_self.addEventListener) {
					// in Node.js
					return _;
				}

				if (!_.disableWorkerMessageHandler) {
					// In worker
					_self.addEventListener('message', function (evt) {
						var message = JSON.parse(evt.data);
						var lang = message.language;
						var code = message.code;
						var immediateClose = message.immediateClose;

						_self.postMessage(_.highlight(code, _.languages[lang], lang));
						if (immediateClose) {
							_self.close();
						}
					}, false);
				}

				return _;
			}

			// Get current script and highlight
			var script = _.util.currentScript();

			if (script) {
				_.filename = script.src;

				if (script.hasAttribute('data-manual')) {
					_.manual = true;
				}
			}

			function highlightAutomaticallyCallback() {
				if (!_.manual) {
					_.highlightAll();
				}
			}

			if (!_.manual) {
				// If the document state is "loading", then we'll use DOMContentLoaded.
				// If the document state is "interactive" and the prism.js script is deferred, then we'll also use the
				// DOMContentLoaded event because there might be some plugins or languages which have also been deferred and they
				// might take longer one animation frame to execute which can create a race condition where only some plugins have
				// been loaded when Prism.highlightAll() is executed, depending on how fast resources are loaded.
				// See https://github.com/PrismJS/prism/issues/2102
				var readyState = document.readyState;
				if (readyState === 'loading' || readyState === 'interactive' && script && script.defer) {
					document.addEventListener('DOMContentLoaded', highlightAutomaticallyCallback);
				} else {
					if (window.requestAnimationFrame) {
						window.requestAnimationFrame(highlightAutomaticallyCallback);
					} else {
						window.setTimeout(highlightAutomaticallyCallback, 16);
					}
				}
			}

			return _;

		}(_self));

		if (module.exports) {
			module.exports = Prism;
		}

		// hack for components to work correctly in node.js
		if (typeof commonjsGlobal !== 'undefined') {
			commonjsGlobal.Prism = Prism;
		}

		// some additional documentation/types

		/**
		 * The expansion of a simple `RegExp` literal to support additional properties.
		 *
		 * @typedef GrammarToken
		 * @property {RegExp} pattern The regular expression of the token.
		 * @property {boolean} [lookbehind=false] If `true`, then the first capturing group of `pattern` will (effectively)
		 * behave as a lookbehind group meaning that the captured text will not be part of the matched text of the new token.
		 * @property {boolean} [greedy=false] Whether the token is greedy.
		 * @property {string|string[]} [alias] An optional alias or list of aliases.
		 * @property {Grammar} [inside] The nested grammar of this token.
		 *
		 * The `inside` grammar will be used to tokenize the text value of each token of this kind.
		 *
		 * This can be used to make nested and even recursive language definitions.
		 *
		 * Note: This can cause infinite recursion. Be careful when you embed different languages or even the same language into
		 * each another.
		 * @global
		 * @public
		 */

		/**
		 * @typedef Grammar
		 * @type {Object<string, RegExp | GrammarToken | Array<RegExp | GrammarToken>>}
		 * @property {Grammar} [rest] An optional grammar object that will be appended to this grammar.
		 * @global
		 * @public
		 */

		/**
		 * A function which will invoked after an element was successfully highlighted.
		 *
		 * @callback HighlightCallback
		 * @param {Element} element The element successfully highlighted.
		 * @returns {void}
		 * @global
		 * @public
		 */

		/**
		 * @callback HookCallback
		 * @param {Object<string, any>} env The environment variables of the hook.
		 * @returns {void}
		 * @global
		 * @public
		 */


		/* **********************************************
		     Begin prism-markup.js
		********************************************** */

		Prism.languages.markup = {
			'comment': {
				pattern: /<!--(?:(?!<!--)[\s\S])*?-->/,
				greedy: true
			},
			'prolog': {
				pattern: /<\?[\s\S]+?\?>/,
				greedy: true
			},
			'doctype': {
				// https://www.w3.org/TR/xml/#NT-doctypedecl
				pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i,
				greedy: true,
				inside: {
					'internal-subset': {
						pattern: /(^[^\[]*\[)[\s\S]+(?=\]>$)/,
						lookbehind: true,
						greedy: true,
						inside: null // see below
					},
					'string': {
						pattern: /"[^"]*"|'[^']*'/,
						greedy: true
					},
					'punctuation': /^<!|>$|[[\]]/,
					'doctype-tag': /^DOCTYPE/i,
					'name': /[^\s<>'"]+/
				}
			},
			'cdata': {
				pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
				greedy: true
			},
			'tag': {
				pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/,
				greedy: true,
				inside: {
					'tag': {
						pattern: /^<\/?[^\s>\/]+/,
						inside: {
							'punctuation': /^<\/?/,
							'namespace': /^[^\s>\/:]+:/
						}
					},
					'special-attr': [],
					'attr-value': {
						pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
						inside: {
							'punctuation': [
								{
									pattern: /^=/,
									alias: 'attr-equals'
								},
								{
									pattern: /^(\s*)["']|["']$/,
									lookbehind: true
								}
							]
						}
					},
					'punctuation': /\/?>/,
					'attr-name': {
						pattern: /[^\s>\/]+/,
						inside: {
							'namespace': /^[^\s>\/:]+:/
						}
					}

				}
			},
			'entity': [
				{
					pattern: /&[\da-z]{1,8};/i,
					alias: 'named-entity'
				},
				/&#x?[\da-f]{1,8};/i
			]
		};

		Prism.languages.markup['tag'].inside['attr-value'].inside['entity'] =
			Prism.languages.markup['entity'];
		Prism.languages.markup['doctype'].inside['internal-subset'].inside = Prism.languages.markup;

		// Plugin to make entity title show the real entity, idea by Roman Komarov
		Prism.hooks.add('wrap', function (env) {

			if (env.type === 'entity') {
				env.attributes['title'] = env.content.replace(/&amp;/, '&');
			}
		});

		Object.defineProperty(Prism.languages.markup.tag, 'addInlined', {
			/**
			 * Adds an inlined language to markup.
			 *
			 * An example of an inlined language is CSS with `<style>` tags.
			 *
			 * @param {string} tagName The name of the tag that contains the inlined language. This name will be treated as
			 * case insensitive.
			 * @param {string} lang The language key.
			 * @example
			 * addInlined('style', 'css');
			 */
			value: function addInlined(tagName, lang) {
				var includedCdataInside = {};
				includedCdataInside['language-' + lang] = {
					pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i,
					lookbehind: true,
					inside: Prism.languages[lang]
				};
				includedCdataInside['cdata'] = /^<!\[CDATA\[|\]\]>$/i;

				var inside = {
					'included-cdata': {
						pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
						inside: includedCdataInside
					}
				};
				inside['language-' + lang] = {
					pattern: /[\s\S]+/,
					inside: Prism.languages[lang]
				};

				var def = {};
				def[tagName] = {
					pattern: RegExp(/(<__[^>]*>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function () { return tagName; }), 'i'),
					lookbehind: true,
					greedy: true,
					inside: inside
				};

				Prism.languages.insertBefore('markup', 'cdata', def);
			}
		});
		Object.defineProperty(Prism.languages.markup.tag, 'addAttribute', {
			/**
			 * Adds an pattern to highlight languages embedded in HTML attributes.
			 *
			 * An example of an inlined language is CSS with `style` attributes.
			 *
			 * @param {string} attrName The name of the tag that contains the inlined language. This name will be treated as
			 * case insensitive.
			 * @param {string} lang The language key.
			 * @example
			 * addAttribute('style', 'css');
			 */
			value: function (attrName, lang) {
				Prism.languages.markup.tag.inside['special-attr'].push({
					pattern: RegExp(
						/(^|["'\s])/.source + '(?:' + attrName + ')' + /\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))/.source,
						'i'
					),
					lookbehind: true,
					inside: {
						'attr-name': /^[^\s=]+/,
						'attr-value': {
							pattern: /=[\s\S]+/,
							inside: {
								'value': {
									pattern: /(^=\s*(["']|(?!["'])))\S[\s\S]*(?=\2$)/,
									lookbehind: true,
									alias: [lang, 'language-' + lang],
									inside: Prism.languages[lang]
								},
								'punctuation': [
									{
										pattern: /^=/,
										alias: 'attr-equals'
									},
									/"|'/
								]
							}
						}
					}
				});
			}
		});

		Prism.languages.html = Prism.languages.markup;
		Prism.languages.mathml = Prism.languages.markup;
		Prism.languages.svg = Prism.languages.markup;

		Prism.languages.xml = Prism.languages.extend('markup', {});
		Prism.languages.ssml = Prism.languages.xml;
		Prism.languages.atom = Prism.languages.xml;
		Prism.languages.rss = Prism.languages.xml;


		/* **********************************************
		     Begin prism-css.js
		********************************************** */

		(function (Prism) {

			var string = /(?:"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n])*')/;

			Prism.languages.css = {
				'comment': /\/\*[\s\S]*?\*\//,
				'atrule': {
					pattern: RegExp('@[\\w-](?:' + /[^;{\s"']|\s+(?!\s)/.source + '|' + string.source + ')*?' + /(?:;|(?=\s*\{))/.source),
					inside: {
						'rule': /^@[\w-]+/,
						'selector-function-argument': {
							pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/,
							lookbehind: true,
							alias: 'selector'
						},
						'keyword': {
							pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
							lookbehind: true
						}
						// See rest below
					}
				},
				'url': {
					// https://drafts.csswg.org/css-values-3/#urls
					pattern: RegExp('\\burl\\((?:' + string.source + '|' + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ')\\)', 'i'),
					greedy: true,
					inside: {
						'function': /^url/i,
						'punctuation': /^\(|\)$/,
						'string': {
							pattern: RegExp('^' + string.source + '$'),
							alias: 'url'
						}
					}
				},
				'selector': {
					pattern: RegExp('(^|[{}\\s])[^{}\\s](?:[^{};"\'\\s]|\\s+(?![\\s{])|' + string.source + ')*(?=\\s*\\{)'),
					lookbehind: true
				},
				'string': {
					pattern: string,
					greedy: true
				},
				'property': {
					pattern: /(^|[^-\w\xA0-\uFFFF])(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i,
					lookbehind: true
				},
				'important': /!important\b/i,
				'function': {
					pattern: /(^|[^-a-z0-9])[-a-z0-9]+(?=\()/i,
					lookbehind: true
				},
				'punctuation': /[(){};:,]/
			};

			Prism.languages.css['atrule'].inside.rest = Prism.languages.css;

			var markup = Prism.languages.markup;
			if (markup) {
				markup.tag.addInlined('style', 'css');
				markup.tag.addAttribute('style', 'css');
			}

		}(Prism));


		/* **********************************************
		     Begin prism-clike.js
		********************************************** */

		Prism.languages.clike = {
			'comment': [
				{
					pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
					lookbehind: true,
					greedy: true
				},
				{
					pattern: /(^|[^\\:])\/\/.*/,
					lookbehind: true,
					greedy: true
				}
			],
			'string': {
				pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
				greedy: true
			},
			'class-name': {
				pattern: /(\b(?:class|extends|implements|instanceof|interface|new|trait)\s+|\bcatch\s+\()[\w.\\]+/i,
				lookbehind: true,
				inside: {
					'punctuation': /[.\\]/
				}
			},
			'keyword': /\b(?:break|catch|continue|do|else|finally|for|function|if|in|instanceof|new|null|return|throw|try|while)\b/,
			'boolean': /\b(?:false|true)\b/,
			'function': /\b\w+(?=\()/,
			'number': /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i,
			'operator': /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
			'punctuation': /[{}[\];(),.:]/
		};


		/* **********************************************
		     Begin prism-javascript.js
		********************************************** */

		Prism.languages.javascript = Prism.languages.extend('clike', {
			'class-name': [
				Prism.languages.clike['class-name'],
				{
					pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:constructor|prototype))/,
					lookbehind: true
				}
			],
			'keyword': [
				{
					pattern: /((?:^|\})\s*)catch\b/,
					lookbehind: true
				},
				{
					pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
					lookbehind: true
				},
			],
			// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
			'function': /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
			'number': {
				pattern: RegExp(
					/(^|[^\w$])/.source +
					'(?:' +
					(
						// constant
						/NaN|Infinity/.source +
						'|' +
						// binary integer
						/0[bB][01]+(?:_[01]+)*n?/.source +
						'|' +
						// octal integer
						/0[oO][0-7]+(?:_[0-7]+)*n?/.source +
						'|' +
						// hexadecimal integer
						/0[xX][\dA-Fa-f]+(?:_[\dA-Fa-f]+)*n?/.source +
						'|' +
						// decimal bigint
						/\d+(?:_\d+)*n/.source +
						'|' +
						// decimal number (integer or float) but no bigint
						/(?:\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\.\d+(?:_\d+)*)(?:[Ee][+-]?\d+(?:_\d+)*)?/.source
					) +
					')' +
					/(?![\w$])/.source
				),
				lookbehind: true
			},
			'operator': /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
		});

		Prism.languages.javascript['class-name'][0].pattern = /(\b(?:class|extends|implements|instanceof|interface|new)\s+)[\w.\\]+/;

		Prism.languages.insertBefore('javascript', 'keyword', {
			'regex': {
				pattern: RegExp(
					// lookbehind
					// eslint-disable-next-line regexp/no-dupe-characters-character-class
					/((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)/.source +
					// Regex pattern:
					// There are 2 regex patterns here. The RegExp set notation proposal added support for nested character
					// classes if the `v` flag is present. Unfortunately, nested CCs are both context-free and incompatible
					// with the only syntax, so we have to define 2 different regex patterns.
					/\//.source +
					'(?:' +
					/(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}/.source +
					'|' +
					// `v` flag syntax. This supports 3 levels of nested character classes.
					/(?:\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.)*\])*\])*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}v[dgimyus]{0,7}/.source +
					')' +
					// lookahead
					/(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/.source
				),
				lookbehind: true,
				greedy: true,
				inside: {
					'regex-source': {
						pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
						lookbehind: true,
						alias: 'language-regex',
						inside: Prism.languages.regex
					},
					'regex-delimiter': /^\/|\/$/,
					'regex-flags': /^[a-z]+$/,
				}
			},
			// This must be declared before keyword because we use "function" inside the look-forward
			'function-variable': {
				pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/,
				alias: 'function'
			},
			'parameter': [
				{
					pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/,
					lookbehind: true,
					inside: Prism.languages.javascript
				},
				{
					pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i,
					lookbehind: true,
					inside: Prism.languages.javascript
				},
				{
					pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/,
					lookbehind: true,
					inside: Prism.languages.javascript
				},
				{
					pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/,
					lookbehind: true,
					inside: Prism.languages.javascript
				}
			],
			'constant': /\b[A-Z](?:[A-Z_]|\dx?)*\b/
		});

		Prism.languages.insertBefore('javascript', 'string', {
			'hashbang': {
				pattern: /^#!.*/,
				greedy: true,
				alias: 'comment'
			},
			'template-string': {
				pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/,
				greedy: true,
				inside: {
					'template-punctuation': {
						pattern: /^`|`$/,
						alias: 'string'
					},
					'interpolation': {
						pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/,
						lookbehind: true,
						inside: {
							'interpolation-punctuation': {
								pattern: /^\$\{|\}$/,
								alias: 'punctuation'
							},
							rest: Prism.languages.javascript
						}
					},
					'string': /[\s\S]+/
				}
			},
			'string-property': {
				pattern: /((?:^|[,{])[ \t]*)(["'])(?:\\(?:\r\n|[\s\S])|(?!\2)[^\\\r\n])*\2(?=\s*:)/m,
				lookbehind: true,
				greedy: true,
				alias: 'property'
			}
		});

		Prism.languages.insertBefore('javascript', 'operator', {
			'literal-property': {
				pattern: /((?:^|[,{])[ \t]*)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*:)/m,
				lookbehind: true,
				alias: 'property'
			},
		});

		if (Prism.languages.markup) {
			Prism.languages.markup.tag.addInlined('script', 'javascript');

			// add attribute support for all DOM events.
			// https://developer.mozilla.org/en-US/docs/Web/Events#Standard_events
			Prism.languages.markup.tag.addAttribute(
				/on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source,
				'javascript'
			);
		}

		Prism.languages.js = Prism.languages.javascript;


		/* **********************************************
		     Begin prism-file-highlight.js
		********************************************** */

		(function () {

			if (typeof Prism === 'undefined' || typeof document === 'undefined') {
				return;
			}

			// https://developer.mozilla.org/en-US/docs/Web/API/Element/matches#Polyfill
			if (!Element.prototype.matches) {
				Element.prototype.matches = Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector;
			}

			var LOADING_MESSAGE = 'Loading…';
			var FAILURE_MESSAGE = function (status, message) {
				return '✖ Error ' + status + ' while fetching file: ' + message;
			};
			var FAILURE_EMPTY_MESSAGE = '✖ Error: File does not exist or is empty';

			var EXTENSIONS = {
				'js': 'javascript',
				'py': 'python',
				'rb': 'ruby',
				'ps1': 'powershell',
				'psm1': 'powershell',
				'sh': 'bash',
				'bat': 'batch',
				'h': 'c',
				'tex': 'latex'
			};

			var STATUS_ATTR = 'data-src-status';
			var STATUS_LOADING = 'loading';
			var STATUS_LOADED = 'loaded';
			var STATUS_FAILED = 'failed';

			var SELECTOR = 'pre[data-src]:not([' + STATUS_ATTR + '="' + STATUS_LOADED + '"])'
				+ ':not([' + STATUS_ATTR + '="' + STATUS_LOADING + '"])';

			/**
			 * Loads the given file.
			 *
			 * @param {string} src The URL or path of the source file to load.
			 * @param {(result: string) => void} success
			 * @param {(reason: string) => void} error
			 */
			function loadFile(src, success, error) {
				var xhr = new XMLHttpRequest();
				xhr.open('GET', src, true);
				xhr.onreadystatechange = function () {
					if (xhr.readyState == 4) {
						if (xhr.status < 400 && xhr.responseText) {
							success(xhr.responseText);
						} else {
							if (xhr.status >= 400) {
								error(FAILURE_MESSAGE(xhr.status, xhr.statusText));
							} else {
								error(FAILURE_EMPTY_MESSAGE);
							}
						}
					}
				};
				xhr.send(null);
			}

			/**
			 * Parses the given range.
			 *
			 * This returns a range with inclusive ends.
			 *
			 * @param {string | null | undefined} range
			 * @returns {[number, number | undefined] | undefined}
			 */
			function parseRange(range) {
				var m = /^\s*(\d+)\s*(?:(,)\s*(?:(\d+)\s*)?)?$/.exec(range || '');
				if (m) {
					var start = Number(m[1]);
					var comma = m[2];
					var end = m[3];

					if (!comma) {
						return [start, start];
					}
					if (!end) {
						return [start, undefined];
					}
					return [start, Number(end)];
				}
				return undefined;
			}

			Prism.hooks.add('before-highlightall', function (env) {
				env.selector += ', ' + SELECTOR;
			});

			Prism.hooks.add('before-sanity-check', function (env) {
				var pre = /** @type {HTMLPreElement} */ (env.element);
				if (pre.matches(SELECTOR)) {
					env.code = ''; // fast-path the whole thing and go to complete

					pre.setAttribute(STATUS_ATTR, STATUS_LOADING); // mark as loading

					// add code element with loading message
					var code = pre.appendChild(document.createElement('CODE'));
					code.textContent = LOADING_MESSAGE;

					var src = pre.getAttribute('data-src');

					var language = env.language;
					if (language === 'none') {
						// the language might be 'none' because there is no language set;
						// in this case, we want to use the extension as the language
						var extension = (/\.(\w+)$/.exec(src) || [, 'none'])[1];
						language = EXTENSIONS[extension] || extension;
					}

					// set language classes
					Prism.util.setLanguage(code, language);
					Prism.util.setLanguage(pre, language);

					// preload the language
					var autoloader = Prism.plugins.autoloader;
					if (autoloader) {
						autoloader.loadLanguages(language);
					}

					// load file
					loadFile(
						src,
						function (text) {
							// mark as loaded
							pre.setAttribute(STATUS_ATTR, STATUS_LOADED);

							// handle data-range
							var range = parseRange(pre.getAttribute('data-range'));
							if (range) {
								var lines = text.split(/\r\n?|\n/g);

								// the range is one-based and inclusive on both ends
								var start = range[0];
								var end = range[1] == null ? lines.length : range[1];

								if (start < 0) { start += lines.length; }
								start = Math.max(0, Math.min(start - 1, lines.length));
								if (end < 0) { end += lines.length; }
								end = Math.max(0, Math.min(end, lines.length));

								text = lines.slice(start, end).join('\n');

								// add data-start for line numbers
								if (!pre.hasAttribute('data-start')) {
									pre.setAttribute('data-start', String(start + 1));
								}
							}

							// highlight code
							code.textContent = text;
							Prism.highlightElement(code);
						},
						function (error) {
							// mark as failed
							pre.setAttribute(STATUS_ATTR, STATUS_FAILED);

							code.textContent = error;
						}
					);
				}
			});

			Prism.plugins.fileHighlight = {
				/**
				 * Executes the File Highlight plugin for all matching `pre` elements under the given container.
				 *
				 * Note: Elements which are already loaded or currently loading will not be touched by this method.
				 *
				 * @param {ParentNode} [container=document]
				 */
				highlight: function highlight(container) {
					var elements = (container || document).querySelectorAll(SELECTOR);

					for (var i = 0, element; (element = elements[i++]);) {
						Prism.highlightElement(element);
					}
				}
			};
			/** @deprecated Use `Prism.plugins.fileHighlight.highlight` instead. */
			Prism.fileHighlight = function () {
				Prism.plugins.fileHighlight.highlight.apply(this, arguments);
			};

		}()); 
	} (prism));
	return prism.exports;
}

var prismClike = {};

var hasRequiredPrismClike;

function requirePrismClike () {
	if (hasRequiredPrismClike) return prismClike;
	hasRequiredPrismClike = 1;
	Prism.languages.clike = {
		'comment': [
			{
				pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/,
				lookbehind: true,
				greedy: true
			},
			{
				pattern: /(^|[^\\:])\/\/.*/,
				lookbehind: true,
				greedy: true
			}
		],
		'string': {
			pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/,
			greedy: true
		},
		'class-name': {
			pattern: /(\b(?:class|extends|implements|instanceof|interface|new|trait)\s+|\bcatch\s+\()[\w.\\]+/i,
			lookbehind: true,
			inside: {
				'punctuation': /[.\\]/
			}
		},
		'keyword': /\b(?:break|catch|continue|do|else|finally|for|function|if|in|instanceof|new|null|return|throw|try|while)\b/,
		'boolean': /\b(?:false|true)\b/,
		'function': /\b\w+(?=\()/,
		'number': /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i,
		'operator': /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/,
		'punctuation': /[{}[\];(),.:]/
	};
	return prismClike;
}

var prismJavascript = {};

var hasRequiredPrismJavascript;

function requirePrismJavascript () {
	if (hasRequiredPrismJavascript) return prismJavascript;
	hasRequiredPrismJavascript = 1;
	Prism.languages.javascript = Prism.languages.extend('clike', {
		'class-name': [
			Prism.languages.clike['class-name'],
			{
				pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:constructor|prototype))/,
				lookbehind: true
			}
		],
		'keyword': [
			{
				pattern: /((?:^|\})\s*)catch\b/,
				lookbehind: true
			},
			{
				pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/,
				lookbehind: true
			},
		],
		// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
		'function': /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/,
		'number': {
			pattern: RegExp(
				/(^|[^\w$])/.source +
				'(?:' +
				(
					// constant
					/NaN|Infinity/.source +
					'|' +
					// binary integer
					/0[bB][01]+(?:_[01]+)*n?/.source +
					'|' +
					// octal integer
					/0[oO][0-7]+(?:_[0-7]+)*n?/.source +
					'|' +
					// hexadecimal integer
					/0[xX][\dA-Fa-f]+(?:_[\dA-Fa-f]+)*n?/.source +
					'|' +
					// decimal bigint
					/\d+(?:_\d+)*n/.source +
					'|' +
					// decimal number (integer or float) but no bigint
					/(?:\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\.\d+(?:_\d+)*)(?:[Ee][+-]?\d+(?:_\d+)*)?/.source
				) +
				')' +
				/(?![\w$])/.source
			),
			lookbehind: true
		},
		'operator': /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/
	});

	Prism.languages.javascript['class-name'][0].pattern = /(\b(?:class|extends|implements|instanceof|interface|new)\s+)[\w.\\]+/;

	Prism.languages.insertBefore('javascript', 'keyword', {
		'regex': {
			pattern: RegExp(
				// lookbehind
				// eslint-disable-next-line regexp/no-dupe-characters-character-class
				/((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)/.source +
				// Regex pattern:
				// There are 2 regex patterns here. The RegExp set notation proposal added support for nested character
				// classes if the `v` flag is present. Unfortunately, nested CCs are both context-free and incompatible
				// with the only syntax, so we have to define 2 different regex patterns.
				/\//.source +
				'(?:' +
				/(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}/.source +
				'|' +
				// `v` flag syntax. This supports 3 levels of nested character classes.
				/(?:\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.)*\])*\])*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}v[dgimyus]{0,7}/.source +
				')' +
				// lookahead
				/(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/.source
			),
			lookbehind: true,
			greedy: true,
			inside: {
				'regex-source': {
					pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/,
					lookbehind: true,
					alias: 'language-regex',
					inside: Prism.languages.regex
				},
				'regex-delimiter': /^\/|\/$/,
				'regex-flags': /^[a-z]+$/,
			}
		},
		// This must be declared before keyword because we use "function" inside the look-forward
		'function-variable': {
			pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/,
			alias: 'function'
		},
		'parameter': [
			{
				pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/,
				lookbehind: true,
				inside: Prism.languages.javascript
			},
			{
				pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i,
				lookbehind: true,
				inside: Prism.languages.javascript
			},
			{
				pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/,
				lookbehind: true,
				inside: Prism.languages.javascript
			},
			{
				pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/,
				lookbehind: true,
				inside: Prism.languages.javascript
			}
		],
		'constant': /\b[A-Z](?:[A-Z_]|\dx?)*\b/
	});

	Prism.languages.insertBefore('javascript', 'string', {
		'hashbang': {
			pattern: /^#!.*/,
			greedy: true,
			alias: 'comment'
		},
		'template-string': {
			pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/,
			greedy: true,
			inside: {
				'template-punctuation': {
					pattern: /^`|`$/,
					alias: 'string'
				},
				'interpolation': {
					pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/,
					lookbehind: true,
					inside: {
						'interpolation-punctuation': {
							pattern: /^\$\{|\}$/,
							alias: 'punctuation'
						},
						rest: Prism.languages.javascript
					}
				},
				'string': /[\s\S]+/
			}
		},
		'string-property': {
			pattern: /((?:^|[,{])[ \t]*)(["'])(?:\\(?:\r\n|[\s\S])|(?!\2)[^\\\r\n])*\2(?=\s*:)/m,
			lookbehind: true,
			greedy: true,
			alias: 'property'
		}
	});

	Prism.languages.insertBefore('javascript', 'operator', {
		'literal-property': {
			pattern: /((?:^|[,{])[ \t]*)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*:)/m,
			lookbehind: true,
			alias: 'property'
		},
	});

	if (Prism.languages.markup) {
		Prism.languages.markup.tag.addInlined('script', 'javascript');

		// add attribute support for all DOM events.
		// https://developer.mozilla.org/en-US/docs/Web/Events#Standard_events
		Prism.languages.markup.tag.addAttribute(
			/on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source,
			'javascript'
		);
	}

	Prism.languages.js = Prism.languages.javascript;
	return prismJavascript;
}

var prismMarkup = {};

var hasRequiredPrismMarkup;

function requirePrismMarkup () {
	if (hasRequiredPrismMarkup) return prismMarkup;
	hasRequiredPrismMarkup = 1;
	Prism.languages.markup = {
		'comment': {
			pattern: /<!--(?:(?!<!--)[\s\S])*?-->/,
			greedy: true
		},
		'prolog': {
			pattern: /<\?[\s\S]+?\?>/,
			greedy: true
		},
		'doctype': {
			// https://www.w3.org/TR/xml/#NT-doctypedecl
			pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i,
			greedy: true,
			inside: {
				'internal-subset': {
					pattern: /(^[^\[]*\[)[\s\S]+(?=\]>$)/,
					lookbehind: true,
					greedy: true,
					inside: null // see below
				},
				'string': {
					pattern: /"[^"]*"|'[^']*'/,
					greedy: true
				},
				'punctuation': /^<!|>$|[[\]]/,
				'doctype-tag': /^DOCTYPE/i,
				'name': /[^\s<>'"]+/
			}
		},
		'cdata': {
			pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
			greedy: true
		},
		'tag': {
			pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/,
			greedy: true,
			inside: {
				'tag': {
					pattern: /^<\/?[^\s>\/]+/,
					inside: {
						'punctuation': /^<\/?/,
						'namespace': /^[^\s>\/:]+:/
					}
				},
				'special-attr': [],
				'attr-value': {
					pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
					inside: {
						'punctuation': [
							{
								pattern: /^=/,
								alias: 'attr-equals'
							},
							{
								pattern: /^(\s*)["']|["']$/,
								lookbehind: true
							}
						]
					}
				},
				'punctuation': /\/?>/,
				'attr-name': {
					pattern: /[^\s>\/]+/,
					inside: {
						'namespace': /^[^\s>\/:]+:/
					}
				}

			}
		},
		'entity': [
			{
				pattern: /&[\da-z]{1,8};/i,
				alias: 'named-entity'
			},
			/&#x?[\da-f]{1,8};/i
		]
	};

	Prism.languages.markup['tag'].inside['attr-value'].inside['entity'] =
		Prism.languages.markup['entity'];
	Prism.languages.markup['doctype'].inside['internal-subset'].inside = Prism.languages.markup;

	// Plugin to make entity title show the real entity, idea by Roman Komarov
	Prism.hooks.add('wrap', function (env) {

		if (env.type === 'entity') {
			env.attributes['title'] = env.content.replace(/&amp;/, '&');
		}
	});

	Object.defineProperty(Prism.languages.markup.tag, 'addInlined', {
		/**
		 * Adds an inlined language to markup.
		 *
		 * An example of an inlined language is CSS with `<style>` tags.
		 *
		 * @param {string} tagName The name of the tag that contains the inlined language. This name will be treated as
		 * case insensitive.
		 * @param {string} lang The language key.
		 * @example
		 * addInlined('style', 'css');
		 */
		value: function addInlined(tagName, lang) {
			var includedCdataInside = {};
			includedCdataInside['language-' + lang] = {
				pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i,
				lookbehind: true,
				inside: Prism.languages[lang]
			};
			includedCdataInside['cdata'] = /^<!\[CDATA\[|\]\]>$/i;

			var inside = {
				'included-cdata': {
					pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i,
					inside: includedCdataInside
				}
			};
			inside['language-' + lang] = {
				pattern: /[\s\S]+/,
				inside: Prism.languages[lang]
			};

			var def = {};
			def[tagName] = {
				pattern: RegExp(/(<__[^>]*>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function () { return tagName; }), 'i'),
				lookbehind: true,
				greedy: true,
				inside: inside
			};

			Prism.languages.insertBefore('markup', 'cdata', def);
		}
	});
	Object.defineProperty(Prism.languages.markup.tag, 'addAttribute', {
		/**
		 * Adds an pattern to highlight languages embedded in HTML attributes.
		 *
		 * An example of an inlined language is CSS with `style` attributes.
		 *
		 * @param {string} attrName The name of the tag that contains the inlined language. This name will be treated as
		 * case insensitive.
		 * @param {string} lang The language key.
		 * @example
		 * addAttribute('style', 'css');
		 */
		value: function (attrName, lang) {
			Prism.languages.markup.tag.inside['special-attr'].push({
				pattern: RegExp(
					/(^|["'\s])/.source + '(?:' + attrName + ')' + /\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))/.source,
					'i'
				),
				lookbehind: true,
				inside: {
					'attr-name': /^[^\s=]+/,
					'attr-value': {
						pattern: /=[\s\S]+/,
						inside: {
							'value': {
								pattern: /(^=\s*(["']|(?!["'])))\S[\s\S]*(?=\2$)/,
								lookbehind: true,
								alias: [lang, 'language-' + lang],
								inside: Prism.languages[lang]
							},
							'punctuation': [
								{
									pattern: /^=/,
									alias: 'attr-equals'
								},
								/"|'/
							]
						}
					}
				}
			});
		}
	});

	Prism.languages.html = Prism.languages.markup;
	Prism.languages.mathml = Prism.languages.markup;
	Prism.languages.svg = Prism.languages.markup;

	Prism.languages.xml = Prism.languages.extend('markup', {});
	Prism.languages.ssml = Prism.languages.xml;
	Prism.languages.atom = Prism.languages.xml;
	Prism.languages.rss = Prism.languages.xml;
	return prismMarkup;
}

var prismMarkdown = {};

var hasRequiredPrismMarkdown;

function requirePrismMarkdown () {
	if (hasRequiredPrismMarkdown) return prismMarkdown;
	hasRequiredPrismMarkdown = 1;
	(function (Prism) {

		// Allow only one line break
		var inner = /(?:\\.|[^\\\n\r]|(?:\n|\r\n?)(?![\r\n]))/.source;

		/**
		 * This function is intended for the creation of the bold or italic pattern.
		 *
		 * This also adds a lookbehind group to the given pattern to ensure that the pattern is not backslash-escaped.
		 *
		 * _Note:_ Keep in mind that this adds a capturing group.
		 *
		 * @param {string} pattern
		 * @returns {RegExp}
		 */
		function createInline(pattern) {
			pattern = pattern.replace(/<inner>/g, function () { return inner; });
			return RegExp(/((?:^|[^\\])(?:\\{2})*)/.source + '(?:' + pattern + ')');
		}


		var tableCell = /(?:\\.|``(?:[^`\r\n]|`(?!`))+``|`[^`\r\n]+`|[^\\|\r\n`])+/.source;
		var tableRow = /\|?__(?:\|__)+\|?(?:(?:\n|\r\n?)|(?![\s\S]))/.source.replace(/__/g, function () { return tableCell; });
		var tableLine = /\|?[ \t]*:?-{3,}:?[ \t]*(?:\|[ \t]*:?-{3,}:?[ \t]*)+\|?(?:\n|\r\n?)/.source;


		Prism.languages.markdown = Prism.languages.extend('markup', {});
		Prism.languages.insertBefore('markdown', 'prolog', {
			'front-matter-block': {
				pattern: /(^(?:\s*[\r\n])?)---(?!.)[\s\S]*?[\r\n]---(?!.)/,
				lookbehind: true,
				greedy: true,
				inside: {
					'punctuation': /^---|---$/,
					'front-matter': {
						pattern: /\S+(?:\s+\S+)*/,
						alias: ['yaml', 'language-yaml'],
						inside: Prism.languages.yaml
					}
				}
			},
			'blockquote': {
				// > ...
				pattern: /^>(?:[\t ]*>)*/m,
				alias: 'punctuation'
			},
			'table': {
				pattern: RegExp('^' + tableRow + tableLine + '(?:' + tableRow + ')*', 'm'),
				inside: {
					'table-data-rows': {
						pattern: RegExp('^(' + tableRow + tableLine + ')(?:' + tableRow + ')*$'),
						lookbehind: true,
						inside: {
							'table-data': {
								pattern: RegExp(tableCell),
								inside: Prism.languages.markdown
							},
							'punctuation': /\|/
						}
					},
					'table-line': {
						pattern: RegExp('^(' + tableRow + ')' + tableLine + '$'),
						lookbehind: true,
						inside: {
							'punctuation': /\||:?-{3,}:?/
						}
					},
					'table-header-row': {
						pattern: RegExp('^' + tableRow + '$'),
						inside: {
							'table-header': {
								pattern: RegExp(tableCell),
								alias: 'important',
								inside: Prism.languages.markdown
							},
							'punctuation': /\|/
						}
					}
				}
			},
			'code': [
				{
					// Prefixed by 4 spaces or 1 tab and preceded by an empty line
					pattern: /((?:^|\n)[ \t]*\n|(?:^|\r\n?)[ \t]*\r\n?)(?: {4}|\t).+(?:(?:\n|\r\n?)(?: {4}|\t).+)*/,
					lookbehind: true,
					alias: 'keyword'
				},
				{
					// ```optional language
					// code block
					// ```
					pattern: /^```[\s\S]*?^```$/m,
					greedy: true,
					inside: {
						'code-block': {
							pattern: /^(```.*(?:\n|\r\n?))[\s\S]+?(?=(?:\n|\r\n?)^```$)/m,
							lookbehind: true
						},
						'code-language': {
							pattern: /^(```).+/,
							lookbehind: true
						},
						'punctuation': /```/
					}
				}
			],
			'title': [
				{
					// title 1
					// =======

					// title 2
					// -------
					pattern: /\S.*(?:\n|\r\n?)(?:==+|--+)(?=[ \t]*$)/m,
					alias: 'important',
					inside: {
						punctuation: /==+$|--+$/
					}
				},
				{
					// # title 1
					// ###### title 6
					pattern: /(^\s*)#.+/m,
					lookbehind: true,
					alias: 'important',
					inside: {
						punctuation: /^#+|#+$/
					}
				}
			],
			'hr': {
				// ***
				// ---
				// * * *
				// -----------
				pattern: /(^\s*)([*-])(?:[\t ]*\2){2,}(?=\s*$)/m,
				lookbehind: true,
				alias: 'punctuation'
			},
			'list': {
				// * item
				// + item
				// - item
				// 1. item
				pattern: /(^\s*)(?:[*+-]|\d+\.)(?=[\t ].)/m,
				lookbehind: true,
				alias: 'punctuation'
			},
			'url-reference': {
				// [id]: http://example.com "Optional title"
				// [id]: http://example.com 'Optional title'
				// [id]: http://example.com (Optional title)
				// [id]: <http://example.com> "Optional title"
				pattern: /!?\[[^\]]+\]:[\t ]+(?:\S+|<(?:\\.|[^>\\])+>)(?:[\t ]+(?:"(?:\\.|[^"\\])*"|'(?:\\.|[^'\\])*'|\((?:\\.|[^)\\])*\)))?/,
				inside: {
					'variable': {
						pattern: /^(!?\[)[^\]]+/,
						lookbehind: true
					},
					'string': /(?:"(?:\\.|[^"\\])*"|'(?:\\.|[^'\\])*'|\((?:\\.|[^)\\])*\))$/,
					'punctuation': /^[\[\]!:]|[<>]/
				},
				alias: 'url'
			},
			'bold': {
				// **strong**
				// __strong__

				// allow one nested instance of italic text using the same delimiter
				pattern: createInline(/\b__(?:(?!_)<inner>|_(?:(?!_)<inner>)+_)+__\b|\*\*(?:(?!\*)<inner>|\*(?:(?!\*)<inner>)+\*)+\*\*/.source),
				lookbehind: true,
				greedy: true,
				inside: {
					'content': {
						pattern: /(^..)[\s\S]+(?=..$)/,
						lookbehind: true,
						inside: {} // see below
					},
					'punctuation': /\*\*|__/
				}
			},
			'italic': {
				// *em*
				// _em_

				// allow one nested instance of bold text using the same delimiter
				pattern: createInline(/\b_(?:(?!_)<inner>|__(?:(?!_)<inner>)+__)+_\b|\*(?:(?!\*)<inner>|\*\*(?:(?!\*)<inner>)+\*\*)+\*/.source),
				lookbehind: true,
				greedy: true,
				inside: {
					'content': {
						pattern: /(^.)[\s\S]+(?=.$)/,
						lookbehind: true,
						inside: {} // see below
					},
					'punctuation': /[*_]/
				}
			},
			'strike': {
				// ~~strike through~~
				// ~strike~
				// eslint-disable-next-line regexp/strict
				pattern: createInline(/(~~?)(?:(?!~)<inner>)+\2/.source),
				lookbehind: true,
				greedy: true,
				inside: {
					'content': {
						pattern: /(^~~?)[\s\S]+(?=\1$)/,
						lookbehind: true,
						inside: {} // see below
					},
					'punctuation': /~~?/
				}
			},
			'code-snippet': {
				// `code`
				// ``code``
				pattern: /(^|[^\\`])(?:``[^`\r\n]+(?:`[^`\r\n]+)*``(?!`)|`[^`\r\n]+`(?!`))/,
				lookbehind: true,
				greedy: true,
				alias: ['code', 'keyword']
			},
			'url': {
				// [example](http://example.com "Optional title")
				// [example][id]
				// [example] [id]
				pattern: createInline(/!?\[(?:(?!\])<inner>)+\](?:\([^\s)]+(?:[\t ]+"(?:\\.|[^"\\])*")?\)|[ \t]?\[(?:(?!\])<inner>)+\])/.source),
				lookbehind: true,
				greedy: true,
				inside: {
					'operator': /^!/,
					'content': {
						pattern: /(^\[)[^\]]+(?=\])/,
						lookbehind: true,
						inside: {} // see below
					},
					'variable': {
						pattern: /(^\][ \t]?\[)[^\]]+(?=\]$)/,
						lookbehind: true
					},
					'url': {
						pattern: /(^\]\()[^\s)]+/,
						lookbehind: true
					},
					'string': {
						pattern: /(^[ \t]+)"(?:\\.|[^"\\])*"(?=\)$)/,
						lookbehind: true
					}
				}
			}
		});

		['url', 'bold', 'italic', 'strike'].forEach(function (token) {
			['url', 'bold', 'italic', 'strike', 'code-snippet'].forEach(function (inside) {
				if (token !== inside) {
					Prism.languages.markdown[token].inside.content.inside[inside] = Prism.languages.markdown[inside];
				}
			});
		});

		Prism.hooks.add('after-tokenize', function (env) {
			if (env.language !== 'markdown' && env.language !== 'md') {
				return;
			}

			function walkTokens(tokens) {
				if (!tokens || typeof tokens === 'string') {
					return;
				}

				for (var i = 0, l = tokens.length; i < l; i++) {
					var token = tokens[i];

					if (token.type !== 'code') {
						walkTokens(token.content);
						continue;
					}

					/*
					 * Add the correct `language-xxxx` class to this code block. Keep in mind that the `code-language` token
					 * is optional. But the grammar is defined so that there is only one case we have to handle:
					 *
					 * token.content = [
					 *     <span class="punctuation">```</span>,
					 *     <span class="code-language">xxxx</span>,
					 *     '\n', // exactly one new lines (\r or \n or \r\n)
					 *     <span class="code-block">...</span>,
					 *     '\n', // exactly one new lines again
					 *     <span class="punctuation">```</span>
					 * ];
					 */

					var codeLang = token.content[1];
					var codeBlock = token.content[3];

					if (codeLang && codeBlock &&
						codeLang.type === 'code-language' && codeBlock.type === 'code-block' &&
						typeof codeLang.content === 'string') {

						// this might be a language that Prism does not support

						// do some replacements to support C++, C#, and F#
						var lang = codeLang.content.replace(/\b#/g, 'sharp').replace(/\b\+\+/g, 'pp');
						// only use the first word
						lang = (/[a-z][\w-]*/i.exec(lang) || [''])[0].toLowerCase();
						var alias = 'language-' + lang;

						// add alias
						if (!codeBlock.alias) {
							codeBlock.alias = [alias];
						} else if (typeof codeBlock.alias === 'string') {
							codeBlock.alias = [codeBlock.alias, alias];
						} else {
							codeBlock.alias.push(alias);
						}
					}
				}
			}

			walkTokens(env.tokens);
		});

		Prism.hooks.add('wrap', function (env) {
			if (env.type !== 'code-block') {
				return;
			}

			var codeLang = '';
			for (var i = 0, l = env.classes.length; i < l; i++) {
				var cls = env.classes[i];
				var match = /language-(.+)/.exec(cls);
				if (match) {
					codeLang = match[1];
					break;
				}
			}

			var grammar = Prism.languages[codeLang];

			if (!grammar) {
				if (codeLang && codeLang !== 'none' && Prism.plugins.autoloader) {
					var id = 'md-' + new Date().valueOf() + '-' + Math.floor(Math.random() * 1e16);
					env.attributes['id'] = id;

					Prism.plugins.autoloader.loadLanguages(codeLang, function () {
						var ele = document.getElementById(id);
						if (ele) {
							ele.innerHTML = Prism.highlight(ele.textContent, Prism.languages[codeLang], codeLang);
						}
					});
				}
			} else {
				env.content = Prism.highlight(textContent(env.content), grammar, codeLang);
			}
		});

		var tagPattern = RegExp(Prism.languages.markup.tag.pattern.source, 'gi');

		/**
		 * A list of known entity names.
		 *
		 * This will always be incomplete to save space. The current list is the one used by lowdash's unescape function.
		 *
		 * @see {@link https://github.com/lodash/lodash/blob/2da024c3b4f9947a48517639de7560457cd4ec6c/unescape.js#L2}
		 */
		var KNOWN_ENTITY_NAMES = {
			'amp': '&',
			'lt': '<',
			'gt': '>',
			'quot': '"',
		};

		// IE 11 doesn't support `String.fromCodePoint`
		var fromCodePoint = String.fromCodePoint || String.fromCharCode;

		/**
		 * Returns the text content of a given HTML source code string.
		 *
		 * @param {string} html
		 * @returns {string}
		 */
		function textContent(html) {
			// remove all tags
			var text = html.replace(tagPattern, '');

			// decode known entities
			text = text.replace(/&(\w{1,8}|#x?[\da-f]{1,8});/gi, function (m, code) {
				code = code.toLowerCase();

				if (code[0] === '#') {
					var value;
					if (code[1] === 'x') {
						value = parseInt(code.slice(2), 16);
					} else {
						value = Number(code.slice(1));
					}

					return fromCodePoint(value);
				} else {
					var known = KNOWN_ENTITY_NAMES[code];
					if (known) {
						return known;
					}

					// unable to decode
					return m;
				}
			});

			return text;
		}

		Prism.languages.md = Prism.languages.markdown;

	}(Prism));
	return prismMarkdown;
}

var prismC = {};

var hasRequiredPrismC;

function requirePrismC () {
	if (hasRequiredPrismC) return prismC;
	hasRequiredPrismC = 1;
	Prism.languages.c = Prism.languages.extend('clike', {
		'comment': {
			pattern: /\/\/(?:[^\r\n\\]|\\(?:\r\n?|\n|(?![\r\n])))*|\/\*[\s\S]*?(?:\*\/|$)/,
			greedy: true
		},
		'string': {
			// https://en.cppreference.com/w/c/language/string_literal
			pattern: /"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"/,
			greedy: true
		},
		'class-name': {
			pattern: /(\b(?:enum|struct)\s+(?:__attribute__\s*\(\([\s\S]*?\)\)\s*)?)\w+|\b[a-z]\w*_t\b/,
			lookbehind: true
		},
		'keyword': /\b(?:_Alignas|_Alignof|_Atomic|_Bool|_Complex|_Generic|_Imaginary|_Noreturn|_Static_assert|_Thread_local|__attribute__|asm|auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto|if|inline|int|long|register|return|short|signed|sizeof|static|struct|switch|typedef|typeof|union|unsigned|void|volatile|while)\b/,
		'function': /\b[a-z_]\w*(?=\s*\()/i,
		'number': /(?:\b0x(?:[\da-f]+(?:\.[\da-f]*)?|\.[\da-f]+)(?:p[+-]?\d+)?|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?)[ful]{0,4}/i,
		'operator': />>=?|<<=?|->|([-+&|:])\1|[?:~]|[-+*/%&|^!=<>]=?/
	});

	Prism.languages.insertBefore('c', 'string', {
		'char': {
			// https://en.cppreference.com/w/c/language/character_constant
			pattern: /'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n]){0,32}'/,
			greedy: true
		}
	});

	Prism.languages.insertBefore('c', 'string', {
		'macro': {
			// allow for multiline macro definitions
			// spaces after the # character compile fine with gcc
			pattern: /(^[\t ]*)#\s*[a-z](?:[^\r\n\\/]|\/(?!\*)|\/\*(?:[^*]|\*(?!\/))*\*\/|\\(?:\r\n|[\s\S]))*/im,
			lookbehind: true,
			greedy: true,
			alias: 'property',
			inside: {
				'string': [
					{
						// highlight the path of the include statement as a string
						pattern: /^(#\s*include\s*)<[^>]+>/,
						lookbehind: true
					},
					Prism.languages.c['string']
				],
				'char': Prism.languages.c['char'],
				'comment': Prism.languages.c['comment'],
				'macro-name': [
					{
						pattern: /(^#\s*define\s+)\w+\b(?!\()/i,
						lookbehind: true
					},
					{
						pattern: /(^#\s*define\s+)\w+\b(?=\()/i,
						lookbehind: true,
						alias: 'function'
					}
				],
				// highlight macro directives as keywords
				'directive': {
					pattern: /^(#\s*)[a-z]+/,
					lookbehind: true,
					alias: 'keyword'
				},
				'directive-hash': /^#/,
				'punctuation': /##|\\(?=[\r\n])/,
				'expression': {
					pattern: /\S[\s\S]*/,
					inside: Prism.languages.c
				}
			}
		}
	});

	Prism.languages.insertBefore('c', 'function', {
		// highlight predefined macros as constants
		'constant': /\b(?:EOF|NULL|SEEK_CUR|SEEK_END|SEEK_SET|__DATE__|__FILE__|__LINE__|__TIMESTAMP__|__TIME__|__func__|stderr|stdin|stdout)\b/
	});

	delete Prism.languages.c['boolean'];
	return prismC;
}

var prismCss = {};

var hasRequiredPrismCss;

function requirePrismCss () {
	if (hasRequiredPrismCss) return prismCss;
	hasRequiredPrismCss = 1;
	(function (Prism) {

		var string = /(?:"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n])*')/;

		Prism.languages.css = {
			'comment': /\/\*[\s\S]*?\*\//,
			'atrule': {
				pattern: RegExp('@[\\w-](?:' + /[^;{\s"']|\s+(?!\s)/.source + '|' + string.source + ')*?' + /(?:;|(?=\s*\{))/.source),
				inside: {
					'rule': /^@[\w-]+/,
					'selector-function-argument': {
						pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/,
						lookbehind: true,
						alias: 'selector'
					},
					'keyword': {
						pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
						lookbehind: true
					}
					// See rest below
				}
			},
			'url': {
				// https://drafts.csswg.org/css-values-3/#urls
				pattern: RegExp('\\burl\\((?:' + string.source + '|' + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ')\\)', 'i'),
				greedy: true,
				inside: {
					'function': /^url/i,
					'punctuation': /^\(|\)$/,
					'string': {
						pattern: RegExp('^' + string.source + '$'),
						alias: 'url'
					}
				}
			},
			'selector': {
				pattern: RegExp('(^|[{}\\s])[^{}\\s](?:[^{};"\'\\s]|\\s+(?![\\s{])|' + string.source + ')*(?=\\s*\\{)'),
				lookbehind: true
			},
			'string': {
				pattern: string,
				greedy: true
			},
			'property': {
				pattern: /(^|[^-\w\xA0-\uFFFF])(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i,
				lookbehind: true
			},
			'important': /!important\b/i,
			'function': {
				pattern: /(^|[^-a-z0-9])[-a-z0-9]+(?=\()/i,
				lookbehind: true
			},
			'punctuation': /[(){};:,]/
		};

		Prism.languages.css['atrule'].inside.rest = Prism.languages.css;

		var markup = Prism.languages.markup;
		if (markup) {
			markup.tag.addInlined('style', 'css');
			markup.tag.addAttribute('style', 'css');
		}

	}(Prism));
	return prismCss;
}

var prismObjectivec = {};

var hasRequiredPrismObjectivec;

function requirePrismObjectivec () {
	if (hasRequiredPrismObjectivec) return prismObjectivec;
	hasRequiredPrismObjectivec = 1;
	Prism.languages.objectivec = Prism.languages.extend('c', {
		'string': {
			pattern: /@?"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"/,
			greedy: true
		},
		'keyword': /\b(?:asm|auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto|if|in|inline|int|long|register|return|self|short|signed|sizeof|static|struct|super|switch|typedef|typeof|union|unsigned|void|volatile|while)\b|(?:@interface|@end|@implementation|@protocol|@class|@public|@protected|@private|@property|@try|@catch|@finally|@throw|@synthesize|@dynamic|@selector)\b/,
		'operator': /-[->]?|\+\+?|!=?|<<?=?|>>?=?|==?|&&?|\|\|?|[~^%?*\/@]/
	});

	delete Prism.languages.objectivec['class-name'];

	Prism.languages.objc = Prism.languages.objectivec;
	return prismObjectivec;
}

var prismSql = {};

var hasRequiredPrismSql;

function requirePrismSql () {
	if (hasRequiredPrismSql) return prismSql;
	hasRequiredPrismSql = 1;
	Prism.languages.sql = {
		'comment': {
			pattern: /(^|[^\\])(?:\/\*[\s\S]*?\*\/|(?:--|\/\/|#).*)/,
			lookbehind: true
		},
		'variable': [
			{
				pattern: /@(["'`])(?:\\[\s\S]|(?!\1)[^\\])+\1/,
				greedy: true
			},
			/@[\w.$]+/
		],
		'string': {
			pattern: /(^|[^@\\])("|')(?:\\[\s\S]|(?!\2)[^\\]|\2\2)*\2/,
			greedy: true,
			lookbehind: true
		},
		'identifier': {
			pattern: /(^|[^@\\])`(?:\\[\s\S]|[^`\\]|``)*`/,
			greedy: true,
			lookbehind: true,
			inside: {
				'punctuation': /^`|`$/
			}
		},
		'function': /\b(?:AVG|COUNT|FIRST|FORMAT|LAST|LCASE|LEN|MAX|MID|MIN|MOD|NOW|ROUND|SUM|UCASE)(?=\s*\()/i, // Should we highlight user defined functions too?
		'keyword': /\b(?:ACTION|ADD|AFTER|ALGORITHM|ALL|ALTER|ANALYZE|ANY|APPLY|AS|ASC|AUTHORIZATION|AUTO_INCREMENT|BACKUP|BDB|BEGIN|BERKELEYDB|BIGINT|BINARY|BIT|BLOB|BOOL|BOOLEAN|BREAK|BROWSE|BTREE|BULK|BY|CALL|CASCADED?|CASE|CHAIN|CHAR(?:ACTER|SET)?|CHECK(?:POINT)?|CLOSE|CLUSTERED|COALESCE|COLLATE|COLUMNS?|COMMENT|COMMIT(?:TED)?|COMPUTE|CONNECT|CONSISTENT|CONSTRAINT|CONTAINS(?:TABLE)?|CONTINUE|CONVERT|CREATE|CROSS|CURRENT(?:_DATE|_TIME|_TIMESTAMP|_USER)?|CURSOR|CYCLE|DATA(?:BASES?)?|DATE(?:TIME)?|DAY|DBCC|DEALLOCATE|DEC|DECIMAL|DECLARE|DEFAULT|DEFINER|DELAYED|DELETE|DELIMITERS?|DENY|DESC|DESCRIBE|DETERMINISTIC|DISABLE|DISCARD|DISK|DISTINCT|DISTINCTROW|DISTRIBUTED|DO|DOUBLE|DROP|DUMMY|DUMP(?:FILE)?|DUPLICATE|ELSE(?:IF)?|ENABLE|ENCLOSED|END|ENGINE|ENUM|ERRLVL|ERRORS|ESCAPED?|EXCEPT|EXEC(?:UTE)?|EXISTS|EXIT|EXPLAIN|EXTENDED|FETCH|FIELDS|FILE|FILLFACTOR|FIRST|FIXED|FLOAT|FOLLOWING|FOR(?: EACH ROW)?|FORCE|FOREIGN|FREETEXT(?:TABLE)?|FROM|FULL|FUNCTION|GEOMETRY(?:COLLECTION)?|GLOBAL|GOTO|GRANT|GROUP|HANDLER|HASH|HAVING|HOLDLOCK|HOUR|IDENTITY(?:COL|_INSERT)?|IF|IGNORE|IMPORT|INDEX|INFILE|INNER|INNODB|INOUT|INSERT|INT|INTEGER|INTERSECT|INTERVAL|INTO|INVOKER|ISOLATION|ITERATE|JOIN|KEYS?|KILL|LANGUAGE|LAST|LEAVE|LEFT|LEVEL|LIMIT|LINENO|LINES|LINESTRING|LOAD|LOCAL|LOCK|LONG(?:BLOB|TEXT)|LOOP|MATCH(?:ED)?|MEDIUM(?:BLOB|INT|TEXT)|MERGE|MIDDLEINT|MINUTE|MODE|MODIFIES|MODIFY|MONTH|MULTI(?:LINESTRING|POINT|POLYGON)|NATIONAL|NATURAL|NCHAR|NEXT|NO|NONCLUSTERED|NULLIF|NUMERIC|OFF?|OFFSETS?|ON|OPEN(?:DATASOURCE|QUERY|ROWSET)?|OPTIMIZE|OPTION(?:ALLY)?|ORDER|OUT(?:ER|FILE)?|OVER|PARTIAL|PARTITION|PERCENT|PIVOT|PLAN|POINT|POLYGON|PRECEDING|PRECISION|PREPARE|PREV|PRIMARY|PRINT|PRIVILEGES|PROC(?:EDURE)?|PUBLIC|PURGE|QUICK|RAISERROR|READS?|REAL|RECONFIGURE|REFERENCES|RELEASE|RENAME|REPEAT(?:ABLE)?|REPLACE|REPLICATION|REQUIRE|RESIGNAL|RESTORE|RESTRICT|RETURN(?:ING|S)?|REVOKE|RIGHT|ROLLBACK|ROUTINE|ROW(?:COUNT|GUIDCOL|S)?|RTREE|RULE|SAVE(?:POINT)?|SCHEMA|SECOND|SELECT|SERIAL(?:IZABLE)?|SESSION(?:_USER)?|SET(?:USER)?|SHARE|SHOW|SHUTDOWN|SIMPLE|SMALLINT|SNAPSHOT|SOME|SONAME|SQL|START(?:ING)?|STATISTICS|STATUS|STRIPED|SYSTEM_USER|TABLES?|TABLESPACE|TEMP(?:ORARY|TABLE)?|TERMINATED|TEXT(?:SIZE)?|THEN|TIME(?:STAMP)?|TINY(?:BLOB|INT|TEXT)|TOP?|TRAN(?:SACTIONS?)?|TRIGGER|TRUNCATE|TSEQUAL|TYPES?|UNBOUNDED|UNCOMMITTED|UNDEFINED|UNION|UNIQUE|UNLOCK|UNPIVOT|UNSIGNED|UPDATE(?:TEXT)?|USAGE|USE|USER|USING|VALUES?|VAR(?:BINARY|CHAR|CHARACTER|YING)|VIEW|WAITFOR|WARNINGS|WHEN|WHERE|WHILE|WITH(?: ROLLUP|IN)?|WORK|WRITE(?:TEXT)?|YEAR)\b/i,
		'boolean': /\b(?:FALSE|NULL|TRUE)\b/i,
		'number': /\b0x[\da-f]+\b|\b\d+(?:\.\d*)?|\B\.\d+\b/i,
		'operator': /[-+*\/=%^~]|&&?|\|\|?|!=?|<(?:=>?|<|>)?|>[>=]?|\b(?:AND|BETWEEN|DIV|ILIKE|IN|IS|LIKE|NOT|OR|REGEXP|RLIKE|SOUNDS LIKE|XOR)\b/i,
		'punctuation': /[;[\]()`,.]/
	};
	return prismSql;
}

var prismPython = {};

var hasRequiredPrismPython;

function requirePrismPython () {
	if (hasRequiredPrismPython) return prismPython;
	hasRequiredPrismPython = 1;
	Prism.languages.python = {
		'comment': {
			pattern: /(^|[^\\])#.*/,
			lookbehind: true,
			greedy: true
		},
		'string-interpolation': {
			pattern: /(?:f|fr|rf)(?:("""|''')[\s\S]*?\1|("|')(?:\\.|(?!\2)[^\\\r\n])*\2)/i,
			greedy: true,
			inside: {
				'interpolation': {
					// "{" <expression> <optional "!s", "!r", or "!a"> <optional ":" format specifier> "}"
					pattern: /((?:^|[^{])(?:\{\{)*)\{(?!\{)(?:[^{}]|\{(?!\{)(?:[^{}]|\{(?!\{)(?:[^{}])+\})+\})+\}/,
					lookbehind: true,
					inside: {
						'format-spec': {
							pattern: /(:)[^:(){}]+(?=\}$)/,
							lookbehind: true
						},
						'conversion-option': {
							pattern: /![sra](?=[:}]$)/,
							alias: 'punctuation'
						},
						rest: null
					}
				},
				'string': /[\s\S]+/
			}
		},
		'triple-quoted-string': {
			pattern: /(?:[rub]|br|rb)?("""|''')[\s\S]*?\1/i,
			greedy: true,
			alias: 'string'
		},
		'string': {
			pattern: /(?:[rub]|br|rb)?("|')(?:\\.|(?!\1)[^\\\r\n])*\1/i,
			greedy: true
		},
		'function': {
			pattern: /((?:^|\s)def[ \t]+)[a-zA-Z_]\w*(?=\s*\()/g,
			lookbehind: true
		},
		'class-name': {
			pattern: /(\bclass\s+)\w+/i,
			lookbehind: true
		},
		'decorator': {
			pattern: /(^[\t ]*)@\w+(?:\.\w+)*/m,
			lookbehind: true,
			alias: ['annotation', 'punctuation'],
			inside: {
				'punctuation': /\./
			}
		},
		'keyword': /\b(?:_(?=\s*:)|and|as|assert|async|await|break|case|class|continue|def|del|elif|else|except|exec|finally|for|from|global|if|import|in|is|lambda|match|nonlocal|not|or|pass|print|raise|return|try|while|with|yield)\b/,
		'builtin': /\b(?:__import__|abs|all|any|apply|ascii|basestring|bin|bool|buffer|bytearray|bytes|callable|chr|classmethod|cmp|coerce|compile|complex|delattr|dict|dir|divmod|enumerate|eval|execfile|file|filter|float|format|frozenset|getattr|globals|hasattr|hash|help|hex|id|input|int|intern|isinstance|issubclass|iter|len|list|locals|long|map|max|memoryview|min|next|object|oct|open|ord|pow|property|range|raw_input|reduce|reload|repr|reversed|round|set|setattr|slice|sorted|staticmethod|str|sum|super|tuple|type|unichr|unicode|vars|xrange|zip)\b/,
		'boolean': /\b(?:False|None|True)\b/,
		'number': /\b0(?:b(?:_?[01])+|o(?:_?[0-7])+|x(?:_?[a-f0-9])+)\b|(?:\b\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\B\.\d+(?:_\d+)*)(?:e[+-]?\d+(?:_\d+)*)?j?(?!\w)/i,
		'operator': /[-+%=]=?|!=|:=|\*\*?=?|\/\/?=?|<[<=>]?|>[=>]?|[&|^~]/,
		'punctuation': /[{}[\];(),.:]/
	};

	Prism.languages.python['string-interpolation'].inside['interpolation'].inside.rest = Prism.languages.python;

	Prism.languages.py = Prism.languages.python;
	return prismPython;
}

var prismRust = {};

var hasRequiredPrismRust;

function requirePrismRust () {
	if (hasRequiredPrismRust) return prismRust;
	hasRequiredPrismRust = 1;
	(function (Prism) {

		var multilineComment = /\/\*(?:[^*/]|\*(?!\/)|\/(?!\*)|<self>)*\*\//.source;
		for (var i = 0; i < 2; i++) {
			// support 4 levels of nested comments
			multilineComment = multilineComment.replace(/<self>/g, function () { return multilineComment; });
		}
		multilineComment = multilineComment.replace(/<self>/g, function () { return /[^\s\S]/.source; });


		Prism.languages.rust = {
			'comment': [
				{
					pattern: RegExp(/(^|[^\\])/.source + multilineComment),
					lookbehind: true,
					greedy: true
				},
				{
					pattern: /(^|[^\\:])\/\/.*/,
					lookbehind: true,
					greedy: true
				}
			],
			'string': {
				pattern: /b?"(?:\\[\s\S]|[^\\"])*"|b?r(#*)"(?:[^"]|"(?!\1))*"\1/,
				greedy: true
			},
			'char': {
				pattern: /b?'(?:\\(?:x[0-7][\da-fA-F]|u\{(?:[\da-fA-F]_*){1,6}\}|.)|[^\\\r\n\t'])'/,
				greedy: true
			},
			'attribute': {
				pattern: /#!?\[(?:[^\[\]"]|"(?:\\[\s\S]|[^\\"])*")*\]/,
				greedy: true,
				alias: 'attr-name',
				inside: {
					'string': null // see below
				}
			},

			// Closure params should not be confused with bitwise OR |
			'closure-params': {
				pattern: /([=(,:]\s*|\bmove\s*)\|[^|]*\||\|[^|]*\|(?=\s*(?:\{|->))/,
				lookbehind: true,
				greedy: true,
				inside: {
					'closure-punctuation': {
						pattern: /^\||\|$/,
						alias: 'punctuation'
					},
					rest: null // see below
				}
			},

			'lifetime-annotation': {
				pattern: /'\w+/,
				alias: 'symbol'
			},

			'fragment-specifier': {
				pattern: /(\$\w+:)[a-z]+/,
				lookbehind: true,
				alias: 'punctuation'
			},
			'variable': /\$\w+/,

			'function-definition': {
				pattern: /(\bfn\s+)\w+/,
				lookbehind: true,
				alias: 'function'
			},
			'type-definition': {
				pattern: /(\b(?:enum|struct|trait|type|union)\s+)\w+/,
				lookbehind: true,
				alias: 'class-name'
			},
			'module-declaration': [
				{
					pattern: /(\b(?:crate|mod)\s+)[a-z][a-z_\d]*/,
					lookbehind: true,
					alias: 'namespace'
				},
				{
					pattern: /(\b(?:crate|self|super)\s*)::\s*[a-z][a-z_\d]*\b(?:\s*::(?:\s*[a-z][a-z_\d]*\s*::)*)?/,
					lookbehind: true,
					alias: 'namespace',
					inside: {
						'punctuation': /::/
					}
				}
			],
			'keyword': [
				// https://github.com/rust-lang/reference/blob/master/src/keywords.md
				/\b(?:Self|abstract|as|async|await|become|box|break|const|continue|crate|do|dyn|else|enum|extern|final|fn|for|if|impl|in|let|loop|macro|match|mod|move|mut|override|priv|pub|ref|return|self|static|struct|super|trait|try|type|typeof|union|unsafe|unsized|use|virtual|where|while|yield)\b/,
				// primitives and str
				// https://doc.rust-lang.org/stable/rust-by-example/primitives.html
				/\b(?:bool|char|f(?:32|64)|[ui](?:8|16|32|64|128|size)|str)\b/
			],

			// functions can technically start with an upper-case letter, but this will introduce a lot of false positives
			// and Rust's naming conventions recommend snake_case anyway.
			// https://doc.rust-lang.org/1.0.0/style/style/naming/README.html
			'function': /\b[a-z_]\w*(?=\s*(?:::\s*<|\())/,
			'macro': {
				pattern: /\b\w+!/,
				alias: 'property'
			},
			'constant': /\b[A-Z_][A-Z_\d]+\b/,
			'class-name': /\b[A-Z]\w*\b/,

			'namespace': {
				pattern: /(?:\b[a-z][a-z_\d]*\s*::\s*)*\b[a-z][a-z_\d]*\s*::(?!\s*<)/,
				inside: {
					'punctuation': /::/
				}
			},

			// Hex, oct, bin, dec numbers with visual separators and type suffix
			'number': /\b(?:0x[\dA-Fa-f](?:_?[\dA-Fa-f])*|0o[0-7](?:_?[0-7])*|0b[01](?:_?[01])*|(?:(?:\d(?:_?\d)*)?\.)?\d(?:_?\d)*(?:[Ee][+-]?\d+)?)(?:_?(?:f32|f64|[iu](?:8|16|32|64|size)?))?\b/,
			'boolean': /\b(?:false|true)\b/,
			'punctuation': /->|\.\.=|\.{1,3}|::|[{}[\];(),:]/,
			'operator': /[-+*\/%!^]=?|=[=>]?|&[&=]?|\|[|=]?|<<?=?|>>?=?|[@?]/
		};

		Prism.languages.rust['closure-params'].inside.rest = Prism.languages.rust;
		Prism.languages.rust['attribute'].inside['string'] = Prism.languages.rust['string'];

	}(Prism));
	return prismRust;
}

var prismSwift = {};

var hasRequiredPrismSwift;

function requirePrismSwift () {
	if (hasRequiredPrismSwift) return prismSwift;
	hasRequiredPrismSwift = 1;
	Prism.languages.swift = {
		'comment': {
			// Nested comments are supported up to 2 levels
			pattern: /(^|[^\\:])(?:\/\/.*|\/\*(?:[^/*]|\/(?!\*)|\*(?!\/)|\/\*(?:[^*]|\*(?!\/))*\*\/)*\*\/)/,
			lookbehind: true,
			greedy: true
		},
		'string-literal': [
			// https://docs.swift.org/swift-book/LanguageGuide/StringsAndCharacters.html
			{
				pattern: RegExp(
					/(^|[^"#])/.source
					+ '(?:'
					// single-line string
					+ /"(?:\\(?:\((?:[^()]|\([^()]*\))*\)|\r\n|[^(])|[^\\\r\n"])*"/.source
					+ '|'
					// multi-line string
					+ /"""(?:\\(?:\((?:[^()]|\([^()]*\))*\)|[^(])|[^\\"]|"(?!""))*"""/.source
					+ ')'
					+ /(?!["#])/.source
				),
				lookbehind: true,
				greedy: true,
				inside: {
					'interpolation': {
						pattern: /(\\\()(?:[^()]|\([^()]*\))*(?=\))/,
						lookbehind: true,
						inside: null // see below
					},
					'interpolation-punctuation': {
						pattern: /^\)|\\\($/,
						alias: 'punctuation'
					},
					'punctuation': /\\(?=[\r\n])/,
					'string': /[\s\S]+/
				}
			},
			{
				pattern: RegExp(
					/(^|[^"#])(#+)/.source
					+ '(?:'
					// single-line string
					+ /"(?:\\(?:#+\((?:[^()]|\([^()]*\))*\)|\r\n|[^#])|[^\\\r\n])*?"/.source
					+ '|'
					// multi-line string
					+ /"""(?:\\(?:#+\((?:[^()]|\([^()]*\))*\)|[^#])|[^\\])*?"""/.source
					+ ')'
					+ '\\2'
				),
				lookbehind: true,
				greedy: true,
				inside: {
					'interpolation': {
						pattern: /(\\#+\()(?:[^()]|\([^()]*\))*(?=\))/,
						lookbehind: true,
						inside: null // see below
					},
					'interpolation-punctuation': {
						pattern: /^\)|\\#+\($/,
						alias: 'punctuation'
					},
					'string': /[\s\S]+/
				}
			},
		],

		'directive': {
			// directives with conditions
			pattern: RegExp(
				/#/.source
				+ '(?:'
				+ (
					/(?:elseif|if)\b/.source
					+ '(?:[ \t]*'
					// This regex is a little complex. It's equivalent to this:
					//   (?:![ \t]*)?(?:\b\w+\b(?:[ \t]*<round>)?|<round>)(?:[ \t]*(?:&&|\|\|))?
					// where <round> is a general parentheses expression.
					+ /(?:![ \t]*)?(?:\b\w+\b(?:[ \t]*\((?:[^()]|\([^()]*\))*\))?|\((?:[^()]|\([^()]*\))*\))(?:[ \t]*(?:&&|\|\|))?/.source
					+ ')+'
				)
				+ '|'
				+ /(?:else|endif)\b/.source
				+ ')'
			),
			alias: 'property',
			inside: {
				'directive-name': /^#\w+/,
				'boolean': /\b(?:false|true)\b/,
				'number': /\b\d+(?:\.\d+)*\b/,
				'operator': /!|&&|\|\||[<>]=?/,
				'punctuation': /[(),]/
			}
		},
		'literal': {
			pattern: /#(?:colorLiteral|column|dsohandle|file(?:ID|Literal|Path)?|function|imageLiteral|line)\b/,
			alias: 'constant'
		},
		'other-directive': {
			pattern: /#\w+\b/,
			alias: 'property'
		},

		'attribute': {
			pattern: /@\w+/,
			alias: 'atrule'
		},

		'function-definition': {
			pattern: /(\bfunc\s+)\w+/,
			lookbehind: true,
			alias: 'function'
		},
		'label': {
			// https://docs.swift.org/swift-book/LanguageGuide/ControlFlow.html#ID141
			pattern: /\b(break|continue)\s+\w+|\b[a-zA-Z_]\w*(?=\s*:\s*(?:for|repeat|while)\b)/,
			lookbehind: true,
			alias: 'important'
		},

		'keyword': /\b(?:Any|Protocol|Self|Type|actor|as|assignment|associatedtype|associativity|async|await|break|case|catch|class|continue|convenience|default|defer|deinit|didSet|do|dynamic|else|enum|extension|fallthrough|fileprivate|final|for|func|get|guard|higherThan|if|import|in|indirect|infix|init|inout|internal|is|isolated|lazy|left|let|lowerThan|mutating|none|nonisolated|nonmutating|open|operator|optional|override|postfix|precedencegroup|prefix|private|protocol|public|repeat|required|rethrows|return|right|safe|self|set|some|static|struct|subscript|super|switch|throw|throws|try|typealias|unowned|unsafe|var|weak|where|while|willSet)\b/,
		'boolean': /\b(?:false|true)\b/,
		'nil': {
			pattern: /\bnil\b/,
			alias: 'constant'
		},

		'short-argument': /\$\d+\b/,
		'omit': {
			pattern: /\b_\b/,
			alias: 'keyword'
		},
		'number': /\b(?:[\d_]+(?:\.[\de_]+)?|0x[a-f0-9_]+(?:\.[a-f0-9p_]+)?|0b[01_]+|0o[0-7_]+)\b/i,

		// A class name must start with an upper-case letter and be either 1 letter long or contain a lower-case letter.
		'class-name': /\b[A-Z](?:[A-Z_\d]*[a-z]\w*)?\b/,
		'function': /\b[a-z_]\w*(?=\s*\()/i,
		'constant': /\b(?:[A-Z_]{2,}|k[A-Z][A-Za-z_]+)\b/,

		// Operators are generic in Swift. Developers can even create new operators (e.g. +++).
		// https://docs.swift.org/swift-book/ReferenceManual/zzSummaryOfTheGrammar.html#ID481
		// This regex only supports ASCII operators.
		'operator': /[-+*/%=!<>&|^~?]+|\.[.\-+*/%=!<>&|^~?]+/,
		'punctuation': /[{}[\]();,.:\\]/
	};

	Prism.languages.swift['string-literal'].forEach(function (rule) {
		rule.inside['interpolation'].inside = Prism.languages.swift;
	});
	return prismSwift;
}

var prismTypescript = {};

var hasRequiredPrismTypescript;

function requirePrismTypescript () {
	if (hasRequiredPrismTypescript) return prismTypescript;
	hasRequiredPrismTypescript = 1;
	(function (Prism) {

		Prism.languages.typescript = Prism.languages.extend('javascript', {
			'class-name': {
				pattern: /(\b(?:class|extends|implements|instanceof|interface|new|type)\s+)(?!keyof\b)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?:\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>)?/,
				lookbehind: true,
				greedy: true,
				inside: null // see below
			},
			'builtin': /\b(?:Array|Function|Promise|any|boolean|console|never|number|string|symbol|unknown)\b/,
		});

		// The keywords TypeScript adds to JavaScript
		Prism.languages.typescript.keyword.push(
			/\b(?:abstract|declare|is|keyof|readonly|require)\b/,
			// keywords that have to be followed by an identifier
			/\b(?:asserts|infer|interface|module|namespace|type)\b(?=\s*(?:[{_$a-zA-Z\xA0-\uFFFF]|$))/,
			// This is for `import type *, {}`
			/\btype\b(?=\s*(?:[\{*]|$))/
		);

		// doesn't work with TS because TS is too complex
		delete Prism.languages.typescript['parameter'];
		delete Prism.languages.typescript['literal-property'];

		// a version of typescript specifically for highlighting types
		var typeInside = Prism.languages.extend('typescript', {});
		delete typeInside['class-name'];

		Prism.languages.typescript['class-name'].inside = typeInside;

		Prism.languages.insertBefore('typescript', 'function', {
			'decorator': {
				pattern: /@[$\w\xA0-\uFFFF]+/,
				inside: {
					'at': {
						pattern: /^@/,
						alias: 'operator'
					},
					'function': /^[\s\S]+/
				}
			},
			'generic-function': {
				// e.g. foo<T extends "bar" | "baz">( ...
				pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>(?=\s*\()/,
				greedy: true,
				inside: {
					'function': /^#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*/,
					'generic': {
						pattern: /<[\s\S]+/, // everything after the first <
						alias: 'class-name',
						inside: typeInside
					}
				}
			}
		});

		Prism.languages.ts = Prism.languages.typescript;

	}(Prism));
	return prismTypescript;
}

var prismJava = {};

var hasRequiredPrismJava;

function requirePrismJava () {
	if (hasRequiredPrismJava) return prismJava;
	hasRequiredPrismJava = 1;
	(function (Prism) {

		var keywords = /\b(?:abstract|assert|boolean|break|byte|case|catch|char|class|const|continue|default|do|double|else|enum|exports|extends|final|finally|float|for|goto|if|implements|import|instanceof|int|interface|long|module|native|new|non-sealed|null|open|opens|package|permits|private|protected|provides|public|record(?!\s*[(){}[\]<>=%~.:,;?+\-*/&|^])|requires|return|sealed|short|static|strictfp|super|switch|synchronized|this|throw|throws|to|transient|transitive|try|uses|var|void|volatile|while|with|yield)\b/;

		// full package (optional) + parent classes (optional)
		var classNamePrefix = /(?:[a-z]\w*\s*\.\s*)*(?:[A-Z]\w*\s*\.\s*)*/.source;

		// based on the java naming conventions
		var className = {
			pattern: RegExp(/(^|[^\w.])/.source + classNamePrefix + /[A-Z](?:[\d_A-Z]*[a-z]\w*)?\b/.source),
			lookbehind: true,
			inside: {
				'namespace': {
					pattern: /^[a-z]\w*(?:\s*\.\s*[a-z]\w*)*(?:\s*\.)?/,
					inside: {
						'punctuation': /\./
					}
				},
				'punctuation': /\./
			}
		};

		Prism.languages.java = Prism.languages.extend('clike', {
			'string': {
				pattern: /(^|[^\\])"(?:\\.|[^"\\\r\n])*"/,
				lookbehind: true,
				greedy: true
			},
			'class-name': [
				className,
				{
					// variables, parameters, and constructor references
					// this to support class names (or generic parameters) which do not contain a lower case letter (also works for methods)
					pattern: RegExp(/(^|[^\w.])/.source + classNamePrefix + /[A-Z]\w*(?=\s+\w+\s*[;,=()]|\s*(?:\[[\s,]*\]\s*)?::\s*new\b)/.source),
					lookbehind: true,
					inside: className.inside
				},
				{
					// class names based on keyword
					// this to support class names (or generic parameters) which do not contain a lower case letter (also works for methods)
					pattern: RegExp(/(\b(?:class|enum|extends|implements|instanceof|interface|new|record|throws)\s+)/.source + classNamePrefix + /[A-Z]\w*\b/.source),
					lookbehind: true,
					inside: className.inside
				}
			],
			'keyword': keywords,
			'function': [
				Prism.languages.clike.function,
				{
					pattern: /(::\s*)[a-z_]\w*/,
					lookbehind: true
				}
			],
			'number': /\b0b[01][01_]*L?\b|\b0x(?:\.[\da-f_p+-]+|[\da-f_]+(?:\.[\da-f_p+-]+)?)\b|(?:\b\d[\d_]*(?:\.[\d_]*)?|\B\.\d[\d_]*)(?:e[+-]?\d[\d_]*)?[dfl]?/i,
			'operator': {
				pattern: /(^|[^.])(?:<<=?|>>>?=?|->|--|\+\+|&&|\|\||::|[?:~]|[-+*/%&|^!=<>]=?)/m,
				lookbehind: true
			},
			'constant': /\b[A-Z][A-Z_\d]+\b/
		});

		Prism.languages.insertBefore('java', 'string', {
			'triple-quoted-string': {
				// http://openjdk.java.net/jeps/355#Description
				pattern: /"""[ \t]*[\r\n](?:(?:"|"")?(?:\\.|[^"\\]))*"""/,
				greedy: true,
				alias: 'string'
			},
			'char': {
				pattern: /'(?:\\.|[^'\\\r\n]){1,6}'/,
				greedy: true
			}
		});

		Prism.languages.insertBefore('java', 'class-name', {
			'annotation': {
				pattern: /(^|[^.])@\w+(?:\s*\.\s*\w+)*/,
				lookbehind: true,
				alias: 'punctuation'
			},
			'generics': {
				pattern: /<(?:[\w\s,.?]|&(?!&)|<(?:[\w\s,.?]|&(?!&)|<(?:[\w\s,.?]|&(?!&)|<(?:[\w\s,.?]|&(?!&))*>)*>)*>)*>/,
				inside: {
					'class-name': className,
					'keyword': keywords,
					'punctuation': /[<>(),.:]/,
					'operator': /[?&|]/
				}
			},
			'import': [
				{
					pattern: RegExp(/(\bimport\s+)/.source + classNamePrefix + /(?:[A-Z]\w*|\*)(?=\s*;)/.source),
					lookbehind: true,
					inside: {
						'namespace': className.inside.namespace,
						'punctuation': /\./,
						'operator': /\*/,
						'class-name': /\w+/
					}
				},
				{
					pattern: RegExp(/(\bimport\s+static\s+)/.source + classNamePrefix + /(?:\w+|\*)(?=\s*;)/.source),
					lookbehind: true,
					alias: 'static',
					inside: {
						'namespace': className.inside.namespace,
						'static': /\b\w+$/,
						'punctuation': /\./,
						'operator': /\*/,
						'class-name': /\w+/
					}
				}
			],
			'namespace': {
				pattern: RegExp(
					/(\b(?:exports|import(?:\s+static)?|module|open|opens|package|provides|requires|to|transitive|uses|with)\s+)(?!<keyword>)[a-z]\w*(?:\.[a-z]\w*)*\.?/
						.source.replace(/<keyword>/g, function () { return keywords.source; })),
				lookbehind: true,
				inside: {
					'punctuation': /\./,
				}
			}
		});
	}(Prism));
	return prismJava;
}

var prismCpp = {};

var hasRequiredPrismCpp;

function requirePrismCpp () {
	if (hasRequiredPrismCpp) return prismCpp;
	hasRequiredPrismCpp = 1;
	(function (Prism) {

		var keyword = /\b(?:alignas|alignof|asm|auto|bool|break|case|catch|char|char16_t|char32_t|char8_t|class|co_await|co_return|co_yield|compl|concept|const|const_cast|consteval|constexpr|constinit|continue|decltype|default|delete|do|double|dynamic_cast|else|enum|explicit|export|extern|final|float|for|friend|goto|if|import|inline|int|int16_t|int32_t|int64_t|int8_t|long|module|mutable|namespace|new|noexcept|nullptr|operator|override|private|protected|public|register|reinterpret_cast|requires|return|short|signed|sizeof|static|static_assert|static_cast|struct|switch|template|this|thread_local|throw|try|typedef|typeid|typename|uint16_t|uint32_t|uint64_t|uint8_t|union|unsigned|using|virtual|void|volatile|wchar_t|while)\b/;
		var modName = /\b(?!<keyword>)\w+(?:\s*\.\s*\w+)*\b/.source.replace(/<keyword>/g, function () { return keyword.source; });

		Prism.languages.cpp = Prism.languages.extend('c', {
			'class-name': [
				{
					pattern: RegExp(/(\b(?:class|concept|enum|struct|typename)\s+)(?!<keyword>)\w+/.source
						.replace(/<keyword>/g, function () { return keyword.source; })),
					lookbehind: true
				},
				// This is intended to capture the class name of method implementations like:
				//   void foo::bar() const {}
				// However! The `foo` in the above example could also be a namespace, so we only capture the class name if
				// it starts with an uppercase letter. This approximation should give decent results.
				/\b[A-Z]\w*(?=\s*::\s*\w+\s*\()/,
				// This will capture the class name before destructors like:
				//   Foo::~Foo() {}
				/\b[A-Z_]\w*(?=\s*::\s*~\w+\s*\()/i,
				// This also intends to capture the class name of method implementations but here the class has template
				// parameters, so it can't be a namespace (until C++ adds generic namespaces).
				/\b\w+(?=\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>\s*::\s*\w+\s*\()/
			],
			'keyword': keyword,
			'number': {
				pattern: /(?:\b0b[01']+|\b0x(?:[\da-f']+(?:\.[\da-f']*)?|\.[\da-f']+)(?:p[+-]?[\d']+)?|(?:\b[\d']+(?:\.[\d']*)?|\B\.[\d']+)(?:e[+-]?[\d']+)?)[ful]{0,4}/i,
				greedy: true
			},
			'operator': />>=?|<<=?|->|--|\+\+|&&|\|\||[?:~]|<=>|[-+*/%&|^!=<>]=?|\b(?:and|and_eq|bitand|bitor|not|not_eq|or|or_eq|xor|xor_eq)\b/,
			'boolean': /\b(?:false|true)\b/
		});

		Prism.languages.insertBefore('cpp', 'string', {
			'module': {
				// https://en.cppreference.com/w/cpp/language/modules
				pattern: RegExp(
					/(\b(?:import|module)\s+)/.source +
					'(?:' +
					// header-name
					/"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|<[^<>\r\n]*>/.source +
					'|' +
					// module name or partition or both
					/<mod-name>(?:\s*:\s*<mod-name>)?|:\s*<mod-name>/.source.replace(/<mod-name>/g, function () { return modName; }) +
					')'
				),
				lookbehind: true,
				greedy: true,
				inside: {
					'string': /^[<"][\s\S]+/,
					'operator': /:/,
					'punctuation': /\./
				}
			},
			'raw-string': {
				pattern: /R"([^()\\ ]{0,16})\([\s\S]*?\)\1"/,
				alias: 'string',
				greedy: true
			}
		});

		Prism.languages.insertBefore('cpp', 'keyword', {
			'generic-function': {
				pattern: /\b(?!operator\b)[a-z_]\w*\s*<(?:[^<>]|<[^<>]*>)*>(?=\s*\()/i,
				inside: {
					'function': /^\w+/,
					'generic': {
						pattern: /<[\s\S]+/,
						alias: 'class-name',
						inside: Prism.languages.cpp
					}
				}
			}
		});

		Prism.languages.insertBefore('cpp', 'operator', {
			'double-colon': {
				pattern: /::/,
				alias: 'punctuation'
			}
		});

		Prism.languages.insertBefore('cpp', 'class-name', {
			// the base clause is an optional list of parent classes
			// https://en.cppreference.com/w/cpp/language/class
			'base-clause': {
				pattern: /(\b(?:class|struct)\s+\w+\s*:\s*)[^;{}"'\s]+(?:\s+[^;{}"'\s]+)*(?=\s*[;{])/,
				lookbehind: true,
				greedy: true,
				inside: Prism.languages.extend('cpp', {})
			}
		});

		Prism.languages.insertBefore('inside', 'double-colon', {
			// All untokenized words that are not namespaces should be class names
			'class-name': /\b[a-z_]\w*\b(?!\s*::)/i
		}, Prism.languages.cpp['base-clause']);

	}(Prism));
	return prismCpp;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalCode_dev;

function requireLexicalCode_dev () {
	if (hasRequiredLexicalCode_dev) return LexicalCode_dev;
	hasRequiredLexicalCode_dev = 1;

	var Prism = requirePrism();
	requirePrismClike();
	requirePrismJavascript();
	requirePrismMarkup();
	requirePrismMarkdown();
	requirePrismC();
	requirePrismCss();
	requirePrismObjectivec();
	requirePrismSql();
	requirePrismPython();
	requirePrismRust();
	requirePrismSwift();
	requirePrismTypescript();
	requirePrismJava();
	requirePrismCpp();
	var utils = LexicalUtils_1;
	var lexical = require$$0__default["default"];

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	const mapToPrismLanguage = language => {
	  // eslint-disable-next-line no-prototype-builtins
	  return language != null && Prism.languages.hasOwnProperty(language) ? language : undefined;
	};

	function hasChildDOMNodeTag(node, tagName) {
	  for (const child of node.childNodes) {
	    if (utils.isHTMLElement(child) && child.tagName === tagName) {
	      return true;
	    }

	    hasChildDOMNodeTag(child, tagName);
	  }

	  return false;
	}

	const LANGUAGE_DATA_ATTRIBUTE = 'data-highlight-language';
	/** @noInheritDoc */

	class CodeNode extends lexical.ElementNode {
	  /** @internal */
	  static getType() {
	    return 'code';
	  }

	  static clone(node) {
	    return new CodeNode(node.__language, node.__key);
	  }

	  constructor(language, key) {
	    super(key);
	    this.__language = mapToPrismLanguage(language);
	  } // View


	  createDOM(config) {
	    const element = document.createElement('code');
	    utils.addClassNamesToElement(element, config.theme.code);
	    element.setAttribute('spellcheck', 'false');
	    const language = this.getLanguage();

	    if (language) {
	      element.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
	    }

	    return element;
	  }

	  updateDOM(prevNode, dom, config) {
	    const language = this.__language;
	    const prevLanguage = prevNode.__language;

	    if (language) {
	      if (language !== prevLanguage) {
	        dom.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
	      }
	    } else if (prevLanguage) {
	      dom.removeAttribute(LANGUAGE_DATA_ATTRIBUTE);
	    }

	    return false;
	  }

	  exportDOM() {
	    const element = document.createElement('pre');
	    element.setAttribute('spellcheck', 'false');
	    const language = this.getLanguage();

	    if (language) {
	      element.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
	    }

	    return {
	      element
	    };
	  }

	  static importDOM() {
	    return {
	      // Typically <pre> is used for code blocks, and <code> for inline code styles
	      // but if it's a multi line <code> we'll create a block. Pass through to
	      // inline format handled by TextNode otherwise.
	      code: node => {
	        const isMultiLine = node.textContent != null && (/\r?\n/.test(node.textContent) || hasChildDOMNodeTag(node, 'BR'));
	        return isMultiLine ? {
	          conversion: convertPreElement,
	          priority: 1
	        } : null;
	      },
	      div: node => ({
	        conversion: convertDivElement,
	        priority: 1
	      }),
	      pre: node => ({
	        conversion: convertPreElement,
	        priority: 0
	      }),
	      table: node => {
	        const table = node; // domNode is a <table> since we matched it by nodeName

	        if (isGitHubCodeTable(table)) {
	          return {
	            conversion: convertTableElement,
	            priority: 3
	          };
	        }

	        return null;
	      },
	      td: node => {
	        // element is a <td> since we matched it by nodeName
	        const td = node;
	        const table = td.closest('table');

	        if (isGitHubCodeCell(td)) {
	          return {
	            conversion: convertTableCellElement,
	            priority: 3
	          };
	        }

	        if (table && isGitHubCodeTable(table)) {
	          // Return a no-op if it's a table cell in a code table, but not a code line.
	          // Otherwise it'll fall back to the T
	          return {
	            conversion: convertCodeNoop,
	            priority: 3
	          };
	        }

	        return null;
	      },
	      tr: node => {
	        // element is a <tr> since we matched it by nodeName
	        const tr = node;
	        const table = tr.closest('table');

	        if (table && isGitHubCodeTable(table)) {
	          return {
	            conversion: convertCodeNoop,
	            priority: 3
	          };
	        }

	        return null;
	      }
	    };
	  }

	  static importJSON(serializedNode) {
	    const node = $createCodeNode(serializedNode.language);
	    node.setFormat(serializedNode.format);
	    node.setIndent(serializedNode.indent);
	    node.setDirection(serializedNode.direction);
	    return node;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      language: this.getLanguage(),
	      type: 'code',
	      version: 1
	    };
	  } // Mutation


	  insertNewAfter(selection, restoreSelection = true) {
	    const children = this.getChildren();
	    const childrenLength = children.length;

	    if (childrenLength >= 2 && children[childrenLength - 1].getTextContent() === '\n' && children[childrenLength - 2].getTextContent() === '\n' && selection.isCollapsed() && selection.anchor.key === this.__key && selection.anchor.offset === childrenLength) {
	      children[childrenLength - 1].remove();
	      children[childrenLength - 2].remove();
	      const newElement = lexical.$createParagraphNode();
	      this.insertAfter(newElement, restoreSelection);
	      return newElement;
	    } // If the selection is within the codeblock, find all leading tabs and
	    // spaces of the current line. Create a new line that has all those
	    // tabs and spaces, such that leading indentation is preserved.


	    const anchor = selection.anchor;
	    const focus = selection.focus;
	    const firstPoint = anchor.isBefore(focus) ? anchor : focus;
	    const firstSelectionNode = firstPoint.getNode();

	    if ($isCodeHighlightNode(firstSelectionNode) || lexical.$isTabNode(firstSelectionNode)) {
	      let node = getFirstCodeNodeOfLine(firstSelectionNode);
	      const insertNodes = []; // eslint-disable-next-line no-constant-condition

	      while (true) {
	        if (lexical.$isTabNode(node)) {
	          insertNodes.push(lexical.$createTabNode());
	          node = node.getNextSibling();
	        } else if ($isCodeHighlightNode(node)) {
	          let spaces = 0;
	          const text = node.getTextContent();
	          const textSize = node.getTextContentSize();

	          for (; spaces < textSize && text[spaces] === ' '; spaces++);

	          if (spaces !== 0) {
	            insertNodes.push($createCodeHighlightNode(' '.repeat(spaces)));
	          }

	          if (spaces !== textSize) {
	            break;
	          }

	          node = node.getNextSibling();
	        } else {
	          break;
	        }
	      }

	      if (insertNodes.length > 0) {
	        selection.insertNodes([lexical.$createLineBreakNode(), ...insertNodes]);
	        return insertNodes[insertNodes.length - 1];
	      }
	    }

	    return null;
	  }

	  canIndent() {
	    return false;
	  }

	  collapseAtStart() {
	    const paragraph = lexical.$createParagraphNode();
	    const children = this.getChildren();
	    children.forEach(child => paragraph.append(child));
	    this.replace(paragraph);
	    return true;
	  }

	  setLanguage(language) {
	    const writable = this.getWritable();
	    writable.__language = mapToPrismLanguage(language);
	  }

	  getLanguage() {
	    return this.getLatest().__language;
	  }

	}
	function $createCodeNode(language) {
	  return lexical.$applyNodeReplacement(new CodeNode(language));
	}
	function $isCodeNode(node) {
	  return node instanceof CodeNode;
	}

	function convertPreElement(domNode) {
	  let language;

	  if (utils.isHTMLElement(domNode)) {
	    language = domNode.getAttribute(LANGUAGE_DATA_ATTRIBUTE);
	  }

	  return {
	    node: $createCodeNode(language)
	  };
	}

	function convertDivElement(domNode) {
	  // domNode is a <div> since we matched it by nodeName
	  const div = domNode;
	  const isCode = isCodeElement(div);

	  if (!isCode && !isCodeChildElement(div)) {
	    return {
	      node: null
	    };
	  }

	  return {
	    after: childLexicalNodes => {
	      const domParent = domNode.parentNode;

	      if (domParent != null && domNode !== domParent.lastChild) {
	        childLexicalNodes.push(lexical.$createLineBreakNode());
	      }

	      return childLexicalNodes;
	    },
	    node: isCode ? $createCodeNode() : null
	  };
	}

	function convertTableElement() {
	  return {
	    node: $createCodeNode()
	  };
	}

	function convertCodeNoop() {
	  return {
	    node: null
	  };
	}

	function convertTableCellElement(domNode) {
	  // domNode is a <td> since we matched it by nodeName
	  const cell = domNode;
	  return {
	    after: childLexicalNodes => {
	      if (cell.parentNode && cell.parentNode.nextSibling) {
	        // Append newline between code lines
	        childLexicalNodes.push(lexical.$createLineBreakNode());
	      }

	      return childLexicalNodes;
	    },
	    node: null
	  };
	}

	function isCodeElement(div) {
	  return div.style.fontFamily.match('monospace') !== null;
	}

	function isCodeChildElement(node) {
	  let parent = node.parentElement;

	  while (parent !== null) {
	    if (isCodeElement(parent)) {
	      return true;
	    }

	    parent = parent.parentElement;
	  }

	  return false;
	}

	function isGitHubCodeCell(cell) {
	  return cell.classList.contains('js-file-line');
	}

	function isGitHubCodeTable(table) {
	  return table.classList.contains('js-file-line-container');
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const DEFAULT_CODE_LANGUAGE = 'javascript';
	const CODE_LANGUAGE_FRIENDLY_NAME_MAP = {
	  c: 'C',
	  clike: 'C-like',
	  cpp: 'C++',
	  css: 'CSS',
	  html: 'HTML',
	  java: 'Java',
	  js: 'JavaScript',
	  markdown: 'Markdown',
	  objc: 'Objective-C',
	  plain: 'Plain Text',
	  py: 'Python',
	  rust: 'Rust',
	  sql: 'SQL',
	  swift: 'Swift',
	  typescript: 'TypeScript',
	  xml: 'XML'
	};
	const CODE_LANGUAGE_MAP = {
	  cpp: 'cpp',
	  java: 'java',
	  javascript: 'js',
	  md: 'markdown',
	  plaintext: 'plain',
	  python: 'py',
	  text: 'plain',
	  ts: 'typescript'
	};
	function normalizeCodeLang(lang) {
	  return CODE_LANGUAGE_MAP[lang] || lang;
	}
	function getLanguageFriendlyName(lang) {
	  const _lang = normalizeCodeLang(lang);

	  return CODE_LANGUAGE_FRIENDLY_NAME_MAP[_lang] || _lang;
	}
	const getDefaultCodeLanguage = () => DEFAULT_CODE_LANGUAGE;
	const getCodeLanguages = () => Object.keys(Prism.languages).filter( // Prism has several language helpers mixed into languages object
	// so filtering them out here to get langs list
	language => typeof Prism.languages[language] !== 'function').sort();
	/** @noInheritDoc */

	class CodeHighlightNode extends lexical.TextNode {
	  /** @internal */
	  constructor(text, highlightType, key) {
	    super(text, key);
	    this.__highlightType = highlightType;
	  }

	  static getType() {
	    return 'code-highlight';
	  }

	  static clone(node) {
	    return new CodeHighlightNode(node.__text, node.__highlightType || undefined, node.__key);
	  }

	  getHighlightType() {
	    const self = this.getLatest();
	    return self.__highlightType;
	  }

	  createDOM(config) {
	    const element = super.createDOM(config);
	    const className = getHighlightThemeClass(config.theme, this.__highlightType);
	    utils.addClassNamesToElement(element, className);
	    return element;
	  }

	  updateDOM(prevNode, dom, config) {
	    const update = super.updateDOM(prevNode, dom, config);
	    const prevClassName = getHighlightThemeClass(config.theme, prevNode.__highlightType);
	    const nextClassName = getHighlightThemeClass(config.theme, this.__highlightType);

	    if (prevClassName !== nextClassName) {
	      if (prevClassName) {
	        utils.removeClassNamesFromElement(dom, prevClassName);
	      }

	      if (nextClassName) {
	        utils.addClassNamesToElement(dom, nextClassName);
	      }
	    }

	    return update;
	  }

	  static importJSON(serializedNode) {
	    const node = $createCodeHighlightNode(serializedNode.text, serializedNode.highlightType);
	    node.setFormat(serializedNode.format);
	    node.setDetail(serializedNode.detail);
	    node.setMode(serializedNode.mode);
	    node.setStyle(serializedNode.style);
	    return node;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      highlightType: this.getHighlightType(),
	      type: 'code-highlight',
	      version: 1
	    };
	  } // Prevent formatting (bold, underline, etc)


	  setFormat(format) {
	    return this;
	  }

	  isParentRequired() {
	    return true;
	  }

	  createParentElementNode() {
	    return $createCodeNode();
	  }

	}

	function getHighlightThemeClass(theme, highlightType) {
	  return highlightType && theme && theme.codeHighlight && theme.codeHighlight[highlightType];
	}

	function $createCodeHighlightNode(text, highlightType) {
	  return lexical.$applyNodeReplacement(new CodeHighlightNode(text, highlightType));
	}
	function $isCodeHighlightNode(node) {
	  return node instanceof CodeHighlightNode;
	}
	function getFirstCodeNodeOfLine(anchor) {
	  let previousNode = anchor;
	  let node = anchor;

	  while ($isCodeHighlightNode(node) || lexical.$isTabNode(node)) {
	    previousNode = node;
	    node = node.getPreviousSibling();
	  }

	  return previousNode;
	}
	function getLastCodeNodeOfLine(anchor) {
	  let nextNode = anchor;
	  let node = anchor;

	  while ($isCodeHighlightNode(node) || lexical.$isTabNode(node)) {
	    nextNode = node;
	    node = node.getNextSibling();
	  }

	  return nextNode;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const PrismTokenizer = {
	  defaultLanguage: DEFAULT_CODE_LANGUAGE,

	  tokenize(code, language) {
	    return Prism.tokenize(code, Prism.languages[language || ''] || Prism.languages[this.defaultLanguage]);
	  }

	};
	function getStartOfCodeInLine(anchor, offset) {
	  let last = null;
	  let lastNonBlank = null;
	  let node = anchor;
	  let nodeOffset = offset;
	  let nodeTextContent = anchor.getTextContent(); // eslint-disable-next-line no-constant-condition

	  while (true) {
	    if (nodeOffset === 0) {
	      node = node.getPreviousSibling();

	      if (node === null) {
	        break;
	      }

	      if (!($isCodeHighlightNode(node) || lexical.$isTabNode(node) || lexical.$isLineBreakNode(node))) {
	        throw Error(`Expected a valid Code Node: CodeHighlightNode, TabNode, LineBreakNode`);
	      }

	      if (lexical.$isLineBreakNode(node)) {
	        last = {
	          node,
	          offset: 1
	        };
	        break;
	      }

	      nodeOffset = Math.max(0, node.getTextContentSize() - 1);
	      nodeTextContent = node.getTextContent();
	    } else {
	      nodeOffset--;
	    }

	    const character = nodeTextContent[nodeOffset];

	    if ($isCodeHighlightNode(node) && character !== ' ') {
	      lastNonBlank = {
	        node,
	        offset: nodeOffset
	      };
	    }
	  } // lastNonBlank !== null: anchor in the middle of code; move to line beginning


	  if (lastNonBlank !== null) {
	    return lastNonBlank;
	  } // Spaces, tabs or nothing ahead of anchor


	  let codeCharacterAtAnchorOffset = null;

	  if (offset < anchor.getTextContentSize()) {
	    if ($isCodeHighlightNode(anchor)) {
	      codeCharacterAtAnchorOffset = anchor.getTextContent()[offset];
	    }
	  } else {
	    const nextSibling = anchor.getNextSibling();

	    if ($isCodeHighlightNode(nextSibling)) {
	      codeCharacterAtAnchorOffset = nextSibling.getTextContent()[0];
	    }
	  }

	  if (codeCharacterAtAnchorOffset !== null && codeCharacterAtAnchorOffset !== ' ') {
	    // Borderline whitespace and code, move to line beginning
	    return last;
	  } else {
	    const nextNonBlank = findNextNonBlankInLine(anchor, offset);

	    if (nextNonBlank !== null) {
	      return nextNonBlank;
	    } else {
	      return last;
	    }
	  }
	}

	function findNextNonBlankInLine(anchor, offset) {
	  let node = anchor;
	  let nodeOffset = offset;
	  let nodeTextContent = anchor.getTextContent();
	  let nodeTextContentSize = anchor.getTextContentSize(); // eslint-disable-next-line no-constant-condition

	  while (true) {
	    if (!$isCodeHighlightNode(node) || nodeOffset === nodeTextContentSize) {
	      node = node.getNextSibling();

	      if (node === null || lexical.$isLineBreakNode(node)) {
	        return null;
	      }

	      if ($isCodeHighlightNode(node)) {
	        nodeOffset = 0;
	        nodeTextContent = node.getTextContent();
	        nodeTextContentSize = node.getTextContentSize();
	      }
	    }

	    if ($isCodeHighlightNode(node)) {
	      if (nodeTextContent[nodeOffset] !== ' ') {
	        return {
	          node,
	          offset: nodeOffset
	        };
	      }

	      nodeOffset++;
	    }
	  }
	}

	function getEndOfCodeInLine(anchor) {
	  const lastNode = getLastCodeNodeOfLine(anchor);

	  if (!!lexical.$isLineBreakNode(lastNode)) {
	    throw Error(`Unexpected lineBreakNode in getEndOfCodeInLine`);
	  }

	  return lastNode;
	}

	function textNodeTransform(node, editor, tokenizer) {
	  // Since CodeNode has flat children structure we only need to check
	  // if node's parent is a code node and run highlighting if so
	  const parentNode = node.getParent();

	  if ($isCodeNode(parentNode)) {
	    codeNodeTransform(parentNode, editor, tokenizer);
	  } else if ($isCodeHighlightNode(node)) {
	    // When code block converted into paragraph or other element
	    // code highlight nodes converted back to normal text
	    node.replace(lexical.$createTextNode(node.__text));
	  }
	}

	function updateCodeGutter(node, editor) {
	  const codeElement = editor.getElementByKey(node.getKey());

	  if (codeElement === null) {
	    return;
	  }

	  const children = node.getChildren();
	  const childrenLength = children.length; // @ts-ignore: internal field

	  if (childrenLength === codeElement.__cachedChildrenLength) {
	    // Avoid updating the attribute if the children length hasn't changed.
	    return;
	  } // @ts-ignore:: internal field


	  codeElement.__cachedChildrenLength = childrenLength;
	  let gutter = '1';
	  let count = 1;

	  for (let i = 0; i < childrenLength; i++) {
	    if (lexical.$isLineBreakNode(children[i])) {
	      gutter += '\n' + ++count;
	    }
	  }

	  codeElement.setAttribute('data-gutter', gutter);
	} // Using `skipTransforms` to prevent extra transforms since reformatting the code
	// will not affect code block content itself.
	//
	// Using extra cache (`nodesCurrentlyHighlighting`) since both CodeNode and CodeHighlightNode
	// transforms might be called at the same time (e.g. new CodeHighlight node inserted) and
	// in both cases we'll rerun whole reformatting over CodeNode, which is redundant.
	// Especially when pasting code into CodeBlock.


	const nodesCurrentlyHighlighting = new Set();

	function codeNodeTransform(node, editor, tokenizer) {
	  const nodeKey = node.getKey();

	  if (nodesCurrentlyHighlighting.has(nodeKey)) {
	    return;
	  }

	  nodesCurrentlyHighlighting.add(nodeKey); // When new code block inserted it might not have language selected

	  if (node.getLanguage() === undefined) {
	    node.setLanguage(tokenizer.defaultLanguage);
	  } // Using nested update call to pass `skipTransforms` since we don't want
	  // each individual codehighlight node to be transformed again as it's already
	  // in its final state


	  editor.update(() => {
	    updateAndRetainSelection(nodeKey, () => {
	      const currentNode = lexical.$getNodeByKey(nodeKey);

	      if (!$isCodeNode(currentNode) || !currentNode.isAttached()) {
	        return false;
	      }

	      const code = currentNode.getTextContent();
	      const tokens = tokenizer.tokenize(code, currentNode.getLanguage() || tokenizer.defaultLanguage);
	      const highlightNodes = getHighlightNodes(tokens);
	      const diffRange = getDiffRange(currentNode.getChildren(), highlightNodes);
	      const {
	        from,
	        to,
	        nodesForReplacement
	      } = diffRange;

	      if (from !== to || nodesForReplacement.length) {
	        node.splice(from, to - from, nodesForReplacement);
	        return true;
	      }

	      return false;
	    });
	  }, {
	    onUpdate: () => {
	      nodesCurrentlyHighlighting.delete(nodeKey);
	    },
	    skipTransforms: true
	  });
	}

	function getHighlightNodes(tokens, type) {
	  const nodes = [];

	  for (const token of tokens) {
	    if (typeof token === 'string') {
	      const partials = token.split(/(\n|\t)/);
	      const partialsLength = partials.length;

	      for (let i = 0; i < partialsLength; i++) {
	        const part = partials[i];

	        if (part === '\n' || part === '\r\n') {
	          nodes.push(lexical.$createLineBreakNode());
	        } else if (part === '\t') {
	          nodes.push(lexical.$createTabNode());
	        } else if (part.length > 0) {
	          nodes.push($createCodeHighlightNode(part, type));
	        }
	      }
	    } else {
	      const {
	        content
	      } = token;

	      if (typeof content === 'string') {
	        nodes.push(...getHighlightNodes([content], token.type));
	      } else if (Array.isArray(content)) {
	        nodes.push(...getHighlightNodes(content, token.type));
	      }
	    }
	  }

	  return nodes;
	} // Wrapping update function into selection retainer, that tries to keep cursor at the same
	// position as before.


	function updateAndRetainSelection(nodeKey, updateFn) {
	  const node = lexical.$getNodeByKey(nodeKey);

	  if (!$isCodeNode(node) || !node.isAttached()) {
	    return;
	  }

	  const selection = lexical.$getSelection(); // If it's not range selection (or null selection) there's no need to change it,
	  // but we can still run highlighting logic

	  if (!lexical.$isRangeSelection(selection)) {
	    updateFn();
	    return;
	  }

	  const anchor = selection.anchor;
	  const anchorOffset = anchor.offset;
	  const isNewLineAnchor = anchor.type === 'element' && lexical.$isLineBreakNode(node.getChildAtIndex(anchor.offset - 1));
	  let textOffset = 0; // Calculating previous text offset (all text node prior to anchor + anchor own text offset)

	  if (!isNewLineAnchor) {
	    const anchorNode = anchor.getNode();
	    textOffset = anchorOffset + anchorNode.getPreviousSiblings().reduce((offset, _node) => {
	      return offset + _node.getTextContentSize();
	    }, 0);
	  }

	  const hasChanges = updateFn();

	  if (!hasChanges) {
	    return;
	  } // Non-text anchors only happen for line breaks, otherwise
	  // selection will be within text node (code highlight node)


	  if (isNewLineAnchor) {
	    anchor.getNode().select(anchorOffset, anchorOffset);
	    return;
	  } // If it was non-element anchor then we walk through child nodes
	  // and looking for a position of original text offset


	  node.getChildren().some(_node => {
	    const isText = lexical.$isTextNode(_node);

	    if (isText || lexical.$isLineBreakNode(_node)) {
	      const textContentSize = _node.getTextContentSize();

	      if (isText && textContentSize >= textOffset) {
	        _node.select(textOffset, textOffset);

	        return true;
	      }

	      textOffset -= textContentSize;
	    }

	    return false;
	  });
	} // Finds minimal diff range between two nodes lists. It returns from/to range boundaries of prevNodes
	// that needs to be replaced with `nodes` (subset of nextNodes) to make prevNodes equal to nextNodes.


	function getDiffRange(prevNodes, nextNodes) {
	  let leadingMatch = 0;

	  while (leadingMatch < prevNodes.length) {
	    if (!isEqual(prevNodes[leadingMatch], nextNodes[leadingMatch])) {
	      break;
	    }

	    leadingMatch++;
	  }

	  const prevNodesLength = prevNodes.length;
	  const nextNodesLength = nextNodes.length;
	  const maxTrailingMatch = Math.min(prevNodesLength, nextNodesLength) - leadingMatch;
	  let trailingMatch = 0;

	  while (trailingMatch < maxTrailingMatch) {
	    trailingMatch++;

	    if (!isEqual(prevNodes[prevNodesLength - trailingMatch], nextNodes[nextNodesLength - trailingMatch])) {
	      trailingMatch--;
	      break;
	    }
	  }

	  const from = leadingMatch;
	  const to = prevNodesLength - trailingMatch;
	  const nodesForReplacement = nextNodes.slice(leadingMatch, nextNodesLength - trailingMatch);
	  return {
	    from,
	    nodesForReplacement,
	    to
	  };
	}

	function isEqual(nodeA, nodeB) {
	  // Only checking for code higlight nodes, tabs and linebreaks. If it's regular text node
	  // returning false so that it's transformed into code highlight node
	  return $isCodeHighlightNode(nodeA) && $isCodeHighlightNode(nodeB) && nodeA.__text === nodeB.__text && nodeA.__highlightType === nodeB.__highlightType || lexical.$isTabNode(nodeA) && lexical.$isTabNode(nodeB) || lexical.$isLineBreakNode(nodeA) && lexical.$isLineBreakNode(nodeB);
	}

	function $isSelectionInCode(selection) {
	  if (!lexical.$isRangeSelection(selection)) {
	    return false;
	  }

	  const anchorNode = selection.anchor.getNode();
	  const focusNode = selection.focus.getNode();

	  if (anchorNode.is(focusNode) && $isCodeNode(anchorNode)) {
	    return true;
	  }

	  const anchorParent = anchorNode.getParent();
	  return $isCodeNode(anchorParent) && anchorParent.is(focusNode.getParent());
	}

	function $getCodeLines(selection) {
	  const nodes = selection.getNodes();
	  const lines = [[]];

	  if (nodes.length === 1 && $isCodeNode(nodes[0])) {
	    return lines;
	  }

	  let lastLine = lines[0];

	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];

	    if (!($isCodeHighlightNode(node) || lexical.$isTabNode(node) || lexical.$isLineBreakNode(node))) {
	      throw Error(`Expected selection to be inside CodeBlock and consisting of CodeHighlightNode, TabNode and LineBreakNode`);
	    }

	    if (lexical.$isLineBreakNode(node)) {
	      if (i !== 0 && lastLine.length > 0) {
	        lastLine = [];
	        lines.push(lastLine);
	      }
	    } else {
	      lastLine.push(node);
	    }
	  }

	  return lines;
	}

	function handleTab(shiftKey) {
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection) || !$isSelectionInCode(selection)) {
	    return null;
	  }

	  const indentOrOutdent = !shiftKey ? lexical.INDENT_CONTENT_COMMAND : lexical.OUTDENT_CONTENT_COMMAND;
	  const tabOrOutdent = !shiftKey ? lexical.INSERT_TAB_COMMAND : lexical.OUTDENT_CONTENT_COMMAND; // 1. If multiple lines selected: indent/outdent

	  const codeLines = $getCodeLines(selection);

	  if (codeLines.length > 1) {
	    return indentOrOutdent;
	  } // 2. If entire line selected: indent/outdent


	  const selectionNodes = selection.getNodes();
	  const firstNode = selectionNodes[0];

	  if (!($isCodeNode(firstNode) || $isCodeHighlightNode(firstNode) || lexical.$isTabNode(firstNode) || lexical.$isLineBreakNode(firstNode))) {
	    throw Error(`Expected selection firstNode to be CodeHighlightNode or TabNode`);
	  }

	  if ($isCodeNode(firstNode)) {
	    return indentOrOutdent;
	  }

	  const firstOfLine = getFirstCodeNodeOfLine(firstNode);
	  const lastOfLine = getLastCodeNodeOfLine(firstNode);
	  const anchor = selection.anchor;
	  const focus = selection.focus;
	  let selectionFirst;
	  let selectionLast;

	  if (focus.isBefore(anchor)) {
	    selectionFirst = focus;
	    selectionLast = anchor;
	  } else {
	    selectionFirst = anchor;
	    selectionLast = focus;
	  }

	  if (firstOfLine !== null && lastOfLine !== null && selectionFirst.key === firstOfLine.getKey() && selectionFirst.offset === 0 && selectionLast.key === lastOfLine.getKey() && selectionLast.offset === lastOfLine.getTextContentSize()) {
	    return indentOrOutdent;
	  } // 3. Else: tab/outdent


	  return tabOrOutdent;
	}

	function handleMultilineIndent(type) {
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection) || !$isSelectionInCode(selection)) {
	    return false;
	  }

	  const codeLines = $getCodeLines(selection);
	  const codeLinesLength = codeLines.length; // Multiple lines selection

	  if (codeLines.length > 1) {
	    for (let i = 0; i < codeLinesLength; i++) {
	      const line = codeLines[i];

	      if (line.length > 0) {
	        let firstOfLine = line[0]; // First and last lines might not be complete

	        if (i === 0) {
	          firstOfLine = getFirstCodeNodeOfLine(firstOfLine);
	        }

	        if (firstOfLine !== null) {
	          if (type === lexical.INDENT_CONTENT_COMMAND) {
	            firstOfLine.insertBefore(lexical.$createTabNode());
	          } else if (lexical.$isTabNode(firstOfLine)) {
	            firstOfLine.remove();
	          }
	        }
	      }
	    }

	    return true;
	  } // Just one line


	  const selectionNodes = selection.getNodes();
	  const firstNode = selectionNodes[0];

	  if (!($isCodeNode(firstNode) || $isCodeHighlightNode(firstNode) || lexical.$isTabNode(firstNode) || lexical.$isLineBreakNode(firstNode))) {
	    throw Error(`Expected selection firstNode to be CodeHighlightNode or CodeTabNode`);
	  }

	  if ($isCodeNode(firstNode)) {
	    // CodeNode is empty
	    if (type === lexical.INDENT_CONTENT_COMMAND) {
	      selection.insertNodes([lexical.$createTabNode()]);
	    }

	    return true;
	  }

	  const firstOfLine = getFirstCodeNodeOfLine(firstNode);

	  if (!(firstOfLine !== null)) {
	    throw Error(`Expected getFirstCodeNodeOfLine to return a valid Code Node`);
	  }

	  if (type === lexical.INDENT_CONTENT_COMMAND) {
	    if (lexical.$isLineBreakNode(firstOfLine)) {
	      firstOfLine.insertAfter(lexical.$createTabNode());
	    } else {
	      firstOfLine.insertBefore(lexical.$createTabNode());
	    }
	  } else if (lexical.$isTabNode(firstOfLine)) {
	    firstOfLine.remove();
	  }

	  return true;
	}

	function handleShiftLines(type, event) {
	  // We only care about the alt+arrow keys
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection)) {
	    return false;
	  } // I'm not quite sure why, but it seems like calling anchor.getNode() collapses the selection here
	  // So first, get the anchor and the focus, then get their nodes


	  const {
	    anchor,
	    focus
	  } = selection;
	  const anchorOffset = anchor.offset;
	  const focusOffset = focus.offset;
	  const anchorNode = anchor.getNode();
	  const focusNode = focus.getNode();
	  const arrowIsUp = type === lexical.KEY_ARROW_UP_COMMAND; // Ensure the selection is within the codeblock

	  if (!$isSelectionInCode(selection) || !($isCodeHighlightNode(anchorNode) || lexical.$isTabNode(anchorNode)) || !($isCodeHighlightNode(focusNode) || lexical.$isTabNode(focusNode))) {
	    return false;
	  }

	  if (!event.altKey) {
	    // Handle moving selection out of the code block, given there are no
	    // sibling thats can natively take the selection.
	    if (selection.isCollapsed()) {
	      const codeNode = anchorNode.getParentOrThrow();

	      if (arrowIsUp && anchorOffset === 0 && anchorNode.getPreviousSibling() === null) {
	        const codeNodeSibling = codeNode.getPreviousSibling();

	        if (codeNodeSibling === null) {
	          codeNode.selectPrevious();
	          event.preventDefault();
	          return true;
	        }
	      } else if (!arrowIsUp && anchorOffset === anchorNode.getTextContentSize() && anchorNode.getNextSibling() === null) {
	        const codeNodeSibling = codeNode.getNextSibling();

	        if (codeNodeSibling === null) {
	          codeNode.selectNext();
	          event.preventDefault();
	          return true;
	        }
	      }
	    }

	    return false;
	  }

	  let start;
	  let end;

	  if (anchorNode.isBefore(focusNode)) {
	    start = getFirstCodeNodeOfLine(anchorNode);
	    end = getLastCodeNodeOfLine(focusNode);
	  } else {
	    start = getFirstCodeNodeOfLine(focusNode);
	    end = getLastCodeNodeOfLine(anchorNode);
	  }

	  if (start == null || end == null) {
	    return false;
	  }

	  const range = start.getNodesBetween(end);

	  for (let i = 0; i < range.length; i++) {
	    const node = range[i];

	    if (!$isCodeHighlightNode(node) && !lexical.$isTabNode(node) && !lexical.$isLineBreakNode(node)) {
	      return false;
	    }
	  } // After this point, we know the selection is within the codeblock. We may not be able to
	  // actually move the lines around, but we want to return true either way to prevent
	  // the event's default behavior


	  event.preventDefault();
	  event.stopPropagation(); // required to stop cursor movement under Firefox

	  const linebreak = arrowIsUp ? start.getPreviousSibling() : end.getNextSibling();

	  if (!lexical.$isLineBreakNode(linebreak)) {
	    return true;
	  }

	  const sibling = arrowIsUp ? linebreak.getPreviousSibling() : linebreak.getNextSibling();

	  if (sibling == null) {
	    return true;
	  }

	  const maybeInsertionPoint = $isCodeHighlightNode(sibling) || lexical.$isTabNode(sibling) || lexical.$isLineBreakNode(sibling) ? arrowIsUp ? getFirstCodeNodeOfLine(sibling) : getLastCodeNodeOfLine(sibling) : null;
	  let insertionPoint = maybeInsertionPoint != null ? maybeInsertionPoint : sibling;
	  linebreak.remove();
	  range.forEach(node => node.remove());

	  if (type === lexical.KEY_ARROW_UP_COMMAND) {
	    range.forEach(node => insertionPoint.insertBefore(node));
	    insertionPoint.insertBefore(linebreak);
	  } else {
	    insertionPoint.insertAfter(linebreak);
	    insertionPoint = linebreak;
	    range.forEach(node => {
	      insertionPoint.insertAfter(node);
	      insertionPoint = node;
	    });
	  }

	  selection.setTextNodeRange(anchorNode, anchorOffset, focusNode, focusOffset);
	  return true;
	}

	function handleMoveTo(type, event) {
	  const selection = lexical.$getSelection();

	  if (!lexical.$isRangeSelection(selection)) {
	    return false;
	  }

	  const {
	    anchor,
	    focus
	  } = selection;
	  const anchorNode = anchor.getNode();
	  const focusNode = focus.getNode();
	  const isMoveToStart = type === lexical.MOVE_TO_START;

	  if (!($isCodeHighlightNode(anchorNode) || lexical.$isTabNode(anchorNode)) || !($isCodeHighlightNode(focusNode) || lexical.$isTabNode(focusNode))) {
	    return false;
	  }

	  if (isMoveToStart) {
	    const start = getStartOfCodeInLine(focusNode, focus.offset);

	    if (start !== null) {
	      const {
	        node,
	        offset
	      } = start;

	      if (lexical.$isLineBreakNode(node)) {
	        node.selectNext(0, 0);
	      } else {
	        selection.setTextNodeRange(node, offset, node, offset);
	      }
	    } else {
	      focusNode.getParentOrThrow().selectStart();
	    }
	  } else {
	    const node = getEndOfCodeInLine(focusNode);
	    node.select();
	  }

	  event.preventDefault();
	  event.stopPropagation();
	  return true;
	}

	function registerCodeHighlighting(editor, tokenizer) {
	  if (!editor.hasNodes([CodeNode, CodeHighlightNode])) {
	    throw new Error('CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor');
	  }

	  if (tokenizer == null) {
	    tokenizer = PrismTokenizer;
	  }

	  return utils.mergeRegister(editor.registerMutationListener(CodeNode, mutations => {
	    editor.update(() => {
	      for (const [key, type] of mutations) {
	        if (type !== 'destroyed') {
	          const node = lexical.$getNodeByKey(key);

	          if (node !== null) {
	            updateCodeGutter(node, editor);
	          }
	        }
	      }
	    });
	  }), editor.registerNodeTransform(CodeNode, node => codeNodeTransform(node, editor, tokenizer)), editor.registerNodeTransform(lexical.TextNode, node => textNodeTransform(node, editor, tokenizer)), editor.registerNodeTransform(CodeHighlightNode, node => textNodeTransform(node, editor, tokenizer)), editor.registerCommand(lexical.KEY_TAB_COMMAND, event => {
	    const command = handleTab(event.shiftKey);

	    if (command === null) {
	      return false;
	    }

	    event.preventDefault();
	    editor.dispatchCommand(command, undefined);
	    return true;
	  }, lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.INSERT_TAB_COMMAND, () => {
	    const selection = lexical.$getSelection();

	    if (!$isSelectionInCode(selection)) {
	      return false;
	    }

	    lexical.$insertNodes([lexical.$createTabNode()]);
	    return true;
	  }, lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.INDENT_CONTENT_COMMAND, payload => handleMultilineIndent(lexical.INDENT_CONTENT_COMMAND), lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.OUTDENT_CONTENT_COMMAND, payload => handleMultilineIndent(lexical.OUTDENT_CONTENT_COMMAND), lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.KEY_ARROW_UP_COMMAND, payload => handleShiftLines(lexical.KEY_ARROW_UP_COMMAND, payload), lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.KEY_ARROW_DOWN_COMMAND, payload => handleShiftLines(lexical.KEY_ARROW_DOWN_COMMAND, payload), lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.MOVE_TO_END, payload => handleMoveTo(lexical.MOVE_TO_END, payload), lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(lexical.MOVE_TO_START, payload => handleMoveTo(lexical.MOVE_TO_START, payload), lexical.COMMAND_PRIORITY_LOW));
	}

	LexicalCode_dev.$createCodeHighlightNode = $createCodeHighlightNode;
	LexicalCode_dev.$createCodeNode = $createCodeNode;
	LexicalCode_dev.$isCodeHighlightNode = $isCodeHighlightNode;
	LexicalCode_dev.$isCodeNode = $isCodeNode;
	LexicalCode_dev.CODE_LANGUAGE_FRIENDLY_NAME_MAP = CODE_LANGUAGE_FRIENDLY_NAME_MAP;
	LexicalCode_dev.CODE_LANGUAGE_MAP = CODE_LANGUAGE_MAP;
	LexicalCode_dev.CodeHighlightNode = CodeHighlightNode;
	LexicalCode_dev.CodeNode = CodeNode;
	LexicalCode_dev.DEFAULT_CODE_LANGUAGE = DEFAULT_CODE_LANGUAGE;
	LexicalCode_dev.PrismTokenizer = PrismTokenizer;
	LexicalCode_dev.getCodeLanguages = getCodeLanguages;
	LexicalCode_dev.getDefaultCodeLanguage = getDefaultCodeLanguage;
	LexicalCode_dev.getEndOfCodeInLine = getEndOfCodeInLine;
	LexicalCode_dev.getFirstCodeNodeOfLine = getFirstCodeNodeOfLine;
	LexicalCode_dev.getLanguageFriendlyName = getLanguageFriendlyName;
	LexicalCode_dev.getLastCodeNodeOfLine = getLastCodeNodeOfLine;
	LexicalCode_dev.getStartOfCodeInLine = getStartOfCodeInLine;
	LexicalCode_dev.normalizeCodeLang = normalizeCodeLang;
	LexicalCode_dev.registerCodeHighlighting = registerCodeHighlighting;
	return LexicalCode_dev;
}

var LexicalCode_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalCode_prod;

function requireLexicalCode_prod () {
	if (hasRequiredLexicalCode_prod) return LexicalCode_prod;
	hasRequiredLexicalCode_prod = 1;
var d=requirePrism();requirePrismClike();requirePrismJavascript();requirePrismMarkup();requirePrismMarkdown();requirePrismC();requirePrismCss();requirePrismObjectivec();requirePrismSql();requirePrismPython();requirePrismRust();requirePrismSwift();
	requirePrismTypescript();requirePrismJava();requirePrismCpp();var l=LexicalUtils_1,r=require$$0__default["default"];let v=a=>null!=a&&d.languages.hasOwnProperty(a)?a:void 0;function x(a,b){for(let c of a.childNodes){if(l.isHTMLElement(c)&&c.tagName===b)return !0;x(c,b);}return !1}
	class y extends r.ElementNode{static getType(){return "code"}static clone(a){return new y(a.__language,a.__key)}constructor(a,b){super(b);this.__language=v(a);}createDOM(a){let b=document.createElement("code");l.addClassNamesToElement(b,a.theme.code);b.setAttribute("spellcheck","false");(a=this.getLanguage())&&b.setAttribute("data-highlight-language",a);return b}updateDOM(a,b){let c=this.__language;a=a.__language;c?c!==a&&b.setAttribute("data-highlight-language",c):a&&b.removeAttribute("data-highlight-language");
	return !1}exportDOM(){let a=document.createElement("pre");a.setAttribute("spellcheck","false");let b=this.getLanguage();b&&a.setAttribute("data-highlight-language",b);return {element:a}}static importDOM(){return {code:a=>null!=a.textContent&&(/\r?\n/.test(a.textContent)||x(a,"BR"))?{conversion:z,priority:1}:null,div:()=>({conversion:aa,priority:1}),pre:()=>({conversion:z,priority:0}),table:a=>A(a)?{conversion:ba,priority:3}:null,td:a=>{let b=a.closest("table");return a.classList.contains("js-file-line")?
	{conversion:ca,priority:3}:b&&A(b)?{conversion:B,priority:3}:null},tr:a=>(a=a.closest("table"))&&A(a)?{conversion:B,priority:3}:null}}static importJSON(a){let b=C(a.language);b.setFormat(a.format);b.setIndent(a.indent);b.setDirection(a.direction);return b}exportJSON(){return {...super.exportJSON(),language:this.getLanguage(),type:"code",version:1}}insertNewAfter(a,b=!0){var c=this.getChildren(),e=c.length;if(2<=e&&"\n"===c[e-1].getTextContent()&&"\n"===c[e-2].getTextContent()&&a.isCollapsed()&&a.anchor.key===
	this.__key&&a.anchor.offset===e)return c[e-1].remove(),c[e-2].remove(),a=r.$createParagraphNode(),this.insertAfter(a,b),a;b=a.anchor;c=a.focus;b=(b.isBefore(c)?b:c).getNode();if(D(b)||r.$isTabNode(b)){b=E(b);for(c=[];;)if(r.$isTabNode(b))c.push(r.$createTabNode()),b=b.getNextSibling();else if(D(b)){e=0;let f=b.getTextContent(),g=b.getTextContentSize();for(;e<g&&" "===f[e];e++);0!==e&&c.push(F(" ".repeat(e)));if(e!==g)break;b=b.getNextSibling();}else break;if(0<c.length)return a.insertNodes([r.$createLineBreakNode(),
	...c]),c[c.length-1]}return null}canIndent(){return !1}collapseAtStart(){let a=r.$createParagraphNode();this.getChildren().forEach(b=>a.append(b));this.replace(a);return !0}setLanguage(a){this.getWritable().__language=v(a);}getLanguage(){return this.getLatest().__language}}function C(a){return r.$applyNodeReplacement(new y(a))}function G(a){return a instanceof y}function z(a){let b;l.isHTMLElement(a)&&(b=a.getAttribute("data-highlight-language"));return {node:C(b)}}
	function aa(a){let b=null!==a.style.fontFamily.match("monospace");return b||da(a)?{after:c=>{let e=a.parentNode;null!=e&&a!==e.lastChild&&c.push(r.$createLineBreakNode());return c},node:b?C():null}:{node:null}}function ba(){return {node:C()}}function B(){return {node:null}}function ca(a){return {after:b=>{a.parentNode&&a.parentNode.nextSibling&&b.push(r.$createLineBreakNode());return b},node:null}}
	function da(a){for(a=a.parentElement;null!==a;){if(null!==a.style.fontFamily.match("monospace"))return !0;a=a.parentElement;}return !1}function A(a){return a.classList.contains("js-file-line-container")}
	let H={c:"C",clike:"C-like",cpp:"C++",css:"CSS",html:"HTML",java:"Java",js:"JavaScript",markdown:"Markdown",objc:"Objective-C",plain:"Plain Text",py:"Python",rust:"Rust",sql:"SQL",swift:"Swift",typescript:"TypeScript",xml:"XML"},I={cpp:"cpp",java:"java",javascript:"js",md:"markdown",plaintext:"plain",python:"py",text:"plain",ts:"typescript"};function K(a){return I[a]||a}
	class L extends r.TextNode{constructor(a,b,c){super(a,c);this.__highlightType=b;}static getType(){return "code-highlight"}static clone(a){return new L(a.__text,a.__highlightType||void 0,a.__key)}getHighlightType(){return this.getLatest().__highlightType}createDOM(a){let b=super.createDOM(a);a=M(a.theme,this.__highlightType);l.addClassNamesToElement(b,a);return b}updateDOM(a,b,c){let e=super.updateDOM(a,b,c);a=M(c.theme,a.__highlightType);c=M(c.theme,this.__highlightType);a!==c&&(a&&l.removeClassNamesFromElement(b,
	a),c&&l.addClassNamesToElement(b,c));return e}static importJSON(a){let b=F(a.text,a.highlightType);b.setFormat(a.format);b.setDetail(a.detail);b.setMode(a.mode);b.setStyle(a.style);return b}exportJSON(){return {...super.exportJSON(),highlightType:this.getHighlightType(),type:"code-highlight",version:1}}setFormat(){return this}isParentRequired(){return !0}createParentElementNode(){return C()}}function M(a,b){return b&&a&&a.codeHighlight&&a.codeHighlight[b]}
	function F(a,b){return r.$applyNodeReplacement(new L(a,b))}function D(a){return a instanceof L}function E(a){let b=a;for(;D(a)||r.$isTabNode(a);)b=a,a=a.getPreviousSibling();return b}function N(a){let b=a;for(;D(a)||r.$isTabNode(a);)b=a,a=a.getNextSibling();return b}let O={defaultLanguage:"javascript",tokenize(a,b){return d.tokenize(a,d.languages[b||""]||d.languages[this.defaultLanguage])}};
	function P(a,b){let c=null;var e=null,f=a;let g=b,h=a.getTextContent();for(;;){if(0===g){f=f.getPreviousSibling();if(null===f)break;if(!(D(f)||r.$isTabNode(f)||r.$isLineBreakNode(f)))throw Error("Expected a valid Code Node: CodeHighlightNode, TabNode, LineBreakNode");if(r.$isLineBreakNode(f)){c={node:f,offset:1};break}g=Math.max(0,f.getTextContentSize()-1);h=f.getTextContent();}else g--;let k=h[g];D(f)&&" "!==k&&(e={node:f,offset:g});}if(null!==e)return e;e=null;b<a.getTextContentSize()?D(a)&&(e=a.getTextContent()[b]):
	(f=a.getNextSibling(),D(f)&&(e=f.getTextContent()[0]));if(null!==e&&" "!==e)return c;a:for(e=a,f=a.getTextContent(),a=a.getTextContentSize();;){if(!D(e)||b===a){e=e.getNextSibling();if(null===e||r.$isLineBreakNode(e)){a=null;break a}D(e)&&(b=0,f=e.getTextContent(),a=e.getTextContentSize());}if(D(e)){if(" "!==f[b]){a={node:e,offset:b};break a}b++;}}return null!==a?a:c}function Q(a){a=N(a);if(r.$isLineBreakNode(a))throw Error("Unexpected lineBreakNode in getEndOfCodeInLine");return a}
	function R(a,b,c){let e=a.getParent();G(e)?S(e,b,c):D(a)&&a.replace(r.$createTextNode(a.__text));}let T=new Set;
	function S(a,b,c){let e=a.getKey();T.has(e)||(T.add(e),void 0===a.getLanguage()&&a.setLanguage(c.defaultLanguage),b.update(()=>{ea(e,()=>{var f=r.$getNodeByKey(e);if(!G(f)||!f.isAttached())return !1;var g=f.getTextContent();g=c.tokenize(g,f.getLanguage()||c.defaultLanguage);g=U(g);var h=f.getChildren();for(f=0;f<h.length&&V(h[f],g[f]);)f++;var k=h.length;let m=g.length,q=Math.min(k,m)-f,n=0;for(;n<q;)if(n++,!V(h[k-n],g[m-n])){n--;break}h=f;k-=n;g=g.slice(f,m-n);let {from:p,to:w,nodesForReplacement:u}=
	{from:h,nodesForReplacement:g,to:k};return p!==w||u.length?(a.splice(p,w-p,u),!0):!1});},{onUpdate:()=>{T.delete(e);},skipTransforms:!0}));}
	function U(a,b){let c=[];for(let e of a)if("string"===typeof e){a=e.split(/(\n|\t)/);let f=a.length;for(let g=0;g<f;g++){let h=a[g];"\n"===h||"\r\n"===h?c.push(r.$createLineBreakNode()):"\t"===h?c.push(r.$createTabNode()):0<h.length&&c.push(F(h,b));}}else (({content:a}=e)),"string"===typeof a?c.push(...U([a],e.type)):Array.isArray(a)&&c.push(...U(a,e.type));return c}
	function ea(a,b){a=r.$getNodeByKey(a);if(G(a)&&a.isAttached()){var c=r.$getSelection();if(r.$isRangeSelection(c)){c=c.anchor;var e=c.offset,f="element"===c.type&&r.$isLineBreakNode(a.getChildAtIndex(c.offset-1)),g=0;if(!f){let h=c.getNode();g=e+h.getPreviousSiblings().reduce((k,m)=>k+m.getTextContentSize(),0);}b()&&(f?c.getNode().select(e,e):a.getChildren().some(h=>{let k=r.$isTextNode(h);if(k||r.$isLineBreakNode(h)){let m=h.getTextContentSize();if(k&&m>=g)return h.select(g,g),!0;g-=m;}return !1}));}else b();}}
	function V(a,b){return D(a)&&D(b)&&a.__text===b.__text&&a.__highlightType===b.__highlightType||r.$isTabNode(a)&&r.$isTabNode(b)||r.$isLineBreakNode(a)&&r.$isLineBreakNode(b)}function W(a){if(!r.$isRangeSelection(a))return !1;var b=a.anchor.getNode();a=a.focus.getNode();if(b.is(a)&&G(b))return !0;b=b.getParent();return G(b)&&b.is(a.getParent())}
	function X(a){a=a.getNodes();let b=[[]];if(1===a.length&&G(a[0]))return b;let c=b[0];for(let e=0;e<a.length;e++){let f=a[e];if(!(D(f)||r.$isTabNode(f)||r.$isLineBreakNode(f)))throw Error("Expected selection to be inside CodeBlock and consisting of CodeHighlightNode, TabNode and LineBreakNode");r.$isLineBreakNode(f)?0!==e&&0<c.length&&(c=[],b.push(c)):c.push(f);}return b}
	function fa(a){var b=r.$getSelection();if(!r.$isRangeSelection(b)||!W(b))return null;let c=a?r.OUTDENT_CONTENT_COMMAND:r.INDENT_CONTENT_COMMAND;a=a?r.OUTDENT_CONTENT_COMMAND:r.INSERT_TAB_COMMAND;if(1<X(b).length)return c;var e=b.getNodes()[0];if(!(G(e)||D(e)||r.$isTabNode(e)||r.$isLineBreakNode(e)))throw Error("Expected selection firstNode to be CodeHighlightNode or TabNode");if(G(e))return c;let f=E(e);e=N(e);var g=b.anchor;let h=b.focus;h.isBefore(g)?b=h:(b=g,g=h);return null!==f&&null!==e&&b.key===
	f.getKey()&&0===b.offset&&g.key===e.getKey()&&g.offset===e.getTextContentSize()?c:a}
	function Y(a){var b=r.$getSelection();if(!r.$isRangeSelection(b)||!W(b))return !1;var c=X(b);let e=c.length;if(1<c.length){for(b=0;b<e;b++){var f=c[b];0<f.length&&(f=f[0],0===b&&(f=E(f)),null!==f&&(a===r.INDENT_CONTENT_COMMAND?f.insertBefore(r.$createTabNode()):r.$isTabNode(f)&&f.remove()));}return !0}c=b.getNodes()[0];if(!(G(c)||D(c)||r.$isTabNode(c)||r.$isLineBreakNode(c)))throw Error("Expected selection firstNode to be CodeHighlightNode or CodeTabNode");if(G(c))return a===r.INDENT_CONTENT_COMMAND&&
	b.insertNodes([r.$createTabNode()]),!0;c=E(c);if(null===c)throw Error("Expected getFirstCodeNodeOfLine to return a valid Code Node");a===r.INDENT_CONTENT_COMMAND?r.$isLineBreakNode(c)?c.insertAfter(r.$createTabNode()):c.insertBefore(r.$createTabNode()):r.$isTabNode(c)&&c.remove();return !0}
	function Z(a,b){let c=r.$getSelection();if(!r.$isRangeSelection(c))return !1;let {anchor:e,focus:f}=c,g=e.offset,h=f.offset,k=e.getNode(),m=f.getNode();var q=a===r.KEY_ARROW_UP_COMMAND;if(!W(c)||!D(k)&&!r.$isTabNode(k)||!D(m)&&!r.$isTabNode(m))return !1;if(!b.altKey){if(c.isCollapsed())if(a=k.getParentOrThrow(),q&&0===g&&null===k.getPreviousSibling()){if(null===a.getPreviousSibling())return a.selectPrevious(),b.preventDefault(),!0}else if(!q&&g===k.getTextContentSize()&&null===k.getNextSibling()&&null===
	a.getNextSibling())return a.selectNext(),b.preventDefault(),!0;return !1}let n;if(k.isBefore(m)){var p=E(k);n=N(m);}else p=E(m),n=N(k);if(null==p||null==n)return !1;let w=p.getNodesBetween(n);for(let t=0;t<w.length;t++){let J=w[t];if(!D(J)&&!r.$isTabNode(J)&&!r.$isLineBreakNode(J))return !1}b.preventDefault();b.stopPropagation();b=q?p.getPreviousSibling():n.getNextSibling();if(!r.$isLineBreakNode(b))return !0;p=q?b.getPreviousSibling():b.getNextSibling();if(null==p)return !0;q=D(p)||r.$isTabNode(p)||r.$isLineBreakNode(p)?
	q?E(p):N(p):null;let u=null!=q?q:p;b.remove();w.forEach(t=>t.remove());a===r.KEY_ARROW_UP_COMMAND?(w.forEach(t=>u.insertBefore(t)),u.insertBefore(b)):(u.insertAfter(b),u=b,w.forEach(t=>{u.insertAfter(t);u=t;}));c.setTextNodeRange(k,g,m,h);return !0}
	function ha(a,b){let c=r.$getSelection();if(!r.$isRangeSelection(c))return !1;let {anchor:e,focus:f}=c;var g=e.getNode();let h=f.getNode();a=a===r.MOVE_TO_START;if(!D(g)&&!r.$isTabNode(g)||!D(h)&&!r.$isTabNode(h))return !1;if(a)if(g=P(h,f.offset),null!==g){let {node:k,offset:m}=g;r.$isLineBreakNode(k)?k.selectNext(0,0):c.setTextNodeRange(k,m,k,m);}else h.getParentOrThrow().selectStart();else Q(h).select();b.preventDefault();b.stopPropagation();return !0}LexicalCode_prod.$createCodeHighlightNode=F;
	LexicalCode_prod.$createCodeNode=C;LexicalCode_prod.$isCodeHighlightNode=D;LexicalCode_prod.$isCodeNode=G;LexicalCode_prod.CODE_LANGUAGE_FRIENDLY_NAME_MAP=H;LexicalCode_prod.CODE_LANGUAGE_MAP=I;LexicalCode_prod.CodeHighlightNode=L;LexicalCode_prod.CodeNode=y;LexicalCode_prod.DEFAULT_CODE_LANGUAGE="javascript";LexicalCode_prod.PrismTokenizer=O;LexicalCode_prod.getCodeLanguages=()=>Object.keys(d.languages).filter(a=>"function"!==typeof d.languages[a]).sort();LexicalCode_prod.getDefaultCodeLanguage=()=>"javascript";LexicalCode_prod.getEndOfCodeInLine=Q;LexicalCode_prod.getFirstCodeNodeOfLine=E;
	LexicalCode_prod.getLanguageFriendlyName=function(a){a=K(a);return H[a]||a};LexicalCode_prod.getLastCodeNodeOfLine=N;LexicalCode_prod.getStartOfCodeInLine=P;LexicalCode_prod.normalizeCodeLang=K;
	LexicalCode_prod.registerCodeHighlighting=function(a,b){if(!a.hasNodes([y,L]))throw Error("CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor");null==b&&(b=O);return l.mergeRegister(a.registerMutationListener(y,c=>{a.update(()=>{for(let [g,h]of c)if("destroyed"!==h){var e=r.$getNodeByKey(g);if(null!==e)a:{var f=e;e=a.getElementByKey(f.getKey());if(null===e)break a;f=f.getChildren();let k=f.length;if(k===e.__cachedChildrenLength)break a;e.__cachedChildrenLength=k;let m="1",q=1;for(let n=
	0;n<k;n++)r.$isLineBreakNode(f[n])&&(m+="\n"+ ++q);e.setAttribute("data-gutter",m);}}});}),a.registerNodeTransform(y,c=>S(c,a,b)),a.registerNodeTransform(r.TextNode,c=>R(c,a,b)),a.registerNodeTransform(L,c=>R(c,a,b)),a.registerCommand(r.KEY_TAB_COMMAND,c=>{let e=fa(c.shiftKey);if(null===e)return !1;c.preventDefault();a.dispatchCommand(e,void 0);return !0},r.COMMAND_PRIORITY_LOW),a.registerCommand(r.INSERT_TAB_COMMAND,()=>{let c=r.$getSelection();if(!W(c))return !1;r.$insertNodes([r.$createTabNode()]);
	return !0},r.COMMAND_PRIORITY_LOW),a.registerCommand(r.INDENT_CONTENT_COMMAND,()=>Y(r.INDENT_CONTENT_COMMAND),r.COMMAND_PRIORITY_LOW),a.registerCommand(r.OUTDENT_CONTENT_COMMAND,()=>Y(r.OUTDENT_CONTENT_COMMAND),r.COMMAND_PRIORITY_LOW),a.registerCommand(r.KEY_ARROW_UP_COMMAND,c=>Z(r.KEY_ARROW_UP_COMMAND,c),r.COMMAND_PRIORITY_LOW),a.registerCommand(r.KEY_ARROW_DOWN_COMMAND,c=>Z(r.KEY_ARROW_DOWN_COMMAND,c),r.COMMAND_PRIORITY_LOW),a.registerCommand(r.MOVE_TO_END,c=>ha(r.MOVE_TO_END,c),r.COMMAND_PRIORITY_LOW),
	a.registerCommand(r.MOVE_TO_START,c=>ha(r.MOVE_TO_START,c),r.COMMAND_PRIORITY_LOW))};
	return LexicalCode_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalCode = process.env.NODE_ENV === 'development' ? requireLexicalCode_dev() : requireLexicalCode_prod();
var LexicalCode_1 = LexicalCode;

function convertImageElement(element) {
    const nodeName = element.nodeName.toLowerCase();
    let node = null;
    if (nodeName === 'img') {
        node = $createImageNode(element.src);
    }
    return { node };
}
class ImageNode extends require$$0.ElementNode {
    static getType() {
        return 'image';
    }
    static clone(node) {
        return new ImageNode(node.__url, node.__key);
    }
    constructor(url, key) {
        super(key);
        this.__url = url;
    }
    createDOM(config) {
        const image = document.createElement('img');
        image.src = this.__url;
        image.classList.add('editor-img');
        return image;
    }
    updateDOM() {
        return false;
    }
    setURL(url) {
        const writable = this.getWritable();
        writable.__url = url;
    }
    static importDOM() {
        return {
            img: (node) => ({
                conversion: convertImageElement,
                priority: 0,
            }),
        };
    }
    exportDOM(editor) {
        const { element } = super.exportDOM(editor);
        if (element && this.isEmpty()) {
            element.append(document.createElement('br'));
        }
        if (element) {
            const formatType = this.getFormatType();
            element.style.textAlign = formatType;
            const direction = this.getDirection();
            if (direction) {
                element.dir = direction;
            }
        }
        return {
            element,
        };
    }
    insertNewAfter(selection, restoreSelection = true) {
        const newElement = require$$0.$createParagraphNode();
        const direction = this.getDirection();
        newElement.setDirection(direction);
        this.insertAfter(newElement, restoreSelection);
        return newElement;
    }
    collapseAtStart() {
        const newElement = require$$0.$createParagraphNode();
        const children = this.getChildren();
        children.forEach((child) => newElement.append(child));
        this.replace(newElement);
        return true;
    }
    extractWithChild() {
        return true;
    }
    exportJSON() {
        throw new Error("Method not implemented.");
    }
    static importJSON(_serializedNode) {
        throw new Error("Method not implemented.");
    }
}
function $createImageNode(url) {
    return new ImageNode(url);
}
const INSERT_IMAGE_COMMAND = require$$0.createCommand('INSERT_IMAGE_COMMAND');

function convertVideoElement(element) {
    const nodeName = element.nodeName.toLowerCase();
    let node = null;
    if (nodeName === 'video') {
        node = $createVideoNode(element.src);
    }
    return { node };
}
class VideoNode extends require$$0.ElementNode {
    static getType() {
        return 'video';
    }
    static clone(node) {
        return new VideoNode(node.__url, node.__key);
    }
    constructor(url, key) {
        super(key);
        this.__url = url;
    }
    createDOM(config) {
        const x = document.createElement('video');
        x.setAttribute("controls", "controls");
        x.setAttribute("src", this.__url);
        return x;
    }
    static importDOM() {
        return {
            video: (node) => ({
                conversion: convertVideoElement,
                priority: 0,
            }),
        };
    }
    updateDOM() {
        return false;
    }
    setURL(url) {
        const writable = this.getWritable();
        writable.__url = url;
    }
    exportJSON() {
        throw new Error("Method not implemented.");
    }
    static importJSON(_serializedNode) {
        throw new Error("Method not implemented.");
    }
}
function $createVideoNode(url) {
    return new VideoNode(url);
}
const INSERT_VIDEO_COMMAND = require$$0.createCommand('INSERT_VIDEO_COMMAND');

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function Image({ selected, src, onClick }) {
    return jsxRuntime.jsxs("div", { className: "my-4 relative shadow-md", children: [selected && jsxRuntime.jsx("i", { className: "icon-check-circle text-3xl text-green-500 absolute" }), jsxRuntime.jsx("img", { className: "w-40 object-contain ", onClick: () => { onClick(); }, src: src, alt: "" })] });
}
function ImageHolder() {
    return jsxRuntime.jsx("div", { className: "w-40 h-405", children: jsxRuntime.jsx(Skeleton__default["default"], { count: 5, className: "h-40 my-3" }) });
}
function ImageViewer({ images, onSelect, loading }) {
    const [img, setImg] = React.useState([]);
    const columns = [1, 2, 3, 4];
    React.useEffect(() => {
        setImg(images.map(p => { return { src: p, selected: false }; }));
    }, [images]);
    if (loading) {
        return jsxRuntime.jsx("div", { className: "w-224 h-96 overflow-y-auto flex-row flex overflow-hidden gap-4", children: columns.map((p) => jsxRuntime.jsx(ImageHolder, {}, p)) });
    }
    return jsxRuntime.jsx("div", { className: "w-224 h-96 overflow-y-auto overflow-hidden", children: jsxRuntime.jsx("ul", { className: "columns-4 gap-4", children: img.map((p, i) => {
                return jsxRuntime.jsx("li", { className: " break-inside-avoid", children: jsxRuntime.jsx(Image, { onClick: () => {
                            p.selected = !p.selected;
                            setImg([...img]);
                            onSelect(img.filter(p => p.selected).map(p => p.src));
                        }, src: p.src, selected: p.selected }) }, i);
            }) }) });
}

function ImageSelection({ onSelect, onCancel, getFiles, uploadUrl }) {
    const [images, setImages] = React.useState([]);
    const [selected, setSelected] = React.useState([]);
    const [uploadProgress, setUploadProgress] = React.useState(0);
    const [loading, setLoading] = React.useState(false);
    const [count, setCount] = React.useState(0);
    const [offset, setOffset] = React.useState(0);
    const limit = 10;
    const loadImg = React.useCallback(() => __awaiter(this, void 0, void 0, function* () {
        if (getFiles) {
            setLoading(true);
            const { results: urls, count } = yield getFiles({ limit, offset });
            setImages(urls);
            setCount(count);
            setLoading(false);
        }
    }), [offset, limit]);
    React.useEffect(() => {
        loadImg();
    }, [limit, offset, getFiles]);
    const upload = (files) => {
        if (uploadUrl) {
            let xhr = new XMLHttpRequest();
            xhr.open('POST', uploadUrl, true);
            xhr.upload.onprogress = function (e) {
                if (e.lengthComputable) {
                    setUploadProgress((e.loaded / e.total) * 100);
                }
            };
            xhr.onload = function () {
                if (this.status == 200) {
                    console.log('Upload complete');
                    loadImg();
                }
            };
            let formData = new FormData();
            formData.append('file', files[0]);
            xhr.send(formData);
        }
    };
    const uploading = React.useMemo(() => {
        return uploadProgress > 0 && uploadProgress < 100;
    }, [uploadProgress]);
    return jsxRuntime.jsxs("div", { className: "bg-gray-100 py-4 px-3 flex flex-col w-224", children: [jsxRuntime.jsx("h3", { className: "border-b pb-2 border-gray-200 text-lg", children: "Add Image" }), jsxRuntime.jsx(ImageViewer, { onSelect: (images) => { setSelected(images); }, images: images, loading: loading }), jsxRuntime.jsx(ui.Pagination, { containerClassName: 'mt-5', limit: limit, count: count, offset: offset, onPageChanged: (i) => { setOffset((i - 1) * limit); } }), uploadUrl && jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("button", { className: "cursor-pointer underline text-blue-400 my-5", disabled: uploading, onClick: () => { var _a; return (_a = document.getElementById("fileInput")) === null || _a === void 0 ? void 0 : _a.click(); }, children: uploading ? `${uploadProgress.toFixed(0)} %` : 'Upload' }), jsxRuntime.jsx("div", { className: "h-0 w-0 overflow-hidden", children: jsxRuntime.jsx("input", { type: "file", id: "fileInput", name: "fileInput", onChange: (e) => {
                                var _a, _b, _c;
                                if (((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.files) && ((_b = e === null || e === void 0 ? void 0 : e.target) === null || _b === void 0 ? void 0 : _b.files[0])) {
                                    upload((_c = e === null || e === void 0 ? void 0 : e.target) === null || _c === void 0 ? void 0 : _c.files);
                                }
                            } }) })] }), jsxRuntime.jsxs("div", { className: "flex flex-row justify-end gap-2 items-center my-2", children: [jsxRuntime.jsx("div", { className: "text-gray-400 cursor-pointer", onClick: () => {
                            onCancel();
                        }, children: "Cancel" }), jsxRuntime.jsx(ui.Button, { onClick: () => {
                            onSelect(selected);
                        }, children: "Confirm" })] })] });
}

function AddUrl({ onCancel, onConfirm, title }) {
    const [url, setUrl] = React__default["default"].useState("");
    return (jsxRuntime.jsxs("div", { className: "bg-gray-100 py-4 px-3 flex flex-col", children: [jsxRuntime.jsx("h3", { className: "border-b pb-2 border-gray-200 text-lg", children: title }), jsxRuntime.jsx("div", { className: "flex flex-col py-4 gap-2", children: jsxRuntime.jsx(ui.FormInput, { label: "Url:", placeholder: "Enter url", onChange: (v) => setUrl(v) }) }), jsxRuntime.jsxs("div", { className: "flex flex-row justify-end gap-2 items-center", children: [jsxRuntime.jsx("div", { onClick: () => {
                            onCancel();
                        }, className: "text-gray-400 cursor-pointer", children: "Cancel" }), jsxRuntime.jsx(ui.Button, { disabled: !url, onClick: () => {
                            onConfirm(url);
                        }, children: "Confirm" })] })] }));
}

const LowPriority = 1;
const supportedBlockTypes = new Set([
    "paragraph",
    "quote",
    "code",
    "h1",
    "h2",
    "ul",
    "ol"
]);
const blockTypeToBlockName = {
    code: "Code Block",
    h1: "Large Heading",
    h2: "Small Heading",
    h3: "Heading",
    h4: "Heading",
    h5: "Heading",
    ol: "Numbered List",
    paragraph: "Normal",
    quote: "Quote",
    ul: "Bulleted List"
};
function Divider() {
    return jsxRuntime.jsx("div", { className: "divider" });
}
function positionEditorElement(editor, rect) {
    if (rect === null) {
        editor.style.opacity = "0";
        editor.style.top = "-1000px";
        editor.style.left = "-1000px";
    }
    else {
        editor.style.opacity = "1";
        editor.style.top = `${rect.top + rect.height + window.pageYOffset + 10}px`;
        editor.style.left = `${rect.left + window.pageXOffset - editor.offsetWidth / 2 + rect.width / 2}px`;
    }
}
function FloatingLinkEditor({ editor }) {
    const editorRef = React.useRef(null);
    const inputRef = React.useRef(null);
    const mouseDownRef = React.useRef(false);
    const [linkUrl, setLinkUrl] = React.useState("");
    const [isEditMode, setEditMode] = React.useState(false);
    const [lastSelection, setLastSelection] = React.useState(null);
    const updateLinkEditor = React.useCallback(() => {
        const selection = require$$0.$getSelection();
        if (require$$0.$isRangeSelection(selection)) {
            const node = getSelectedNode(selection);
            const parent = node.getParent();
            if (LexicalLink_1.$isLinkNode(parent)) {
                setLinkUrl(parent.getURL());
            }
            else if (LexicalLink_1.$isLinkNode(node)) {
                setLinkUrl(node.getURL());
            }
            else {
                setLinkUrl("");
            }
        }
        const editorElem = editorRef.current;
        const nativeSelection = window.getSelection();
        const activeElement = document.activeElement;
        if (editorElem === null) {
            return;
        }
        const rootElement = editor.getRootElement();
        if (nativeSelection &&
            selection !== null &&
            !nativeSelection.isCollapsed &&
            rootElement !== null &&
            rootElement.contains(nativeSelection.anchorNode)) {
            const domRange = nativeSelection.getRangeAt(0);
            let rect;
            if (nativeSelection.anchorNode === rootElement) {
                let inner = rootElement;
                while (inner.firstElementChild != null) {
                    inner = inner.firstElementChild;
                }
                rect = inner.getBoundingClientRect();
            }
            else {
                rect = domRange.getBoundingClientRect();
            }
            if (!mouseDownRef.current) {
                positionEditorElement(editorElem, rect);
            }
            setLastSelection(selection);
        }
        else if (!activeElement || activeElement.className !== "link-input") {
            positionEditorElement(editorElem, null);
            setLastSelection(null);
            setEditMode(false);
            setLinkUrl("");
        }
        return true;
    }, [editor]);
    React.useEffect(() => {
        return LexicalUtils_1.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            editorState.read(() => {
                updateLinkEditor();
            });
        }), editor.registerCommand(require$$0.SELECTION_CHANGE_COMMAND, () => {
            updateLinkEditor();
            return true;
        }, LowPriority));
    }, [editor, updateLinkEditor]);
    React.useEffect(() => {
        editor.getEditorState().read(() => {
            updateLinkEditor();
        });
    }, [editor, updateLinkEditor]);
    React.useEffect(() => {
        if (isEditMode && inputRef.current) {
            inputRef.current.focus();
        }
    }, [isEditMode]);
    return (jsxRuntime.jsx("div", { ref: editorRef, className: "link-editor", children: isEditMode ? (jsxRuntime.jsx("input", { ref: inputRef, className: "link-input", value: linkUrl, onChange: (event) => {
                setLinkUrl(event.target.value);
            }, onKeyDown: (event) => {
                if (event.key === "Enter") {
                    event.preventDefault();
                    if (lastSelection !== null) {
                        if (linkUrl !== "") {
                            editor.dispatchCommand(LexicalLink_1.TOGGLE_LINK_COMMAND, linkUrl);
                        }
                        setEditMode(false);
                    }
                }
                else if (event.key === "Escape") {
                    event.preventDefault();
                    setEditMode(false);
                }
            } })) : (jsxRuntime.jsx(jsxRuntime.Fragment, { children: jsxRuntime.jsxs("div", { className: "link-input", children: [jsxRuntime.jsx("a", { href: linkUrl, target: "_blank", rel: "noopener noreferrer", children: linkUrl }), jsxRuntime.jsx("div", { className: "link-edit", role: "button", tabIndex: 0, onMouseDown: (event) => event.preventDefault(), onClick: () => {
                            setEditMode(true);
                        } })] }) })) }));
}
function Select({ onChange, className, options, value }) {
    return (jsxRuntime.jsxs("select", { className: className, onChange: onChange, value: value, children: [jsxRuntime.jsx("option", { hidden: true, value: "" }), options.map((option) => (jsxRuntime.jsx("option", { value: option, children: option }, option)))] }));
}
function getSelectedNode(selection) {
    const anchor = selection.anchor;
    const focus = selection.focus;
    const anchorNode = selection.anchor.getNode();
    const focusNode = selection.focus.getNode();
    if (anchorNode === focusNode) {
        return anchorNode;
    }
    const isBackward = selection.isBackward();
    if (isBackward) {
        return LexicalSelection_1.$isAtNodeEnd(focus) ? anchorNode : focusNode;
    }
    else {
        return LexicalSelection_1.$isAtNodeEnd(anchor) ? focusNode : anchorNode;
    }
}
function BlockOptionsDropdownList({ editor, blockType, toolbarRef, setShowBlockOptionsDropDown }) {
    const dropDownRef = React.useRef(null);
    React.useEffect(() => {
        const toolbar = toolbarRef.current;
        const dropDown = dropDownRef.current;
        if (toolbar !== null && dropDown !== null) {
            const { top, left } = toolbar.getBoundingClientRect();
            dropDown.style.top = `${top + 40}px`;
            dropDown.style.left = `${left}px`;
        }
    }, [dropDownRef, toolbarRef]);
    React.useEffect(() => {
        const dropDown = dropDownRef.current;
        const toolbar = toolbarRef.current;
        if (dropDown !== null && toolbar !== null) {
            const handle = (event) => {
                const target = event.target;
                if (!dropDown.contains(target) && !toolbar.contains(target)) {
                    setShowBlockOptionsDropDown(false);
                }
            };
            document.addEventListener("click", handle);
            return () => {
                document.removeEventListener("click", handle);
            };
        }
    }, [dropDownRef, setShowBlockOptionsDropDown, toolbarRef]);
    const formatParagraph = () => {
        if (blockType !== "paragraph") {
            editor.update(() => {
                const selection = require$$0.$getSelection();
                if (require$$0.$isRangeSelection(selection)) {
                    LexicalSelection_1.$wrapNodes(selection, () => require$$0.$createParagraphNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatLargeHeading = () => {
        if (blockType !== "h1") {
            editor.update(() => {
                const selection = require$$0.$getSelection();
                if (require$$0.$isRangeSelection(selection)) {
                    LexicalSelection_1.$wrapNodes(selection, () => LexicalRichText_1.$createHeadingNode("h1"));
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatSmallHeading = () => {
        if (blockType !== "h2") {
            editor.update(() => {
                const selection = require$$0.$getSelection();
                if (require$$0.$isRangeSelection(selection)) {
                    LexicalSelection_1.$wrapNodes(selection, () => LexicalRichText_1.$createHeadingNode("h2"));
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatBulletList = () => {
        if (blockType !== "ul") {
            editor.dispatchCommand(LexicalList_1.INSERT_UNORDERED_LIST_COMMAND);
        }
        else {
            editor.dispatchCommand(LexicalList_1.REMOVE_LIST_COMMAND);
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatNumberedList = () => {
        if (blockType !== "ol") {
            editor.dispatchCommand(LexicalList_1.INSERT_ORDERED_LIST_COMMAND);
        }
        else {
            editor.dispatchCommand(LexicalList_1.REMOVE_LIST_COMMAND);
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatQuote = () => {
        if (blockType !== "quote") {
            editor.update(() => {
                const selection = require$$0.$getSelection();
                if (require$$0.$isRangeSelection(selection)) {
                    LexicalSelection_1.$wrapNodes(selection, () => LexicalRichText_1.$createQuoteNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    const formatCode = () => {
        if (blockType !== "code") {
            editor.update(() => {
                const selection = require$$0.$getSelection();
                if (require$$0.$isRangeSelection(selection)) {
                    LexicalSelection_1.$wrapNodes(selection, () => LexicalCode_1.$createCodeNode());
                }
            });
        }
        setShowBlockOptionsDropDown(false);
    };
    return (jsxRuntime.jsxs("div", { className: "dropdown", ref: dropDownRef, children: [jsxRuntime.jsxs("button", { className: "item", onClick: formatParagraph, children: [jsxRuntime.jsx("span", { className: "icon paragraph" }), jsxRuntime.jsx("span", { className: "text", children: "Normal" }), blockType === "paragraph" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatLargeHeading, children: [jsxRuntime.jsx("span", { className: "icon large-heading" }), jsxRuntime.jsx("span", { className: "text", children: "Large Heading" }), blockType === "h1" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatSmallHeading, children: [jsxRuntime.jsx("span", { className: "icon small-heading" }), jsxRuntime.jsx("span", { className: "text", children: "Small Heading" }), blockType === "h2" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatBulletList, children: [jsxRuntime.jsx("span", { className: "icon bullet-list" }), jsxRuntime.jsx("span", { className: "text", children: "Bullet List" }), blockType === "ul" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatNumberedList, children: [jsxRuntime.jsx("span", { className: "icon numbered-list" }), jsxRuntime.jsx("span", { className: "text", children: "Numbered List" }), blockType === "ol" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatQuote, children: [jsxRuntime.jsx("span", { className: "icon quote" }), jsxRuntime.jsx("span", { className: "text", children: "Quote" }), blockType === "quote" && jsxRuntime.jsx("span", { className: "active" })] }), jsxRuntime.jsxs("button", { className: "item", onClick: formatCode, children: [jsxRuntime.jsx("span", { className: "icon code" }), jsxRuntime.jsx("span", { className: "text", children: "Code Block" }), blockType === "code" && jsxRuntime.jsx("span", { className: "active" })] })] }));
}
function ToolbarPlugin({ uploadImageUrl: uploadUrl, getImages }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const toolbarRef = React.useRef(null);
    const [canUndo, setCanUndo] = React.useState(false);
    const [canRedo, setCanRedo] = React.useState(false);
    const [blockType, setBlockType] = React.useState("paragraph");
    const [selectedElementKey, setSelectedElementKey] = React.useState(null);
    const [showBlockOptionsDropDown, setShowBlockOptionsDropDown] = React.useState(false);
    const [codeLanguage, setCodeLanguage] = React.useState("");
    const [isRTL, setIsRTL] = React.useState(false);
    const [isLink, setIsLink] = React.useState(false);
    const [isBold, setIsBold] = React.useState(false);
    const [isItalic, setIsItalic] = React.useState(false);
    const [isUnderline, setIsUnderline] = React.useState(false);
    const [isStrikethrough, setIsStrikethrough] = React.useState(false);
    const [isCode, setIsCode] = React.useState(false);
    const updateToolbar = React.useCallback(() => {
        const selection = require$$0.$getSelection();
        if (require$$0.$isRangeSelection(selection)) {
            const anchorNode = selection.anchor.getNode();
            const element = anchorNode.getKey() === "root"
                ? anchorNode
                : anchorNode.getTopLevelElementOrThrow();
            const elementKey = element.getKey();
            const elementDOM = editor.getElementByKey(elementKey);
            if (elementDOM !== null) {
                setSelectedElementKey(elementKey);
                if (LexicalList_1.$isListNode(element)) {
                    const parentList = LexicalUtils_1.$getNearestNodeOfType(anchorNode, LexicalList_1.ListNode);
                    const type = parentList ? parentList.getTag() : element.getTag();
                    setBlockType(type);
                }
                else {
                    const type = LexicalRichText_1.$isHeadingNode(element)
                        ? element.getTag()
                        : element.getType();
                    setBlockType(type);
                    if (LexicalCode_1.$isCodeNode(element)) {
                        setCodeLanguage(element.getLanguage() || LexicalCode_1.getDefaultCodeLanguage());
                    }
                }
            }
            // Update text format
            setIsBold(selection.hasFormat("bold"));
            setIsItalic(selection.hasFormat("italic"));
            setIsUnderline(selection.hasFormat("underline"));
            setIsStrikethrough(selection.hasFormat("strikethrough"));
            setIsCode(selection.hasFormat("code"));
            setIsRTL(LexicalSelection_1.$isParentElementRTL(selection));
            // Update links
            const node = getSelectedNode(selection);
            const parent = node.getParent();
            if (LexicalLink_1.$isLinkNode(parent) || LexicalLink_1.$isLinkNode(node)) {
                setIsLink(true);
            }
            else {
                setIsLink(false);
            }
        }
    }, [editor]);
    React.useEffect(() => {
        return LexicalUtils_1.mergeRegister(editor.registerUpdateListener(({ editorState }) => {
            editorState.read(() => {
                updateToolbar();
            });
        }), editor.registerCommand(require$$0.SELECTION_CHANGE_COMMAND, (_payload, newEditor) => {
            updateToolbar();
            return false;
        }, LowPriority), editor.registerCommand(require$$0.CAN_UNDO_COMMAND, (payload) => {
            setCanUndo(payload);
            return false;
        }, LowPriority), editor.registerCommand(require$$0.CAN_REDO_COMMAND, (payload) => {
            setCanRedo(payload);
            return false;
        }, LowPriority));
    }, [editor, updateToolbar]);
    const [video, setVideoActive] = React__default["default"].useState(false);
    const [imgActive, setImgActive] = React__default["default"].useState(false);
    const codeLanguges = React.useMemo(() => LexicalCode_1.getCodeLanguages(), []);
    const onCodeLanguageSelect = React.useCallback((e) => {
        editor.update(() => {
            if (selectedElementKey !== null) {
                const node = require$$0.$getNodeByKey(selectedElementKey);
                if (LexicalCode_1.$isCodeNode(node)) {
                    node.setLanguage(e.target.value);
                }
            }
        });
    }, [editor, selectedElementKey]);
    const insertLink = React.useCallback(() => {
        if (!isLink) {
            editor.dispatchCommand(LexicalLink_1.TOGGLE_LINK_COMMAND, "https://");
        }
        else {
            editor.dispatchCommand(LexicalLink_1.TOGGLE_LINK_COMMAND, null);
        }
    }, [editor, isLink]);
    const insertImage = React.useCallback((url) => {
        // Executing command defined in a plugin
        editor.dispatchCommand(INSERT_IMAGE_COMMAND, url);
    }, [editor]);
    const insertVideo = (url) => {
        console.log(insertVideo, url);
        // Executing command defined in a plugin
        editor.dispatchCommand(INSERT_VIDEO_COMMAND, url);
    };
    return (jsxRuntime.jsxs("div", { className: "toolbar", ref: toolbarRef, children: [jsxRuntime.jsx("button", { disabled: !canUndo, onClick: () => {
                    editor.dispatchCommand(require$$0.UNDO_COMMAND);
                }, className: "toolbar-item spaced", "aria-label": "Undo", children: jsxRuntime.jsx("i", { className: "format undo" }) }), jsxRuntime.jsx("button", { disabled: !canRedo, onClick: () => {
                    editor.dispatchCommand(require$$0.REDO_COMMAND);
                }, className: "toolbar-item", "aria-label": "Redo", children: jsxRuntime.jsx("i", { className: "format redo" }) }), jsxRuntime.jsx(Divider, {}), supportedBlockTypes.has(blockType) && (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsxs("button", { className: "toolbar-item block-controls", onClick: () => setShowBlockOptionsDropDown(!showBlockOptionsDropDown), "aria-label": "Formatting Options", children: [jsxRuntime.jsx("span", { className: "icon block-type " + blockType }), jsxRuntime.jsx("span", { className: "text", children: blockTypeToBlockName[blockType] }), jsxRuntime.jsx("i", { className: "chevron-down" })] }), showBlockOptionsDropDown &&
                        reactDom.createPortal(jsxRuntime.jsx(BlockOptionsDropdownList, { editor: editor, blockType: blockType, toolbarRef: toolbarRef, setShowBlockOptionsDropDown: setShowBlockOptionsDropDown }), document.body), jsxRuntime.jsx(Divider, {})] })), blockType === "code" ? (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx(Select, { className: "toolbar-item code-language", onChange: onCodeLanguageSelect, options: codeLanguges, value: codeLanguage }), jsxRuntime.jsx("i", { className: "chevron-down inside" })] })) : (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_TEXT_COMMAND, "bold");
                        }, className: "toolbar-item spaced " + (isBold ? "active" : ""), "aria-label": "Format Bold", children: jsxRuntime.jsx("i", { className: "format bold" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_TEXT_COMMAND, "italic");
                        }, className: "toolbar-item spaced " + (isItalic ? "active" : ""), "aria-label": "Format Italics", children: jsxRuntime.jsx("i", { className: "format italic" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_TEXT_COMMAND, "underline");
                        }, className: "toolbar-item spaced " + (isUnderline ? "active" : ""), "aria-label": "Format Underline", children: jsxRuntime.jsx("i", { className: "format underline" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_TEXT_COMMAND, "strikethrough");
                        }, className: "toolbar-item spaced " + (isStrikethrough ? "active" : ""), "aria-label": "Format Strikethrough", children: jsxRuntime.jsx("i", { className: "format strikethrough" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_TEXT_COMMAND, "code");
                        }, className: "toolbar-item spaced " + (isCode ? "active" : ""), "aria-label": "Insert Code", children: jsxRuntime.jsx("i", { className: "format code" }) }), jsxRuntime.jsx("button", { onClick: insertLink, className: "toolbar-item spaced " + (isLink ? "active" : ""), "aria-label": "Insert Link", children: jsxRuntime.jsx("i", { className: "format link" }) }), isLink &&
                        reactDom.createPortal(jsxRuntime.jsx(FloatingLinkEditor, { editor: editor }), document.body), jsxRuntime.jsx(Divider, {}), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_ELEMENT_COMMAND, "left");
                        }, className: "toolbar-item spaced", "aria-label": "Left Align", children: jsxRuntime.jsx("i", { className: "format left-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_ELEMENT_COMMAND, "center");
                        }, className: "toolbar-item spaced", "aria-label": "Center Align", children: jsxRuntime.jsx("i", { className: "format center-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_ELEMENT_COMMAND, "right");
                        }, className: "toolbar-item spaced", "aria-label": "Right Align", children: jsxRuntime.jsx("i", { className: "format right-align" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            editor.dispatchCommand(require$$0.FORMAT_ELEMENT_COMMAND, "justify");
                        }, className: "toolbar-item", "aria-label": "Justify Align", children: jsxRuntime.jsx("i", { className: "format justify-align" }) }), jsxRuntime.jsx(Divider, {}), jsxRuntime.jsx("button", { onClick: () => {
                            setImgActive(true);
                        }, className: "toolbar-item spaced", "aria-label": "Image", children: jsxRuntime.jsx("i", { className: "format image" }) }), jsxRuntime.jsx("button", { onClick: () => {
                            setVideoActive(true);
                        }, className: "toolbar-item spaced", "aria-label": "Video", children: jsxRuntime.jsx("i", { className: "format video" }) })] })), jsxRuntime.jsx(ui.Modal, { active: video, setActive: setVideoActive, children: jsxRuntime.jsx(AddUrl, { title: "Add Video", onCancel: () => setVideoActive(false), onConfirm: (url => {
                        setVideoActive(false);
                        insertVideo(url);
                    }) }) }), jsxRuntime.jsx(ui.Modal, { className: "w-224", active: imgActive, setActive: setImgActive, children: !!getImages ? jsxRuntime.jsx(ImageSelection, { uploadUrl: uploadUrl, onCancel: () => {
                        setImgActive(false);
                    }, onSelect: (images) => {
                        images.map(p => insertImage(p));
                        setImgActive(false);
                    }, getFiles: getImages }) : jsxRuntime.jsx(AddUrl, { title: "Add Image", onCancel: () => setVideoActive(false), onConfirm: (url => {
                        setImgActive(false);
                        insertImage(url);
                    }) }) })] }));
}

var LexicalTable_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalTable_dev;

function requireLexicalTable_dev () {
	if (hasRequiredLexicalTable_dev) return LexicalTable_dev;
	hasRequiredLexicalTable_dev = 1;

	var lexical = require$$0__default["default"];
	var utils = LexicalUtils_1;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const PIXEL_VALUE_REG_EXP = /^(\d+(?:\.\d+)?)px$/;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const TableCellHeaderStates = {
	  BOTH: 3,
	  COLUMN: 2,
	  NO_STATUS: 0,
	  ROW: 1
	};

	/** @noInheritDoc */
	class TableCellNode extends lexical.DEPRECATED_GridCellNode {
	  /** @internal */

	  /** @internal */

	  /** @internal */
	  static getType() {
	    return 'tablecell';
	  }

	  static clone(node) {
	    const cellNode = new TableCellNode(node.__headerState, node.__colSpan, node.__width, node.__key);
	    cellNode.__rowSpan = node.__rowSpan;
	    cellNode.__backgroundColor = node.__backgroundColor;
	    return cellNode;
	  }

	  static importDOM() {
	    return {
	      td: node => ({
	        conversion: convertTableCellNodeElement,
	        priority: 0
	      }),
	      th: node => ({
	        conversion: convertTableCellNodeElement,
	        priority: 0
	      })
	    };
	  }

	  static importJSON(serializedNode) {
	    const colSpan = serializedNode.colSpan || 1;
	    const rowSpan = serializedNode.rowSpan || 1;
	    const cellNode = $createTableCellNode(serializedNode.headerState, colSpan, serializedNode.width || undefined);
	    cellNode.__rowSpan = rowSpan;
	    cellNode.__backgroundColor = serializedNode.backgroundColor || null;
	    return cellNode;
	  }

	  constructor(headerState = TableCellHeaderStates.NO_STATUS, colSpan = 1, width, key) {
	    super(colSpan, key);
	    this.__headerState = headerState;
	    this.__width = width;
	    this.__backgroundColor = null;
	  }

	  createDOM(config) {
	    const element = document.createElement(this.getTag());

	    if (this.__width) {
	      element.style.width = `${this.__width}px`;
	    }

	    if (this.__colSpan > 1) {
	      element.colSpan = this.__colSpan;
	    }

	    if (this.__rowSpan > 1) {
	      element.rowSpan = this.__rowSpan;
	    }

	    if (this.__backgroundColor !== null) {
	      element.style.backgroundColor = this.__backgroundColor;
	    }

	    utils.addClassNamesToElement(element, config.theme.tableCell, this.hasHeader() && config.theme.tableCellHeader);
	    return element;
	  }

	  exportDOM(editor) {
	    const {
	      element
	    } = super.exportDOM(editor);

	    if (element) {
	      const element_ = element;
	      const maxWidth = 700;
	      const colCount = this.getParentOrThrow().getChildrenSize();
	      element_.style.border = '1px solid black';

	      if (this.__colSpan > 1) {
	        element_.colSpan = this.__colSpan;
	      }

	      if (this.__rowSpan > 1) {
	        element_.rowSpan = this.__rowSpan;
	      }

	      element_.style.width = `${this.getWidth() || Math.max(90, maxWidth / colCount)}px`;
	      element_.style.verticalAlign = 'top';
	      element_.style.textAlign = 'start';
	      const backgroundColor = this.getBackgroundColor();

	      if (backgroundColor !== null) {
	        element_.style.backgroundColor = backgroundColor;
	      } else if (this.hasHeader()) {
	        element_.style.backgroundColor = '#f2f3f5';
	      }
	    }

	    return {
	      element
	    };
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      backgroundColor: this.getBackgroundColor(),
	      headerState: this.__headerState,
	      type: 'tablecell',
	      width: this.getWidth()
	    };
	  }

	  getTag() {
	    return this.hasHeader() ? 'th' : 'td';
	  }

	  setHeaderStyles(headerState) {
	    const self = this.getWritable();
	    self.__headerState = headerState;
	    return this.__headerState;
	  }

	  getHeaderStyles() {
	    return this.getLatest().__headerState;
	  }

	  setWidth(width) {
	    const self = this.getWritable();
	    self.__width = width;
	    return this.__width;
	  }

	  getWidth() {
	    return this.getLatest().__width;
	  }

	  getBackgroundColor() {
	    return this.getLatest().__backgroundColor;
	  }

	  setBackgroundColor(newBackgroundColor) {
	    this.getWritable().__backgroundColor = newBackgroundColor;
	  }

	  toggleHeaderStyle(headerStateToToggle) {
	    const self = this.getWritable();

	    if ((self.__headerState & headerStateToToggle) === headerStateToToggle) {
	      self.__headerState -= headerStateToToggle;
	    } else {
	      self.__headerState += headerStateToToggle;
	    }

	    return self;
	  }

	  hasHeaderState(headerState) {
	    return (this.getHeaderStyles() & headerState) === headerState;
	  }

	  hasHeader() {
	    return this.getLatest().__headerState !== TableCellHeaderStates.NO_STATUS;
	  }

	  updateDOM(prevNode) {
	    return prevNode.__headerState !== this.__headerState || prevNode.__width !== this.__width || prevNode.__colSpan !== this.__colSpan || prevNode.__rowSpan !== this.__rowSpan || prevNode.__backgroundColor !== this.__backgroundColor;
	  }

	  isShadowRoot() {
	    return true;
	  }

	  collapseAtStart() {
	    return true;
	  }

	  canBeEmpty() {
	    return false;
	  }

	  canIndent() {
	    return false;
	  }

	}
	function convertTableCellNodeElement(domNode) {
	  const domNode_ = domNode;
	  const nodeName = domNode.nodeName.toLowerCase();
	  let width = undefined;

	  if (PIXEL_VALUE_REG_EXP.test(domNode_.style.width)) {
	    width = parseFloat(domNode_.style.width);
	  }

	  const tableCellNode = $createTableCellNode(nodeName === 'th' ? TableCellHeaderStates.ROW : TableCellHeaderStates.NO_STATUS, domNode_.colSpan, width);
	  tableCellNode.__rowSpan = domNode_.rowSpan;
	  const backgroundColor = domNode_.style.backgroundColor;

	  if (backgroundColor !== '') {
	    tableCellNode.__backgroundColor = backgroundColor;
	  }

	  return {
	    forChild: (lexicalNode, parentLexicalNode) => {
	      if ($isTableCellNode(parentLexicalNode) && !lexical.$isElementNode(lexicalNode)) {
	        const paragraphNode = lexical.$createParagraphNode();

	        if (lexical.$isLineBreakNode(lexicalNode) && lexicalNode.getTextContent() === '\n') {
	          return null;
	        }

	        paragraphNode.append(lexicalNode);
	        return paragraphNode;
	      }

	      return lexicalNode;
	    },
	    node: tableCellNode
	  };
	}
	function $createTableCellNode(headerState, colSpan = 1, width) {
	  return lexical.$applyNodeReplacement(new TableCellNode(headerState, colSpan, width));
	}
	function $isTableCellNode(node) {
	  return node instanceof TableCellNode;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	/** @noInheritDoc */
	class TableRowNode extends lexical.DEPRECATED_GridRowNode {
	  /** @internal */
	  static getType() {
	    return 'tablerow';
	  }

	  static clone(node) {
	    return new TableRowNode(node.__height, node.__key);
	  }

	  static importDOM() {
	    return {
	      tr: node => ({
	        conversion: convertTableRowElement,
	        priority: 0
	      })
	    };
	  }

	  static importJSON(serializedNode) {
	    return $createTableRowNode(serializedNode.height);
	  }

	  constructor(height, key) {
	    super(key);
	    this.__height = height;
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      type: 'tablerow',
	      version: 1
	    };
	  }

	  createDOM(config) {
	    const element = document.createElement('tr');

	    if (this.__height) {
	      element.style.height = `${this.__height}px`;
	    }

	    utils.addClassNamesToElement(element, config.theme.tableRow);
	    return element;
	  }

	  isShadowRoot() {
	    return true;
	  }

	  setHeight(height) {
	    const self = this.getWritable();
	    self.__height = height;
	    return this.__height;
	  }

	  getHeight() {
	    return this.getLatest().__height;
	  }

	  updateDOM(prevNode) {
	    return prevNode.__height !== this.__height;
	  }

	  canBeEmpty() {
	    return false;
	  }

	  canIndent() {
	    return false;
	  }

	}
	function convertTableRowElement(domNode) {
	  const domNode_ = domNode;
	  let height = undefined;

	  if (PIXEL_VALUE_REG_EXP.test(domNode_.style.height)) {
	    height = parseFloat(domNode_.style.height);
	  }

	  return {
	    node: $createTableRowNode(height)
	  };
	}
	function $createTableRowNode(height) {
	  return lexical.$applyNodeReplacement(new TableRowNode(height));
	}
	function $isTableRowNode(node) {
	  return node instanceof TableRowNode;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const CAN_USE_DOM = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined';

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	const getDOMSelection = targetWindow => CAN_USE_DOM ? (targetWindow || window).getSelection() : null;

	class TableSelection {
	  constructor(editor, tableNodeKey) {
	    this.isHighlightingCells = false;
	    this.anchorX = -1;
	    this.anchorY = -1;
	    this.focusX = -1;
	    this.focusY = -1;
	    this.listenersToRemove = new Set();
	    this.tableNodeKey = tableNodeKey;
	    this.editor = editor;
	    this.grid = {
	      cells: [],
	      columns: 0,
	      rows: 0
	    };
	    this.gridSelection = null;
	    this.anchorCellNodeKey = null;
	    this.focusCellNodeKey = null;
	    this.anchorCell = null;
	    this.focusCell = null;
	    this.hasHijackedSelectionStyles = false;
	    this.trackTableGrid();
	  }

	  getGrid() {
	    return this.grid;
	  }

	  removeListeners() {
	    Array.from(this.listenersToRemove).forEach(removeListener => removeListener());
	  }

	  trackTableGrid() {
	    const observer = new MutationObserver(records => {
	      this.editor.update(() => {
	        let gridNeedsRedraw = false;

	        for (let i = 0; i < records.length; i++) {
	          const record = records[i];
	          const target = record.target;
	          const nodeName = target.nodeName;

	          if (nodeName === 'TABLE' || nodeName === 'TR') {
	            gridNeedsRedraw = true;
	            break;
	          }
	        }

	        if (!gridNeedsRedraw) {
	          return;
	        }

	        const tableElement = this.editor.getElementByKey(this.tableNodeKey);

	        if (!tableElement) {
	          throw new Error('Expected to find TableElement in DOM');
	        }

	        this.grid = getTableGrid(tableElement);
	      });
	    });
	    this.editor.update(() => {
	      const tableElement = this.editor.getElementByKey(this.tableNodeKey);

	      if (!tableElement) {
	        throw new Error('Expected to find TableElement in DOM');
	      }

	      this.grid = getTableGrid(tableElement);
	      observer.observe(tableElement, {
	        childList: true,
	        subtree: true
	      });
	    });
	  }

	  clearHighlight() {
	    const editor = this.editor;
	    this.isHighlightingCells = false;
	    this.anchorX = -1;
	    this.anchorY = -1;
	    this.focusX = -1;
	    this.focusY = -1;
	    this.gridSelection = null;
	    this.anchorCellNodeKey = null;
	    this.focusCellNodeKey = null;
	    this.anchorCell = null;
	    this.focusCell = null;
	    this.hasHijackedSelectionStyles = false;
	    this.enableHighlightStyle();
	    editor.update(() => {
	      const tableNode = lexical.$getNodeByKey(this.tableNodeKey);

	      if (!$isTableNode(tableNode)) {
	        throw new Error('Expected TableNode.');
	      }

	      const tableElement = editor.getElementByKey(this.tableNodeKey);

	      if (!tableElement) {
	        throw new Error('Expected to find TableElement in DOM');
	      }

	      const grid = getTableGrid(tableElement);
	      $updateDOMForSelection(editor, grid, null);
	      lexical.$setSelection(null);
	      editor.dispatchCommand(lexical.SELECTION_CHANGE_COMMAND, undefined);
	    });
	  }

	  enableHighlightStyle() {
	    const editor = this.editor;
	    editor.update(() => {
	      const tableElement = editor.getElementByKey(this.tableNodeKey);

	      if (!tableElement) {
	        throw new Error('Expected to find TableElement in DOM');
	      }

	      utils.removeClassNamesFromElement(tableElement, editor._config.theme.tableSelection);
	      tableElement.classList.remove('disable-selection');
	      this.hasHijackedSelectionStyles = false;
	    });
	  }

	  disableHighlightStyle() {
	    const editor = this.editor;
	    editor.update(() => {
	      const tableElement = editor.getElementByKey(this.tableNodeKey);

	      if (!tableElement) {
	        throw new Error('Expected to find TableElement in DOM');
	      }

	      utils.addClassNamesToElement(tableElement, editor._config.theme.tableSelection);
	      this.hasHijackedSelectionStyles = true;
	    });
	  }

	  updateTableGridSelection(selection) {
	    if (selection != null && selection.gridKey === this.tableNodeKey) {
	      const editor = this.editor;
	      this.gridSelection = selection;
	      this.isHighlightingCells = true;
	      this.disableHighlightStyle();
	      $updateDOMForSelection(editor, this.grid, this.gridSelection);
	    } else if (selection == null) {
	      this.clearHighlight();
	    }
	  }

	  setFocusCellForSelection(cell, ignoreStart = false) {
	    const editor = this.editor;
	    editor.update(() => {
	      const tableNode = lexical.$getNodeByKey(this.tableNodeKey);

	      if (!$isTableNode(tableNode)) {
	        throw new Error('Expected TableNode.');
	      }

	      const tableElement = editor.getElementByKey(this.tableNodeKey);

	      if (!tableElement) {
	        throw new Error('Expected to find TableElement in DOM');
	      }

	      const cellX = cell.x;
	      const cellY = cell.y;
	      this.focusCell = cell;

	      if (this.anchorCell !== null) {
	        const domSelection = getDOMSelection(editor._window); // Collapse the selection

	        if (domSelection) {
	          domSelection.setBaseAndExtent(this.anchorCell.elem, 0, this.focusCell.elem, 0);
	        }
	      }

	      if (!this.isHighlightingCells && (this.anchorX !== cellX || this.anchorY !== cellY || ignoreStart)) {
	        this.isHighlightingCells = true;
	        this.disableHighlightStyle();
	      } else if (cellX === this.focusX && cellY === this.focusY) {
	        return;
	      }

	      this.focusX = cellX;
	      this.focusY = cellY;

	      if (this.isHighlightingCells) {
	        const focusTableCellNode = lexical.$getNearestNodeFromDOMNode(cell.elem);

	        if (this.gridSelection != null && this.anchorCellNodeKey != null && $isTableCellNode(focusTableCellNode)) {
	          const focusNodeKey = focusTableCellNode.getKey();
	          this.gridSelection = this.gridSelection.clone() || lexical.DEPRECATED_$createGridSelection();
	          this.focusCellNodeKey = focusNodeKey;
	          this.gridSelection.set(this.tableNodeKey, this.anchorCellNodeKey, this.focusCellNodeKey);
	          lexical.$setSelection(this.gridSelection);
	          editor.dispatchCommand(lexical.SELECTION_CHANGE_COMMAND, undefined);
	          $updateDOMForSelection(editor, this.grid, this.gridSelection);
	        }
	      }
	    });
	  }

	  setAnchorCellForSelection(cell) {
	    this.isHighlightingCells = false;
	    this.anchorCell = cell;
	    this.anchorX = cell.x;
	    this.anchorY = cell.y;
	    this.editor.update(() => {
	      const anchorTableCellNode = lexical.$getNearestNodeFromDOMNode(cell.elem);

	      if ($isTableCellNode(anchorTableCellNode)) {
	        const anchorNodeKey = anchorTableCellNode.getKey();
	        this.gridSelection = lexical.DEPRECATED_$createGridSelection();
	        this.anchorCellNodeKey = anchorNodeKey;
	      }
	    });
	  }

	  formatCells(type) {
	    this.editor.update(() => {
	      const selection = lexical.$getSelection();

	      if (!lexical.DEPRECATED_$isGridSelection(selection)) {
	        {
	          throw Error(`Expected grid selection`);
	        }
	      }

	      const formatSelection = lexical.$createRangeSelection();
	      const anchor = formatSelection.anchor;
	      const focus = formatSelection.focus;
	      selection.getNodes().forEach(cellNode => {
	        if ($isTableCellNode(cellNode) && cellNode.getTextContentSize() !== 0) {
	          anchor.set(cellNode.getKey(), 0, 'element');
	          focus.set(cellNode.getKey(), cellNode.getChildrenSize(), 'element');
	          formatSelection.formatText(type);
	        }
	      });
	      lexical.$setSelection(selection);
	      this.editor.dispatchCommand(lexical.SELECTION_CHANGE_COMMAND, undefined);
	    });
	  }

	  clearText() {
	    const editor = this.editor;
	    editor.update(() => {
	      const tableNode = lexical.$getNodeByKey(this.tableNodeKey);

	      if (!$isTableNode(tableNode)) {
	        throw new Error('Expected TableNode.');
	      }

	      const selection = lexical.$getSelection();

	      if (!lexical.DEPRECATED_$isGridSelection(selection)) {
	        {
	          throw Error(`Expected grid selection`);
	        }
	      }

	      const selectedNodes = selection.getNodes().filter($isTableCellNode);

	      if (selectedNodes.length === this.grid.columns * this.grid.rows) {
	        tableNode.selectPrevious(); // Delete entire table

	        tableNode.remove();
	        const rootNode = lexical.$getRoot();
	        rootNode.selectStart();
	        return;
	      }

	      selectedNodes.forEach(cellNode => {
	        if (lexical.$isElementNode(cellNode)) {
	          const paragraphNode = lexical.$createParagraphNode();
	          const textNode = lexical.$createTextNode();
	          paragraphNode.append(textNode);
	          cellNode.append(paragraphNode);
	          cellNode.getChildren().forEach(child => {
	            if (child !== paragraphNode) {
	              child.remove();
	            }
	          });
	        }
	      });
	      $updateDOMForSelection(editor, this.grid, null);
	      lexical.$setSelection(null);
	      editor.dispatchCommand(lexical.SELECTION_CHANGE_COMMAND, undefined);
	    });
	  }

	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const LEXICAL_ELEMENT_KEY = '__lexicalTableSelection';
	function applyTableHandlers(tableNode, tableElement, editor, hasTabHandler) {
	  const rootElement = editor.getRootElement();

	  if (rootElement === null) {
	    throw new Error('No root element.');
	  }

	  const tableSelection = new TableSelection(editor, tableNode.getKey());
	  const editorWindow = editor._window || window;
	  attachTableSelectionToTableElement(tableElement, tableSelection);
	  tableElement.addEventListener('mousedown', event => {
	    setTimeout(() => {
	      if (event.button !== 0) {
	        return;
	      }

	      if (!editorWindow) {
	        return;
	      }

	      const anchorCell = getCellFromTarget(event.target);

	      if (anchorCell !== null) {
	        stopEvent(event);
	        tableSelection.setAnchorCellForSelection(anchorCell);
	      }

	      const onMouseUp = () => {
	        editorWindow.removeEventListener('mouseup', onMouseUp);
	        editorWindow.removeEventListener('mousemove', onMouseMove);
	      };

	      const onMouseMove = moveEvent => {
	        const focusCell = getCellFromTarget(moveEvent.target);

	        if (focusCell !== null && (tableSelection.anchorX !== focusCell.x || tableSelection.anchorY !== focusCell.y)) {
	          moveEvent.preventDefault();
	          tableSelection.setFocusCellForSelection(focusCell);
	        }
	      };

	      editorWindow.addEventListener('mouseup', onMouseUp);
	      editorWindow.addEventListener('mousemove', onMouseMove);
	    }, 0);
	  }); // Clear selection when clicking outside of dom.

	  const mouseDownCallback = event => {
	    if (event.button !== 0) {
	      return;
	    }

	    editor.update(() => {
	      const selection = lexical.$getSelection();
	      const target = event.target;

	      if (lexical.DEPRECATED_$isGridSelection(selection) && selection.gridKey === tableSelection.tableNodeKey && rootElement.contains(target)) {
	        tableSelection.clearHighlight();
	      }
	    });
	  };

	  editorWindow.addEventListener('mousedown', mouseDownCallback);
	  tableSelection.listenersToRemove.add(() => editorWindow.removeEventListener('mousedown', mouseDownCallback));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_ARROW_DOWN_COMMAND, event => $handleArrowKey(editor, event, 'down', tableNode, tableSelection), lexical.COMMAND_PRIORITY_HIGH));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_ARROW_UP_COMMAND, event => $handleArrowKey(editor, event, 'up', tableNode, tableSelection), lexical.COMMAND_PRIORITY_HIGH));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_ARROW_LEFT_COMMAND, event => $handleArrowKey(editor, event, 'backward', tableNode, tableSelection), lexical.COMMAND_PRIORITY_HIGH));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_ARROW_RIGHT_COMMAND, event => $handleArrowKey(editor, event, 'forward', tableNode, tableSelection), lexical.COMMAND_PRIORITY_HIGH));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_ESCAPE_COMMAND, event => {
	    const selection = lexical.$getSelection();

	    if (lexical.DEPRECATED_$isGridSelection(selection)) {
	      const focusCellNode = utils.$findMatchingParent(selection.focus.getNode(), $isTableCellNode);

	      if ($isTableCellNode(focusCellNode)) {
	        stopEvent(event);
	        focusCellNode.selectEnd();
	        return true;
	      }
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_HIGH));

	  const deleteTextHandler = command => () => {
	    const selection = lexical.$getSelection();

	    if (!$isSelectionInTable(selection, tableNode)) {
	      return false;
	    }

	    if (lexical.DEPRECATED_$isGridSelection(selection)) {
	      tableSelection.clearText();
	      return true;
	    } else if (lexical.$isRangeSelection(selection)) {
	      const tableCellNode = utils.$findMatchingParent(selection.anchor.getNode(), n => $isTableCellNode(n));

	      if (!$isTableCellNode(tableCellNode)) {
	        return false;
	      }

	      const anchorNode = selection.anchor.getNode();
	      const focusNode = selection.focus.getNode();
	      const isAnchorInside = tableNode.isParentOf(anchorNode);
	      const isFocusInside = tableNode.isParentOf(focusNode);
	      const selectionContainsPartialTable = isAnchorInside && !isFocusInside || isFocusInside && !isAnchorInside;

	      if (selectionContainsPartialTable) {
	        tableSelection.clearText();
	        return true;
	      }

	      const nearestElementNode = utils.$findMatchingParent(selection.anchor.getNode(), n => lexical.$isElementNode(n));
	      const topLevelCellElementNode = nearestElementNode && utils.$findMatchingParent(nearestElementNode, n => lexical.$isElementNode(n) && $isTableCellNode(n.getParent()));

	      if (!lexical.$isElementNode(topLevelCellElementNode) || !lexical.$isElementNode(nearestElementNode)) {
	        return false;
	      }

	      if (command === lexical.DELETE_LINE_COMMAND && topLevelCellElementNode.getPreviousSibling() === null) {
	        // TODO: Fix Delete Line in Table Cells.
	        return true;
	      }

	      if (command === lexical.DELETE_CHARACTER_COMMAND || command === lexical.DELETE_WORD_COMMAND) {
	        if (selection.isCollapsed() && selection.anchor.offset === 0) {
	          if (nearestElementNode !== topLevelCellElementNode) {
	            const children = nearestElementNode.getChildren();
	            const newParagraphNode = lexical.$createParagraphNode();
	            children.forEach(child => newParagraphNode.append(child));
	            nearestElementNode.replace(newParagraphNode);
	            nearestElementNode.getWritable().__parent = tableCellNode.getKey();
	            return true;
	          }
	        }
	      }
	    }

	    return false;
	  };

	  [lexical.DELETE_WORD_COMMAND, lexical.DELETE_LINE_COMMAND, lexical.DELETE_CHARACTER_COMMAND].forEach(command => {
	    tableSelection.listenersToRemove.add(editor.registerCommand(command, deleteTextHandler(command), lexical.COMMAND_PRIORITY_CRITICAL));
	  });

	  const deleteCellHandler = event => {
	    const selection = lexical.$getSelection();

	    if (!$isSelectionInTable(selection, tableNode)) {
	      return false;
	    }

	    if (lexical.DEPRECATED_$isGridSelection(selection)) {
	      event.preventDefault();
	      event.stopPropagation();
	      tableSelection.clearText();
	      return true;
	    } else if (lexical.$isRangeSelection(selection)) {
	      const tableCellNode = utils.$findMatchingParent(selection.anchor.getNode(), n => $isTableCellNode(n));

	      if (!$isTableCellNode(tableCellNode)) {
	        return false;
	      }
	    }

	    return false;
	  };

	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_BACKSPACE_COMMAND, deleteCellHandler, lexical.COMMAND_PRIORITY_CRITICAL));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_DELETE_COMMAND, deleteCellHandler, lexical.COMMAND_PRIORITY_CRITICAL));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.FORMAT_TEXT_COMMAND, payload => {
	    const selection = lexical.$getSelection();

	    if (!$isSelectionInTable(selection, tableNode)) {
	      return false;
	    }

	    if (lexical.DEPRECATED_$isGridSelection(selection)) {
	      tableSelection.formatCells(payload);
	      return true;
	    } else if (lexical.$isRangeSelection(selection)) {
	      const tableCellNode = utils.$findMatchingParent(selection.anchor.getNode(), n => $isTableCellNode(n));

	      if (!$isTableCellNode(tableCellNode)) {
	        return false;
	      }
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_CRITICAL));
	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.CONTROLLED_TEXT_INSERTION_COMMAND, payload => {
	    const selection = lexical.$getSelection();

	    if (!$isSelectionInTable(selection, tableNode)) {
	      return false;
	    }

	    if (lexical.DEPRECATED_$isGridSelection(selection)) {
	      tableSelection.clearHighlight();
	      return false;
	    } else if (lexical.$isRangeSelection(selection)) {
	      const tableCellNode = utils.$findMatchingParent(selection.anchor.getNode(), n => $isTableCellNode(n));

	      if (!$isTableCellNode(tableCellNode)) {
	        return false;
	      }
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_CRITICAL));

	  if (hasTabHandler) {
	    tableSelection.listenersToRemove.add(editor.registerCommand(lexical.KEY_TAB_COMMAND, event => {
	      const selection = lexical.$getSelection();

	      if (!lexical.$isRangeSelection(selection) || !selection.isCollapsed() || !$isSelectionInTable(selection, tableNode)) {
	        return false;
	      }

	      const tableCellNode = $findCellNode(selection.anchor.getNode());

	      if (tableCellNode === null) {
	        return false;
	      }

	      stopEvent(event);
	      const currentCords = tableNode.getCordsFromCellNode(tableCellNode, tableSelection.grid);
	      selectGridNodeInDirection(tableSelection, tableNode, currentCords.x, currentCords.y, !event.shiftKey ? 'forward' : 'backward');
	      return true;
	    }, lexical.COMMAND_PRIORITY_CRITICAL));
	  }

	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.FOCUS_COMMAND, payload => {
	    return tableNode.isSelected();
	  }, lexical.COMMAND_PRIORITY_HIGH));

	  function getCellFromCellNode(tableCellNode) {
	    const currentCords = tableNode.getCordsFromCellNode(tableCellNode, tableSelection.grid);
	    return tableNode.getCellFromCordsOrThrow(currentCords.x, currentCords.y, tableSelection.grid);
	  }

	  tableSelection.listenersToRemove.add(editor.registerCommand(lexical.SELECTION_CHANGE_COMMAND, () => {
	    const selection = lexical.$getSelection();
	    const prevSelection = lexical.$getPreviousSelection();

	    if (lexical.$isRangeSelection(selection)) {
	      const {
	        anchor,
	        focus
	      } = selection;
	      const anchorNode = anchor.getNode();
	      const focusNode = focus.getNode(); // Using explicit comparison with table node to ensure it's not a nested table
	      // as in that case we'll leave selection resolving to that table

	      const anchorCellNode = $findCellNode(anchorNode);
	      const focusCellNode = $findCellNode(focusNode);
	      const isAnchorInside = anchorCellNode && tableNode.is($findTableNode(anchorCellNode));
	      const isFocusInside = focusCellNode && tableNode.is($findTableNode(focusCellNode));
	      const isPartialyWithinTable = isAnchorInside !== isFocusInside;
	      const isWithinTable = isAnchorInside && isFocusInside;
	      const isBackward = selection.isBackward();

	      if (isPartialyWithinTable) {
	        const newSelection = selection.clone();
	        newSelection.focus.set(tableNode.getKey(), isBackward ? 0 : tableNode.getChildrenSize(), 'element');
	        lexical.$setSelection(newSelection);
	        $addHighlightStyleToTable(editor, tableSelection);
	      } else if (isWithinTable) {
	        // Handle case when selection spans across multiple cells but still
	        // has range selection, then we convert it into grid selection
	        if (!anchorCellNode.is(focusCellNode)) {
	          tableSelection.setAnchorCellForSelection(getCellFromCellNode(anchorCellNode));
	          tableSelection.setFocusCellForSelection(getCellFromCellNode(focusCellNode), true);
	        }
	      }
	    }

	    if (selection && !selection.is(prevSelection) && (lexical.DEPRECATED_$isGridSelection(selection) || lexical.DEPRECATED_$isGridSelection(prevSelection)) && tableSelection.gridSelection && !tableSelection.gridSelection.is(prevSelection)) {
	      if (lexical.DEPRECATED_$isGridSelection(selection) && selection.gridKey === tableSelection.tableNodeKey) {
	        tableSelection.updateTableGridSelection(selection);
	      } else if (!lexical.DEPRECATED_$isGridSelection(selection) && lexical.DEPRECATED_$isGridSelection(prevSelection) && prevSelection.gridKey === tableSelection.tableNodeKey) {
	        tableSelection.updateTableGridSelection(null);
	      }

	      return false;
	    }

	    if (tableSelection.hasHijackedSelectionStyles && !tableNode.isSelected()) {
	      $removeHighlightStyleToTable(editor, tableSelection);
	    } else if (!tableSelection.hasHijackedSelectionStyles && tableNode.isSelected()) {
	      $addHighlightStyleToTable(editor, tableSelection);
	    }

	    return false;
	  }, lexical.COMMAND_PRIORITY_CRITICAL));
	  return tableSelection;
	}
	function attachTableSelectionToTableElement(tableElement, tableSelection) {
	  tableElement[LEXICAL_ELEMENT_KEY] = tableSelection;
	}
	function getTableSelectionFromTableElement(tableElement) {
	  return tableElement[LEXICAL_ELEMENT_KEY];
	}
	function getCellFromTarget(node) {
	  let currentNode = node;

	  while (currentNode != null) {
	    const nodeName = currentNode.nodeName;

	    if (nodeName === 'TD' || nodeName === 'TH') {
	      // @ts-expect-error: internal field
	      const cell = currentNode._cell;

	      if (cell === undefined) {
	        return null;
	      }

	      return cell;
	    }

	    currentNode = currentNode.parentNode;
	  }

	  return null;
	}
	function getTableGrid(tableElement) {
	  const cells = [];
	  const grid = {
	    cells,
	    columns: 0,
	    rows: 0
	  };
	  let currentNode = tableElement.firstChild;
	  let x = 0;
	  let y = 0;
	  cells.length = 0;

	  while (currentNode != null) {
	    const nodeMame = currentNode.nodeName;

	    if (nodeMame === 'TD' || nodeMame === 'TH') {
	      const elem = currentNode;
	      const cell = {
	        elem,
	        hasBackgroundColor: elem.style.backgroundColor !== '',
	        highlighted: false,
	        x,
	        y
	      }; // @ts-expect-error: internal field

	      currentNode._cell = cell;

	      if (cells[y] === undefined) {
	        cells[y] = [];
	      }

	      cells[y][x] = cell;
	    } else {
	      const child = currentNode.firstChild;

	      if (child != null) {
	        currentNode = child;
	        continue;
	      }
	    }

	    const sibling = currentNode.nextSibling;

	    if (sibling != null) {
	      x++;
	      currentNode = sibling;
	      continue;
	    }

	    const parent = currentNode.parentNode;

	    if (parent != null) {
	      const parentSibling = parent.nextSibling;

	      if (parentSibling == null) {
	        break;
	      }

	      y++;
	      x = 0;
	      currentNode = parentSibling;
	    }
	  }

	  grid.columns = x + 1;
	  grid.rows = y + 1;
	  return grid;
	}
	function $updateDOMForSelection(editor, grid, selection) {
	  const selectedCellNodes = new Set(selection ? selection.getNodes() : []);
	  $forEachGridCell(grid, (cell, lexicalNode) => {
	    const elem = cell.elem;

	    if (selectedCellNodes.has(lexicalNode)) {
	      cell.highlighted = true;
	      $addHighlightToDOM(editor, cell);
	    } else {
	      cell.highlighted = false;
	      $removeHighlightFromDOM(editor, cell);

	      if (!elem.getAttribute('style')) {
	        elem.removeAttribute('style');
	      }
	    }
	  });
	}
	function $forEachGridCell(grid, cb) {
	  const {
	    cells
	  } = grid;

	  for (let y = 0; y < cells.length; y++) {
	    const row = cells[y];

	    for (let x = 0; x < row.length; x++) {
	      const cell = row[x];
	      const lexicalNode = lexical.$getNearestNodeFromDOMNode(cell.elem);

	      if (lexicalNode !== null) {
	        cb(cell, lexicalNode, {
	          x,
	          y
	        });
	      }
	    }
	  }
	}
	function $addHighlightStyleToTable(editor, tableSelection) {
	  tableSelection.disableHighlightStyle();
	  $forEachGridCell(tableSelection.grid, cell => {
	    cell.highlighted = true;
	    $addHighlightToDOM(editor, cell);
	  });
	}
	function $removeHighlightStyleToTable(editor, tableSelection) {
	  tableSelection.enableHighlightStyle();
	  $forEachGridCell(tableSelection.grid, cell => {
	    const elem = cell.elem;
	    cell.highlighted = false;
	    $removeHighlightFromDOM(editor, cell);

	    if (!elem.getAttribute('style')) {
	      elem.removeAttribute('style');
	    }
	  });
	}

	const selectGridNodeInDirection = (tableSelection, tableNode, x, y, direction) => {
	  const isForward = direction === 'forward';

	  switch (direction) {
	    case 'backward':
	    case 'forward':
	      if (x !== (isForward ? tableSelection.grid.columns - 1 : 0)) {
	        selectTableCellNode(tableNode.getCellNodeFromCordsOrThrow(x + (isForward ? 1 : -1), y, tableSelection.grid), isForward);
	      } else {
	        if (y !== (isForward ? tableSelection.grid.rows - 1 : 0)) {
	          selectTableCellNode(tableNode.getCellNodeFromCordsOrThrow(isForward ? 0 : tableSelection.grid.columns - 1, y + (isForward ? 1 : -1), tableSelection.grid), isForward);
	        } else if (!isForward) {
	          tableNode.selectPrevious();
	        } else {
	          tableNode.selectNext();
	        }
	      }

	      return true;

	    case 'up':
	      if (y !== 0) {
	        selectTableCellNode(tableNode.getCellNodeFromCordsOrThrow(x, y - 1, tableSelection.grid), false);
	      } else {
	        tableNode.selectPrevious();
	      }

	      return true;

	    case 'down':
	      if (y !== tableSelection.grid.rows - 1) {
	        selectTableCellNode(tableNode.getCellNodeFromCordsOrThrow(x, y + 1, tableSelection.grid), true);
	      } else {
	        tableNode.selectNext();
	      }

	      return true;

	    default:
	      return false;
	  }
	};

	const adjustFocusNodeInDirection = (tableSelection, tableNode, x, y, direction) => {
	  const isForward = direction === 'forward';

	  switch (direction) {
	    case 'backward':
	    case 'forward':
	      if (x !== (isForward ? tableSelection.grid.columns - 1 : 0)) {
	        tableSelection.setFocusCellForSelection(tableNode.getCellFromCordsOrThrow(x + (isForward ? 1 : -1), y, tableSelection.grid));
	      }

	      return true;

	    case 'up':
	      if (y !== 0) {
	        tableSelection.setFocusCellForSelection(tableNode.getCellFromCordsOrThrow(x, y - 1, tableSelection.grid));
	        return true;
	      } else {
	        return false;
	      }

	    case 'down':
	      if (y !== tableSelection.grid.rows - 1) {
	        tableSelection.setFocusCellForSelection(tableNode.getCellFromCordsOrThrow(x, y + 1, tableSelection.grid));
	        return true;
	      } else {
	        return false;
	      }

	    default:
	      return false;
	  }
	};

	function $isSelectionInTable(selection, tableNode) {
	  if (lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection)) {
	    const isAnchorInside = tableNode.isParentOf(selection.anchor.getNode());
	    const isFocusInside = tableNode.isParentOf(selection.focus.getNode());
	    return isAnchorInside && isFocusInside;
	  }

	  return false;
	}

	function selectTableCellNode(tableCell, fromStart) {
	  if (fromStart) {
	    tableCell.selectStart();
	  } else {
	    tableCell.selectEnd();
	  }
	}

	const BROWSER_BLUE_RGB = '172,206,247';

	function $addHighlightToDOM(editor, cell) {
	  const element = cell.elem;
	  const node = lexical.$getNearestNodeFromDOMNode(element);

	  if (!$isTableCellNode(node)) {
	    throw Error(`Expected to find LexicalNode from Table Cell DOMNode`);
	  }

	  const backgroundColor = node.getBackgroundColor();

	  if (backgroundColor === null) {
	    element.style.setProperty('background-color', `rgb(${BROWSER_BLUE_RGB})`);
	  } else {
	    element.style.setProperty('background-image', `linear-gradient(to right, rgba(${BROWSER_BLUE_RGB},0.85), rgba(${BROWSER_BLUE_RGB},0.85))`);
	  }

	  element.style.setProperty('caret-color', 'transparent');
	}

	function $removeHighlightFromDOM(editor, cell) {
	  const element = cell.elem;
	  const node = lexical.$getNearestNodeFromDOMNode(element);

	  if (!$isTableCellNode(node)) {
	    throw Error(`Expected to find LexicalNode from Table Cell DOMNode`);
	  }

	  const backgroundColor = node.getBackgroundColor();

	  if (backgroundColor === null) {
	    element.style.removeProperty('background-color');
	  }

	  element.style.removeProperty('background-image');
	  element.style.removeProperty('caret-color');
	}

	function $findCellNode(node) {
	  const cellNode = utils.$findMatchingParent(node, $isTableCellNode);
	  return $isTableCellNode(cellNode) ? cellNode : null;
	}

	function $findTableNode(node) {
	  const tableNode = utils.$findMatchingParent(node, $isTableNode);
	  return $isTableNode(tableNode) ? tableNode : null;
	}

	function $handleArrowKey(editor, event, direction, tableNode, tableSelection) {
	  const selection = lexical.$getSelection();

	  if (!$isSelectionInTable(selection, tableNode)) {
	    return false;
	  }

	  if (lexical.$isRangeSelection(selection) && selection.isCollapsed()) {
	    // Horizontal move between cels seem to work well without interruption
	    // so just exit early, and handle vertical moves
	    if (direction === 'backward' || direction === 'forward') {
	      return false;
	    }

	    const {
	      anchor,
	      focus
	    } = selection;
	    const anchorCellNode = utils.$findMatchingParent(anchor.getNode(), $isTableCellNode);
	    const focusCellNode = utils.$findMatchingParent(focus.getNode(), $isTableCellNode);

	    if (!$isTableCellNode(anchorCellNode) || !anchorCellNode.is(focusCellNode)) {
	      return false;
	    }

	    const anchorCellDom = editor.getElementByKey(anchorCellNode.__key);
	    const anchorDOM = editor.getElementByKey(anchor.key);

	    if (anchorDOM == null || anchorCellDom == null) {
	      return false;
	    }

	    let edgeSelectionRect;

	    if (anchor.type === 'element') {
	      edgeSelectionRect = anchorDOM.getBoundingClientRect();
	    } else {
	      const domSelection = window.getSelection();

	      if (domSelection === null || domSelection.rangeCount === 0) {
	        return false;
	      }

	      const range = domSelection.getRangeAt(0);
	      edgeSelectionRect = range.getBoundingClientRect();
	    }

	    const edgeChild = direction === 'up' ? anchorCellNode.getFirstChild() : anchorCellNode.getLastChild();

	    if (edgeChild == null) {
	      return false;
	    }

	    const edgeChildDOM = editor.getElementByKey(edgeChild.__key);

	    if (edgeChildDOM == null) {
	      return false;
	    }

	    const edgeRect = edgeChildDOM.getBoundingClientRect();
	    const isExiting = direction === 'up' ? edgeRect.top > edgeSelectionRect.top - edgeSelectionRect.height : edgeSelectionRect.bottom + edgeSelectionRect.height > edgeRect.bottom;

	    if (isExiting) {
	      stopEvent(event);
	      const cords = tableNode.getCordsFromCellNode(anchorCellNode, tableSelection.grid);

	      if (event.shiftKey) {
	        const cell = tableNode.getCellFromCordsOrThrow(cords.x, cords.y, tableSelection.grid);
	        tableSelection.setAnchorCellForSelection(cell);
	        tableSelection.setFocusCellForSelection(cell, true);
	      } else {
	        return selectGridNodeInDirection(tableSelection, tableNode, cords.x, cords.y, direction);
	      }

	      return true;
	    }
	  } else if (lexical.DEPRECATED_$isGridSelection(selection)) {
	    const {
	      anchor,
	      focus
	    } = selection;
	    const anchorCellNode = utils.$findMatchingParent(anchor.getNode(), $isTableCellNode);
	    const focusCellNode = utils.$findMatchingParent(focus.getNode(), $isTableCellNode);

	    if (!$isTableCellNode(anchorCellNode) || !$isTableCellNode(focusCellNode)) {
	      return false;
	    }

	    stopEvent(event);

	    if (event.shiftKey) {
	      const cords = tableNode.getCordsFromCellNode(focusCellNode, tableSelection.grid);
	      return adjustFocusNodeInDirection(tableSelection, tableNode, cords.x, cords.y, direction);
	    } else {
	      focusCellNode.selectEnd();
	    }

	    return true;
	  }

	  return false;
	}

	function stopEvent(event) {
	  event.preventDefault();
	  event.stopImmediatePropagation();
	  event.stopPropagation();
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	/** @noInheritDoc */
	class TableNode extends lexical.DEPRECATED_GridNode {
	  /** @internal */
	  static getType() {
	    return 'table';
	  }

	  static clone(node) {
	    return new TableNode(node.__key);
	  }

	  static importDOM() {
	    return {
	      table: _node => ({
	        conversion: convertTableElement,
	        priority: 1
	      })
	    };
	  }

	  static importJSON(_serializedNode) {
	    return $createTableNode();
	  }

	  constructor(key) {
	    super(key);
	  }

	  exportJSON() {
	    return { ...super.exportJSON(),
	      type: 'table',
	      version: 1
	    };
	  }

	  createDOM(config, editor) {
	    const tableElement = document.createElement('table');
	    utils.addClassNamesToElement(tableElement, config.theme.table);
	    return tableElement;
	  }

	  updateDOM() {
	    return false;
	  }

	  exportDOM(editor) {
	    return { ...super.exportDOM(editor),
	      after: tableElement => {
	        if (tableElement) {
	          const newElement = tableElement.cloneNode();
	          const colGroup = document.createElement('colgroup');
	          const tBody = document.createElement('tbody');
	          tBody.append(...tableElement.children);
	          const firstRow = this.getFirstChildOrThrow();

	          if (!$isTableRowNode(firstRow)) {
	            throw new Error('Expected to find row node.');
	          }

	          const colCount = firstRow.getChildrenSize();

	          for (let i = 0; i < colCount; i++) {
	            const col = document.createElement('col');
	            colGroup.append(col);
	          }

	          newElement.replaceChildren(colGroup, tBody);
	          return newElement;
	        }
	      }
	    };
	  } // TODO 0.10 deprecate


	  canExtractContents() {
	    return false;
	  }

	  canBeEmpty() {
	    return false;
	  }

	  isShadowRoot() {
	    return true;
	  }

	  getCordsFromCellNode(tableCellNode, grid) {
	    const {
	      rows,
	      cells
	    } = grid;

	    for (let y = 0; y < rows; y++) {
	      const row = cells[y];

	      if (row == null) {
	        throw new Error(`Row not found at y:${y}`);
	      }

	      const x = row.findIndex(({
	        elem
	      }) => {
	        const cellNode = lexical.$getNearestNodeFromDOMNode(elem);
	        return cellNode === tableCellNode;
	      });

	      if (x !== -1) {
	        return {
	          x,
	          y
	        };
	      }
	    }

	    throw new Error('Cell not found in table.');
	  }

	  getCellFromCords(x, y, grid) {
	    const {
	      cells
	    } = grid;
	    const row = cells[y];

	    if (row == null) {
	      return null;
	    }

	    const cell = row[x];

	    if (cell == null) {
	      return null;
	    }

	    return cell;
	  }

	  getCellFromCordsOrThrow(x, y, grid) {
	    const cell = this.getCellFromCords(x, y, grid);

	    if (!cell) {
	      throw new Error('Cell not found at cords.');
	    }

	    return cell;
	  }

	  getCellNodeFromCords(x, y, grid) {
	    const cell = this.getCellFromCords(x, y, grid);

	    if (cell == null) {
	      return null;
	    }

	    const node = lexical.$getNearestNodeFromDOMNode(cell.elem);

	    if ($isTableCellNode(node)) {
	      return node;
	    }

	    return null;
	  }

	  getCellNodeFromCordsOrThrow(x, y, grid) {
	    const node = this.getCellNodeFromCords(x, y, grid);

	    if (!node) {
	      throw new Error('Node at cords not TableCellNode.');
	    }

	    return node;
	  }

	  canSelectBefore() {
	    return true;
	  }

	  canIndent() {
	    return false;
	  }

	}
	function $getElementGridForTableNode(editor, tableNode) {
	  const tableElement = editor.getElementByKey(tableNode.getKey());

	  if (tableElement == null) {
	    throw new Error('Table Element Not Found');
	  }

	  return getTableGrid(tableElement);
	}
	function convertTableElement(_domNode) {
	  return {
	    node: $createTableNode()
	  };
	}
	function $createTableNode() {
	  return lexical.$applyNodeReplacement(new TableNode());
	}
	function $isTableNode(node) {
	  return node instanceof TableNode;
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	function $createTableNodeWithDimensions(rowCount, columnCount, includeHeaders = true) {
	  const tableNode = $createTableNode();

	  for (let iRow = 0; iRow < rowCount; iRow++) {
	    const tableRowNode = $createTableRowNode();

	    for (let iColumn = 0; iColumn < columnCount; iColumn++) {
	      let headerState = TableCellHeaderStates.NO_STATUS;

	      if (typeof includeHeaders === 'object') {
	        if (iRow === 0 && includeHeaders.rows) headerState |= TableCellHeaderStates.ROW;
	        if (iColumn === 0 && includeHeaders.columns) headerState |= TableCellHeaderStates.COLUMN;
	      } else if (includeHeaders) {
	        if (iRow === 0) headerState |= TableCellHeaderStates.ROW;
	        if (iColumn === 0) headerState |= TableCellHeaderStates.COLUMN;
	      }

	      const tableCellNode = $createTableCellNode(headerState);
	      const paragraphNode = lexical.$createParagraphNode();
	      paragraphNode.append(lexical.$createTextNode());
	      tableCellNode.append(paragraphNode);
	      tableRowNode.append(tableCellNode);
	    }

	    tableNode.append(tableRowNode);
	  }

	  return tableNode;
	}
	function $getTableCellNodeFromLexicalNode(startingNode) {
	  const node = utils.$findMatchingParent(startingNode, n => $isTableCellNode(n));

	  if ($isTableCellNode(node)) {
	    return node;
	  }

	  return null;
	}
	function $getTableRowNodeFromTableCellNodeOrThrow(startingNode) {
	  const node = utils.$findMatchingParent(startingNode, n => $isTableRowNode(n));

	  if ($isTableRowNode(node)) {
	    return node;
	  }

	  throw new Error('Expected table cell to be inside of table row.');
	}
	function $getTableNodeFromLexicalNodeOrThrow(startingNode) {
	  const node = utils.$findMatchingParent(startingNode, n => $isTableNode(n));

	  if ($isTableNode(node)) {
	    return node;
	  }

	  throw new Error('Expected table cell to be inside of table.');
	}
	function $getTableRowIndexFromTableCellNode(tableCellNode) {
	  const tableRowNode = $getTableRowNodeFromTableCellNodeOrThrow(tableCellNode);
	  const tableNode = $getTableNodeFromLexicalNodeOrThrow(tableRowNode);
	  return tableNode.getChildren().findIndex(n => n.is(tableRowNode));
	}
	function $getTableColumnIndexFromTableCellNode(tableCellNode) {
	  const tableRowNode = $getTableRowNodeFromTableCellNodeOrThrow(tableCellNode);
	  return tableRowNode.getChildren().findIndex(n => n.is(tableCellNode));
	}
	function $getTableCellSiblingsFromTableCellNode(tableCellNode, grid) {
	  const tableNode = $getTableNodeFromLexicalNodeOrThrow(tableCellNode);
	  const {
	    x,
	    y
	  } = tableNode.getCordsFromCellNode(tableCellNode, grid);
	  return {
	    above: tableNode.getCellNodeFromCords(x, y - 1, grid),
	    below: tableNode.getCellNodeFromCords(x, y + 1, grid),
	    left: tableNode.getCellNodeFromCords(x - 1, y, grid),
	    right: tableNode.getCellNodeFromCords(x + 1, y, grid)
	  };
	}
	function $removeTableRowAtIndex(tableNode, indexToDelete) {
	  const tableRows = tableNode.getChildren();

	  if (indexToDelete >= tableRows.length || indexToDelete < 0) {
	    throw new Error('Expected table cell to be inside of table row.');
	  }

	  const targetRowNode = tableRows[indexToDelete];
	  targetRowNode.remove();
	  return tableNode;
	}
	function $insertTableRow(tableNode, targetIndex, shouldInsertAfter = true, rowCount, grid) {
	  const tableRows = tableNode.getChildren();

	  if (targetIndex >= tableRows.length || targetIndex < 0) {
	    throw new Error('Table row target index out of range');
	  }

	  const targetRowNode = tableRows[targetIndex];

	  if ($isTableRowNode(targetRowNode)) {
	    for (let r = 0; r < rowCount; r++) {
	      const tableRowCells = targetRowNode.getChildren();
	      const tableColumnCount = tableRowCells.length;
	      const newTableRowNode = $createTableRowNode();

	      for (let c = 0; c < tableColumnCount; c++) {
	        const tableCellFromTargetRow = tableRowCells[c];

	        if (!$isTableCellNode(tableCellFromTargetRow)) {
	          throw Error(`Expected table cell`);
	        }

	        const {
	          above,
	          below
	        } = $getTableCellSiblingsFromTableCellNode(tableCellFromTargetRow, grid);
	        let headerState = TableCellHeaderStates.NO_STATUS;
	        const width = above && above.getWidth() || below && below.getWidth() || undefined;

	        if (above && above.hasHeaderState(TableCellHeaderStates.COLUMN) || below && below.hasHeaderState(TableCellHeaderStates.COLUMN)) {
	          headerState |= TableCellHeaderStates.COLUMN;
	        }

	        const tableCellNode = $createTableCellNode(headerState, 1, width);
	        tableCellNode.append(lexical.$createParagraphNode());
	        newTableRowNode.append(tableCellNode);
	      }

	      if (shouldInsertAfter) {
	        targetRowNode.insertAfter(newTableRowNode);
	      } else {
	        targetRowNode.insertBefore(newTableRowNode);
	      }
	    }
	  } else {
	    throw new Error('Row before insertion index does not exist.');
	  }

	  return tableNode;
	}
	function $insertTableRow__EXPERIMENTAL(insertAfter = true) {
	  const selection = lexical.$getSelection();

	  if (!(lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    throw Error(`Expected a RangeSelection or GridSelection`);
	  }

	  const focus = selection.focus.getNode();
	  const [focusCell,, grid] = lexical.DEPRECATED_$getNodeTriplet(focus);
	  const [gridMap, focusCellMap] = lexical.DEPRECATED_$computeGridMap(grid, focusCell, focusCell);
	  const columnCount = gridMap[0].length;
	  const {
	    startRow: focusStartRow
	  } = focusCellMap;

	  if (insertAfter) {
	    const focusEndRow = focusStartRow + focusCell.__rowSpan - 1;
	    const focusEndRowMap = gridMap[focusEndRow];
	    const newRow = $createTableRowNode();

	    for (let i = 0; i < columnCount; i++) {
	      const {
	        cell,
	        startRow
	      } = focusEndRowMap[i];

	      if (startRow + cell.__rowSpan - 1 <= focusEndRow) {
	        newRow.append($createTableCellNode(TableCellHeaderStates.NO_STATUS));
	      } else {
	        cell.setRowSpan(cell.__rowSpan + 1);
	      }
	    }

	    const focusEndRowNode = grid.getChildAtIndex(focusEndRow);

	    if (!lexical.DEPRECATED_$isGridRowNode(focusEndRowNode)) {
	      throw Error(`focusEndRow is not a GridRowNode`);
	    }

	    focusEndRowNode.insertAfter(newRow);
	  } else {
	    const focusStartRowMap = gridMap[focusStartRow];
	    const newRow = $createTableRowNode();

	    for (let i = 0; i < columnCount; i++) {
	      const {
	        cell,
	        startRow
	      } = focusStartRowMap[i];

	      if (startRow === focusStartRow) {
	        newRow.append($createTableCellNode(TableCellHeaderStates.NO_STATUS));
	      } else {
	        cell.setRowSpan(cell.__rowSpan + 1);
	      }
	    }

	    const focusStartRowNode = grid.getChildAtIndex(focusStartRow);

	    if (!lexical.DEPRECATED_$isGridRowNode(focusStartRowNode)) {
	      throw Error(`focusEndRow is not a GridRowNode`);
	    }

	    focusStartRowNode.insertBefore(newRow);
	  }
	}
	function $insertTableColumn(tableNode, targetIndex, shouldInsertAfter = true, columnCount, grid) {
	  const tableRows = tableNode.getChildren();

	  for (let r = 0; r < tableRows.length; r++) {
	    const currentTableRowNode = tableRows[r];

	    if ($isTableRowNode(currentTableRowNode)) {
	      for (let c = 0; c < columnCount; c++) {
	        const tableRowChildren = currentTableRowNode.getChildren();

	        if (targetIndex >= tableRowChildren.length || targetIndex < 0) {
	          throw new Error('Table column target index out of range');
	        }

	        const targetCell = tableRowChildren[targetIndex];

	        if (!$isTableCellNode(targetCell)) {
	          throw Error(`Expected table cell`);
	        }

	        const {
	          left,
	          right
	        } = $getTableCellSiblingsFromTableCellNode(targetCell, grid);
	        let headerState = TableCellHeaderStates.NO_STATUS;

	        if (left && left.hasHeaderState(TableCellHeaderStates.ROW) || right && right.hasHeaderState(TableCellHeaderStates.ROW)) {
	          headerState |= TableCellHeaderStates.ROW;
	        }

	        const newTableCell = $createTableCellNode(headerState);
	        newTableCell.append(lexical.$createParagraphNode());

	        if (shouldInsertAfter) {
	          targetCell.insertAfter(newTableCell);
	        } else {
	          targetCell.insertBefore(newTableCell);
	        }
	      }
	    }
	  }

	  return tableNode;
	}
	function $insertTableColumn__EXPERIMENTAL(insertAfter = true) {
	  const selection = lexical.$getSelection();

	  if (!(lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    throw Error(`Expected a RangeSelection or GridSelection`);
	  }

	  const anchor = selection.anchor.getNode();
	  const focus = selection.focus.getNode();
	  const [anchorCell] = lexical.DEPRECATED_$getNodeTriplet(anchor);
	  const [focusCell,, grid] = lexical.DEPRECATED_$getNodeTriplet(focus);
	  const [gridMap, focusCellMap, anchorCellMap] = lexical.DEPRECATED_$computeGridMap(grid, focusCell, anchorCell);
	  const rowCount = gridMap.length;
	  const startColumn = insertAfter ? Math.max(focusCellMap.startColumn, anchorCellMap.startColumn) : Math.min(focusCellMap.startColumn, anchorCellMap.startColumn);
	  const insertAfterColumn = insertAfter ? startColumn + focusCell.__colSpan - 1 : startColumn - 1;
	  const gridFirstChild = grid.getFirstChild();

	  if (!lexical.DEPRECATED_$isGridRowNode(gridFirstChild)) {
	    throw Error(`Expected firstTable child to be a row`);
	  }

	  let firstInsertedCell = null;

	  function $createTableCellNodeForInsertTableColumn() {
	    const cell = $createTableCellNode(TableCellHeaderStates.NO_STATUS).append(lexical.$createParagraphNode());

	    if (firstInsertedCell === null) {
	      firstInsertedCell = cell;
	    }

	    return cell;
	  }

	  let loopRow = gridFirstChild;

	  rowLoop: for (let i = 0; i < rowCount; i++) {
	    if (i !== 0) {
	      const currentRow = loopRow.getNextSibling();

	      if (!lexical.DEPRECATED_$isGridRowNode(currentRow)) {
	        throw Error(`Expected row nextSibling to be a row`);
	      }

	      loopRow = currentRow;
	    }

	    const rowMap = gridMap[i];

	    if (insertAfterColumn < 0) {
	      $insertFirst(loopRow, $createTableCellNodeForInsertTableColumn());
	      continue;
	    }

	    const {
	      cell: currentCell,
	      startColumn: currentStartColumn,
	      startRow: currentStartRow
	    } = rowMap[insertAfterColumn];

	    if (currentStartColumn + currentCell.__colSpan - 1 <= insertAfterColumn) {
	      let insertAfterCell = currentCell;
	      let insertAfterCellRowStart = currentStartRow;
	      let prevCellIndex = insertAfterColumn;

	      while (insertAfterCellRowStart !== i && insertAfterCell.__rowSpan > 1) {
	        prevCellIndex -= currentCell.__colSpan;

	        if (prevCellIndex >= 0) {
	          const {
	            cell: cell_,
	            startRow: startRow_
	          } = rowMap[prevCellIndex];
	          insertAfterCell = cell_;
	          insertAfterCellRowStart = startRow_;
	        } else {
	          loopRow.append($createTableCellNodeForInsertTableColumn());
	          continue rowLoop;
	        }
	      }

	      insertAfterCell.insertAfter($createTableCellNodeForInsertTableColumn());
	    } else {
	      currentCell.setColSpan(currentCell.__colSpan + 1);
	    }
	  }

	  if (firstInsertedCell !== null) {
	    $moveSelectionToCell(firstInsertedCell);
	  }
	}
	function $deleteTableColumn(tableNode, targetIndex) {
	  const tableRows = tableNode.getChildren();

	  for (let i = 0; i < tableRows.length; i++) {
	    const currentTableRowNode = tableRows[i];

	    if ($isTableRowNode(currentTableRowNode)) {
	      const tableRowChildren = currentTableRowNode.getChildren();

	      if (targetIndex >= tableRowChildren.length || targetIndex < 0) {
	        throw new Error('Table column target index out of range');
	      }

	      tableRowChildren[targetIndex].remove();
	    }
	  }

	  return tableNode;
	}
	function $deleteTableRow__EXPERIMENTAL() {
	  const selection = lexical.$getSelection();

	  if (!(lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    throw Error(`Expected a RangeSelection or GridSelection`);
	  }

	  const anchor = selection.anchor.getNode();
	  const focus = selection.focus.getNode();
	  const [anchorCell,, grid] = lexical.DEPRECATED_$getNodeTriplet(anchor);
	  const [focusCell] = lexical.DEPRECATED_$getNodeTriplet(focus);
	  const [gridMap, anchorCellMap, focusCellMap] = lexical.DEPRECATED_$computeGridMap(grid, anchorCell, focusCell);
	  const {
	    startRow: anchorStartRow
	  } = anchorCellMap;
	  const {
	    startRow: focusStartRow
	  } = focusCellMap;
	  const focusEndRow = focusStartRow + focusCell.__rowSpan - 1;

	  if (gridMap.length === focusEndRow - anchorStartRow + 1) {
	    // Empty grid
	    grid.remove();
	    return;
	  }

	  const columnCount = gridMap[0].length;
	  const nextRow = gridMap[focusEndRow + 1];
	  const nextRowNode = grid.getChildAtIndex(focusEndRow + 1);

	  for (let row = focusEndRow; row >= anchorStartRow; row--) {
	    for (let column = columnCount - 1; column >= 0; column--) {
	      const {
	        cell,
	        startRow: cellStartRow,
	        startColumn: cellStartColumn
	      } = gridMap[row][column];

	      if (cellStartColumn !== column) {
	        // Don't repeat work for the same Cell
	        continue;
	      } // Rows overflowing top have to be trimmed


	      if (row === anchorStartRow && cellStartRow < anchorStartRow) {
	        cell.setRowSpan(cell.__rowSpan - (cellStartRow - anchorStartRow));
	      } // Rows overflowing bottom have to be trimmed and moved to the next row


	      if (cellStartRow >= anchorStartRow && cellStartRow + cell.__rowSpan - 1 > focusEndRow) {
	        cell.setRowSpan(cell.__rowSpan - (focusEndRow - cellStartRow + 1));

	        if (!(nextRowNode !== null)) {
	          throw Error(`Expected nextRowNode not to be null`);
	        }

	        if (column === 0) {
	          $insertFirst(nextRowNode, cell);
	        } else {
	          const {
	            cell: previousCell
	          } = nextRow[column - 1];
	          previousCell.insertAfter(cell);
	        }
	      }
	    }

	    const rowNode = grid.getChildAtIndex(row);

	    if (!lexical.DEPRECATED_$isGridRowNode(rowNode)) {
	      throw Error(`Expected GridNode childAtIndex(${String(row)}) to be RowNode`);
	    }

	    rowNode.remove();
	  }

	  if (nextRow !== undefined) {
	    const {
	      cell
	    } = nextRow[0];
	    $moveSelectionToCell(cell);
	  } else {
	    const previousRow = gridMap[anchorStartRow - 1];
	    const {
	      cell
	    } = previousRow[0];
	    $moveSelectionToCell(cell);
	  }
	}
	function $deleteTableColumn__EXPERIMENTAL() {
	  const selection = lexical.$getSelection();

	  if (!(lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    throw Error(`Expected a RangeSelection or GridSelection`);
	  }

	  const anchor = selection.anchor.getNode();
	  const focus = selection.focus.getNode();
	  const [anchorCell,, grid] = lexical.DEPRECATED_$getNodeTriplet(anchor);
	  const [focusCell] = lexical.DEPRECATED_$getNodeTriplet(focus);
	  const [gridMap, anchorCellMap, focusCellMap] = lexical.DEPRECATED_$computeGridMap(grid, anchorCell, focusCell);
	  const {
	    startColumn: anchorStartColumn
	  } = anchorCellMap;
	  const {
	    startRow: focusStartRow,
	    startColumn: focusStartColumn
	  } = focusCellMap;
	  const startColumn = Math.min(anchorStartColumn, focusStartColumn);
	  const endColumn = Math.max(anchorStartColumn + anchorCell.__colSpan - 1, focusStartColumn + focusCell.__colSpan - 1);
	  const selectedColumnCount = endColumn - startColumn + 1;
	  const columnCount = gridMap[0].length;

	  if (columnCount === endColumn - startColumn + 1) {
	    // Empty grid
	    grid.selectPrevious();
	    grid.remove();
	    return;
	  }

	  const rowCount = gridMap.length;

	  for (let row = 0; row < rowCount; row++) {
	    for (let column = startColumn; column <= endColumn; column++) {
	      const {
	        cell,
	        startColumn: cellStartColumn
	      } = gridMap[row][column];

	      if (cellStartColumn < startColumn) {
	        if (column === startColumn) {
	          const overflowLeft = startColumn - cellStartColumn; // Overflowing left

	          cell.setColSpan(cell.__colSpan - // Possible overflow right too
	          Math.min(selectedColumnCount, cell.__colSpan - overflowLeft));
	        }
	      } else if (cellStartColumn + cell.__colSpan - 1 > endColumn) {
	        if (column === endColumn) {
	          // Overflowing right
	          const inSelectedArea = endColumn - cellStartColumn + 1;
	          cell.setColSpan(cell.__colSpan - inSelectedArea);
	        }
	      } else {
	        cell.remove();
	      }
	    }
	  }

	  const focusRowMap = gridMap[focusStartRow];
	  const nextColumn = focusRowMap[focusStartColumn + focusCell.__colSpan];

	  if (nextColumn !== undefined) {
	    const {
	      cell
	    } = nextColumn;
	    $moveSelectionToCell(cell);
	  } else {
	    const previousRow = focusRowMap[focusStartColumn - 1];
	    const {
	      cell
	    } = previousRow;
	    $moveSelectionToCell(cell);
	  }
	}

	function $moveSelectionToCell(cell) {
	  const firstDescendant = cell.getFirstDescendant();

	  if (!(firstDescendant !== null)) {
	    throw Error(`Unexpected empty cell`);
	  }

	  firstDescendant.getParentOrThrow().selectStart();
	}

	function $insertFirst(parent, node) {
	  const firstChild = parent.getFirstChild();

	  if (firstChild !== null) {
	    firstChild.insertBefore(node);
	  } else {
	    parent.append(node);
	  }
	}

	function $unmergeCell() {
	  const selection = lexical.$getSelection();

	  if (!(lexical.$isRangeSelection(selection) || lexical.DEPRECATED_$isGridSelection(selection))) {
	    throw Error(`Expected a RangeSelection or GridSelection`);
	  }

	  const anchor = selection.anchor.getNode();
	  const [cell, row, grid] = lexical.DEPRECATED_$getNodeTriplet(anchor);
	  const colSpan = cell.__colSpan;
	  const rowSpan = cell.__rowSpan;

	  if (colSpan > 1) {
	    for (let i = 1; i < colSpan; i++) {
	      cell.insertAfter($createTableCellNode(TableCellHeaderStates.NO_STATUS));
	    }

	    cell.setColSpan(1);
	  }

	  if (rowSpan > 1) {
	    const [map, cellMap] = lexical.DEPRECATED_$computeGridMap(grid, cell, cell);
	    const {
	      startColumn,
	      startRow
	    } = cellMap;
	    let currentRowNode;

	    for (let i = 1; i < rowSpan; i++) {
	      const currentRow = startRow + i;
	      const currentRowMap = map[currentRow];
	      currentRowNode = row.getNextSibling();

	      if (!lexical.DEPRECATED_$isGridRowNode(currentRowNode)) {
	        throw Error(`Expected row next sibling to be a row`);
	      }

	      let insertAfterCell = null;

	      for (let column = 0; column < startColumn; column++) {
	        const currentCellMap = currentRowMap[column];
	        const currentCell = currentCellMap.cell;

	        if (currentCellMap.startRow === currentRow) {
	          insertAfterCell = currentCell;
	        }

	        if (currentCell.__colSpan > 1) {
	          column += currentCell.__colSpan - 1;
	        }
	      }

	      if (insertAfterCell === null) {
	        for (let j = 0; j < colSpan; j++) {
	          $insertFirst(currentRowNode, $createTableCellNode(TableCellHeaderStates.NO_STATUS));
	        }
	      } else {
	        for (let j = 0; j < colSpan; j++) {
	          insertAfterCell.insertAfter($createTableCellNode(TableCellHeaderStates.NO_STATUS));
	        }
	      }
	    }

	    cell.setRowSpan(1);
	  }
	}

	/** @module @lexical/table */
	const INSERT_TABLE_COMMAND = lexical.createCommand('INSERT_TABLE_COMMAND');

	LexicalTable_dev.$createTableCellNode = $createTableCellNode;
	LexicalTable_dev.$createTableNode = $createTableNode;
	LexicalTable_dev.$createTableNodeWithDimensions = $createTableNodeWithDimensions;
	LexicalTable_dev.$createTableRowNode = $createTableRowNode;
	LexicalTable_dev.$deleteTableColumn = $deleteTableColumn;
	LexicalTable_dev.$deleteTableColumn__EXPERIMENTAL = $deleteTableColumn__EXPERIMENTAL;
	LexicalTable_dev.$deleteTableRow__EXPERIMENTAL = $deleteTableRow__EXPERIMENTAL;
	LexicalTable_dev.$getElementGridForTableNode = $getElementGridForTableNode;
	LexicalTable_dev.$getTableCellNodeFromLexicalNode = $getTableCellNodeFromLexicalNode;
	LexicalTable_dev.$getTableColumnIndexFromTableCellNode = $getTableColumnIndexFromTableCellNode;
	LexicalTable_dev.$getTableNodeFromLexicalNodeOrThrow = $getTableNodeFromLexicalNodeOrThrow;
	LexicalTable_dev.$getTableRowIndexFromTableCellNode = $getTableRowIndexFromTableCellNode;
	LexicalTable_dev.$getTableRowNodeFromTableCellNodeOrThrow = $getTableRowNodeFromTableCellNodeOrThrow;
	LexicalTable_dev.$insertTableColumn = $insertTableColumn;
	LexicalTable_dev.$insertTableColumn__EXPERIMENTAL = $insertTableColumn__EXPERIMENTAL;
	LexicalTable_dev.$insertTableRow = $insertTableRow;
	LexicalTable_dev.$insertTableRow__EXPERIMENTAL = $insertTableRow__EXPERIMENTAL;
	LexicalTable_dev.$isTableCellNode = $isTableCellNode;
	LexicalTable_dev.$isTableNode = $isTableNode;
	LexicalTable_dev.$isTableRowNode = $isTableRowNode;
	LexicalTable_dev.$removeTableRowAtIndex = $removeTableRowAtIndex;
	LexicalTable_dev.$unmergeCell = $unmergeCell;
	LexicalTable_dev.INSERT_TABLE_COMMAND = INSERT_TABLE_COMMAND;
	LexicalTable_dev.TableCellHeaderStates = TableCellHeaderStates;
	LexicalTable_dev.TableCellNode = TableCellNode;
	LexicalTable_dev.TableNode = TableNode;
	LexicalTable_dev.TableRowNode = TableRowNode;
	LexicalTable_dev.TableSelection = TableSelection;
	LexicalTable_dev.applyTableHandlers = applyTableHandlers;
	LexicalTable_dev.getCellFromTarget = getCellFromTarget;
	LexicalTable_dev.getTableSelectionFromTableElement = getTableSelectionFromTableElement;
	return LexicalTable_dev;
}

var LexicalTable_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalTable_prod;

function requireLexicalTable_prod () {
	if (hasRequiredLexicalTable_prod) return LexicalTable_prod;
	hasRequiredLexicalTable_prod = 1;
var d=require$$0__default["default"],t=LexicalUtils_1;let w=/^(\d+(?:\.\d+)?)px$/,x={BOTH:3,COLUMN:2,NO_STATUS:0,ROW:1};
	class y extends d.DEPRECATED_GridCellNode{static getType(){return "tablecell"}static clone(a){let b=new y(a.__headerState,a.__colSpan,a.__width,a.__key);b.__rowSpan=a.__rowSpan;b.__backgroundColor=a.__backgroundColor;return b}static importDOM(){return {td:()=>({conversion:z,priority:0}),th:()=>({conversion:z,priority:0})}}static importJSON(a){let b=a.rowSpan||1,c=B(a.headerState,a.colSpan||1,a.width||void 0);c.__rowSpan=b;c.__backgroundColor=a.backgroundColor||null;return c}constructor(a=x.NO_STATUS,
	b=1,c,e){super(b,e);this.__headerState=a;this.__width=c;this.__backgroundColor=null;}createDOM(a){let b=document.createElement(this.getTag());this.__width&&(b.style.width=`${this.__width}px`);1<this.__colSpan&&(b.colSpan=this.__colSpan);1<this.__rowSpan&&(b.rowSpan=this.__rowSpan);null!==this.__backgroundColor&&(b.style.backgroundColor=this.__backgroundColor);t.addClassNamesToElement(b,a.theme.tableCell,this.hasHeader()&&a.theme.tableCellHeader);return b}exportDOM(a){({element:a}=super.exportDOM(a));
	if(a){var b=this.getParentOrThrow().getChildrenSize();a.style.border="1px solid black";1<this.__colSpan&&(a.colSpan=this.__colSpan);1<this.__rowSpan&&(a.rowSpan=this.__rowSpan);a.style.width=`${this.getWidth()||Math.max(90,700/b)}px`;a.style.verticalAlign="top";a.style.textAlign="start";b=this.getBackgroundColor();null!==b?a.style.backgroundColor=b:this.hasHeader()&&(a.style.backgroundColor="#f2f3f5");}return {element:a}}exportJSON(){return {...super.exportJSON(),backgroundColor:this.getBackgroundColor(),
	headerState:this.__headerState,type:"tablecell",width:this.getWidth()}}getTag(){return this.hasHeader()?"th":"td"}setHeaderStyles(a){this.getWritable().__headerState=a;return this.__headerState}getHeaderStyles(){return this.getLatest().__headerState}setWidth(a){this.getWritable().__width=a;return this.__width}getWidth(){return this.getLatest().__width}getBackgroundColor(){return this.getLatest().__backgroundColor}setBackgroundColor(a){this.getWritable().__backgroundColor=a;}toggleHeaderStyle(a){let b=
	this.getWritable();b.__headerState=(b.__headerState&a)===a?b.__headerState-a:b.__headerState+a;return b}hasHeaderState(a){return (this.getHeaderStyles()&a)===a}hasHeader(){return this.getLatest().__headerState!==x.NO_STATUS}updateDOM(a){return a.__headerState!==this.__headerState||a.__width!==this.__width||a.__colSpan!==this.__colSpan||a.__rowSpan!==this.__rowSpan||a.__backgroundColor!==this.__backgroundColor}isShadowRoot(){return !0}collapseAtStart(){return !0}canBeEmpty(){return !1}canIndent(){return !1}}
	function z(a){var b=a.nodeName.toLowerCase();let c=void 0;w.test(a.style.width)&&(c=parseFloat(a.style.width));b=B("th"===b?x.ROW:x.NO_STATUS,a.colSpan,c);b.__rowSpan=a.rowSpan;a=a.style.backgroundColor;""!==a&&(b.__backgroundColor=a);return {forChild:(e,g)=>{if(C(g)&&!d.$isElementNode(e)){g=d.$createParagraphNode();if(d.$isLineBreakNode(e)&&"\n"===e.getTextContent())return null;g.append(e);return g}return e},node:b}}function B(a,b=1,c){return d.$applyNodeReplacement(new y(a,b,c))}
	function C(a){return a instanceof y}
	class D extends d.DEPRECATED_GridRowNode{static getType(){return "tablerow"}static clone(a){return new D(a.__height,a.__key)}static importDOM(){return {tr:()=>({conversion:aa,priority:0})}}static importJSON(a){return E(a.height)}constructor(a,b){super(b);this.__height=a;}exportJSON(){return {...super.exportJSON(),type:"tablerow",version:1}}createDOM(a){let b=document.createElement("tr");this.__height&&(b.style.height=`${this.__height}px`);t.addClassNamesToElement(b,a.theme.tableRow);return b}isShadowRoot(){return !0}setHeight(a){this.getWritable().__height=
	a;return this.__height}getHeight(){return this.getLatest().__height}updateDOM(a){return a.__height!==this.__height}canBeEmpty(){return !1}canIndent(){return !1}}function aa(a){let b=void 0;w.test(a.style.height)&&(b=parseFloat(a.style.height));return {node:E(b)}}function E(a){return d.$applyNodeReplacement(new D(a))}function F(a){return a instanceof D}
	function G(a){let b=new URLSearchParams;b.append("code",a);for(let c=1;c<arguments.length;c++)b.append("v",arguments[c]);throw Error(`Minified Lexical error #${a}; visit https://lexical.dev/docs/error?${b} for the full message or `+"use the non-minified dev environment for full errors and additional helpful warnings.");}let ba="undefined"!==typeof window&&"undefined"!==typeof window.document&&"undefined"!==typeof window.document.createElement;
	class I{constructor(a,b){this.isHighlightingCells=!1;this.focusY=this.focusX=this.anchorY=this.anchorX=-1;this.listenersToRemove=new Set;this.tableNodeKey=b;this.editor=a;this.grid={cells:[],columns:0,rows:0};this.focusCell=this.anchorCell=this.focusCellNodeKey=this.anchorCellNodeKey=this.gridSelection=null;this.hasHijackedSelectionStyles=!1;this.trackTableGrid();}getGrid(){return this.grid}removeListeners(){Array.from(this.listenersToRemove).forEach(a=>a());}trackTableGrid(){let a=new MutationObserver(b=>
	{this.editor.update(()=>{var c=!1;for(let e=0;e<b.length;e++){const g=b[e].target.nodeName;if("TABLE"===g||"TR"===g){c=!0;break}}if(c){c=this.editor.getElementByKey(this.tableNodeKey);if(!c)throw Error("Expected to find TableElement in DOM");this.grid=J(c);}});});this.editor.update(()=>{let b=this.editor.getElementByKey(this.tableNodeKey);if(!b)throw Error("Expected to find TableElement in DOM");this.grid=J(b);a.observe(b,{childList:!0,subtree:!0});});}clearHighlight(){let a=this.editor;this.isHighlightingCells=
	!1;this.focusY=this.focusX=this.anchorY=this.anchorX=-1;this.focusCell=this.anchorCell=this.focusCellNodeKey=this.anchorCellNodeKey=this.gridSelection=null;this.hasHijackedSelectionStyles=!1;this.enableHighlightStyle();a.update(()=>{var b=d.$getNodeByKey(this.tableNodeKey);if(!K(b))throw Error("Expected TableNode.");b=a.getElementByKey(this.tableNodeKey);if(!b)throw Error("Expected to find TableElement in DOM");b=J(b);L(a,b,null);d.$setSelection(null);a.dispatchCommand(d.SELECTION_CHANGE_COMMAND,
	void 0);});}enableHighlightStyle(){let a=this.editor;a.update(()=>{let b=a.getElementByKey(this.tableNodeKey);if(!b)throw Error("Expected to find TableElement in DOM");t.removeClassNamesFromElement(b,a._config.theme.tableSelection);b.classList.remove("disable-selection");this.hasHijackedSelectionStyles=!1;});}disableHighlightStyle(){let a=this.editor;a.update(()=>{let b=a.getElementByKey(this.tableNodeKey);if(!b)throw Error("Expected to find TableElement in DOM");t.addClassNamesToElement(b,a._config.theme.tableSelection);
	this.hasHijackedSelectionStyles=!0;});}updateTableGridSelection(a){if(null!=a&&a.gridKey===this.tableNodeKey){let b=this.editor;this.gridSelection=a;this.isHighlightingCells=!0;this.disableHighlightStyle();L(b,this.grid,this.gridSelection);}else null==a&&this.clearHighlight();}setFocusCellForSelection(a,b=!1){let c=this.editor;c.update(()=>{var e=d.$getNodeByKey(this.tableNodeKey);if(!K(e))throw Error("Expected TableNode.");if(!c.getElementByKey(this.tableNodeKey))throw Error("Expected to find TableElement in DOM");
	e=a.x;let g=a.y;this.focusCell=a;if(null!==this.anchorCell){let h=ba?(c._window||window).getSelection():null;h&&h.setBaseAndExtent(this.anchorCell.elem,0,this.focusCell.elem,0);}if(!this.isHighlightingCells&&(this.anchorX!==e||this.anchorY!==g||b))this.isHighlightingCells=!0,this.disableHighlightStyle();else if(e===this.focusX&&g===this.focusY)return;this.focusX=e;this.focusY=g;this.isHighlightingCells&&(e=d.$getNearestNodeFromDOMNode(a.elem),null!=this.gridSelection&&null!=this.anchorCellNodeKey&&
	C(e)&&(e=e.getKey(),this.gridSelection=this.gridSelection.clone()||d.DEPRECATED_$createGridSelection(),this.focusCellNodeKey=e,this.gridSelection.set(this.tableNodeKey,this.anchorCellNodeKey,this.focusCellNodeKey),d.$setSelection(this.gridSelection),c.dispatchCommand(d.SELECTION_CHANGE_COMMAND,void 0),L(c,this.grid,this.gridSelection)));});}setAnchorCellForSelection(a){this.isHighlightingCells=!1;this.anchorCell=a;this.anchorX=a.x;this.anchorY=a.y;this.editor.update(()=>{var b=d.$getNearestNodeFromDOMNode(a.elem);
	C(b)&&(b=b.getKey(),this.gridSelection=d.DEPRECATED_$createGridSelection(),this.anchorCellNodeKey=b);});}formatCells(a){this.editor.update(()=>{let b=d.$getSelection();d.DEPRECATED_$isGridSelection(b)||G(11);let c=d.$createRangeSelection(),e=c.anchor,g=c.focus;b.getNodes().forEach(h=>{C(h)&&0!==h.getTextContentSize()&&(e.set(h.getKey(),0,"element"),g.set(h.getKey(),h.getChildrenSize(),"element"),c.formatText(a));});d.$setSelection(b);this.editor.dispatchCommand(d.SELECTION_CHANGE_COMMAND,void 0);});}clearText(){let a=
	this.editor;a.update(()=>{let b=d.$getNodeByKey(this.tableNodeKey);if(!K(b))throw Error("Expected TableNode.");var c=d.$getSelection();d.DEPRECATED_$isGridSelection(c)||G(11);c=c.getNodes().filter(C);c.length===this.grid.columns*this.grid.rows?(b.selectPrevious(),b.remove(),d.$getRoot().selectStart()):(c.forEach(e=>{if(d.$isElementNode(e)){let g=d.$createParagraphNode(),h=d.$createTextNode();g.append(h);e.append(g);e.getChildren().forEach(f=>{f!==g&&f.remove();});}}),L(a,this.grid,null),d.$setSelection(null),
	a.dispatchCommand(d.SELECTION_CHANGE_COMMAND,void 0));});}}function M(a){for(;null!=a;){let b=a.nodeName;if("TD"===b||"TH"===b){a=a._cell;if(void 0===a)break;return a}a=a.parentNode;}return null}
	function J(a){let b=[],c={cells:b,columns:0,rows:0};var e=a.firstChild;let g=a=0;for(b.length=0;null!=e;){var h=e.nodeName;if("TD"===h||"TH"===h)h=e,h={elem:h,hasBackgroundColor:""!==h.style.backgroundColor,highlighted:!1,x:a,y:g},e._cell=h,void 0===b[g]&&(b[g]=[]),b[g][a]=h;else if(h=e.firstChild,null!=h){e=h;continue}h=e.nextSibling;if(null!=h)a++,e=h;else if(h=e.parentNode,null!=h){e=h.nextSibling;if(null==e)break;g++;a=0;}}c.columns=a+1;c.rows=g+1;return c}
	function L(a,b,c){let e=new Set(c?c.getNodes():[]);N(b,(g,h)=>{let f=g.elem;e.has(h)?(g.highlighted=!0,O(a,g)):(g.highlighted=!1,ca(a,g),f.getAttribute("style")||f.removeAttribute("style"));});}function N(a,b){({cells:a}=a);for(let c=0;c<a.length;c++){let e=a[c];for(let g=0;g<e.length;g++){let h=e[g],f=d.$getNearestNodeFromDOMNode(h.elem);null!==f&&b(h,f,{x:g,y:c});}}}function da(a,b){b.disableHighlightStyle();N(b.grid,c=>{c.highlighted=!0;O(a,c);});}
	function ea(a,b){b.enableHighlightStyle();N(b.grid,c=>{let e=c.elem;c.highlighted=!1;ca(a,c);e.getAttribute("style")||e.removeAttribute("style");});}
	let fa=(a,b,c,e,g)=>{const h="forward"===g;switch(g){case "backward":case "forward":return c!==(h?a.grid.columns-1:0)?(a=b.getCellNodeFromCordsOrThrow(c+(h?1:-1),e,a.grid),h?a.selectStart():a.selectEnd()):e!==(h?a.grid.rows-1:0)?(a=b.getCellNodeFromCordsOrThrow(h?0:a.grid.columns-1,e+(h?1:-1),a.grid),h?a.selectStart():a.selectEnd()):h?b.selectNext():b.selectPrevious(),!0;case "up":return 0!==e?b.getCellNodeFromCordsOrThrow(c,e-1,a.grid).selectEnd():b.selectPrevious(),!0;case "down":return e!==a.grid.rows-
	1?b.getCellNodeFromCordsOrThrow(c,e+1,a.grid).selectStart():b.selectNext(),!0;default:return !1}},ha=(a,b,c,e,g)=>{const h="forward"===g;switch(g){case "backward":case "forward":return c!==(h?a.grid.columns-1:0)&&a.setFocusCellForSelection(b.getCellFromCordsOrThrow(c+(h?1:-1),e,a.grid)),!0;case "up":return 0!==e?(a.setFocusCellForSelection(b.getCellFromCordsOrThrow(c,e-1,a.grid)),!0):!1;case "down":return e!==a.grid.rows-1?(a.setFocusCellForSelection(b.getCellFromCordsOrThrow(c,e+1,a.grid)),!0):!1;
	default:return !1}};function P(a,b){if(d.$isRangeSelection(a)||d.DEPRECATED_$isGridSelection(a)){let c=b.isParentOf(a.anchor.getNode());a=b.isParentOf(a.focus.getNode());return c&&a}return !1}
	function O(a,b){a=b.elem;b=d.$getNearestNodeFromDOMNode(a);C(b)||G(131);null===b.getBackgroundColor()?a.style.setProperty("background-color","rgb(172,206,247)"):a.style.setProperty("background-image","linear-gradient(to right, rgba(172,206,247,0.85), rgba(172,206,247,0.85))");a.style.setProperty("caret-color","transparent");}
	function ca(a,b){a=b.elem;b=d.$getNearestNodeFromDOMNode(a);C(b)||G(131);null===b.getBackgroundColor()&&a.style.removeProperty("background-color");a.style.removeProperty("background-image");a.style.removeProperty("caret-color");}function Q(a){a=t.$findMatchingParent(a,C);return C(a)?a:null}function ia(a){a=t.$findMatchingParent(a,K);return K(a)?a:null}
	function R(a,b,c,e,g){var h=d.$getSelection();if(!P(h,e))return !1;if(d.$isRangeSelection(h)&&h.isCollapsed()){if("backward"===c||"forward"===c)return !1;let {anchor:q,focus:r}=h;h=t.$findMatchingParent(q.getNode(),C);var f=t.$findMatchingParent(r.getNode(),C);if(!C(h)||!h.is(f))return !1;f=a.getElementByKey(h.__key);var m=a.getElementByKey(q.key);if(null==m||null==f)return !1;if("element"===q.type)f=m.getBoundingClientRect();else {f=window.getSelection();if(null===f||0===f.rangeCount)return !1;f=f.getRangeAt(0).getBoundingClientRect();}m=
	"up"===c?h.getFirstChild():h.getLastChild();if(null==m)return !1;a=a.getElementByKey(m.__key);if(null==a)return !1;a=a.getBoundingClientRect();if("up"===c?a.top>f.top-f.height:f.bottom+f.height>a.bottom){S(b);h=e.getCordsFromCellNode(h,g.grid);if(b.shiftKey)c=e.getCellFromCordsOrThrow(h.x,h.y,g.grid),g.setAnchorCellForSelection(c),g.setFocusCellForSelection(c,!0);else return fa(g,e,h.x,h.y,c);return !0}}else if(d.DEPRECATED_$isGridSelection(h)){let {anchor:q,focus:r}=h;h=t.$findMatchingParent(q.getNode(),
	C);a=t.$findMatchingParent(r.getNode(),C);if(!C(h)||!C(a))return !1;S(b);if(b.shiftKey)return b=e.getCordsFromCellNode(a,g.grid),ha(g,e,b.x,b.y,c);a.selectEnd();return !0}return !1}function S(a){a.preventDefault();a.stopImmediatePropagation();a.stopPropagation();}
	class T extends d.DEPRECATED_GridNode{static getType(){return "table"}static clone(a){return new T(a.__key)}static importDOM(){return {table:()=>({conversion:ja,priority:1})}}static importJSON(){return U()}constructor(a){super(a);}exportJSON(){return {...super.exportJSON(),type:"table",version:1}}createDOM(a){let b=document.createElement("table");t.addClassNamesToElement(b,a.theme.table);return b}updateDOM(){return !1}exportDOM(a){return {...super.exportDOM(a),after:b=>{if(b){let c=b.cloneNode(),e=document.createElement("colgroup"),
	g=document.createElement("tbody");g.append(...b.children);b=this.getFirstChildOrThrow();if(!F(b))throw Error("Expected to find row node.");b=b.getChildrenSize();for(let h=0;h<b;h++){let f=document.createElement("col");e.append(f);}c.replaceChildren(e,g);return c}}}}canExtractContents(){return !1}canBeEmpty(){return !1}isShadowRoot(){return !0}getCordsFromCellNode(a,b){let {rows:c,cells:e}=b;for(b=0;b<c;b++){var g=e[b];if(null==g)throw Error(`Row not found at y:${b}`);g=g.findIndex(({elem:h})=>d.$getNearestNodeFromDOMNode(h)===
	a);if(-1!==g)return {x:g,y:b}}throw Error("Cell not found in table.");}getCellFromCords(a,b,c){({cells:c}=c);b=c[b];if(null==b)return null;a=b[a];return null==a?null:a}getCellFromCordsOrThrow(a,b,c){a=this.getCellFromCords(a,b,c);if(!a)throw Error("Cell not found at cords.");return a}getCellNodeFromCords(a,b,c){a=this.getCellFromCords(a,b,c);if(null==a)return null;a=d.$getNearestNodeFromDOMNode(a.elem);return C(a)?a:null}getCellNodeFromCordsOrThrow(a,b,c){a=this.getCellNodeFromCords(a,b,c);if(!a)throw Error("Node at cords not TableCellNode.");
	return a}canSelectBefore(){return !0}canIndent(){return !1}}function ja(){return {node:U()}}function U(){return d.$applyNodeReplacement(new T)}function K(a){return a instanceof T}function W(a){a=t.$findMatchingParent(a,b=>F(b));if(F(a))return a;throw Error("Expected table cell to be inside of table row.");}function X(a){a=t.$findMatchingParent(a,b=>K(b));if(K(a))return a;throw Error("Expected table cell to be inside of table.");}
	function ka(a,b){let c=X(a),{x:e,y:g}=c.getCordsFromCellNode(a,b);return {above:c.getCellNodeFromCords(e,g-1,b),below:c.getCellNodeFromCords(e,g+1,b),left:c.getCellNodeFromCords(e-1,g,b),right:c.getCellNodeFromCords(e+1,g,b)}}function Y(a){a=a.getFirstDescendant();null===a&&G(124);a.getParentOrThrow().selectStart();}function Z(a,b){let c=a.getFirstChild();null!==c?c.insertBefore(b):a.append(b);}let la=d.createCommand("INSERT_TABLE_COMMAND");LexicalTable_prod.$createTableCellNode=B;LexicalTable_prod.$createTableNode=U;
	LexicalTable_prod.$createTableNodeWithDimensions=function(a,b,c=!0){let e=U();for(let h=0;h<a;h++){let f=E();for(let m=0;m<b;m++){var g=x.NO_STATUS;"object"===typeof c?(0===h&&c.rows&&(g|=x.ROW),0===m&&c.columns&&(g|=x.COLUMN)):c&&(0===h&&(g|=x.ROW),0===m&&(g|=x.COLUMN));g=B(g);let q=d.$createParagraphNode();q.append(d.$createTextNode());g.append(q);f.append(g);}e.append(f);}return e};LexicalTable_prod.$createTableRowNode=E;
	LexicalTable_prod.$deleteTableColumn=function(a,b){let c=a.getChildren();for(let g=0;g<c.length;g++){var e=c[g];if(F(e)){e=e.getChildren();if(b>=e.length||0>b)throw Error("Table column target index out of range");e[b].remove();}}return a};
	LexicalTable_prod.$deleteTableColumn__EXPERIMENTAL=function(){var a=d.$getSelection();d.$isRangeSelection(a)||d.DEPRECATED_$isGridSelection(a)||G(118);var b=a.anchor.getNode();a=a.focus.getNode();let [c,,e]=d.DEPRECATED_$getNodeTriplet(b);[b]=d.DEPRECATED_$getNodeTriplet(a);let [g,h,f]=d.DEPRECATED_$computeGridMap(e,c,b);var {startColumn:m}=h;let {startRow:q,startColumn:r}=f;a=Math.min(m,r);m=Math.max(m+c.__colSpan-1,r+b.__colSpan-1);let k=m-a+1;if(g[0].length===m-a+1)e.selectPrevious(),e.remove();else {var l=
	g.length;for(let n=0;n<l;n++)for(let p=a;p<=m;p++){let {cell:v,startColumn:u}=g[n][p];u<a?p===a&&v.setColSpan(v.__colSpan-Math.min(k,v.__colSpan-(a-u))):u+v.__colSpan-1>m?p===m&&v.setColSpan(v.__colSpan-(m-u+1)):v.remove();}a=g[q];b=a[r+b.__colSpan];void 0!==b?({cell:b}=b,Y(b)):({cell:b}=a[r-1],Y(b));}};
	LexicalTable_prod.$deleteTableRow__EXPERIMENTAL=function(){var a=d.$getSelection();d.$isRangeSelection(a)||d.DEPRECATED_$isGridSelection(a)||G(118);var b=a.anchor.getNode();a=a.focus.getNode();let [c,,e]=d.DEPRECATED_$getNodeTriplet(b);[a]=d.DEPRECATED_$getNodeTriplet(a);let [g,h,f]=d.DEPRECATED_$computeGridMap(e,c,a);({startRow:b}=h);var {startRow:m}=f;a=m+a.__rowSpan-1;if(g.length===a-b+1)e.remove();else {m=g[0].length;var q=g[a+1],r=e.getChildAtIndex(a+1);for(let l=a;l>=b;l--){for(var k=m-1;0<=k;k--){let {cell:n,
	startRow:p,startColumn:v}=g[l][k];if(v===k&&(l===b&&p<b&&n.setRowSpan(n.__rowSpan-(p-b)),p>=b&&p+n.__rowSpan-1>a))if(n.setRowSpan(n.__rowSpan-(a-p+1)),null===r&&G(122),0===k)Z(r,n);else {let {cell:u}=q[k-1];u.insertAfter(n);}}k=e.getChildAtIndex(l);d.DEPRECATED_$isGridRowNode(k)||G(123,String(l));k.remove();}void 0!==q?({cell:b}=q[0],Y(b)):({cell:b}=g[b-1][0],Y(b));}};LexicalTable_prod.$getElementGridForTableNode=function(a,b){a=a.getElementByKey(b.getKey());if(null==a)throw Error("Table Element Not Found");return J(a)};
	LexicalTable_prod.$getTableCellNodeFromLexicalNode=function(a){a=t.$findMatchingParent(a,b=>C(b));return C(a)?a:null};LexicalTable_prod.$getTableColumnIndexFromTableCellNode=function(a){return W(a).getChildren().findIndex(b=>b.is(a))};LexicalTable_prod.$getTableNodeFromLexicalNodeOrThrow=X;LexicalTable_prod.$getTableRowIndexFromTableCellNode=function(a){let b=W(a);return X(b).getChildren().findIndex(c=>c.is(b))};LexicalTable_prod.$getTableRowNodeFromTableCellNodeOrThrow=W;
	LexicalTable_prod.$insertTableColumn=function(a,b,c=!0,e,g){let h=a.getChildren();for(let q=0;q<h.length;q++){let r=h[q];if(F(r))for(let k=0;k<e;k++){var f=r.getChildren();if(b>=f.length||0>b)throw Error("Table column target index out of range");f=f[b];C(f)||G(12);let {left:l,right:n}=ka(f,g);var m=x.NO_STATUS;if(l&&l.hasHeaderState(x.ROW)||n&&n.hasHeaderState(x.ROW))m|=x.ROW;m=B(m);m.append(d.$createParagraphNode());c?f.insertAfter(m):f.insertBefore(m);}}return a};
	LexicalTable_prod.$insertTableColumn__EXPERIMENTAL=function(a=!0){function b(){let l=B(x.NO_STATUS).append(d.$createParagraphNode());null===r&&(r=l);return l}var c=d.$getSelection();d.$isRangeSelection(c)||d.DEPRECATED_$isGridSelection(c)||G(118);var e=c.anchor.getNode();c=c.focus.getNode();[e]=d.DEPRECATED_$getNodeTriplet(e);let [g,,h]=d.DEPRECATED_$getNodeTriplet(c),[f,m,q]=d.DEPRECATED_$computeGridMap(h,g,e);e=f.length;c=a?Math.max(m.startColumn,q.startColumn):Math.min(m.startColumn,q.startColumn);a=a?c+
	g.__colSpan-1:c-1;c=h.getFirstChild();d.DEPRECATED_$isGridRowNode(c)||G(120);let r=null;var k=c;a:for(c=0;c<e;c++){0!==c&&(k=k.getNextSibling(),d.DEPRECATED_$isGridRowNode(k)||G(121));let l=f[c];if(0>a){Z(k,b());continue}let {cell:n,startColumn:p,startRow:v}=l[a];if(p+n.__colSpan-1<=a){let u=n,A=v,H=a;for(;A!==c&&1<u.__rowSpan;)if(H-=n.__colSpan,0<=H){let {cell:V,startRow:ma}=l[H];u=V;A=ma;}else {k.append(b());continue a}u.insertAfter(b());}else n.setColSpan(n.__colSpan+1);}null!==r&&Y(r);};
	LexicalTable_prod.$insertTableRow=function(a,b,c=!0,e,g){var h=a.getChildren();if(b>=h.length||0>b)throw Error("Table row target index out of range");b=h[b];if(F(b))for(h=0;h<e;h++){let m=b.getChildren(),q=m.length,r=E();for(let k=0;k<q;k++){var f=m[k];C(f)||G(12);let {above:l,below:n}=ka(f,g);f=x.NO_STATUS;let p=l&&l.getWidth()||n&&n.getWidth()||void 0;if(l&&l.hasHeaderState(x.COLUMN)||n&&n.hasHeaderState(x.COLUMN))f|=x.COLUMN;f=B(f,1,p);f.append(d.$createParagraphNode());r.append(f);}c?b.insertAfter(r):b.insertBefore(r);}else throw Error("Row before insertion index does not exist.");
	return a};
	LexicalTable_prod.$insertTableRow__EXPERIMENTAL=function(a=!0){var b=d.$getSelection();d.$isRangeSelection(b)||d.DEPRECATED_$isGridSelection(b)||G(118);b=b.focus.getNode();let [c,,e]=d.DEPRECATED_$getNodeTriplet(b),[g,h]=d.DEPRECATED_$computeGridMap(e,c,c);b=g[0].length;var {startRow:f}=h;if(a){a=f+c.__rowSpan-1;var m=g[a];f=E();for(var q=0;q<b;q++){let {cell:r,startRow:k}=m[q];k+r.__rowSpan-1<=a?f.append(B(x.NO_STATUS)):r.setRowSpan(r.__rowSpan+1);}b=e.getChildAtIndex(a);d.DEPRECATED_$isGridRowNode(b)||G(119);
	b.insertAfter(f);}else {m=g[f];a=E();for(q=0;q<b;q++){let {cell:r,startRow:k}=m[q];k===f?a.append(B(x.NO_STATUS)):r.setRowSpan(r.__rowSpan+1);}b=e.getChildAtIndex(f);d.DEPRECATED_$isGridRowNode(b)||G(119);b.insertBefore(a);}};LexicalTable_prod.$isTableCellNode=C;LexicalTable_prod.$isTableNode=K;LexicalTable_prod.$isTableRowNode=F;LexicalTable_prod.$removeTableRowAtIndex=function(a,b){let c=a.getChildren();if(b>=c.length||0>b)throw Error("Expected table cell to be inside of table row.");c[b].remove();return a};
	LexicalTable_prod.$unmergeCell=function(){var a=d.$getSelection();d.$isRangeSelection(a)||d.DEPRECATED_$isGridSelection(a)||G(118);a=a.anchor.getNode();let [b,c,e]=d.DEPRECATED_$getNodeTriplet(a);a=b.__colSpan;let g=b.__rowSpan;if(1<a){for(var h=1;h<a;h++)b.insertAfter(B(x.NO_STATUS));b.setColSpan(1);}if(1<g){let [q,r]=d.DEPRECATED_$computeGridMap(e,b,b),{startColumn:k,startRow:l}=r;for(h=1;h<g;h++){let n=l+h,p=q[n];var f=c.getNextSibling();d.DEPRECATED_$isGridRowNode(f)||G(125);var m=null;for(let v=0;v<k;v++){let u=
	p[v],A=u.cell;u.startRow===n&&(m=A);1<A.__colSpan&&(v+=A.__colSpan-1);}if(null===m)for(m=0;m<a;m++)Z(f,B(x.NO_STATUS));else for(f=0;f<a;f++)m.insertAfter(B(x.NO_STATUS));}b.setRowSpan(1);}};LexicalTable_prod.INSERT_TABLE_COMMAND=la;LexicalTable_prod.TableCellHeaderStates=x;LexicalTable_prod.TableCellNode=y;LexicalTable_prod.TableNode=T;LexicalTable_prod.TableRowNode=D;LexicalTable_prod.TableSelection=I;
	LexicalTable_prod.applyTableHandlers=function(a,b,c,e){function g(k){k=a.getCordsFromCellNode(k,f.grid);return a.getCellFromCordsOrThrow(k.x,k.y,f.grid)}let h=c.getRootElement();if(null===h)throw Error("No root element.");let f=new I(c,a.getKey()),m=c._window||window;b.__lexicalTableSelection=f;b.addEventListener("mousedown",k=>{setTimeout(()=>{if(0===k.button&&m){var l=M(k.target);null!==l&&(S(k),f.setAnchorCellForSelection(l));var n=()=>{m.removeEventListener("mouseup",n);m.removeEventListener("mousemove",
	p);},p=v=>{const u=M(v.target);null===u||f.anchorX===u.x&&f.anchorY===u.y||(v.preventDefault(),f.setFocusCellForSelection(u));};m.addEventListener("mouseup",n);m.addEventListener("mousemove",p);}},0);});let q=k=>{0===k.button&&c.update(()=>{const l=d.$getSelection(),n=k.target;d.DEPRECATED_$isGridSelection(l)&&l.gridKey===f.tableNodeKey&&h.contains(n)&&f.clearHighlight();});};m.addEventListener("mousedown",q);f.listenersToRemove.add(()=>m.removeEventListener("mousedown",q));f.listenersToRemove.add(c.registerCommand(d.KEY_ARROW_DOWN_COMMAND,
	k=>R(c,k,"down",a,f),d.COMMAND_PRIORITY_HIGH));f.listenersToRemove.add(c.registerCommand(d.KEY_ARROW_UP_COMMAND,k=>R(c,k,"up",a,f),d.COMMAND_PRIORITY_HIGH));f.listenersToRemove.add(c.registerCommand(d.KEY_ARROW_LEFT_COMMAND,k=>R(c,k,"backward",a,f),d.COMMAND_PRIORITY_HIGH));f.listenersToRemove.add(c.registerCommand(d.KEY_ARROW_RIGHT_COMMAND,k=>R(c,k,"forward",a,f),d.COMMAND_PRIORITY_HIGH));f.listenersToRemove.add(c.registerCommand(d.KEY_ESCAPE_COMMAND,k=>{var l=d.$getSelection();return d.DEPRECATED_$isGridSelection(l)&&
	(l=t.$findMatchingParent(l.focus.getNode(),C),C(l))?(S(k),l.selectEnd(),!0):!1},d.COMMAND_PRIORITY_HIGH));let r=k=>()=>{var l=d.$getSelection();if(!P(l,a))return !1;if(d.DEPRECATED_$isGridSelection(l))return f.clearText(),!0;if(d.$isRangeSelection(l)){const v=t.$findMatchingParent(l.anchor.getNode(),u=>C(u));if(!C(v))return !1;var n=l.anchor.getNode(),p=l.focus.getNode();n=a.isParentOf(n);p=a.isParentOf(p);if(n&&!p||p&&!n)return f.clearText(),!0;n=(p=t.$findMatchingParent(l.anchor.getNode(),u=>d.$isElementNode(u)))&&
	t.$findMatchingParent(p,u=>d.$isElementNode(u)&&C(u.getParent()));if(!d.$isElementNode(n)||!d.$isElementNode(p))return !1;if(k===d.DELETE_LINE_COMMAND&&null===n.getPreviousSibling())return !0;if((k===d.DELETE_CHARACTER_COMMAND||k===d.DELETE_WORD_COMMAND)&&l.isCollapsed()&&0===l.anchor.offset&&p!==n){l=p.getChildren();const u=d.$createParagraphNode();l.forEach(A=>u.append(A));p.replace(u);p.getWritable().__parent=v.getKey();return !0}}return !1};[d.DELETE_WORD_COMMAND,d.DELETE_LINE_COMMAND,d.DELETE_CHARACTER_COMMAND].forEach(k=>
	{f.listenersToRemove.add(c.registerCommand(k,r(k),d.COMMAND_PRIORITY_CRITICAL));});b=k=>{const l=d.$getSelection();if(!P(l,a))return !1;if(d.DEPRECATED_$isGridSelection(l))return k.preventDefault(),k.stopPropagation(),f.clearText(),!0;d.$isRangeSelection(l)&&(k=t.$findMatchingParent(l.anchor.getNode(),n=>C(n)),C(k));return !1};f.listenersToRemove.add(c.registerCommand(d.KEY_BACKSPACE_COMMAND,b,d.COMMAND_PRIORITY_CRITICAL));f.listenersToRemove.add(c.registerCommand(d.KEY_DELETE_COMMAND,b,d.COMMAND_PRIORITY_CRITICAL));
	f.listenersToRemove.add(c.registerCommand(d.FORMAT_TEXT_COMMAND,k=>{let l=d.$getSelection();if(!P(l,a))return !1;if(d.DEPRECATED_$isGridSelection(l))return f.formatCells(k),!0;d.$isRangeSelection(l)&&(k=t.$findMatchingParent(l.anchor.getNode(),n=>C(n)),C(k));return !1},d.COMMAND_PRIORITY_CRITICAL));f.listenersToRemove.add(c.registerCommand(d.CONTROLLED_TEXT_INSERTION_COMMAND,()=>{var k=d.$getSelection();if(!P(k,a))return !1;d.DEPRECATED_$isGridSelection(k)?f.clearHighlight():d.$isRangeSelection(k)&&
	(k=t.$findMatchingParent(k.anchor.getNode(),l=>C(l)),C(k));return !1},d.COMMAND_PRIORITY_CRITICAL));e&&f.listenersToRemove.add(c.registerCommand(d.KEY_TAB_COMMAND,k=>{var l=d.$getSelection();if(!d.$isRangeSelection(l)||!l.isCollapsed()||!P(l,a))return !1;l=Q(l.anchor.getNode());if(null===l)return !1;S(k);l=a.getCordsFromCellNode(l,f.grid);fa(f,a,l.x,l.y,k.shiftKey?"backward":"forward");return !0},d.COMMAND_PRIORITY_CRITICAL));f.listenersToRemove.add(c.registerCommand(d.FOCUS_COMMAND,()=>a.isSelected(),
	d.COMMAND_PRIORITY_HIGH));f.listenersToRemove.add(c.registerCommand(d.SELECTION_CHANGE_COMMAND,()=>{let k=d.$getSelection(),l=d.$getPreviousSelection();if(d.$isRangeSelection(k)){let {anchor:A,focus:H}=k;var n=A.getNode(),p=H.getNode();n=Q(n);p=Q(p);var v=n&&a.is(ia(n)),u=p&&a.is(ia(p));let V=v!==u;u=v&&u;v=k.isBackward();V?(n=k.clone(),n.focus.set(a.getKey(),v?0:a.getChildrenSize(),"element"),d.$setSelection(n),da(c,f)):u&&!n.is(p)&&(f.setAnchorCellForSelection(g(n)),f.setFocusCellForSelection(g(p),
	!0));}if(k&&!k.is(l)&&(d.DEPRECATED_$isGridSelection(k)||d.DEPRECATED_$isGridSelection(l))&&f.gridSelection&&!f.gridSelection.is(l))return d.DEPRECATED_$isGridSelection(k)&&k.gridKey===f.tableNodeKey?f.updateTableGridSelection(k):!d.DEPRECATED_$isGridSelection(k)&&d.DEPRECATED_$isGridSelection(l)&&l.gridKey===f.tableNodeKey&&f.updateTableGridSelection(null),!1;f.hasHijackedSelectionStyles&&!a.isSelected()?ea(c,f):!f.hasHijackedSelectionStyles&&a.isSelected()&&da(c,f);return !1},d.COMMAND_PRIORITY_CRITICAL));
	return f};LexicalTable_prod.getCellFromTarget=M;LexicalTable_prod.getTableSelectionFromTableElement=function(a){return a.__lexicalTableSelection};
	return LexicalTable_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalTable = process.env.NODE_ENV === 'development' ? requireLexicalTable_dev() : requireLexicalTable_prod();
var LexicalTable_1 = LexicalTable;

var LexicalMarkdown_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalMarkdown_dev;

function requireLexicalMarkdown_dev () {
	if (hasRequiredLexicalMarkdown_dev) return LexicalMarkdown_dev;
	hasRequiredLexicalMarkdown_dev = 1;

	var lexical = require$$0__default["default"];
	var code = LexicalCode_1;
	var list = LexicalList_1;
	var richText = LexicalRichText_1;
	var utils = LexicalUtils_1;
	var link = LexicalLink_1;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	function indexBy(list, callback) {
	  const index = {};

	  for (const item of list) {
	    const key = callback(item);

	    if (index[key]) {
	      index[key].push(item);
	    } else {
	      index[key] = [item];
	    }
	  }

	  return index;
	}
	function transformersByType(transformers) {
	  const byType = indexBy(transformers, t => t.type);
	  return {
	    element: byType.element || [],
	    textFormat: byType['text-format'] || [],
	    textMatch: byType['text-match'] || []
	  };
	}
	const PUNCTUATION_OR_SPACE = /[!-/:-@[-`{-~\s]/;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	function createMarkdownExport(transformers) {
	  const byType = transformersByType(transformers); // Export only uses text formats that are responsible for single format
	  // e.g. it will filter out *** (bold, italic) and instead use separate ** and *

	  const textFormatTransformers = byType.textFormat.filter(transformer => transformer.format.length === 1);
	  return node => {
	    const output = [];
	    const children = (node || lexical.$getRoot()).getChildren();

	    for (const child of children) {
	      const result = exportTopLevelElements(child, byType.element, textFormatTransformers, byType.textMatch);

	      if (result != null) {
	        output.push(result);
	      }
	    }

	    return output.join('\n\n');
	  };
	}

	function exportTopLevelElements(node, elementTransformers, textTransformersIndex, textMatchTransformers) {
	  for (const transformer of elementTransformers) {
	    const result = transformer.export(node, _node => exportChildren(_node, textTransformersIndex, textMatchTransformers));

	    if (result != null) {
	      return result;
	    }
	  }

	  if (lexical.$isElementNode(node)) {
	    return exportChildren(node, textTransformersIndex, textMatchTransformers);
	  } else if (lexical.$isDecoratorNode(node)) {
	    return node.getTextContent();
	  } else {
	    return null;
	  }
	}

	function exportChildren(node, textTransformersIndex, textMatchTransformers) {
	  const output = [];
	  const children = node.getChildren();

	  mainLoop: for (const child of children) {
	    for (const transformer of textMatchTransformers) {
	      const result = transformer.export(child, parentNode => exportChildren(parentNode, textTransformersIndex, textMatchTransformers), (textNode, textContent) => exportTextFormat(textNode, textContent, textTransformersIndex));

	      if (result != null) {
	        output.push(result);
	        continue mainLoop;
	      }
	    }

	    if (lexical.$isLineBreakNode(child)) {
	      output.push('\n');
	    } else if (lexical.$isTextNode(child)) {
	      output.push(exportTextFormat(child, child.getTextContent(), textTransformersIndex));
	    } else if (lexical.$isElementNode(child)) {
	      output.push(exportChildren(child, textTransformersIndex, textMatchTransformers));
	    } else if (lexical.$isDecoratorNode(child)) {
	      output.push(child.getTextContent());
	    }
	  }

	  return output.join('');
	}

	function exportTextFormat(node, textContent, textTransformers) {
	  // This function handles the case of a string looking like this: "   foo   "
	  // Where it would be invalid markdown to generate: "**   foo   **"
	  // We instead want to trim the whitespace out, apply formatting, and then
	  // bring the whitespace back. So our returned string looks like this: "   **foo**   "
	  const frozenString = textContent.trim();
	  let output = frozenString;
	  const applied = new Set();

	  for (const transformer of textTransformers) {
	    const format = transformer.format[0];
	    const tag = transformer.tag;

	    if (hasFormat(node, format) && !applied.has(format)) {
	      // Multiple tags might be used for the same format (*, _)
	      applied.add(format); // Prevent adding opening tag is already opened by the previous sibling

	      const previousNode = getTextSibling(node, true);

	      if (!hasFormat(previousNode, format)) {
	        output = tag + output;
	      } // Prevent adding closing tag if next sibling will do it


	      const nextNode = getTextSibling(node, false);

	      if (!hasFormat(nextNode, format)) {
	        output += tag;
	      }
	    }
	  } // Replace trimmed version of textContent ensuring surrounding whitespace is not modified


	  return textContent.replace(frozenString, output);
	} // Get next or previous text sibling a text node, including cases
	// when it's a child of inline element (e.g. link)


	function getTextSibling(node, backward) {
	  let sibling = backward ? node.getPreviousSibling() : node.getNextSibling();

	  if (!sibling) {
	    const parent = node.getParentOrThrow();

	    if (parent.isInline()) {
	      sibling = backward ? parent.getPreviousSibling() : parent.getNextSibling();
	    }
	  }

	  while (sibling) {
	    if (lexical.$isElementNode(sibling)) {
	      if (!sibling.isInline()) {
	        break;
	      }

	      const descendant = backward ? sibling.getLastDescendant() : sibling.getFirstDescendant();

	      if (lexical.$isTextNode(descendant)) {
	        return descendant;
	      } else {
	        sibling = backward ? sibling.getPreviousSibling() : sibling.getNextSibling();
	      }
	    }

	    if (lexical.$isTextNode(sibling)) {
	      return sibling;
	    }

	    if (!lexical.$isElementNode(sibling)) {
	      return null;
	    }
	  }

	  return null;
	}

	function hasFormat(node, format) {
	  return lexical.$isTextNode(node) && node.hasFormat(format);
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const CAN_USE_DOM = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined';

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const documentMode = CAN_USE_DOM && 'documentMode' in document ? document.documentMode : null;
	CAN_USE_DOM && /Mac|iPod|iPhone|iPad/.test(navigator.platform);
	CAN_USE_DOM && /^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent);
	CAN_USE_DOM && 'InputEvent' in window && !documentMode ? 'getTargetRanges' in new window.InputEvent('input') : false;
	const IS_SAFARI = CAN_USE_DOM && /Version\/[\d.]+.*Safari/.test(navigator.userAgent);
	const IS_IOS = CAN_USE_DOM && /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream; // Keep these in case we need to use them in the future.
	// export const IS_WINDOWS: boolean = CAN_USE_DOM && /Win/.test(navigator.platform);

	const IS_CHROME = CAN_USE_DOM && /^(?=.*Chrome).*/i.test(navigator.userAgent); // export const canUseTextInputEvent: boolean = CAN_USE_DOM && 'TextEvent' in window && !documentMode;

	const IS_APPLE_WEBKIT = CAN_USE_DOM && /AppleWebKit\/[\d.]+/.test(navigator.userAgent) && !IS_CHROME;

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */
	const MARKDOWN_EMPTY_LINE_REG_EXP = /^\s{0,3}$/;
	const CODE_BLOCK_REG_EXP = /^```(\w{1,10})?\s?$/;
	function createMarkdownImport(transformers) {
	  const byType = transformersByType(transformers);
	  const textFormatTransformersIndex = createTextFormatTransformersIndex(byType.textFormat);
	  return (markdownString, node) => {
	    const lines = markdownString.split('\n');
	    const linesLength = lines.length;
	    const root = node || lexical.$getRoot();
	    root.clear();

	    for (let i = 0; i < linesLength; i++) {
	      const lineText = lines[i]; // Codeblocks are processed first as anything inside such block
	      // is ignored for further processing
	      // TODO:
	      // Abstract it to be dynamic as other transformers (add multiline match option)

	      const [codeBlockNode, shiftedIndex] = importCodeBlock(lines, i, root);

	      if (codeBlockNode != null) {
	        i = shiftedIndex;
	        continue;
	      }

	      importBlocks(lineText, root, byType.element, textFormatTransformersIndex, byType.textMatch);
	    } // Removing empty paragraphs as md does not really
	    // allow empty lines and uses them as dilimiter


	    const children = root.getChildren();

	    for (const child of children) {
	      if (isEmptyParagraph(child)) {
	        child.remove();
	      }
	    }

	    if (lexical.$getSelection() !== null) {
	      root.selectEnd();
	    }
	  };
	}

	function isEmptyParagraph(node) {
	  if (!lexical.$isParagraphNode(node)) {
	    return false;
	  }

	  const firstChild = node.getFirstChild();
	  return firstChild == null || node.getChildrenSize() === 1 && lexical.$isTextNode(firstChild) && MARKDOWN_EMPTY_LINE_REG_EXP.test(firstChild.getTextContent());
	}

	function importBlocks(lineText, rootNode, elementTransformers, textFormatTransformersIndex, textMatchTransformers) {
	  const lineTextTrimmed = lineText.trim();
	  const textNode = lexical.$createTextNode(lineTextTrimmed);
	  const elementNode = lexical.$createParagraphNode();
	  elementNode.append(textNode);
	  rootNode.append(elementNode);

	  for (const {
	    regExp,
	    replace
	  } of elementTransformers) {
	    const match = lineText.match(regExp);

	    if (match) {
	      textNode.setTextContent(lineText.slice(match[0].length));
	      replace(elementNode, [textNode], match, true);
	      break;
	    }
	  }

	  importTextFormatTransformers(textNode, textFormatTransformersIndex, textMatchTransformers); // If no transformer found and we left with original paragraph node
	  // can check if its content can be appended to the previous node
	  // if it's a paragraph, quote or list

	  if (elementNode.isAttached() && lineTextTrimmed.length > 0) {
	    const previousNode = elementNode.getPreviousSibling();

	    if (lexical.$isParagraphNode(previousNode) || richText.$isQuoteNode(previousNode) || list.$isListNode(previousNode)) {
	      let targetNode = previousNode;

	      if (list.$isListNode(previousNode)) {
	        const lastDescendant = previousNode.getLastDescendant();

	        if (lastDescendant == null) {
	          targetNode = null;
	        } else {
	          targetNode = utils.$findMatchingParent(lastDescendant, list.$isListItemNode);
	        }
	      }

	      if (targetNode != null && targetNode.getTextContentSize() > 0) {
	        targetNode.splice(targetNode.getChildrenSize(), 0, [lexical.$createLineBreakNode(), ...elementNode.getChildren()]);
	        elementNode.remove();
	      }
	    }
	  }
	}

	function importCodeBlock(lines, startLineIndex, rootNode) {
	  const openMatch = lines[startLineIndex].match(CODE_BLOCK_REG_EXP);

	  if (openMatch) {
	    let endLineIndex = startLineIndex;
	    const linesLength = lines.length;

	    while (++endLineIndex < linesLength) {
	      const closeMatch = lines[endLineIndex].match(CODE_BLOCK_REG_EXP);

	      if (closeMatch) {
	        const codeBlockNode = code.$createCodeNode(openMatch[1]);
	        const textNode = lexical.$createTextNode(lines.slice(startLineIndex + 1, endLineIndex).join('\n'));
	        codeBlockNode.append(textNode);
	        rootNode.append(codeBlockNode);
	        return [codeBlockNode, endLineIndex];
	      }
	    }
	  }

	  return [null, startLineIndex];
	} // Processing text content and replaces text format tags.
	// It takes outermost tag match and its content, creates text node with
	// format based on tag and then recursively executed over node's content
	//
	// E.g. for "*Hello **world**!*" string it will create text node with
	// "Hello **world**!" content and italic format and run recursively over
	// its content to transform "**world**" part


	function importTextFormatTransformers(textNode, textFormatTransformersIndex, textMatchTransformers) {
	  const textContent = textNode.getTextContent();
	  const match = findOutermostMatch(textContent, textFormatTransformersIndex);

	  if (!match) {
	    // Once text format processing is done run text match transformers, as it
	    // only can span within single text node (unline formats that can cover multiple nodes)
	    importTextMatchTransformers(textNode, textMatchTransformers);
	    return;
	  }

	  let currentNode, remainderNode, leadingNode; // If matching full content there's no need to run splitText and can reuse existing textNode
	  // to update its content and apply format. E.g. for **_Hello_** string after applying bold
	  // format (**) it will reuse the same text node to apply italic (_)

	  if (match[0] === textContent) {
	    currentNode = textNode;
	  } else {
	    const startIndex = match.index || 0;
	    const endIndex = startIndex + match[0].length;

	    if (startIndex === 0) {
	      [currentNode, remainderNode] = textNode.splitText(endIndex);
	    } else {
	      [leadingNode, currentNode, remainderNode] = textNode.splitText(startIndex, endIndex);
	    }
	  }

	  currentNode.setTextContent(match[2]);
	  const transformer = textFormatTransformersIndex.transformersByTag[match[1]];

	  if (transformer) {
	    for (const format of transformer.format) {
	      if (!currentNode.hasFormat(format)) {
	        currentNode.toggleFormat(format);
	      }
	    }
	  } // Recursively run over inner text if it's not inline code


	  if (!currentNode.hasFormat('code')) {
	    importTextFormatTransformers(currentNode, textFormatTransformersIndex, textMatchTransformers);
	  } // Run over leading/remaining text if any


	  if (leadingNode) {
	    importTextFormatTransformers(leadingNode, textFormatTransformersIndex, textMatchTransformers);
	  }

	  if (remainderNode) {
	    importTextFormatTransformers(remainderNode, textFormatTransformersIndex, textMatchTransformers);
	  }
	}

	function importTextMatchTransformers(textNode_, textMatchTransformers) {
	  let textNode = textNode_;

	  mainLoop: while (textNode) {
	    for (const transformer of textMatchTransformers) {
	      const match = textNode.getTextContent().match(transformer.importRegExp);

	      if (!match) {
	        continue;
	      }

	      const startIndex = match.index || 0;
	      const endIndex = startIndex + match[0].length;
	      let replaceNode, leftTextNode, rightTextNode;

	      if (startIndex === 0) {
	        [replaceNode, textNode] = textNode.splitText(endIndex);
	      } else {
	        [leftTextNode, replaceNode, rightTextNode] = textNode.splitText(startIndex, endIndex);
	      }

	      if (leftTextNode) {
	        importTextMatchTransformers(leftTextNode, textMatchTransformers);
	      }

	      if (rightTextNode) {
	        textNode = rightTextNode;
	      }

	      transformer.replace(replaceNode, match);
	      continue mainLoop;
	    }

	    break;
	  }
	} // Finds first "<tag>content<tag>" match that is not nested into another tag


	function findOutermostMatch(textContent, textTransformersIndex) {
	  const openTagsMatch = textContent.match(textTransformersIndex.openTagsRegExp);

	  if (openTagsMatch == null) {
	    return null;
	  }

	  for (const match of openTagsMatch) {
	    // Open tags reg exp might capture leading space so removing it
	    // before using match to find transformer
	    const tag = match.replace(/^\s/, '');
	    const fullMatchRegExp = textTransformersIndex.fullMatchRegExpByTag[tag];

	    if (fullMatchRegExp == null) {
	      continue;
	    }

	    const fullMatch = textContent.match(fullMatchRegExp);
	    const transformer = textTransformersIndex.transformersByTag[tag];

	    if (fullMatch != null && transformer != null) {
	      if (transformer.intraword !== false) {
	        return fullMatch;
	      } // For non-intraword transformers checking if it's within a word
	      // or surrounded with space/punctuation/newline


	      const {
	        index = 0
	      } = fullMatch;
	      const beforeChar = textContent[index - 1];
	      const afterChar = textContent[index + fullMatch[0].length];

	      if ((!beforeChar || PUNCTUATION_OR_SPACE.test(beforeChar)) && (!afterChar || PUNCTUATION_OR_SPACE.test(afterChar))) {
	        return fullMatch;
	      }
	    }
	  }

	  return null;
	}

	function createTextFormatTransformersIndex(textTransformers) {
	  const transformersByTag = {};
	  const fullMatchRegExpByTag = {};
	  const openTagsRegExp = [];
	  const escapeRegExp = `(?<![\\\\])`;

	  for (const transformer of textTransformers) {
	    const {
	      tag
	    } = transformer;
	    transformersByTag[tag] = transformer;
	    const tagRegExp = tag.replace(/(\*|\^|\+)/g, '\\$1');
	    openTagsRegExp.push(tagRegExp);

	    if (IS_SAFARI || IS_IOS || IS_APPLE_WEBKIT) {
	      fullMatchRegExpByTag[tag] = new RegExp(`(${tagRegExp})(?![${tagRegExp}\\s])(.*?[^${tagRegExp}\\s])${tagRegExp}(?!${tagRegExp})`);
	    } else {
	      fullMatchRegExpByTag[tag] = new RegExp(`(?<![\\\\${tagRegExp}])(${tagRegExp})((\\\\${tagRegExp})?.*?[^${tagRegExp}\\s](\\\\${tagRegExp})?)((?<!\\\\)|(?<=\\\\\\\\))(${tagRegExp})(?![\\\\${tagRegExp}])`);
	    }
	  }

	  return {
	    // Reg exp to find open tag + content + close tag
	    fullMatchRegExpByTag,
	    // Reg exp to find opening tags
	    openTagsRegExp: new RegExp((IS_SAFARI || IS_IOS || IS_APPLE_WEBKIT ? '' : `${escapeRegExp}`) + '(' + openTagsRegExp.join('|') + ')', 'g'),
	    transformersByTag
	  };
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	function runElementTransformers(parentNode, anchorNode, anchorOffset, elementTransformers) {
	  const grandParentNode = parentNode.getParent();

	  if (!lexical.$isRootOrShadowRoot(grandParentNode) || parentNode.getFirstChild() !== anchorNode) {
	    return false;
	  }

	  const textContent = anchorNode.getTextContent(); // Checking for anchorOffset position to prevent any checks for cases when caret is too far
	  // from a line start to be a part of block-level markdown trigger.
	  //
	  // TODO:
	  // Can have a quick check if caret is close enough to the beginning of the string (e.g. offset less than 10-20)
	  // since otherwise it won't be a markdown shortcut, but tables are exception

	  if (textContent[anchorOffset - 1] !== ' ') {
	    return false;
	  }

	  for (const {
	    regExp,
	    replace
	  } of elementTransformers) {
	    const match = textContent.match(regExp);

	    if (match && match[0].length === anchorOffset) {
	      const nextSiblings = anchorNode.getNextSiblings();
	      const [leadingNode, remainderNode] = anchorNode.splitText(anchorOffset);
	      leadingNode.remove();
	      const siblings = remainderNode ? [remainderNode, ...nextSiblings] : nextSiblings;
	      replace(parentNode, siblings, match, false);
	      return true;
	    }
	  }

	  return false;
	}

	function runTextMatchTransformers(anchorNode, anchorOffset, transformersByTrigger) {
	  let textContent = anchorNode.getTextContent();
	  const lastChar = textContent[anchorOffset - 1];
	  const transformers = transformersByTrigger[lastChar];

	  if (transformers == null) {
	    return false;
	  } // If typing in the middle of content, remove the tail to do
	  // reg exp match up to a string end (caret position)


	  if (anchorOffset < textContent.length) {
	    textContent = textContent.slice(0, anchorOffset);
	  }

	  for (const transformer of transformers) {
	    const match = textContent.match(transformer.regExp);

	    if (match === null) {
	      continue;
	    }

	    const startIndex = match.index || 0;
	    const endIndex = startIndex + match[0].length;
	    let replaceNode;

	    if (startIndex === 0) {
	      [replaceNode] = anchorNode.splitText(endIndex);
	    } else {
	      [, replaceNode] = anchorNode.splitText(startIndex, endIndex);
	    }

	    replaceNode.selectNext(0, 0);
	    transformer.replace(replaceNode, match);
	    return true;
	  }

	  return false;
	}

	function runTextFormatTransformers(anchorNode, anchorOffset, textFormatTransformers) {
	  const textContent = anchorNode.getTextContent();
	  const closeTagEndIndex = anchorOffset - 1;
	  const closeChar = textContent[closeTagEndIndex]; // Quick check if we're possibly at the end of inline markdown style

	  const matchers = textFormatTransformers[closeChar];

	  if (!matchers) {
	    return false;
	  }

	  for (const matcher of matchers) {
	    const {
	      tag
	    } = matcher;
	    const tagLength = tag.length;
	    const closeTagStartIndex = closeTagEndIndex - tagLength + 1; // If tag is not single char check if rest of it matches with text content

	    if (tagLength > 1) {
	      if (!isEqualSubString(textContent, closeTagStartIndex, tag, 0, tagLength)) {
	        continue;
	      }
	    } // Space before closing tag cancels inline markdown


	    if (textContent[closeTagStartIndex - 1] === ' ') {
	      continue;
	    } // Some tags can not be used within words, hence should have newline/space/punctuation after it


	    const afterCloseTagChar = textContent[closeTagEndIndex + 1];

	    if (matcher.intraword === false && afterCloseTagChar && !PUNCTUATION_OR_SPACE.test(afterCloseTagChar)) {
	      continue;
	    }

	    const closeNode = anchorNode;
	    let openNode = closeNode;
	    let openTagStartIndex = getOpenTagStartIndex(textContent, closeTagStartIndex, tag); // Go through text node siblings and search for opening tag
	    // if haven't found it within the same text node as closing tag

	    let sibling = openNode;

	    while (openTagStartIndex < 0 && (sibling = sibling.getPreviousSibling())) {
	      if (lexical.$isLineBreakNode(sibling)) {
	        break;
	      }

	      if (lexical.$isTextNode(sibling)) {
	        const siblingTextContent = sibling.getTextContent();
	        openNode = sibling;
	        openTagStartIndex = getOpenTagStartIndex(siblingTextContent, siblingTextContent.length, tag);
	      }
	    } // Opening tag is not found


	    if (openTagStartIndex < 0) {
	      continue;
	    } // No content between opening and closing tag


	    if (openNode === closeNode && openTagStartIndex + tagLength === closeTagStartIndex) {
	      continue;
	    } // Checking longer tags for repeating chars (e.g. *** vs **)


	    const prevOpenNodeText = openNode.getTextContent();

	    if (openTagStartIndex > 0 && prevOpenNodeText[openTagStartIndex - 1] === closeChar) {
	      continue;
	    } // Some tags can not be used within words, hence should have newline/space/punctuation before it


	    const beforeOpenTagChar = prevOpenNodeText[openTagStartIndex - 1];

	    if (matcher.intraword === false && beforeOpenTagChar && !PUNCTUATION_OR_SPACE.test(beforeOpenTagChar)) {
	      continue;
	    } // Clean text from opening and closing tags (starting from closing tag
	    // to prevent any offset shifts if we start from opening one)


	    const prevCloseNodeText = closeNode.getTextContent();
	    const closeNodeText = prevCloseNodeText.slice(0, closeTagStartIndex) + prevCloseNodeText.slice(closeTagEndIndex + 1);
	    closeNode.setTextContent(closeNodeText);
	    const openNodeText = openNode === closeNode ? closeNodeText : prevOpenNodeText;
	    openNode.setTextContent(openNodeText.slice(0, openTagStartIndex) + openNodeText.slice(openTagStartIndex + tagLength));
	    const selection = lexical.$getSelection();
	    const nextSelection = lexical.$createRangeSelection();
	    lexical.$setSelection(nextSelection); // Adjust offset based on deleted chars

	    const newOffset = closeTagEndIndex - tagLength * (openNode === closeNode ? 2 : 1) + 1;
	    nextSelection.anchor.set(openNode.__key, openTagStartIndex, 'text');
	    nextSelection.focus.set(closeNode.__key, newOffset, 'text'); // Apply formatting to selected text

	    for (const format of matcher.format) {
	      if (!nextSelection.hasFormat(format)) {
	        nextSelection.formatText(format);
	      }
	    } // Collapse selection up to the focus point


	    nextSelection.anchor.set(nextSelection.focus.key, nextSelection.focus.offset, nextSelection.focus.type); // Remove formatting from collapsed selection

	    for (const format of matcher.format) {
	      if (nextSelection.hasFormat(format)) {
	        nextSelection.toggleFormat(format);
	      }
	    }

	    if (lexical.$isRangeSelection(selection)) {
	      nextSelection.format = selection.format;
	    }

	    return true;
	  }

	  return false;
	}

	function getOpenTagStartIndex(string, maxIndex, tag) {
	  const tagLength = tag.length;

	  for (let i = maxIndex; i >= tagLength; i--) {
	    const startIndex = i - tagLength;

	    if (isEqualSubString(string, startIndex, tag, 0, tagLength) && // Space after opening tag cancels transformation
	    string[startIndex + tagLength] !== ' ') {
	      return startIndex;
	    }
	  }

	  return -1;
	}

	function isEqualSubString(stringA, aStart, stringB, bStart, length) {
	  for (let i = 0; i < length; i++) {
	    if (stringA[aStart + i] !== stringB[bStart + i]) {
	      return false;
	    }
	  }

	  return true;
	}

	function registerMarkdownShortcuts(editor, transformers = TRANSFORMERS) {
	  const byType = transformersByType(transformers);
	  const textFormatTransformersIndex = indexBy(byType.textFormat, ({
	    tag
	  }) => tag[tag.length - 1]);
	  const textMatchTransformersIndex = indexBy(byType.textMatch, ({
	    trigger
	  }) => trigger);

	  for (const transformer of transformers) {
	    const type = transformer.type;

	    if (type === 'element' || type === 'text-match') {
	      const dependencies = transformer.dependencies;

	      for (const node of dependencies) {
	        if (!editor.hasNode(node)) {
	          {
	            throw Error(`MarkdownShortcuts: missing dependency ${node.getType()} for transformer. Ensure node dependency is included in editor initial config.`);
	          }
	        }
	      }
	    }
	  }

	  const transform = (parentNode, anchorNode, anchorOffset) => {
	    if (runElementTransformers(parentNode, anchorNode, anchorOffset, byType.element)) {
	      return;
	    }

	    if (runTextMatchTransformers(anchorNode, anchorOffset, textMatchTransformersIndex)) {
	      return;
	    }

	    runTextFormatTransformers(anchorNode, anchorOffset, textFormatTransformersIndex);
	  };

	  return editor.registerUpdateListener(({
	    tags,
	    dirtyLeaves,
	    editorState,
	    prevEditorState
	  }) => {
	    // Ignore updates from undo/redo (as changes already calculated)
	    if (tags.has('historic')) {
	      return;
	    } // If editor is still composing (i.e. backticks) we must wait before the user confirms the key


	    if (editor.isComposing()) {
	      return;
	    }

	    const selection = editorState.read(lexical.$getSelection);
	    const prevSelection = prevEditorState.read(lexical.$getSelection);

	    if (!lexical.$isRangeSelection(prevSelection) || !lexical.$isRangeSelection(selection) || !selection.isCollapsed()) {
	      return;
	    }

	    const anchorKey = selection.anchor.key;
	    const anchorOffset = selection.anchor.offset;

	    const anchorNode = editorState._nodeMap.get(anchorKey);

	    if (!lexical.$isTextNode(anchorNode) || !dirtyLeaves.has(anchorKey) || anchorOffset !== 1 && anchorOffset > prevSelection.anchor.offset + 1) {
	      return;
	    }

	    editor.update(() => {
	      // Markdown is not available inside code
	      if (anchorNode.hasFormat('code')) {
	        return;
	      }

	      const parentNode = anchorNode.getParent();

	      if (parentNode === null || code.$isCodeNode(parentNode)) {
	        return;
	      }

	      transform(parentNode, anchorNode, selection.anchor.offset);
	    });
	  });
	}

	/**
	 * Copyright (c) Meta Platforms, Inc. and affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 */

	const createBlockNode = createNode => {
	  return (parentNode, children, match) => {
	    const node = createNode(match);
	    node.append(...children);
	    parentNode.replace(node);
	    node.select(0, 0);
	  };
	}; // Amount of spaces that define indentation level
	// TODO: should be an option


	const LIST_INDENT_SIZE = 4;

	const listReplace = listType => {
	  return (parentNode, children, match) => {
	    const previousNode = parentNode.getPreviousSibling();
	    const nextNode = parentNode.getNextSibling();
	    const listItem = list.$createListItemNode(listType === 'check' ? match[3] === 'x' : undefined);

	    if (list.$isListNode(nextNode) && nextNode.getListType() === listType) {
	      const firstChild = nextNode.getFirstChild();

	      if (firstChild !== null) {
	        firstChild.insertBefore(listItem);
	      } else {
	        // should never happen, but let's handle gracefully, just in case.
	        nextNode.append(listItem);
	      }

	      parentNode.remove();
	    } else if (list.$isListNode(previousNode) && previousNode.getListType() === listType) {
	      previousNode.append(listItem);
	      parentNode.remove();
	    } else {
	      const list$1 = list.$createListNode(listType, listType === 'number' ? Number(match[2]) : undefined);
	      list$1.append(listItem);
	      parentNode.replace(list$1);
	    }

	    listItem.append(...children);
	    listItem.select(0, 0);
	    const indent = Math.floor(match[1].length / LIST_INDENT_SIZE);

	    if (indent) {
	      listItem.setIndent(indent);
	    }
	  };
	};

	const listExport = (listNode, exportChildren, depth) => {
	  const output = [];
	  const children = listNode.getChildren();
	  let index = 0;

	  for (const listItemNode of children) {
	    if (list.$isListItemNode(listItemNode)) {
	      if (listItemNode.getChildrenSize() === 1) {
	        const firstChild = listItemNode.getFirstChild();

	        if (list.$isListNode(firstChild)) {
	          output.push(listExport(firstChild, exportChildren, depth + 1));
	          continue;
	        }
	      }

	      const indent = ' '.repeat(depth * LIST_INDENT_SIZE);
	      const listType = listNode.getListType();
	      const prefix = listType === 'number' ? `${listNode.getStart() + index}. ` : listType === 'check' ? `- [${listItemNode.getChecked() ? 'x' : ' '}] ` : '- ';
	      output.push(indent + prefix + exportChildren(listItemNode));
	      index++;
	    }
	  }

	  return output.join('\n');
	};

	const HEADING = {
	  dependencies: [richText.HeadingNode],
	  export: (node, exportChildren) => {
	    if (!richText.$isHeadingNode(node)) {
	      return null;
	    }

	    const level = Number(node.getTag().slice(1));
	    return '#'.repeat(level) + ' ' + exportChildren(node);
	  },
	  regExp: /^(#{1,6})\s/,
	  replace: createBlockNode(match => {
	    const tag = 'h' + match[1].length;
	    return richText.$createHeadingNode(tag);
	  }),
	  type: 'element'
	};
	const QUOTE = {
	  dependencies: [richText.QuoteNode],
	  export: (node, exportChildren) => {
	    if (!richText.$isQuoteNode(node)) {
	      return null;
	    }

	    const lines = exportChildren(node).split('\n');
	    const output = [];

	    for (const line of lines) {
	      output.push('> ' + line);
	    }

	    return output.join('\n');
	  },
	  regExp: /^>\s/,
	  replace: (parentNode, children, _match, isImport) => {
	    if (isImport) {
	      const previousNode = parentNode.getPreviousSibling();

	      if (richText.$isQuoteNode(previousNode)) {
	        previousNode.splice(previousNode.getChildrenSize(), 0, [lexical.$createLineBreakNode(), ...children]);
	        previousNode.select(0, 0);
	        parentNode.remove();
	        return;
	      }
	    }

	    const node = richText.$createQuoteNode();
	    node.append(...children);
	    parentNode.replace(node);
	    node.select(0, 0);
	  },
	  type: 'element'
	};
	const CODE = {
	  dependencies: [code.CodeNode],
	  export: node => {
	    if (!code.$isCodeNode(node)) {
	      return null;
	    }

	    const textContent = node.getTextContent();
	    return '```' + (node.getLanguage() || '') + (textContent ? '\n' + textContent : '') + '\n' + '```';
	  },
	  regExp: /^```(\w{1,10})?\s/,
	  replace: createBlockNode(match => {
	    return code.$createCodeNode(match ? match[1] : undefined);
	  }),
	  type: 'element'
	};
	const UNORDERED_LIST = {
	  dependencies: [list.ListNode, list.ListItemNode],
	  export: (node, exportChildren) => {
	    return list.$isListNode(node) ? listExport(node, exportChildren, 0) : null;
	  },
	  regExp: /^(\s*)[-*+]\s/,
	  replace: listReplace('bullet'),
	  type: 'element'
	};
	const CHECK_LIST = {
	  dependencies: [list.ListNode, list.ListItemNode],
	  export: (node, exportChildren) => {
	    return list.$isListNode(node) ? listExport(node, exportChildren, 0) : null;
	  },
	  regExp: /^(\s*)(?:-\s)?\s?(\[(\s|x)?\])\s/i,
	  replace: listReplace('check'),
	  type: 'element'
	};
	const ORDERED_LIST = {
	  dependencies: [list.ListNode, list.ListItemNode],
	  export: (node, exportChildren) => {
	    return list.$isListNode(node) ? listExport(node, exportChildren, 0) : null;
	  },
	  regExp: /^(\s*)(\d{1,})\.\s/,
	  replace: listReplace('number'),
	  type: 'element'
	};
	const INLINE_CODE = {
	  format: ['code'],
	  tag: '`',
	  type: 'text-format'
	};
	const HIGHLIGHT = {
	  format: ['highlight'],
	  tag: '==',
	  type: 'text-format'
	};
	const BOLD_ITALIC_STAR = {
	  format: ['bold', 'italic'],
	  tag: '***',
	  type: 'text-format'
	};
	const BOLD_ITALIC_UNDERSCORE = {
	  format: ['bold', 'italic'],
	  intraword: false,
	  tag: '___',
	  type: 'text-format'
	};
	const BOLD_STAR = {
	  format: ['bold'],
	  tag: '**',
	  type: 'text-format'
	};
	const BOLD_UNDERSCORE = {
	  format: ['bold'],
	  intraword: false,
	  tag: '__',
	  type: 'text-format'
	};
	const STRIKETHROUGH = {
	  format: ['strikethrough'],
	  tag: '~~',
	  type: 'text-format'
	};
	const ITALIC_STAR = {
	  format: ['italic'],
	  tag: '*',
	  type: 'text-format'
	};
	const ITALIC_UNDERSCORE = {
	  format: ['italic'],
	  intraword: false,
	  tag: '_',
	  type: 'text-format'
	}; // Order of text transformers matters:
	//
	// - code should go first as it prevents any transformations inside
	// - then longer tags match (e.g. ** or __ should go before * or _)

	const LINK = {
	  dependencies: [link.LinkNode],
	  export: (node, exportChildren, exportFormat) => {
	    if (!link.$isLinkNode(node)) {
	      return null;
	    }

	    const title = node.getTitle();
	    const linkContent = title ? `[${node.getTextContent()}](${node.getURL()} "${title}")` : `[${node.getTextContent()}](${node.getURL()})`;
	    const firstChild = node.getFirstChild(); // Add text styles only if link has single text node inside. If it's more
	    // then one we ignore it as markdown does not support nested styles for links

	    if (node.getChildrenSize() === 1 && lexical.$isTextNode(firstChild)) {
	      return exportFormat(firstChild, linkContent);
	    } else {
	      return linkContent;
	    }
	  },
	  importRegExp: /(?:\[([^[]+)\])(?:\((?:([^()\s]+)(?:\s"((?:[^"]*\\")*[^"]*)"\s*)?)\))/,
	  regExp: /(?:\[([^[]+)\])(?:\((?:([^()\s]+)(?:\s"((?:[^"]*\\")*[^"]*)"\s*)?)\))$/,
	  replace: (textNode, match) => {
	    const [, linkText, linkUrl, linkTitle] = match;
	    const linkNode = link.$createLinkNode(linkUrl, {
	      title: linkTitle
	    });
	    const linkTextNode = lexical.$createTextNode(linkText);
	    linkTextNode.setFormat(textNode.getFormat());
	    linkNode.append(linkTextNode);
	    textNode.replace(linkNode);
	  },
	  trigger: ')',
	  type: 'text-match'
	};

	/** @module @lexical/markdown */
	const ELEMENT_TRANSFORMERS = [HEADING, QUOTE, CODE, UNORDERED_LIST, ORDERED_LIST]; // Order of text format transformers matters:
	//
	// - code should go first as it prevents any transformations inside
	// - then longer tags match (e.g. ** or __ should go before * or _)

	const TEXT_FORMAT_TRANSFORMERS = [INLINE_CODE, BOLD_ITALIC_STAR, BOLD_ITALIC_UNDERSCORE, BOLD_STAR, BOLD_UNDERSCORE, HIGHLIGHT, ITALIC_STAR, ITALIC_UNDERSCORE, STRIKETHROUGH];
	const TEXT_MATCH_TRANSFORMERS = [LINK];
	const TRANSFORMERS = [...ELEMENT_TRANSFORMERS, ...TEXT_FORMAT_TRANSFORMERS, ...TEXT_MATCH_TRANSFORMERS];

	function $convertFromMarkdownString(markdown, transformers = TRANSFORMERS, node) {
	  const importMarkdown = createMarkdownImport(transformers);
	  return importMarkdown(markdown, node);
	}

	function $convertToMarkdownString(transformers = TRANSFORMERS, node) {
	  const exportMarkdown = createMarkdownExport(transformers);
	  return exportMarkdown(node);
	}

	LexicalMarkdown_dev.$convertFromMarkdownString = $convertFromMarkdownString;
	LexicalMarkdown_dev.$convertToMarkdownString = $convertToMarkdownString;
	LexicalMarkdown_dev.BOLD_ITALIC_STAR = BOLD_ITALIC_STAR;
	LexicalMarkdown_dev.BOLD_ITALIC_UNDERSCORE = BOLD_ITALIC_UNDERSCORE;
	LexicalMarkdown_dev.BOLD_STAR = BOLD_STAR;
	LexicalMarkdown_dev.BOLD_UNDERSCORE = BOLD_UNDERSCORE;
	LexicalMarkdown_dev.CHECK_LIST = CHECK_LIST;
	LexicalMarkdown_dev.CODE = CODE;
	LexicalMarkdown_dev.ELEMENT_TRANSFORMERS = ELEMENT_TRANSFORMERS;
	LexicalMarkdown_dev.HEADING = HEADING;
	LexicalMarkdown_dev.HIGHLIGHT = HIGHLIGHT;
	LexicalMarkdown_dev.INLINE_CODE = INLINE_CODE;
	LexicalMarkdown_dev.ITALIC_STAR = ITALIC_STAR;
	LexicalMarkdown_dev.ITALIC_UNDERSCORE = ITALIC_UNDERSCORE;
	LexicalMarkdown_dev.LINK = LINK;
	LexicalMarkdown_dev.ORDERED_LIST = ORDERED_LIST;
	LexicalMarkdown_dev.QUOTE = QUOTE;
	LexicalMarkdown_dev.STRIKETHROUGH = STRIKETHROUGH;
	LexicalMarkdown_dev.TEXT_FORMAT_TRANSFORMERS = TEXT_FORMAT_TRANSFORMERS;
	LexicalMarkdown_dev.TEXT_MATCH_TRANSFORMERS = TEXT_MATCH_TRANSFORMERS;
	LexicalMarkdown_dev.TRANSFORMERS = TRANSFORMERS;
	LexicalMarkdown_dev.UNORDERED_LIST = UNORDERED_LIST;
	LexicalMarkdown_dev.registerMarkdownShortcuts = registerMarkdownShortcuts;
	return LexicalMarkdown_dev;
}

var LexicalMarkdown_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredLexicalMarkdown_prod;

function requireLexicalMarkdown_prod () {
	if (hasRequiredLexicalMarkdown_prod) return LexicalMarkdown_prod;
	hasRequiredLexicalMarkdown_prod = 1;
var k=require$$0__default["default"],t=LexicalCode_1,A=LexicalList_1,B=LexicalRichText_1,aa=LexicalUtils_1,G=LexicalLink_1;function H(a,b){let c={};for(let d of a)a=b(d),c[a]?c[a].push(d):c[a]=[d];return c}function I(a){a=H(a,b=>b.type);return {element:a.element||[],textFormat:a["text-format"]||[],textMatch:a["text-match"]||[]}}let J=/[!-/:-@[-`{-~\s]/;
	function ba(a){let b=I(a),c=b.textFormat.filter(d=>1===d.format.length);return d=>{let e=[];d=(d||k.$getRoot()).getChildren();for(let f of d)d=ca(f,b.element,c,b.textMatch),null!=d&&e.push(d);return e.join("\n\n")}}function ca(a,b,c,d){for(let e of b)if(b=e.export(a,f=>K(f,c,d)),null!=b)return b;return k.$isElementNode(a)?K(a,c,d):k.$isDecoratorNode(a)?a.getTextContent():null}
	function K(a,b,c){let d=[];a=a.getChildren();a:for(let e of a){for(let f of c)if(a=f.export(e,g=>K(g,b,c),(g,l)=>L(g,l,b)),null!=a){d.push(a);continue a}k.$isLineBreakNode(e)?d.push("\n"):k.$isTextNode(e)?d.push(L(e,e.getTextContent(),b)):k.$isElementNode(e)?d.push(K(e,b,c)):k.$isDecoratorNode(e)&&d.push(e.getTextContent());}return d.join("")}
	function L(a,b,c){let d=b.trim(),e=d,f=new Set;for(let l of c){c=l.format[0];let p=l.tag;if(M(a,c)&&!f.has(c)){f.add(c);var g=N(a,!0);M(g,c)||(e=p+e);g=N(a,!1);M(g,c)||(e+=p);}}return b.replace(d,e)}
	function N(a,b){let c=b?a.getPreviousSibling():a.getNextSibling();c||(a=a.getParentOrThrow(),a.isInline()&&(c=b?a.getPreviousSibling():a.getNextSibling()));for(;c;){if(k.$isElementNode(c)){if(!c.isInline())break;a=b?c.getLastDescendant():c.getFirstDescendant();if(k.$isTextNode(a))return a;c=b?c.getPreviousSibling():c.getNextSibling();}if(k.$isTextNode(c))return c;if(!k.$isElementNode(c))break}return null}function M(a,b){return k.$isTextNode(a)&&a.hasFormat(b)}
	let O="undefined"!==typeof window&&"undefined"!==typeof window.document&&"undefined"!==typeof window.document.createElement,da=O&&"documentMode"in document?document.documentMode:null;O&&/Mac|iPod|iPhone|iPad/.test(navigator.platform);O&&/^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent);O&&"InputEvent"in window&&!da?"getTargetRanges"in new window.InputEvent("input"):!1;
	let P=O&&/Version\/[\d.]+.*Safari/.test(navigator.userAgent),Q=O&&/iPad|iPhone|iPod/.test(navigator.userAgent)&&!window.MSStream,ea=O&&/^(?=.*Chrome).*/i.test(navigator.userAgent),R=O&&/AppleWebKit\/[\d.]+/.test(navigator.userAgent)&&!ea,fa=/^\s{0,3}$/,S=/^```(\w{1,10})?\s?$/;
	function ha(a){let b=I(a),c=ia(b.textFormat);return (d,e)=>{d=d.split("\n");var f=d.length;e=e||k.$getRoot();e.clear();for(let h=0;h<f;h++){var g=d[h];a:{var l=d,p=h;var r=e;var y=l[p].match(S);if(y)for(var q=p,m=l.length;++q<m;)if(l[q].match(S)){y=t.$createCodeNode(y[1]);l=k.$createTextNode(l.slice(p+1,q).join("\n"));y.append(l);r.append(y);r=[y,q];break a}r=[null,p];}let [n,v]=r;if(null!=n)h=v;else {r=g;m=e;var w=b.element;q=c;l=b.textMatch;p=r.trim();y=k.$createTextNode(p);g=k.$createParagraphNode();
	g.append(y);m.append(g);for(let {regExp:x,replace:u}of w)if(m=r.match(x)){y.setTextContent(r.slice(m[0].length));u(g,[y],m,!0);break}T(y,q,l);g.isAttached()&&0<p.length&&(r=g.getPreviousSibling(),k.$isParagraphNode(r)||B.$isQuoteNode(r)||A.$isListNode(r))&&(q=r,A.$isListNode(r)&&(r=r.getLastDescendant(),q=null==r?null:aa.$findMatchingParent(r,A.$isListItemNode)),null!=q&&0<q.getTextContentSize()&&(q.splice(q.getChildrenSize(),0,[k.$createLineBreakNode(),...g.getChildren()]),g.remove()));}}d=e.getChildren();
	for(let h of d)d=h,k.$isParagraphNode(d)?(f=d.getFirstChild(),d=null==f||1===d.getChildrenSize()&&k.$isTextNode(f)&&fa.test(f.getTextContent())):d=!1,d&&h.remove();null!==k.$getSelection()&&e.selectEnd();}}
	function T(a,b,c){var d=a.getTextContent();let e=ja(d,b);if(e){var f,g;if(e[0]===d)var l=a;else {d=e.index||0;let p=d+e[0].length;0===d?[l,f]=a.splitText(p):[g,l,f]=a.splitText(d,p);}l.setTextContent(e[2]);if(a=b.transformersByTag[e[1]])for(let p of a.format)l.hasFormat(p)||l.toggleFormat(p);l.hasFormat("code")||T(l,b,c);g&&T(g,b,c);f&&T(f,b,c);}else U(a,c);}
	function U(a,b){a:for(;a;){for(let c of b){let d=a.getTextContent().match(c.importRegExp);if(!d)continue;let e=d.index||0,f=e+d[0].length,g,l,p;0===e?[g,a]=a.splitText(f):[l,g,p]=a.splitText(e,f);l&&U(l,b);p&&(a=p);c.replace(g,d);continue a}break}}
	function ja(a,b){var c=a.match(b.openTagsRegExp);if(null==c)return null;for(let f of c){var d=f.replace(/^\s/,"");c=b.fullMatchRegExpByTag[d];if(null!=c&&(c=a.match(c),d=b.transformersByTag[d],null!=c&&null!=d)){if(!1!==d.intraword)return c;var {index:e=0}=c;d=a[e-1];e=a[e+c[0].length];if(!(d&&!J.test(d)||e&&!J.test(e)))return c}}return null}
	function ia(a){let b={},c={},d=[];for(let e of a){({tag:a}=e);b[a]=e;let f=a.replace(/(\*|\^|\+)/g,"\\$1");d.push(f);c[a]=P||Q||R?new RegExp(`(${f})(?![${f}\\s])(.*?[^${f}\\s])${f}(?!${f})`):new RegExp(`(?<![\\\\${f}])(${f})((\\\\${f})?.*?[^${f}\\s](\\\\${f})?)((?<!\\\\)|(?<=\\\\\\\\))(${f})(?![\\\\${f}])`);}return {fullMatchRegExpByTag:c,openTagsRegExp:new RegExp((P||Q||R?"":"(?<![\\\\])")+"("+d.join("|")+")","g"),transformersByTag:b}}
	function V(a,b,c){let d=c.length;for(;b>=d;b--){let e=b-d;if(W(a,e,c,0,d)&&" "!==a[e+d])return e}return -1}function W(a,b,c,d,e){for(let f=0;f<e;f++)if(a[b+f]!==c[d+f])return !1;return !0}
	let ka=a=>(b,c,d)=>{d=a(d);d.append(...c);b.replace(d);d.select(0,0);},X=a=>(b,c,d)=>{var e=b.getPreviousSibling(),f=b.getNextSibling();const g=A.$createListItemNode("check"===a?"x"===d[3]:void 0);A.$isListNode(f)&&f.getListType()===a?(e=f.getFirstChild(),null!==e?e.insertBefore(g):f.append(g),b.remove()):A.$isListNode(e)&&e.getListType()===a?(e.append(g),b.remove()):(f=A.$createListNode(a,"number"===a?Number(d[2]):void 0),f.append(g),b.replace(f));g.append(...c);g.select(0,0);(b=Math.floor(d[1].length/
	4))&&g.setIndent(b);},Y=(a,b,c)=>{const d=[];var e=a.getChildren();let f=0;for(const l of e)if(A.$isListItemNode(l)){if(1===l.getChildrenSize()&&(e=l.getFirstChild(),A.$isListNode(e))){d.push(Y(e,b,c+1));continue}e=" ".repeat(4*c);var g=a.getListType();g="number"===g?`${a.getStart()+f}. `:"check"===g?`- [${l.getChecked()?"x":" "}] `:"- ";d.push(e+g+b(l));f++;}return d.join("\n")},la={dependencies:[B.HeadingNode],export:(a,b)=>{if(!B.$isHeadingNode(a))return null;const c=Number(a.getTag().slice(1));
	return "#".repeat(c)+" "+b(a)},regExp:/^(#{1,6})\s/,replace:ka(a=>B.$createHeadingNode("h"+a[1].length)),type:"element"},ma={dependencies:[B.QuoteNode],export:(a,b)=>{if(!B.$isQuoteNode(a))return null;a=b(a).split("\n");b=[];for(const c of a)b.push("> "+c);return b.join("\n")},regExp:/^>\s/,replace:(a,b,c,d)=>{if(d&&(c=a.getPreviousSibling(),B.$isQuoteNode(c))){c.splice(c.getChildrenSize(),0,[k.$createLineBreakNode(),...b]);c.select(0,0);a.remove();return}c=B.$createQuoteNode();c.append(...b);a.replace(c);
	c.select(0,0);},type:"element"},na={dependencies:[t.CodeNode],export:a=>{if(!t.$isCodeNode(a))return null;const b=a.getTextContent();return "```"+(a.getLanguage()||"")+(b?"\n"+b:"")+"\n```"},regExp:/^```(\w{1,10})?\s/,replace:ka(a=>t.$createCodeNode(a?a[1]:void 0)),type:"element"},oa={dependencies:[A.ListNode,A.ListItemNode],export:(a,b)=>A.$isListNode(a)?Y(a,b,0):null,regExp:/^(\s*)[-*+]\s/,replace:X("bullet"),type:"element"},pa={dependencies:[A.ListNode,A.ListItemNode],export:(a,b)=>A.$isListNode(a)?
	Y(a,b,0):null,regExp:/^(\s*)(?:-\s)?\s?(\[(\s|x)?\])\s/i,replace:X("check"),type:"element"},qa={dependencies:[A.ListNode,A.ListItemNode],export:(a,b)=>A.$isListNode(a)?Y(a,b,0):null,regExp:/^(\s*)(\d{1,})\.\s/,replace:X("number"),type:"element"},ra={format:["code"],tag:"`",type:"text-format"},sa={format:["highlight"],tag:"==",type:"text-format"},ta={format:["bold","italic"],tag:"***",type:"text-format"},va={format:["bold","italic"],intraword:!1,tag:"___",type:"text-format"},wa={format:["bold"],tag:"**",
	type:"text-format"},xa={format:["bold"],intraword:!1,tag:"__",type:"text-format"},ya={format:["strikethrough"],tag:"~~",type:"text-format"},za={format:["italic"],tag:"*",type:"text-format"},Aa={format:["italic"],intraword:!1,tag:"_",type:"text-format"},Ba={dependencies:[G.LinkNode],export:(a,b,c)=>{if(!G.$isLinkNode(a))return null;b=(b=a.getTitle())?`[${a.getTextContent()}](${a.getURL()} "${b}")`:`[${a.getTextContent()}](${a.getURL()})`;const d=a.getFirstChild();return 1===a.getChildrenSize()&&k.$isTextNode(d)?
	c(d,b):b},importRegExp:/(?:\[([^[]+)\])(?:\((?:([^()\s]+)(?:\s"((?:[^"]*\\")*[^"]*)"\s*)?)\))/,regExp:/(?:\[([^[]+)\])(?:\((?:([^()\s]+)(?:\s"((?:[^"]*\\")*[^"]*)"\s*)?)\))$/,replace:(a,b)=>{const [,c,d,e]=b;b=G.$createLinkNode(d,{title:e});const f=k.$createTextNode(c);f.setFormat(a.getFormat());b.append(f);a.replace(b);},trigger:")",type:"text-match"},Ca=[la,ma,na,oa,qa],Da=[ra,ta,va,wa,xa,sa,za,Aa,ya],Ea=[Ba],Z=[...Ca,...Da,...Ea];
	LexicalMarkdown_prod.$convertFromMarkdownString=function(a,b=Z,c){return ha(b)(a,c)};LexicalMarkdown_prod.$convertToMarkdownString=function(a=Z,b){return ba(a)(b)};LexicalMarkdown_prod.BOLD_ITALIC_STAR=ta;LexicalMarkdown_prod.BOLD_ITALIC_UNDERSCORE=va;LexicalMarkdown_prod.BOLD_STAR=wa;LexicalMarkdown_prod.BOLD_UNDERSCORE=xa;LexicalMarkdown_prod.CHECK_LIST=pa;LexicalMarkdown_prod.CODE=na;LexicalMarkdown_prod.ELEMENT_TRANSFORMERS=Ca;LexicalMarkdown_prod.HEADING=la;LexicalMarkdown_prod.HIGHLIGHT=sa;LexicalMarkdown_prod.INLINE_CODE=ra;LexicalMarkdown_prod.ITALIC_STAR=za;LexicalMarkdown_prod.ITALIC_UNDERSCORE=Aa;LexicalMarkdown_prod.LINK=Ba;LexicalMarkdown_prod.ORDERED_LIST=qa;LexicalMarkdown_prod.QUOTE=ma;
	LexicalMarkdown_prod.STRIKETHROUGH=ya;LexicalMarkdown_prod.TEXT_FORMAT_TRANSFORMERS=Da;LexicalMarkdown_prod.TEXT_MATCH_TRANSFORMERS=Ea;LexicalMarkdown_prod.TRANSFORMERS=Z;LexicalMarkdown_prod.UNORDERED_LIST=oa;
	LexicalMarkdown_prod.registerMarkdownShortcuts=function(a,b=Z){let c=I(b),d=H(c.textFormat,({tag:f})=>f[f.length-1]),e=H(c.textMatch,({trigger:f})=>f);for(let f of b)if(b=f.type,"element"===b||"text-match"===b){b=f.dependencies;for(let g of b)if(!a.hasNode(g))throw Error(`MarkdownShortcuts: missing dependency ${g.getType()} for transformer. Ensure node dependency is included in editor initial config.`);}return a.registerUpdateListener(({tags:f,dirtyLeaves:g,editorState:l,prevEditorState:p})=>{if(!f.has("historic")&&
	!a.isComposing()){var r=l.read(k.$getSelection);f=p.read(k.$getSelection);if(k.$isRangeSelection(f)&&k.$isRangeSelection(r)&&r.isCollapsed()){p=r.anchor.key;var y=r.anchor.offset,q=l._nodeMap.get(p);!k.$isTextNode(q)||!g.has(p)||1!==y&&y>f.anchor.offset+1||a.update(()=>{if(!q.hasFormat("code")){var m=q.getParent();if(null!==m&&!t.$isCodeNode(m)){var w=r.anchor.offset;b:{var h=c.element,n=m.getParent();if(k.$isRootOrShadowRoot(n)&&m.getFirstChild()===q&&(n=q.getTextContent()," "===n[w-1]))for(let {regExp:D,
	replace:E}of h)if((h=n.match(D))&&h[0].length===w){n=q.getNextSiblings();let [F,ua]=q.splitText(w);F.remove();n=ua?[ua,...n]:n;E(m,n,h,!1);m=!0;break b}m=!1;}if(!m){b:{h=q.getTextContent();m=e[h[w-1]];if(null!=m){w<h.length&&(h=h.slice(0,w));for(x of m)if(m=h.match(x.regExp),null!==m){h=m.index||0;n=h+m[0].length;var v=void 0;0===h?[v]=q.splitText(n):[,v]=q.splitText(h,n);v.selectNext(0,0);x.replace(v,m);var x=!0;break b}}x=!1;}if(!x)b:{n=q.getTextContent();--w;var u=n[w];if(x=d[u])for(let D of x){var {tag:C}=
	D;x=C.length;let E=w-x+1;if(!(1<x&&!W(n,E,C,0,x)||" "===n[E-1])&&(v=n[w+1],!1!==D.intraword||!v||J.test(v))){m=v=q;h=V(n,E,C);for(var z=m;0>h&&(z=z.getPreviousSibling())&&!k.$isLineBreakNode(z);)k.$isTextNode(z)&&(h=z.getTextContent(),m=z,h=V(h,h.length,C));if(!(0>h||m===v&&h+x===E||(C=m.getTextContent(),0<h&&C[h-1]===u||(z=C[h-1],!1===D.intraword&&z&&!J.test(z))))){n=v.getTextContent();n=n.slice(0,E)+n.slice(w+1);v.setTextContent(n);n=m===v?n:C;m.setTextContent(n.slice(0,h)+n.slice(h+x));n=k.$getSelection();
	u=k.$createRangeSelection();k.$setSelection(u);w=w-x*(m===v?2:1)+1;u.anchor.set(m.__key,h,"text");u.focus.set(v.__key,w,"text");for(let F of D.format)u.hasFormat(F)||u.formatText(F);u.anchor.set(u.focus.key,u.focus.offset,u.focus.type);for(let F of D.format)u.hasFormat(F)&&u.toggleFormat(F);k.$isRangeSelection(n)&&(u.format=n.format);break b}}}}}}}});}}})};
	return LexicalMarkdown_prod;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
const LexicalMarkdown = process.env.NODE_ENV === 'development' ? requireLexicalMarkdown_dev() : requireLexicalMarkdown_prod();
var LexicalMarkdown_1 = LexicalMarkdown;

function getElementNodesInSelection(selection) {
    const nodesInSelection = selection.getNodes();
    if (nodesInSelection.length === 0) {
        return new Set([
            selection.anchor.getNode().getParentOrThrow(),
            selection.focus.getNode().getParentOrThrow()
        ]);
    }
    return new Set(nodesInSelection.map((n) => (require$$0.$isElementNode(n) ? n : n.getParentOrThrow())));
}
function isIndentPermitted(maxDepth) {
    const selection = require$$0.$getSelection();
    if (!require$$0.$isRangeSelection(selection)) {
        return false;
    }
    const elementNodesInSelection = getElementNodesInSelection(selection);
    let totalDepth = 0;
    for (const elementNode of elementNodesInSelection) {
        if (LexicalList_1.$isListNode(elementNode)) {
            totalDepth = Math.max(LexicalList_1.$getListDepth(elementNode) + 1, totalDepth);
        }
        else if (LexicalList_1.$isListItemNode(elementNode)) {
            const parent = elementNode.getParent();
            if (!LexicalList_1.$isListNode(parent)) {
                throw new Error("ListMaxIndentLevelPlugin: A ListItemNode must have a ListNode for a parent.");
            }
            totalDepth = Math.max(LexicalList_1.$getListDepth(parent) + 1, totalDepth);
        }
    }
    return totalDepth <= maxDepth;
}
function ListMaxIndentLevelPlugin({ maxDepth }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        return editor.registerCommand(require$$0.INDENT_CONTENT_COMMAND, () => !isIndentPermitted(maxDepth !== null && maxDepth !== void 0 ? maxDepth : 7), require$$0.COMMAND_PRIORITY_HIGH);
    }, [editor, maxDepth]);
    return null;
}

function CodeHighlightPlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        return LexicalCode_1.registerCodeHighlighting(editor);
    }, [editor]);
    return null;
}

const URL_MATCHER = /((https?:\/\/(www\.)?)|(www\.))[-a-zA-Z0-9@:%._+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_+.~#?&//=]*)/;
const EMAIL_MATCHER = /(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))/;
const MATCHERS = [
    (text) => {
        const match = URL_MATCHER.exec(text);
        return (match && {
            index: match.index,
            length: match[0].length,
            text: match[0],
            url: match[0]
        });
    },
    (text) => {
        const match = EMAIL_MATCHER.exec(text);
        return (match && {
            index: match.index,
            length: match[0].length,
            text: match[0],
            url: `mailto:${match[0]}`
        });
    }
];
function PlaygroundAutoLinkPlugin() {
    return jsxRuntime.jsx(LexicalAutoLinkPlugin.AutoLinkPlugin, { matchers: MATCHERS });
}

function InitialWithHtmlPlugin({ html: initHtml = '' }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        if (initHtml) {
            const parser = new DOMParser();
            const dom = parser.parseFromString(initHtml, 'text/html');
            editor.update(() => {
                const nodes = LexicalHtml_1.$generateNodesFromDOM(editor, dom);
                require$$0.$getRoot().select();
                require$$0.$insertNodes(nodes);
            });
        }
    }, [editor, initHtml]);
    return null;
}

function HeaderPlugin({ placeholder = 'Enter a title...' }) {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    const [header, setHeder] = React.useState('');
    const [value, setValue] = React.useState('');
    React.useLayoutEffect(() => {
        return editor.registerUpdateListener(() => {
            if (editor) {
                editor.update(() => {
                    const firstNode = require$$0.$getRoot().getChildAtIndex(0);
                    if (firstNode && firstNode.__tag === 'h1') {
                        console.log(firstNode.getTextContent());
                        setValue(firstNode.getTextContent());
                    }
                });
            }
        });
    }, [editor]);
    React.useEffect(() => {
        if (editor) {
            if (header) {
                const parser = new DOMParser();
                const dom = parser.parseFromString(`<h1 class=\"editor-heading-h1\"><span>${header}</span></h1>`, 'text/html');
                editor.update(() => {
                    const nodes = LexicalHtml_1.$generateNodesFromDOM(editor, dom);
                    const firstNode = require$$0.$getRoot().getChildAtIndex(0);
                    if (firstNode) {
                        firstNode.insertBefore(nodes[0]);
                        if (firstNode.__tag === 'h1') {
                            firstNode.remove();
                        }
                    }
                });
            }
        }
    }, [editor, header]);
    return jsxRuntime.jsx("input", { type: "text", placeholder: placeholder, value: value, onChange: (e) => { setValue(e.currentTarget.value); }, onBlur: () => setHeder(value), autoFocus: true, className: "text-4xl h-24 w-full border-b mb-4 outline-0 px-2" });
}

function VideoPlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        // Similar with command listener, which returns unlisten callback
        const removeListener = editor.registerCommand(INSERT_VIDEO_COMMAND, (payload) => {
            // Adding custom command that will be handled by this plugin
            editor.update(() => {
                require$$0.$insertNodes([$createVideoNode(payload)], true);
            });
            // Returning true indicates that command is handled and no further propagation is required
            return true;
        }, 0);
        return () => {
            removeListener();
        };
    }, [editor]);
    return null;
}

function ImagePlugin() {
    const [editor] = LexicalComposerContext.useLexicalComposerContext();
    React.useEffect(() => {
        // Similar with command listener, which returns unlisten callback
        const removeListener = editor.registerCommand(INSERT_IMAGE_COMMAND, (payload) => {
            // Adding custom command that will be handled by this plugin
            editor.update(() => {
                require$$0.$insertNodes([$createImageNode(payload)], true);
            });
            // Returning true indicates that command is handled and no further propagation is required
            return true;
        }, 0);
        return () => {
            removeListener();
        };
    }, [editor]);
    return null;
}

const domain = `https://editor.cpchain.io`;
const defaultUrl = domain + `/graphql`;
const editorUploadImageUrl = `${domain}/upload`;
function graphqlQuery(query, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield fetch((opts === null || opts === void 0 ? void 0 : opts.server) || defaultUrl, {
            method: 'POST',
            headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({
                query
            })
        });
        const data = yield res.json();
        return data.data;
    });
}
function getFiles({ limit, offset }) {
    return __awaiter(this, void 0, void 0, function* () {
        const r = yield graphqlQuery(`query { 
        files(limit:${limit},offset:${offset}, tags:["image"], excludeTags:["svgr/webpack"]) {
            count,
            results {
              originPath,
              minPath,
              tags,
            }
          }
      } `);
        return r.files;
    });
}
function getEditorImages({ limit, offset }) {
    return __awaiter(this, void 0, void 0, function* () {
        const r = yield getFiles({ limit, offset });
        const urls = r.results.map(p => domain + p.originPath);
        return { count: r.count, results: urls };
    });
}

function DefaultPlaceholder() {
    return jsxRuntime.jsx("div", { className: "editor-placeholder", children: "Enter some text..." });
}
const editorConfig = {
    // The editor theme
    theme: exampleTheme,
    // Handling of errors during update
    onError(error) {
        throw error;
    },
    // Any custom nodes go here
    nodes: [
        LexicalRichText_1.HeadingNode,
        LexicalList_1.ListNode,
        LexicalList_1.ListItemNode,
        LexicalRichText_1.QuoteNode,
        LexicalCode_1.CodeNode,
        LexicalCode_1.CodeHighlightNode,
        LexicalTable_1.TableNode,
        LexicalTable_1.TableCellNode,
        LexicalTable_1.TableRowNode,
        LexicalLink_1.AutoLinkNode,
        LexicalLink_1.LinkNode,
        VideoNode,
        ImageNode
    ]
};
function Editor({ getImages = getEditorImages, titlePlaceHolder, initialHtml: initHtml, onChange, Placeholder = DefaultPlaceholder, uploadImageUrl = editorUploadImageUrl }) {
    const onEditorChange = React.useCallback((editorState, editor) => {
        editorState.read(() => {
            const htmlString = LexicalHtml_1.$generateHtmlFromNodes(editor);
            if (htmlString !== initHtml && htmlString !== '<p class="editor-paragraph"><br></p>') {
                const firstNode = require$$0.$getRoot().getChildAtIndex(0);
                let header = '';
                if (firstNode && firstNode.__tag === 'h1') {
                    header = firstNode.getTextContent();
                }
                onChange({ html: htmlString, title: header });
            }
        });
    }, [initHtml]);
    return (jsxRuntime.jsx(LexicalComposer.LexicalComposer, { initialConfig: editorConfig, children: jsxRuntime.jsxs("div", { className: "editor-container shadow-xl", children: [jsxRuntime.jsx(HeaderPlugin, { placeholder: titlePlaceHolder }), jsxRuntime.jsx(ToolbarPlugin, { getImages: getImages, uploadImageUrl: uploadImageUrl }), jsxRuntime.jsxs("div", { className: "editor-inner", children: [jsxRuntime.jsx(LexicalRichTextPlugin.RichTextPlugin, { contentEditable: jsxRuntime.jsx(LexicalContentEditable.ContentEditable, { className: "editor-input" }), placeholder: jsxRuntime.jsx(Placeholder, {}), ErrorBoundary: LexicalErrorBoundary__default["default"] }), jsxRuntime.jsx(LexicalOnChangePlugin.OnChangePlugin, { onChange: onEditorChange }), jsxRuntime.jsx(InitialWithHtmlPlugin, { html: initHtml }), jsxRuntime.jsx(LexicalHistoryPlugin.HistoryPlugin, {}), jsxRuntime.jsx(LexicalAutoFocusPlugin.AutoFocusPlugin, {}), jsxRuntime.jsx(CodeHighlightPlugin, {}), jsxRuntime.jsx(LexicalListPlugin.ListPlugin, {}), jsxRuntime.jsx(LexicalLinkPlugin.LinkPlugin, {}), jsxRuntime.jsx(PlaygroundAutoLinkPlugin, {}), jsxRuntime.jsx(ListMaxIndentLevelPlugin, { maxDepth: 7 }), jsxRuntime.jsx(LexicalMarkdownShortcutPlugin.MarkdownShortcutPlugin, { transformers: LexicalMarkdown_1.TRANSFORMERS }), jsxRuntime.jsx(VideoPlugin, {}), jsxRuntime.jsx(ImagePlugin, {})] })] }) }));
}

exports.Editor = Editor;
